#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int n, m;
int k[MAXN + 5];
int p[MAXN + 5];
int idx[MAXN + 5];
int par[MAXN + 5];
int last[MAXN + 5];
vector<int> G[MAXN + 5];

void DFS(int u, int p)
{
    for (auto v : G[u])
    {
        if (v != p)
        {
            par[v] = u;
            DFS(v, u);
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> k[i];
        for (int j = 1; j <= k[i]; ++ j)
        {
            int u;
            cin >> u;
            G[i].push_back(u);
        }
    }

    for (int i = 1; i <= m; ++ i)
    {
        cin >> p[i];
    }

    DFS(1, -1);

    int cnt = 0;
    for (int i = 2; i <= n; ++ i)
    {
        last[i] = G[i].back();
        if (last[i] == par[i]) cnt++;
    }

    int u = 1, v;
    while (true)
    {
        if (u == 1 and cnt == n - 1) break;
        v = G[u][idx[u]];
        if (u != 1)
        {
            if (last[u] == par[u]) cnt--;
            last[u] = v;
            if (v == par[u]) cnt++;
        }
        idx[u]++;
        idx[u] %= k[u];
        u = v;
    }

    return 0;
}
