#include <iostream>
#include <chrono>
#include <cmath>
#include <algorithm>
#include <vector>

#define maxn 500005
#define pb(x) push_back(x)
#define endl '\n'
#define mod 1000000007

using namespace std;

int t;
int n, k, x;
int a[maxn], b[maxn];
int c[maxn];

int get_gcd()
{
    int gcd = 1;

    for(int i = 1; i <= k; i++)
    {
        gcd = __gcd(gcd , a[c[i]]);
        gcd = __gcd(gcd , b[c[i]]);
    }

    return gcd;
}




bool check()
{
    bool lamp = true;

    for(int i = 1; i <= n; i++)
        c[i] = i;
    int gcd = -1;

    do
    {
        int cur = get_gcd();

        if(gcd == -1)
        {
            gcd = get_gcd();
            continue;
        }

        if(cur != gcd)
        {
            lamp = false;
            break;
        }
    }
    while(next_permutation(c + 1, c + 1 + n));

    return lamp;
}

bool cmp(const vector <int>& a , const vector <int>& b)
{
    for(int i = 1; i <= min((int)(a.size()) , (int)(b.size())); i++)
    {
        if(a[i] == b[i])
            continue;

        if(b[i] > a[i])
            return true;

        if(a[i] > b[i])
            return false;
    }
    return true;
}


vector <vector <int>> valid;



void read()
{
    cin >> n >> k >> x;

    for(int i = 1; i <= n; i++)
        cin >> a[i];

    int idx[maxn];

    for(int i = 1; i <= n; i++)
        idx[i] = i;

    do
    {
        for(int i = 1; i <= n; i++)
            b[i] = a[idx[i]];

        if(check() == true)
        {
            vector <int> curr;
            curr.resize(n);

            for(int i = 0; i < n; i++)
                curr[i] = b[i + 1];
            valid.pb(curr);
        }

    }while(next_permutation(idx + 1 , idx + 1 + n));

    sort(valid.begin() , valid.end() , cmp);

    for(int i = 0; i < valid[0].size(); i++)
        cout << valid[0][i] << " ";
}





void combine()
{
    cin >> t;

    while(t--)
    {
        read();
    }

}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    combine();

    return 0;
}
