#pragma once
#include"game.h"
#include<bits/stdc++.h>
using namespace std;
const int maxn = 2e5 + 10;
int n, d, a[maxn];
int used[maxn];
int dp[maxn];
/*
used[i] == 1 mod 2 -> 2nd
used[u] == 0 mod 2 -> 1st
*/

bool is_max_extreum(int i){
    for (int j = i - 1; j >= 0 && j >= i - d; --j)
        if (a[j] > a[i]) return false;
    for (int j = i + 1; j < n && j <= i + d; ++j)
        if (a[j] > a[i]) return false;
    return true;
}

bool is_in_range(int cur, int deltamax, int i){
    //cerr << "range check: " << cur << " " << deltamax << " " << i << "\n";
    if (i < 0) return false;
    //cerr << "i >= 0\n";
    if (i >= n) return false;
    //cerr << "i < n\n";
    if (deltamax < 0){
        //cerr << "deltamax < 0 and sum is " << cur + deltamax << "\n";
        if (i < cur + deltamax) return false;
    }
    else{
        //cerr << "deltamax > 0 and sum is " << cur + deltamax << "\n";
        if (i > cur + deltamax) return false;
    } 
    return true;
}

inline void init_dp(){
    memset(used, 0, sizeof(used));
    memset(dp, 0, sizeof(dp));
    queue<pair<int, bool> > q;
    for (int i = 0; i < n; ++i)
        if (is_max_extreum(i)){
            used[i] = 1;
            dp[i] = 0;
            q.push({i, true});
            q.push({i, false});
        }
    while (!q.empty()){
        int cur = q.front().first;
        bool dir = q.front().second;
        //cerr << "cur: " << cur << " dir: " << dir << "\n";
        q.pop();
        used[cur] = true;
        int delta = (dir)? 1: -1;
        int deltamax = delta * d;
        //cerr << "delta: " << delta << " deltamax: " << deltamax << "\n";
        for (int i = cur + delta; is_in_range(cur, deltamax, i); i += delta){
            //cerr << "i: " << i << " used[i]: " << used[i] << "\n";
            if (!used[i]){
                if (dp[cur] == 0) dp[i] = 1;
                q.push({i, dir});
            }
        }
    }
}

void init(vector<int> A, int D){
    d = D;
    n = A.size();
    for (int i = 0; i < n; ++i)
        a[i] = A[i];
    init_dp();
}
void updateValue(int index, int newValue){
    a[index] = newValue;
    init_dp();
}
bool isWinning(int startIndex){
    //return (used[startIndex] % 2)? false: true;
    return dp[startIndex];
}

/*void init_used(){
    memset(used, 0, sizeof(used));
    queue<int> q;
    for (int i = 0; i < n; ++i)
        if (is_max_extreum(i)){
            used[i] = 1;
            q.push(i);
        }
    while (!q.empty()){
        int i = q.front();
        q.pop();
        for (int j = i - 1; j >= 0 && j >= i - d; --j)
            if (!used[j]){
                used[j] = used[i] + 1;
                q.push(used[j]);
            }
        for (int j = i - 1; j < n && j <= i + d; ++j)
            if (!used[j]){
                used[j] = used[i] + 1;
                q.push(used[j]);
            }
    }
    for (int i = 0; i < n; ++i)
        cerr << "used at i: " << used[i] << "\n"; 
}*/