#include<iostream>
#include<vector>
#include<bitset>
#define MAXN 100010
using namespace std;
vector<int> edges[MAXN];
vector<int> cycle;
vector<int> pos[MAXN];
int p[MAXN];
int a[MAXN];
int visit[MAXN];
bitset<MAXN> used;
int nextpos(int lim, int val)
{
    if(lim>=pos[val][pos[val].size()-1])return pos[val][0];
    int l=0,r=pos[val].size()-1;
    while(l!=r)
    {
        int mid=(l+r)>>1;
        if(pos[val][mid]>lim)r=mid;
        else l=mid+1;
    }
    return pos[val][l];
}
int main()
{
    int n,m,cntr=1,curr=1,next,last=0;
    long long ans=0;
    bool fl=1,done=0;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        cin>>p[i];
        for(int j=1;j<=p[i];j++)
        {
            int x;
            cin>>x;
            edges[i].push_back(x);
        }
    }
    for(int i=1;i<=m;i++)cin>>a[i];
    visit[1]=1;
    while(1)
    {
        if(cntr==m+1){done=1;break;}
        ans++;
        if(curr==a[cntr])cntr++;
        if(last>0)
        {
            cycle.push_back(curr);
            pos[curr].push_back(cycle.size());
        }
        if(curr==last)break;
        used[curr]=1;
        if(p[curr]==1)next=0;
        else
        {
            next=visit[curr]%p[curr];
            if(next==0)next=p[curr];
            next--;
        }
        if(fl)if(used.count()==n){last=curr;fl=0;}
        curr=edges[curr][next];
        visit[curr]++;
    }
    int prev=0;
    for(int i=cntr;i<=m;i++)
    {
        int lastpos=nextpos(prev,a[i]);
        ans+=(lastpos-prev);
        if(lastpos<=prev)ans+=cycle.size();
        prev=lastpos;
    }
    cout<<ans<<"\n";
}