#include <iostream>
#include <vector>
#include "game.h"
using namespace std;
const int MAXN = 1e5+7;
int rangeMax[MAXN];
int rangeSecMax[MAXN];
int maxInRange[MAXN]; /// za vseki index pazim dali v range-a mu ima chislo koeto e max v svoq range
int D;
vector<int> val;
int n;
void init(vector<int> originalA, int originalD){
  D = originalD;
  val = originalA;
  n = val.size();
  int firstpos = 0;
  int firstmax,secmax;
  for(int i = 0;i<n;i++){
    firstpos = max(i-D,0);
    if(val[firstpos]>val[firstpos+1]){
      firstmax = firstpos;
      secmax = firstpos+1;
    }else{
      firstmax = firstpos+1;
      secmax = firstpos;
    }
    for(int j = firstpos+2;j<=min(i+D,n-1);j++){
      if(val[j]>val[firstmax]){
      secmax = firstmax;
      firstmax = j;
      }else if(val[j]>val[secmax]){
        secmax = j;
      }
    }
    rangeMax[i]=firstmax;
    rangeSecMax[i]=secmax;
  }
  for(int i=0;i<n;i++) maxInRange[i]=-1;
  for(int i=0;i<n;i++){
    if(rangeMax[i]==i){
      for(int j=max(i-D,0);j<=min(i+D,n-1);j++){
        if(i!=j) maxInRange[j]=i;
      }
    }
  }
  /*for(int i=0;i<n;i++){
    cout<<rangeMax[i]<<" "<<rangeSecMax[i]<<"\n";
  }*/
}
void updateValue(int index, int newValue){
  val[index]=newValue;
  int firstpos = 0;
  int firstmax,secmax;
  for(int i = max(index-D,0);i<=min(index+D,n-1);i++){
    firstpos = max(i-D,0);
    if(val[firstpos]>val[firstpos+1]){
      firstmax = firstpos;
      secmax = firstpos+1;
    }else{
      firstmax = firstpos+1;
      secmax = firstpos;
    }
    for(int j = firstpos+2;j<min(i+D,n);j++){
      if(val[j]>val[firstmax]){
      secmax = firstmax;
      firstmax = j;
      }else if(val[j]>val[secmax]){
        secmax = j;
      }
    }
    rangeMax[i]=firstmax;
    rangeSecMax[i]=secmax;
  }
  for(int i = max(index-D,0);i<=min(index+D,n-1);i++) maxInRange[i]=-1;
  for(int i = max(index-D,0);i<=min(index+D,n-1);i++){
    if(rangeMax[i]==i){
      for(int j=max(i-D,0);j<=min(i+D,n-1);j++){
          if(i!=j) maxInRange[j]=i;
      }
    }
  }
}
bool isWinning(int startIndex){
  int igrach = 0;
  int ind = startIndex;
  while(rangeMax[ind]!=ind){
    //cerr<<ind<<" "<<igrach<<"\n";
    if(maxInRange[ind]!=-1) ind = maxInRange[ind];
    else ind = rangeMax[ind];
    igrach=(igrach+1)%2;
  }
  return igrach;
}
