#ifndef _LOCALTEST
#include "game.h"
#endif
#include<bits/stdc++.h>
using namespace std;
vector<int> ar;
int d;

void init(vector<int> A, int D)
{
    d = D;
    for(int i = 0; i < A.size(); i++)
    {
        ar.push_back(A[i]);
    }
}

void updateValue(int index, int newValue)
{
    ar[index] = newValue;
}

int curr_idx = 0;
bool isWinning(int startIndex)
{
    if(curr_idx > ar.size())
    {
        curr_idx -= ar.size();
        return isWinning(startIndex);
    }

    if(curr_idx < startIndex + d)
    {
        curr_idx += d;
        return true;
    }

    return false;
}

/*
6 2
1 7 4 9 30 2
5
5 0
2 1
1 4 8
2 0
2 1
*/


#ifdef _GRADERTEST
int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
#endif // _GRADERTEST
