#ifndef _LOCALTEST
#include "game.h"
#endif
#include<bits/stdc++.h>
using namespace std;

vector<int> ar;
vector<int> ar2;
#define sz ar.size()

void precomput()
{
    for(int i = 0; i < ar.size(); i++)
    {
        ar2.push_back(ar[i] + d);
    }
}

void init(vector<int> A, int D)
{
    d = D;
    for(int i = 0; i < A.size(); i++)
    {
        ar.push_back(A[i]);
    }
    precomput();
}

void updateValue(int index, int newValue)
{
    ar2[index-1] = newValue;
    precomput();
}

bool isWinning(int startIndex)
{
    if(ar2[startIndex] == ar2[startIndex + 1])
    {
        return ar2[startIndex] > ar2[startIndex];
    }

    return ar2[startIndex] < ar2[startIndex + 1];
}

/*
6 2
1 7 4 9 30 2
5
5 0
2 1
1 4 8
2 0
2 1
*/


#ifdef _GRADERTEST
int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
#endif // _GRADERTEST
