//#define _LOCALTEST

#include<bits/stdc++.h>
using namespace std;
int n, k, x;
int a[100][100];

vector<int> check1;
vector<int> check2;

void __cpyvec(vector<int> a, vector<int>* b)
{
    for(int i = 0; i < a.size(); i++) b->push_back(a[i]);
}

void read()
{
    cin >> n >> k >> x;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            cin >> a[i][j];
        }
    }
}

bool solve3(vector<int> a, vector<int> b)
{
    int cnt = 0;
    for(int i = 0; i < a.size(); i++)
    {
        if(i+1 > a.size()) break;

        if(__gcd(a[i], b[i]) == __gcd(a[i + 1], b[i + 1]) && __gcd(a[i], b[i]) == k)
        {
            cnt++;
        }
    }
    return cnt == a.size()-1;
}

void solve2(vector<int> v)
{
    sort(v.begin(), v.end());
    do
    {
        __cpyvec(v, &check1);
#ifdef _DEBUG
        cout << "FIRST PERMUTATION : ";
        for(int i = 0; i < check1.size(); i++)
        {
            cout << check1[i] << ' ';
        }
        cout << endl;
#endif // _DEBUG
        next_permutation(v.begin(), v.end());

        __cpyvec(v, &check2);
#ifdef _DEBUG
        cout << "SECOND PERMUTATION : ";
        for(int i = 0; i < check2.size(); i++)
        {
            cout << check2[i] << ' ';
        }
        cout << endl;
#endif // _DEBUG

        if(solve3(check1, check2))
        {
            for(int i = 0; i < check1.size(); i++)
            {
                cout << check1[i] << ' ';
            }
            cout << endl;
            break;
        }
        check1.clear();
        check2.clear();
    }while(next_permutation(v.begin(), v.end()));
}


void solve()
{
    vector<int> v;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            v.push_back(a[i][j]);
        }
        solve2(v);
        v.clear();
    }
}

int main()
{
#ifndef _LOCALTEST
    int T;
    cin >> T;
    while(T--)
    {
        read();
    }
#else
    n = 3;
    k = 2;
    x = 1;
    a[0][0] = 2;
    a[0][1] = 6;
    a[0][2] = 4;

#endif // _LOCALTEST
    solve();
}

/*
1
3 2 1
2 6 4
4 2 3
*/
