#include <iostream>
#include <vector>
#define MAX_N 1004
using namespace std;

int  n, m, k;
vector<vector<int>> graf;
int friends[MAX_N];
int days;
int help;

void visit(int start, int target)
{
    days++;
    if(start==target)
    {
        return;
    }
    help=graf[start][0];
    graf[start].erase(graf[start].begin()+0);
    graf[start].push_back(help);
    visit(help, target);
}

int main()
{
    cin >> n >> m;
    graf.resize(n+1);
    int s;
    for(int i=1; i<=n; i++)
    {
        cin >> k;
        graf[i].resize(k);
        for(int j=0; j<k; j++)
        {
            cin >> graf[i][j];
        }
    }
    for(int i=1; i<=m; i++)
    {
        cin >> friends[i];
    }
    s=1;
    for(int i=1; i<=m; i++)
    {
        visit(s, friends[i]);
        s=graf[friends[i]][0];
        graf[friends[i]].erase(graf[friends[i]].begin()+0);
        graf[friends[i]].push_back(s);
    }

    cout << days;

    return 0;
}
