#include <iostream>
#include <vector>
#define MAX_M 100005
using namespace std;

vector <pair<int, int>> nums;
vector <pair<int, int>> primes;
vector <pair<int, int>> devide;
long long maxnum=1e9;
int used[MAX_M];
int n, k, x;


void eratosten()
{
    used[0]=0;
    used[1]=0;
    for(int i=2; i<MAX_M; i++)
    {
        if(used[i]==0)
        {
            primes.push_back({i, 1});
            for(int j=i*2; j<MAX_M; j+=i)
            {
                used[j]++;

            }
        }
    }
}
void fill_primes_2()
{
    int insize=primes.size();
    bool t;
    for(int i=MAX_M; i<=1e9; i++)
    {
        t=false;
        for(int j=0; j<insize; j++)
        {
            if(i%primes[j].first==0)
            {
                t=true;
                break;
            }
        }
        if(!t)
        {
            primes.push_back({i,1});
        }
    }
}
void fill_primes()
{
    int insize=primes.size();

    for(int i=0; i<insize; i++)
    {
        for(long long j=primes[i].first*primes[i].first; j<=maxnum; j*=primes[i].first)
        {
            primes.push_back({j, primes[i].first});
        }
    }
}

void fill_devide()
{
    int counter;
    for(int i=0; i<primes.size(); i++)
    {
        counter=0;
        for(int j=0; j<nums.size(); j++)
        {
            if(nums[j].first%primes[i].first==0)
            {
                counter++;
            }
        }
        if(counter<k)
        {
            devide.push_back(primes[i]);
        }
    }
}

void new_nums()
{
    for(int i=0; i<nums.size(); i++)
    {
        nums[i].second=1;
        for(int j=0; j<devide.size(); j++)
        {
            if(nums[i].first%devide[j].first==0)
            {
                if(devide[j].second==1)
                {
                    nums[i].second=nums[i].second*devide[j].first;
                }
                else
                {
                    nums[i].second=nums[i].second*devide[j].second;
                }
            }
        }
    }
    for(int i=0; i<nums.size(); i++)
    {
        nums[i].first=nums[i].first/nums[i].second;
    }
}

void sort_nums()
{
    for(int i=0; i<nums.size(); i++)
    {
        for(int j=i+1; j<nums.size(); j++)
        {
            if(nums[i].first==nums[j].first && nums[i].second > nums[j].second)
            {
                swap(nums[i], nums[j]);
            }
        }
    }
}
void print_nums()
{
    for(int i=0; i<nums.size(); i++)
    {
        cout << nums[i].first*nums[i].second << " ";
    }
    cout << endl;
}

int main()
{
    int q;
    cin >> q;

    eratosten();
    fill_primes_2();
    fill_primes();

    for(int i=0; i<q; i++)
    {
        cin >> n >> k >> x;
        nums.clear();
        devide.clear();
        nums.resize(n);
        for(int i=0; i<n; i++)
        {
            cin >> nums[i].first;
        }
        fill_devide();
        //cout << "*";
        new_nums();
        /*for(int i=0; i<n; i++)
        {
            cout << nums[i].first << " " << nums[i].second << endl;
        }*/
        //cout << "#";
        sort_nums();
        //cout << "^^";
        print_nums();

    }


    return 0;
}
