#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 50;

vector <int> friendLocations;
class Graph
{
private:
    int N;
    deque <int> graph[MAXN];
public:
    Graph(){}
    Graph(int N)
        :N(N){}

    void AddEdge(int u, int v)
    {
        graph[u].push_back(v);

    }

    int Solve(int currNode, int visitedFriends)
    {

        if (visitedFriends == friendLocations.size())
            return 0;

        bool canVisit = (friendLocations[visitedFriends] == currNode);

        int nextNode = graph[currNode].front();
        graph[currNode].pop_front();
        graph[currNode].push_back(nextNode);

        return Solve(nextNode, visitedFriends+canVisit) + 1;

    }
};
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int N, M;
    cin >> N >> M;

    Graph *graph = new Graph(N);

    for (int i = 1; i <= N; i++)
    {
        int k;
        cin >> k;

        for (int j = 0; j < k; j++)
        {
            int neighbour;
            cin >> neighbour;

            graph->AddEdge(i, neighbour);
        }
    }

    for (int i = 0; i < M; i++)
    {
        int townLocation;
        cin >> townLocation;

        friendLocations.push_back(townLocation);
    }

    cout << graph->Solve(1, 0) << endl;

    return 0;
}
