#include <bits/stdc++.h>
#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__
#include "game.h"
#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 50;
bool isWinnable[MAXN];

void FillArray(int n, int d, int pos, bool direction)
{
    if (pos < 0 || pos >= n)
        return;

    isWinnable[pos] = 0;

    if (direction == 0)
    {
        int lowerBound = max(pos-d, 0);
        for (int i = pos-1; i >= lowerBound; i--)
        {
            isWinnable[i] = 1;
        }

        FillArray(n, d, lowerBound-1, direction);
    }

    if (direction == 1)
    {
        int upperBound = min(pos+d, n-1);
        for (int i = pos+1; i <= upperBound; i++)
        {
            isWinnable[i] = 1;
        }

        FillArray(n, d, upperBound+1, direction);
    }
}
void init(std::vector<int> A, int D)
{
    for (int i = 0; i < MAXN; i++)
        isWinnable[i] = true;

    int maxValue = INT_MIN, maxPos = 0;

    for (int i = 0; i < A.size(); i++)
    {
        if (A[i] > maxValue)
        {
            maxValue = A[i];
            maxPos = i;
        }
    }

    FillArray(A.size(), D, maxPos, 0);
    FillArray(A.size(), D, maxPos, 1);
}

void updateValue(int index, int newValue)
{

}

bool isWinning(int startIndex)
{
    return isWinnable[startIndex];
}
