#include <bits/stdc++.h>
#ifdef __LOCAL__
    #include "Lgrader.cpp"
#endif // __LOCAL__
#include "game.h"
#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 50;
int N, d;
bool isWinnable[MAXN];
bool used[MAXN];

int arr[MAXN];
struct ArrayElement
{
    int val, pos;
    ArrayElement(){}
    ArrayElement(int val, int pos)
        :val(val), pos(pos){}

    bool operator< (const ArrayElement &other)
    {
        return val > other.val;
    }
};

void FillNeighbours(int pos, int n, int d)
{
    int lowerBound = max(0, pos-d);
    int upperBound = min(n-1, pos+d);

    used[pos] = true;
    for (int i = pos+1; i <= upperBound; i++)
    {
        if (used[i])
            break;

        used[i] = true;
        isWinnable[i] = true;
    }

    for (int i = pos-1; i >= lowerBound; i--)
    {
        if (used[i])
            break;

        used[i] = true;
        isWinnable[i] = true;
    }
}
vector <ArrayElement> elements;
void init(std::vector<int> A, int D)
{
    for (int i = 0; i < A.size(); i++)
    {
        elements.emplace_back(A[i], i);
    }

    N = A.size();
    d = D;

    sort(elements.begin(), elements.end());

    for (ArrayElement element:elements)
    {
        if (used[element.pos])
            continue;

        isWinnable[element.pos] = false;
        FillNeighbours(element.pos, N, d);
    }
}

void updateValue(int index, int newValue)
{

}

bool isWinning(int startIndex)
{
    return isWinnable[startIndex];
}
