#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 1e5+50;
int N, K, X;
pair <int, int> original[MAXN];

int arr[MAXN];
bool used[MAXN];
bool hasAnswer;
vector <int> ans;

int br;
bool check(int pos, vector <int>& sequence, int curr_gcd, int orig_gcd, int used)
{
    if (br > N+5)
        return true;

    if (used == K)
    {
        br++;
        return curr_gcd==orig_gcd;
    }

    bool res = true;
    for (int i = pos+1; i < N; i++)
    {
        res &= check(i, sequence, __gcd(curr_gcd, sequence[i]), __gcd(orig_gcd, arr[i]), used+1);
    }

    return res;
}
void gen(int pos, vector<int>& sequence, int curr_gcd, int orig_gcd)
{
    if (hasAnswer)
        return;

    if (pos == N)
    {
        br = 0;
        if (check(-1, sequence, 0, 0, 0) == true)
        {
            ans = sequence;
            hasAnswer = true;
        }
        return;
    }

    int new_orig_gcd = __gcd(orig_gcd, arr[pos]);

    for (int i =0; i < N; i++)
    {
        if (used[original[i].second])
            continue;

        int new_curr_gcd = __gcd(curr_gcd, original[i].first);
            //cout << new_curr_gcd << " " << new_orig_gcd << endl;

        if (new_curr_gcd != new_orig_gcd)
            continue;

        used[original[i].second] = true;
        sequence[pos] = original[i].first;
        gen(pos+1, sequence, curr_gcd, orig_gcd);
        used[original[i].second] = false;
    }
}

void genFirstK(int pos, vector<int>& sequence , int curr_gcd, int orig_gcd)
{
    if (pos == K-1)
    {
        gen(pos, sequence, curr_gcd, orig_gcd);

        return;
    }

    orig_gcd = __gcd(orig_gcd, arr[pos]);
    for (int i = 0; i < N; i++)
    {

        if (used[original[i].second])
            continue;

        int new_gcd = __gcd(curr_gcd, original[i].first);


        used[original[i].second] = true;

        sequence[pos] = original[i].first;
        genFirstK(pos+1, sequence, new_gcd, orig_gcd);

        used[original[i].second] = false;
    }
}



void Solve()
{
    cin >> N >> K >> X;

    for (int i = 0; i < N; i++)
    {
        cin >> original[i].first;
        arr[i] = original[i].first;
        original[i].second = i;
    }

    sort(original, original+N);
    ans.clear();
    memset(used, false, sizeof(used));
    hasAnswer = false;
    vector <int> sequence(N);
    genFirstK(0, sequence, 0, 0);

    cout << ans[0];

    for (int i = 1; i < N; i++)
        cout << " " << ans[i];

    cout << endl;

}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int T;
    cin >> T;

    while (T--)
    {
        Solve();
    }

    return 0;
}

/*
3
4 2 1
21 3 6 9
3 2 1
2 6 4
3 2 1
8 2 4
*/
