#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 5 * 1e5 + 1;
vector<int> neighbors[MAXN];
int counter[MAXN];
int coord[MAXN];
int travel(int curr, int nex, int m) {
    if (coord[nex] == curr) {
        nex++;
    }
    if (nex > m) {
        return 1;
    }
    int visit = neighbors[curr][counter[curr]];
    counter[curr]++;
    counter[curr] %= neighbors[curr].size();
    return 1 + travel(visit, nex, m);
}
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        for (int j = 1; j <= k; j++) {
            neighbors[i].push_back(0);
            cin >> neighbors[i][j - 1];
        }
        counter[i] = 0;
    }
    for (int i = 1; i <= m; i++) {
        cin >> coord[i];
    }
    cout << travel(1, 1, m) << '\n';
}
void XLR8() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
int main() {
    XLR8();
    solve();
    return 0;
}
