#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 5 * 1e5 + 1;
vector<int> neighbors[MAXN];
int counter[MAXN];
int par_ind[MAXN];
int standard[MAXN];
void dfs(int curr, int prev) {
    standard[curr] = 1;
    for (int i = 0; i < neighbors[curr].size(); i++) {
        if (neighbors[curr][i] != prev) {
            dfs(neighbors[curr][i], curr);
            standard[curr] += standard[neighbors[curr][i]] + 1;
        } else {
            par_ind[curr] = i;
        }
    }
}
int time(int curr, int m) {
    if (m == 0) {
        return 0;
    }
    if (m == 1) {
        return 1;
    }
    if (m >= 1 + neighbors[curr].size() - (curr != 1) && counter[curr] == ((par_ind[curr] + 1) % neighbors[curr].size())) {
        return (m / (1 + neighbors[curr].size() - (curr != 1))) * standard[curr] + time(curr, m % (1 + neighbors[curr].size() - (curr != 1)));
    }
    int t = 0;
    m--;
    while (m > 0 && counter[curr] != par_ind[curr]) {
        int nex = neighbors[curr][counter[curr]];
        t += time(nex, par_ind[nex] - counter[nex] + 1 + neighbors[nex].size() * (par_ind[nex] - counter[nex] + 1 <= 0));
        m -= 1;
        counter[curr]++;
        counter[curr] %= neighbors[curr].size();
    }
    return t + time(curr, m);
}
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        for (int j = 1; j <= k; j++) {
            neighbors[i].push_back(0);
            cin >> neighbors[i][j - 1];
        }
    }
    for (int i = 1; i <= m; i++) {
        int k;
        cin >> k;
    }
    dfs(1, 0);
    cout << time(1, m);
}
void XLR8() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
int main() {
    XLR8();
    solve();
    return 0;
}
