#include<bits/stdc++.h>
#include "game.h"
using namespace std;

vector<int> A;
vector<int> pos;
vector<int> segment;
int d,n;
bool cmp(int lhs,int rhs)
{
    return A[lhs]>A[rhs];
}
void build()
{
    segment.assign(n,-1);
    sort(pos.begin(),pos.end(),cmp);
    for(int i=0; i<n; i++)
    {
        if(segment[pos[i]]!=-1) continue;
        for(int j=max(0,pos[i]-d); j<min(n,pos[i]+d+1); j++)
        {
            if(segment[j]!=-1) continue;
            segment[j]=pos[i];
        }
    }
}
void init(std::vector<int> As, int Ds)
{
    A=As;
    A.push_back(-1);
    d=Ds;
    n=As.size();

    for(int i=0; i<=n; i++)
    {
        pos.push_back(i);
    }
    build();
}
void fillGap(int l,int r)
{
    int max_id=l;
    for(int i=l+1; i<=r; i++)
    {
        if(A[i]>A[max_id]) max_id=i;
    }
    for(int i=l; i<=r; i++) segment[i]=max_id;
}
void updateValue(int index, int newValue)
{
    int oldValue=A[index];
    A[index]=newValue;

    /// changing seg leader
    if(segment[index]==index)
    {
        if(newValue<oldValue)
        {
            int max_id=index;
            for(int i=index-1; i>=0; i--)
            {
                if(segment[i]!=index)break;
                if(A[i]>newValue) max_id=i;
            }
            for(int i=index+1; i<n; i++)
            {
                if(segment[i]!=index)break;
                if(A[i]>newValue) max_id=i;
            }
            if(max_id!=index)
            {
                build();
            }
            else
            {
                int lSeg=-1,lB=0;
                for(int i=index-1; i>=0; i--)
                {
                    if(segment[i]!=index)
                    {
                        lSeg=segment[i];
                        lB=i+1;
                    }
                }
                if(lSeg!=-1&&A[lSeg]>newValue)
                {
                    for(int i=lB; i<lSeg+d+1; i++) segment[i]=lSeg;
                }
                int rSeg=-1,rB=n-1;
                for(int i=index+1; i<=n; i++)
                {
                    if(segment[i]!=index)
                    {
                        rSeg=segment[i];
                        rB=i-1;
                    }
                }
                if(rSeg!=-1&&A[rSeg]>newValue)
                {
                    for(int i=rB; i>rSeg-d-1; i++) segment[i]=rSeg;
                }
            }
        }
        else
        {
            vector<pair<int,bool>> deadSeg;
            // right creep
            for(int i=index+1; i<min(n,index+d+1); i++)
            {
                if(A[segment[i]]>A[index]) break;
                if(segment[i]==i) deadSeg.push_back({i,1});
                segment[i]=index;
            }
            // left creep
            for(int i=index-1; i>=max(0,index-d); i--)
            {
                if(A[segment[i]]>A[index]) break;
                if(segment[i]==i) deadSeg.push_back({i,0});
                segment[i]=index;
            }
            for(auto dseg:deadSeg)
            {
                // take from right
                if(dseg.second)
                {
                    int leftB=-1, rightB=n, rSeg=-1;
                    for(int i=dseg.first; i<n; i++)
                    {
                        if(leftB==-1&&segment[i]==dseg.first)
                        {
                            leftB=i;
                        }
                        if(leftB!=-1&&segment[i]!=dseg.first)
                        {
                            rSeg=segment[i];
                            rightB=i;
                        }
                    }
                    if(rSeg==-1)continue;
                    for(int i=rightB-1; i>=leftB&&i>=rSeg-d; i--)
                    {
                        segment[i]=rSeg;
                    }
                    fillGap(leftB,min(rightB,rSeg-d-1));
                }
                // take from left
                else
                {
                    int leftB=-1, rightB=n, lSeg=-1;
                    for(int i=dseg.first; i>=0; i--)
                    {
                        if(rightB==n&&segment[i]==dseg.first)
                        {
                            rightB=i+1;
                        }
                        if(rightB!=n&&segment[i]!=dseg.first)
                        {
                            leftB=i+1;
                            lSeg=segment[i];
                        }
                    }
                    if(lSeg==-1)continue;
                    for(int i=leftB; i<rightB&&i<lSeg+d+1; i++)
                    {
                        segment[i]=lSeg;
                    }
                    fillGap(max(lSeg+d+1,leftB),rightB);
                }
            }
        }
    }
    else   /// changing seg member
    {
        // stop if new cant take over
        if(newValue<A[segment[index]]) return;
        int oldSeg=segment[index];
        segment[index]=index;
        vector<pair<int,bool>> deadSeg;
        // right creep
        for(int i=index+1; i<min(n,index+d+1); i++)
        {
            if(A[segment[i]]>A[index]) break;
            if(segment[i]==i) deadSeg.push_back({i,1});
            segment[i]=index;
        }
        // left creep
        for(int i=index-1; i>=max(0,index-d); i--)
        {
            if(A[segment[i]]>A[index]) break;
            if(segment[i]==i) deadSeg.push_back({i,0});
            segment[i]=index;
        }
        for(auto dseg:deadSeg)
        {
            // take from right
            if(dseg.second)
            {
                int leftB=-1, rightB=n, rSeg=-1;
                for(int i=dseg.first; i<n; i++)
                {
                    if(leftB==-1&&segment[i]==dseg.first)
                    {
                        leftB=i;
                    }
                    if(leftB!=-1&&segment[i]!=dseg.first)
                    {
                        rSeg=segment[i];
                        rightB=i;
                    }
                }
                if(rSeg==-1)continue;
                for(int i=rightB-1; i>=leftB&&i>=rSeg-d; i--)
                {
                    segment[i]=rSeg;
                }
                fillGap(leftB,min(rightB,rSeg-d-1));
            }
            // take from left
            else
            {
                int leftB=-1, rightB=n, lSeg=-1;
                for(int i=dseg.first; i>=0; i--)
                {
                    if(rightB==n&&segment[i]==dseg.first)
                    {
                        rightB=i+1;
                    }
                    if(rightB!=n&&segment[i]!=dseg.first)
                    {
                        leftB=i+1;
                        lSeg=segment[i];
                    }
                }
                if(lSeg==-1)continue;
                for(int i=leftB; i<rightB&&i<lSeg+d+1; i++)
                {
                    segment[i]=lSeg;
                }
                fillGap(max(lSeg+d+1,leftB),rightB);
            }
        }
    }
}
bool isWinning(int startIndex)
{

    return (segment[startIndex]!=startIndex);
}