#include <bits/stdc++.h>

using namespace std;

void speed()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

template<typename T>
struct Element
{
    Element<T>* next;
    T val;
    Element<T>()
    {
        next=nullptr;
    }
    Element<T>(T _val)
    {
        val=_val;
        next=nullptr;
    }

};

template<typename T>
class Queue
{
private:
    Element<T> *fr, *bk;
    int sz;
public:
    void push(T val)
    {

        sz++;
        if(bk==nullptr)
        {
            fr=new Element<T>(val);
            bk=fr;
        }
        else
        {
            Element<T> *p=new Element<T>(val);
            bk->next=p;
            bk=p;
        }
        //cout<<"PUSHED "<<val<<endl;
    }
    void pop()
    {
        sz--;
        if(fr==bk)
        {
            delete(fr);
            fr=nullptr;
            bk=nullptr;
            return;
        }
        Element<T> *p=fr;
        fr=fr->next;
        delete(p);
        //cout<<"POPPED"<<endl;
    }
    T get_front()
    {
        //cout<<"GOT FRONT "<<fr->val<<endl;
        return fr->val;
    }
    int get_size(){return sz;}
};


int n, m;
const int MAXN=5*(1e5)+5;
Queue<int>v[MAXN];
int p;
void read()
{
    cin>>n>>m;
    int k;
    int ver;
    for(int i=1;i<=n;i++)
    {
        cin>>k;
        while(k--)
        {
            cin>>ver;
            v[i].push(ver);
        }
    }
    for(int i=1;i<=m;i++)
    {
        cin>>p;
    }
}

long long t=0;int fr=0;

void dfs(int beg=1, bool st=1)
{
    //cout<<"AT VERTEX "<<beg<<endl;
    t++;
    if(beg==1)
    {
        fr++;
    }
    if(fr==m)return;
    int nb=v[beg].get_front();
    v[beg].pop();
    v[beg].push(nb);
    dfs(nb, 0);
}

void solve()
{
    dfs();
    cout<<t<<endl;
    //cout<<t*(m-1)+1<<endl;
}

int main()
{
    speed();
    read();
    solve();
    return 0;
}
