#include <bits/stdc++.h>
#include "game.h"
using namespace std;


vector<int>a;int n, d;
vector<pair<int, int>>local_maxima;

void build_local_maxima()
{
    local_maxima.clear();
    deque<pair<int, int>>dq;
    for(int i=0;i<n;i++)
    {
        if(dq.empty())
        {
            dq.push_back({i, a[i]});
        }
        else
        {
            pair<int, int>_fr=dq.back();
            while(!dq.empty())
            {
                _fr=dq.back();
                if(_fr.second<a[i])
                {
                    dq.pop_back();
                }
                else
                {
                    if(i-_fr.first>=d)
                    {
                        dq.push_back({i, a[i]});
                    }
                    break;
                }
            }
            if(dq.empty())
            {
                dq.push_back({i, a[i]});
            }
            pair<int, int>_back=dq.front();
            if(_back.first<i-d)
            {
                local_maxima.push_back(_back);
                dq.pop_front();
            }
        }
    }
    while(!dq.empty())
    {
        pair<int, int>_back=dq.front();
        local_maxima.push_back(_back);
        dq.pop_front();
    }
    int sz=local_maxima.size()-1;

}

bool isWinning(int startIndex)
{
    int l=0, r=local_maxima.size()-1;
    while(l<=r)
    {
        int m=(l+r)/2;
        if(local_maxima[m].first>startIndex)
        {
            r=m-1;
        }else l=m+1;
    }
    int d1=-1, d2=-1;
    if(l<local_maxima.size())
    {
        d1=abs(startIndex-local_maxima[l].first);
        //cout<<"L"<<": "<<local_maxima[l].first;
    }
    if(r>0)
        {
        d2=abs(startIndex-local_maxima[r].first);
        //cout<<"R"<<": "<<local_maxima[r].first;
    }
    if(d1==-1)
    {
         return (d2%d==0);
    }
    else if(d2==-1)
    {
         return (d1%d==0);
    }
    else
    {
        return ((d1%d==0)||(d2%d==0));
    }

}

void updateValue(int index, int newValue)
{
    a[index]=newValue;
    build_local_maxima();
}

void init(std::vector<int>A, int D)
{
    a=A;
    n=A.size();
    d=D;
    build_local_maxima();
}
