#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=5e5+5;
const int MAXM=5e5+5;

int n,m;
vector<int> adj[MAXN];
int p[MAXM];
int ptr[MAXN];
int fPtr=0;
int cnt=0;
queue<pair<long long,int> > q;
unordered_map<long long, int> mp;

long long getState(int v,int x)
{
    return (long long)v*MAXN+x;
}

void dfs(int v)
{
    for(;;)
    {
        cnt++;
        if(v==p[fPtr])
        {
            fPtr++;
            while(!q.empty())
            {
                auto cur=q.front();
                int diff=cnt-cur.second;
                mp[cur.first]=diff;
                q.pop();
            }
        }
        if(fPtr>=m) break;
        if(ptr[v]>=adj[v].size()) ptr[v]=0;
        int nxt=adj[v][ptr[v]++];
        long long state=getState(nxt, ptr[nxt]);
        int t=mp[state];
        if(t)
        {
            cnt+=t;
            while(!q.empty())
            {
                auto cur=q.front();
                int diff=cnt-cur.second;
                mp[cur.first]=diff;
                q.pop();
            }
            v=1;
            ptr[1]++;
            cnt--;
        }
        else v=nxt;
    }
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;
for(int i=1;i<=n;i++)
{
    int k;
    cin>>k;
    for(int j=0;j<k;j++)
    {
        int v;
        cin>>v;
        adj[i].push_back(v);
    }
}
for(int i=0;i<m;i++)
{
    cin>>p[i];
}

dfs(1);

cout<<cnt<<endl;

return 0;
}
