/**
  * Gledam tozi do men kak bavno otvarq gazirana voda, koqto e na mnogo malko ot tova da grumne.
  * Zabavno e.
  */
#include <bits/stdc++.h>
using namespace std;

int n, m;
vector<int> k;
vector<bool> goRight;
vector<vector<int>> G;
vector<int> p;

int main(){
    #ifndef IATI_LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    #endif

    cin >> n >> m;
    k.resize(n+1);
    G.resize(n+1);
    goRight.resize(n+1);
    int twoEnds[2]; int eIdx = 0;
    for(int i = 1; i <= n; i++){
        cin >> k[i];
        if(k[i] == 1){ twoEnds[eIdx++] = i; }
        G[i].resize(k[i]);
        for(int j = 0; j < k[i]; j++){
            cin >> G[i][j];
        }
    }
    int ending = min(twoEnds[0], twoEnds[1]);
    p.resize(m);
    for(int i = 0; i < m; i++){
        cin >> p[i];
    }

    /// linearise
    vector<int> lin;
    int oneIdx = n-1;
    int curr = ending;
    goRight[0] = true;
    while(curr != -1){
        lin.push_back(curr);
        if(lin.size() > 1){
            int prev = lin[lin.size()-2];
            goRight[prev] = (G[prev][0] == curr);
//            cout << prev << ' ' << goRight[prev] << '\n';
        }
        if(curr == 1){ oneIdx = lin.size()-1; }
        int idx = 0;
        if(lin[lin.size()-2] == G[curr][idx]){ idx++; }
        if(k[curr] == 1 && curr != ending){ curr = -1; continue; }
        curr = G[curr][idx];
    }
    ///

//    for(int i = 0; i < n; i++){
//        cout << lin[i] << ' ';
//    } cout << '\n';
//    for(int i = 0; i < n; i++){
//        cout << (goRight[lin[i]]?'>':'<') << ' ';
//    }cout << '\n';
//    cout << oneIdx << '\n';

    vector<vector<int>> dp(n);
    dp[0] = {0};
    for(int i = 1; i < oneIdx; i++){
        for(int j = 0; j < (1<<i); j++){
            if(j%2 == goRight[lin[i]]){
                dp[i].push_back(0);
            }else{
                dp[i].push_back(dp[i-1][j/2] + 2);
            }
        }
    }
    dp[n-1] = {0};
    for(int i = n-2; i > oneIdx; i--){
        for(int j = 0; j < (1 << (n-i-1)); j++){
            if(j%2 == goRight[lin[i]]){
                dp[i].push_back(0);
            }else{
                dp[i].push_back(dp[i+1][j/2] + 2);
            }
        }
    }

//    for(int i = 0; i < n; i++){
//        for(int j = 0; j < dp[i].size(); j++){
//            cout << dp[i][j] << ' ';
//        }
//        cout << '\n';
//    } cout << '\n';

    int pc = m-1;
    int li = 0, ri = 0;
    int cnt = 0;
    while(pc){
        if(goRight[1] == false){
            cnt += dp[oneIdx-1][li++] + 2;
            li %= dp[oneIdx-1].size();
        }else{
            cnt += dp[oneIdx+1][ri++] + 2;
            ri %= dp[oneIdx+1].size();
        }
        goRight[1] = !goRight[1];
        pc--;
//        cnt++;
    }

//    int frIdx = 0;
//    int currIdx = oneIdx;
//    int cnt = 0;
//    while(frIdx < m){
//        cout << lin[currIdx] << ' ';
//        if(p[frIdx] == lin[currIdx]){
//            frIdx++;
//        }
//
//        int change = goRight[lin[currIdx]]?1:-1;
//        if(k[lin[currIdx]] == 2){ goRight[lin[currIdx]] = !goRight[lin[currIdx]]; }
//        currIdx += change;
//        cnt++;
//    }
//    cout << '\n';

    cout << cnt << '\n';
    return 0;
}
