/**
  * Taka i ne mi potrqbva tozi razshiren evklid
  */
#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;

int eea(int a, int b, int& x, int& y){ /// otnovo nazubren za nishto :(
    if(a == 0){
        x = 0;
        y = 1;
        return b;
    }
    int x1, y1;
    int d = eea(b%a, a, x1, y1);
    x = y1 - (b/a)*x1;
    y = x1;
    return d;
}

int gcd(int a, int b){
    if(a == 0){ return b; }
    return gcd(b%a, a);
}

vector<vector<int>> genIdxs(int start, int n, int k){
    if(k == 0){ return {{}}; }
    vector<vector<int>> res;
    for(int i = start; i <= n-k; i++){
        vector<vector<int>> coord = genIdxs(i+1, n, k-1);
        for(vector<int>& vr : coord){
            vr.push_back(i);
            res.push_back(vr);
        }
    }
    return res;
}

vector<int> solve(int n, int k, int x, vector<int> a){
//    int totalGcd = a[0];
//    for(int i = 1; i < n; i++){ totalGcd = gcd(totalGcd, a[i]); }

    vvi pos = genIdxs(0, n, k);
    vi b(a.begin(), a.end());
    sort(b.begin(), b.end());
    while(true){
        bool isOk = true;
        for(int i = 0; i < pos.size(); i++){
//            for(int p : pos[i]){ cout << p << ' '; } cout << '\n';
//            for(int p : b){ cout << p << ' '; } cout << '\n';
            int aGcd = a[pos[i][0]];
            int bGcd = b[pos[i][0]];
            for(int j = 1; j < pos[i].size(); j++){
                aGcd = gcd(aGcd, a[pos[i][j]]);
                bGcd = gcd(bGcd, b[pos[i][j]]);
            }
//            cout << aGcd << ' ' << bGcd << '\n';
            if(aGcd != bGcd){ isOk = false; break; }
        }
        if(isOk){ return b; }
        bool np = next_permutation(b.begin(), b.end());
        if(!np){ return a; }
    }
}

int main(){
//    vvi pos = genIdxs(0, 5, 2);
//    for(int i = 0; i < pos.size(); i++){
//        for(int j = 0; j < pos[i].size(); j++){
//            cout << pos[i][j] << ' ';
//        }
//        cout << '\n';
//    }


    int T;
    cin >> T;
    vector<int> a;
    for(int t = 1; t <= T; t++){
        int n, k, x;
        cin >> n >> k >> x;
        a.resize(n);
        for(int i = 0; i < n; i++){ cin >> a[i]; }
        vector<int> sol = solve(n, k, x, a);
        for(int i = 0; i < n; i++){
            cout << sol[i];
            if(i != n-1){ cout << ' '; }
        }
        cout << '\n';
    }
    return 0;
}
