#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = 5e5 + 10;

ll n, m, f[maxn];
vector < ll > adj[maxn], child[maxn];
void input()
{
    cin >> n >> m;
    for (ll i = 1; i <= n; i ++)
    {
        ll k;
        cin >> k;
        for (ll j = 0; j < k; j ++)
        {
            ll x;
            cin >> x;
            adj[i].push_back(x);
        }
    }
    for (ll i = 1; i <= n; i ++)
        cin >> f[i];
}

ll tin[maxn], tout[maxn], timer;
ll ord[2 * maxn], par[maxn];
vector < ll > occ[maxn];
void dfs(ll v, ll p)
{
    tin[v] = ++ timer;
    ord[timer] = v;
    par[v] = p;
    occ[v].push_back(timer);
    if (p != -1)
    {
        ll id = 0;
        while(adj[v][id] != p)
            id ++;
        ll sz = adj[v].size();
        for (ll i = id + 1; i < sz; i ++)
        {
            child[v].push_back(adj[v][i]);
        }
        for (ll i = 0; i < id; i ++)
        {
            child[v].push_back(adj[v][i]);
        }
    }
    else
    {
        child[v] = adj[v];
    }

    ///cout << "Vertex " << v << " " << child[v].size() << endl;
    for (ll u : child[v])
    {
        dfs(u, v);

        ord[++ timer] = v;
        occ[v].push_back(timer);
    }


    tout[v] = timer;
}

ll act[maxn];

vector < ll > get_free;
set < ll > to_take[maxn];

ll fen[2 * maxn];
void add(ll id, ll v)
{
    for (ll i = id; i <= timer; i += (i & -i))
    {
        fen[i] += v;
    }
}

ll sum(ll id)
{
    ll s = 0;
    for (ll i = id; i > 0; i -= (i & -i))
        s += fen[i];
    return s;
}

void is_valid(ll id)
{
    if (!(id >= 1 && id < timer))
        return;
    if (act[ord[id]] && act[ord[id - 1]])

    {
        if (to_take[ord[id]].count(id))
            return;
            ///cout << "to add " << id << endl;
        add(id, 1);
        to_take[ord[id]].insert(id);
    }
}
void get_active(ll v)
{
    act[v] = 1;
    for (ll i : occ[v])
    {
//cout << "check " << i << " " << i + 1 << endl;
        is_valid(i);
        is_valid(i + 1);
    }
    bool over = false;
    for (ll u : adj[v])
    {
        if (u == par[v]) /// !!!
        {
            over = true;
            continue;
        }
        if (over)
        {
            get_free.push_back(u);
        }
        else
            get_active(u);
    }
}
void simulate()
{  act[0] = 1;
        get_active(1);
    /// skip 1
    ll pivot = 1;
    ll last_day = 0;
    while(true)
    {
        /**for (ll i = 1; i <= timer - 1; i ++)
        {
            if (act[ord[i]] && (i == 1 ||  act[ord[i - 1]]))
                cout << ord[i] << " ";
        }
        cout << endl;*/
        //cout << "------------" << endl;
        assert(act[ord[1]] == 1 && ord[1] == 1);
        int ls = 0;
        while(true)
        {
            set < ll > :: iterator it = to_take[f[pivot]].upper_bound(ls);
            if (it == to_take[f[pivot]].end())
                break;
            ls = *it;
            pivot ++;
        }
        /**for (ll i = 1; i <= timer - 1 && pivot <= m; i ++)
        {
             if (!(act[ord[i]] && act[ord[i - 1]]))
                continue;
                //cout << "here " << i << endl;
            ///last_day ++;
            if (f[pivot] == ord[i])
                pivot ++, ls = i;
        }*/

        if (pivot > m)
        {
            last_day = last_day + sum(ls);
            break;
        }


        last_day = last_day + sum(timer - 1);
        ///cout << last_day << endl;
            vector < ll > vec = get_free;
        get_free.clear();
        for (ll v : vec)
            get_active(v);
    }

    cout << last_day << endl;
}
void solve()
{
    input();
    dfs(1, -1);
    simulate();
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
4 4
2 2 3
1 1
2 1 4
1 3
2 1 1 4
*/
