#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const int maxn = 5e5 + 10;

int n, m, f[maxn];
vector < int > adj[maxn], child[maxn];
void input()
{
    cin >> n >> m;
    for (int i = 1; i <= n; i ++)
    {
        int k;
        cin >> k;
        for (int j = 0; j < k; j ++)
        {
            int x;
            cin >> x;
            adj[i].push_back(x);
        }
    }
    for (int i = 1; i <= n; i ++)
        cin >> f[i];
}

int tin[maxn], tout[maxn], timer;
int ord[2 * maxn], par[maxn];
vector < int > occ[maxn];
void dfs(int v, int p)
{
    tin[v] = ++ timer;
    ord[timer] = v;
    par[v] = p;
    occ[v].push_back(timer);
    if (p != -1)
    {
        int id = 0;
        while(adj[v][id] != p)
            id ++;
        int sz = adj[v].size();
        for (int i = id + 1; i < sz; i ++)
        {
            child[v].push_back(adj[v][i]);
        }
        for (int i = 0; i < id; i ++)
        {
            child[v].push_back(adj[v][i]);
        }
    }
    else
    {
        child[v] = adj[v];
    }

    ///cout << "Vertex " << v << " " << child[v].size() << endl;
    for (int u : child[v])
    {
        dfs(u, v);

        ord[++ timer] = v;
        occ[v].push_back(timer);
    }


    tout[v] = timer;
}

int act[maxn];

vector < int > get_free;
set < int > to_take[maxn];

int fen[2 * maxn];
void add(int id, int v)
{
    for (int i = id; i <= timer; i += (i & -i))
    {
        fen[i] += v;
    }
}

int sum(int id)
{
    int s = 0;
    for (int i = id; i > 0; i -= (i & -i))
        s += fen[i];
    return s;
}

void is_valid(int id)
{
    if (!(id >= 1 && id < timer))
        return;
    if (act[ord[id]] && act[ord[id - 1]])

    {
        if (to_take[ord[id]].count(id))
            return;
        ///cout << "to add " << id << endl;
        if (m <= 1000)
        add(id, 1);
        to_take[ord[id]].insert(id);
    }
}
int df = 0;
void get_active(int v)
{

    act[v] = 1;
    for (int i : occ[v])
    {
//cout << "check " << i << " " << i + 1 << endl;
        is_valid(i);
        is_valid(i + 1);
    }
    bool over = false;
    for (int u : adj[v])
    {
        if (u == par[v]) /// !!!
        {
            over = true;
            continue;
        }
        if (over)
        {
            get_free.push_back(u);
        }
        else
            get_active(u);
    }
}
void simulate()
{
    act[0] = 1;

    get_active(1);
    /// skip 1
    int pivot = 1;
    ll last_day = 0;

    while(true)
    {
        /**for (int i = 1; i <= timer - 1; i ++)
        {
            if (act[ord[i]] && (i == 1 ||  act[ord[i - 1]]))
                cout << ord[i] << " ";
        }
        cout << endl;*/
        //cout << "------------" << endl;
        assert(act[ord[1]] == 1 && ord[1] == 1);
        int ls = 0;
        while(true)
        {

            set < int > :: iterator it = to_take[f[pivot]].upper_bound(ls);
            if (it == to_take[f[pivot]].end())
                break;
            ls = *it;
            pivot ++;
        }


        if (pivot > m)
        {
            if (m <= 1000)
            last_day = last_day + (ll)sum(ls);
            break;
        }

        if (m <= 1000)
        last_day = last_day + (ll)sum(timer - 1);
        ///cout << last_day << endl;
        vector < int > vec = get_free;
        get_free.clear();
        for (int v : vec)
            get_active(v);
    }

    cout << last_day << endl;
}
void solve()
{
    input();
    dfs(1, -1);
    simulate();
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
4 4
2 2 3
1 1
2 1 4
1 3
2 1 1 4
*/
