#include<bits/stdc++.h>
#include "game.h"

using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10;

int a[maxn], d, n, par[maxn];

void find_parent(int v)
{
    int mx = -1;
    for (int i = max(0, v - d); i < min(n, v + d + 1); i ++)
    {
        if (mx == -1 || a[i] >a[mx])
            mx = i;
    }

    if (a[mx] <= a[v])
        par[v] = -1;
    else
        par[v] = mx;
}

void init(vector < int > A, int D)
{
    n = A.size();
    d = D;
    for (int i = 0; i < n; i ++)
    {
        a[i] = A[i];
        //values.insert({-a[i], i});
    }

    for (int i = 0; i < n; i ++)
    {
        find_parent(i);
    }

}


void updateValue(int index, int newValue)
{
    a[index] = newValue;

        for (int i = max(0, index - d); i < min(n, index + d + 1); i ++)
    {
        find_parent(i);
    }
}

bool isWinning(int startIndex)
{
    int cnt = 0;
    while(startIndex != -1)
    {
        cnt ++;
        startIndex = par[startIndex];
    }

    return (cnt + 1) % 2;
}
