#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1010;
const int maxa = 1e9 + 10, block = sqrt(maxa) + 10;
int n, a[maxn], k, x;
unordered_map < int, vector < int > > to;
unordered_map < int, int > cnt;

int prime[block];
void eratosten()
{
    prime[0] = prime[1] = 1;
    for (int i = 2; i < block; i ++)
    {
        if (prime[i])
            continue;
        for (int j = i * 2; j < block; j += i)
            prime[j] = 1;
    }
    for (int j = 0; j < block; j ++)
    {
        prime[j] ^= 1;
    }
}

bool is_prime(int x)
{

    if (x == 1)
        return false;

    int b = sqrt(x);
    for (int i = 2; i <= b; i ++)
        if (x % i == 0)
            return false;

    return true;
}

void get_divisors(int x, int id)
{
    int b = sqrt(x);

    for (int i = 1; i <= b; i ++)
    {

        if (x % i == 0)
        {
            if (is_prime(i))
            {
                ll j = i;
                while((ll)(x) % (ll)((ll)j * (ll)(i)) == 0)
                    j = j * i;
                to[j].push_back(id);
                cnt[j] ++;

            }
            if (x / i != i && is_prime(x / i))
            {
                to[x / i].push_back(id);
                cnt[x / i] ++;
            }


        }
    }
}

int mst[maxn];
int used[maxn], p[maxn];
void solve()
{
    to.clear();
    cnt.clear();

    cin >> n >> k >> x;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
        get_divisors(a[i], i);
    }

    for (int i = 1; i <= n; i ++)
        mst[i] = 1;

    unordered_map < int, int > :: iterator it;
    for (it = cnt.begin(); it != cnt.end(); it ++)
    {
        if (it -> second >= k)
        {
            for (int i : to[it -> first])
            {

                mst[i] = (ll)(it -> first) * (ll)(mst[i]) / (ll)(__gcd(mst[i], it -> first));

            }
        }
    }

    for (int i = 1; i <= n; i ++)
        used[i] = 0;
    for (int i = 1; i <= n; i ++)
    {
        int mx = -1;
        for (int j = 1; j <= n; j ++)
        {
            if (used[j])
                continue;
            if (a[j] % mst[i] != 0 || (a[i] % mst[j]) != 0)
                continue;
            if (mx == -1 || a[j] < a[mx])
                mx = j;
        }

        used[mx] = 1;
        p[i] = a[mx];
    }

    for (int i = 1; i <= n; i ++)
        cout << p[i] << " ";
    cout << endl;
}

int main()
{
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
1
4 2 3
7 3 6 9
*/
