#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll maxn = 1e5 + 10;
const ll maxa = 1e9 + 10, block = sqrt(maxa) + 10;
ll n, a[maxn], k, x;
unordered_map < ll, vector < ll > > to;
unordered_map < ll, ll > cnt;

ll prime[block], ps[block];
vector < ll > pr;
void eratosten()
{
    prime[0] = prime[1] = 1;
    for (ll i = 2; i < block; i ++)
    {
        if (prime[i])
            continue;
        ps[i] = i;
        pr.push_back(i);
        for (ll j = i * 2; j < block; j += i)
            prime[j] = 1, ps[j] = i;
    }
    for (ll j = 0; j < block; j ++)
    {
        prime[j] ^= 1;
    }
}

bool is_prime(ll x)
{

    if (x == 1)
        return false;

    ll b = sqrt(x);
    for (ll i : pr)
    {
        if (i > b)
            break;
        if (x % i == 0)
            return false;
    }


    return true;
}

void get_divisors(ll x, ll id)
{
    ll b = sqrt(x);


    for (ll i : pr)
    {
        if (i > b)
            break;
        if (x % i == 0)
        {
            if (prime[i])
            {
                ll j = i;
                while((x / i) % j == 0)
                {
                    to[j].push_back(id);
                    cnt[j] ++;
                    j = j * i;
                }
                to[j].push_back(id);
                cnt[j] ++;

            }


        }
    }


    for (ll d : pr)
    {
        if (d > b)
            break;
        while(x % d == 0)
            x /= d;

    }

    if (x > 1)
    {
        to[x].push_back(id);
        cnt[x] ++;
    }
}

ll mst[maxn];
ll used[maxn], p[maxn];
ll best[maxn];
unordered_map < ll, multiset < ll > > tk;
void solve()
{


    cin >> n >> k >> x;
    for (ll i = 1; i <= n; i ++)
    {
        cin >> a[i];

    }
    for (ll i = 1; i <= n; i ++)
        best[i] = 1e18;
    for (ll st = 0; st <= n; st ++)
    {
        if (x == 1 && st == 1)
            break;
        to.clear();
        cnt.clear();
        for (ll i = 1; i <= n; i ++)
        {
            get_divisors(a[i], i);
            if (i == st)
            {

                ll dx = 1;
                while((a[i] / x) == dx)
                    dx *= (ll)x;
                dx *= x;
                cnt[dx] ++;
                to[x].push_back(i);
            }
        }
        a[st] *= x;
        for (ll i = 1; i <= n; i ++)
            mst[i] = 1;


        unordered_map < ll, ll > :: iterator it;
        for (it = cnt.begin(); it != cnt.end(); it ++)
        {
            if (it -> second >= k)
            {
                for (ll i : to[it -> first])
                {

                    if (it -> first > block)
                        mst[i] = it -> first * mst[i];
                    else
                        mst[i] = ps[it -> first] * (mst[i]);

                }
            }
        }
        tk.clear();
        for (ll i = 1; i <= n; i ++)
        {
            tk[mst[i]].insert(a[i]);
        }

        for (ll i = 1; i <= n; i ++)
            used[i] = 0;
        for (ll i = 1; i <= n; i ++)
        {
            p[i] = *tk[mst[i]].begin();
            tk[mst[i]].erase(tk[mst[i]].find(p[i]));

            //used[mx] = 1;
            //p[i] = a[mx];
        }
        for (ll i = 1; i <= n; i ++)
        {
            if (p[i] < best[i])
            {
                for (ll j = 1; j <= n; j ++)
                    best[j] = p[j];
                break;
            }
            if (p[i] > best[i])
                break;
        }

        a[st] /= x;
    }
    for (ll i = 1; i <= n; i ++)
        cout << best[i] << " ";
    cout << endl;
}

int main()
{
    eratosten();
    speed();
    ll t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
1
4 2 3
7 3 6 9
*/
