#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;
const int maxa = 1e9 + 10, block = sqrt(maxa) + 10;
int n, k;
ll x, a[maxn];
unordered_map < int, vector < int > > to;
unordered_map < int, int > cnt;

int prime[block], ps[block];
vector < int > pr;
void eratosten()
{
    prime[0] = prime[1] = 1;
    for (int i = 2; i < block; i ++)
    {
        if (prime[i])
            continue;
        ps[i] = i;
        pr.push_back(i);
        for (int j = i * 2; j < block; j += i)
            prime[j] = 1, ps[j] = i;
    }
    for (int j = 0; j < block; j ++)
    {
        prime[j] ^= 1;
    }
}

bool is_prime(int x)
{

    if (x == 1)
        return false;

    int b = sqrt(x);
    for (int i : pr)
    {
        if (i > b)
            break;
        if (x % i == 0)
            return false;
    }


    return true;
}

void get_divisors(int x, int id)
{
    int b = sqrt(x);


    for (int i : pr)
    {
        if (i > b)
            break;
        if (x % i == 0)
        {
            if (prime[i])
            {
                int j = i;
                while((x / i) % j == 0)
                {
                    to[j].push_back(id);
                    cnt[j] ++;
                    j = j * i;
                }
                to[j].push_back(id);
                cnt[j] ++;

            }


        }
    }


    for (int d : pr)
    {
        if (d > b)
            break;
        while(x % d == 0)
            x /= d;

    }

    if (x > 1)
    {
        to[x].push_back(id);
        cnt[x] ++;
    }
}

ll mst[maxn];
int used[maxn];
ll p[maxn];
ll best[maxn];
const ll inf = 1e18;

unordered_map < ll, multiset < ll > > tk;

void try_with(int st)
{
    to.clear();
    cnt.clear();
    for (int i = 1; i <= n; i ++)
    {
        get_divisors(a[i], i);

    }
    for (int i = 1; i <= n; i ++)
        mst[i] = 1;


    unordered_map < int, int > :: iterator it;
    for (it = cnt.begin(); it != cnt.end(); it ++)
    {
        if (it -> second >= k)
        {
            for (int i : to[it -> first])
            {

                if (it -> first > block)
                    mst[i] = it -> first * mst[i];
                else
                    mst[i] = ps[it -> first] * (mst[i]);

            }
        }
    }
    mst[st] *= x;
    tk.clear();
    for (int i = 1; i <= n; i ++)
    {
        if (i == st)
            tk[mst[i]].insert((ll)a[i] * (ll)x);
        else
            tk[mst[i]].insert(a[i]);
    }

    for (int i = 1; i <= n; i ++)
        used[i] = 0;
    for (int i = 1; i <= n; i ++)
    {
        p[i] = *tk[mst[i]].begin();
        tk[mst[i]].erase(tk[mst[i]].find(p[i]));

        //used[mx] = 1;
        //p[i] = a[mx];
    }
    for (int i = 1; i <= n; i ++)
        assert(p[i] > 0);
    for (int i = 1; i <= n; i ++)
    {
        if (p[i] < best[i])
        {
            for (int j = 1; j <= n; j ++)
                best[j] = p[j];
            break;
        }
        if (p[i] > best[i])
            break;
    }
}


void solve()
{


    cin >> n >> k >> x;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];

    }

    to.clear();
    cnt.clear();
    for (int i = 1; i <= n; i ++)
    {
        get_divisors(a[i], i);

    }
    for (int i = 1; i <= n; i ++)
        mst[i] = 1;
    for (int i = 1; i <= n; i ++)
        best[i] = inf;


    unordered_map < int, int > :: iterator it;
    for (it = cnt.begin(); it != cnt.end(); it ++)
    {
        if (it -> second >= k)
        {
            for (int i : to[it -> first])
            {

                if (it -> first > block)
                    mst[i] = it -> first * mst[i];
                else
                    mst[i] = ps[it -> first] * (mst[i]);

            }
        }
    }

    tk.clear();
    for (int i = 1; i <= n; i ++)
    {

            tk[mst[i]].insert(a[i]);
    }

    for (int i = 1; i <= n; i ++)
        used[i] = 0;

    vector < int > funny;
    funny.push_back(0);
    for (int i = 1; i <= n; i ++)
    {
        ll v1 = *tk[mst[i]].begin();
        ll v2 = inf;
        if (!tk[mst[i] * x].empty())
        {
            v2 = *tk[mst[i] * x].begin();
            ///cout << "here " << v2 << endl;
        }
        ll v3 = inf;
        if (mst[i] % x == 0 && !tk[mst[i] / x].empty())
        {
            v3 = *tk[mst[i] / x].begin() * x;
        }

        if (v1 <= v2 && v1 <= v3)
           {
               tk[mst[i]].erase(tk[mst[i]].begin());
               continue;
           }


        int id2 = 1;

        while(id2 <= n && a[id2] * x != v3)
            id2 ++;


        funny.push_back(i);
        if (id2 <= n)
        funny.push_back(id2);
        break;
    }

    //for (int st : funny)
      //  cout << "st " <<st << endl;

    for (int st : funny)
        try_with(st);

    for (int i = 1; i <= n; i ++)
        cout << best[i] << " ";
    cout << endl;
}

int main()
{
    eratosten();
    ///speed();
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
1
4 2 3
7 3 6 9
*/
