#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5 + 3;

int n, k, x;
int a[MAXN];
int a2[MAXN];
int b[MAXN];
map <int, int> used;

bool found = 0;

bool check(int ind, int x)
{
    vector <int> v(ind-1, 0);

    for (int i = 0; i < k-1; i++)
        v[i] = 1;
    sort(v.begin(), v.end());

    do
    {
        int gcd1 = a[ind];
        int gcd2 = a2[x];
        int cnt = 1;

        for (int j = 1; j < ind; j++)
        {
            if (v[j-1])
            {
                gcd1 = __gcd(a[ind-j], gcd1);
                gcd2 = __gcd(b[ind-j], gcd2);
                cnt++;
            }
        }

        if (gcd1 != gcd2 && cnt == k) return false;
    }
    while (next_permutation(v.begin(), v.end()));

    return true;
}

void rec(int ind)
{
    if (found) return;
    if (ind == n + 1)
    {
        found = 1;
        for (int i = 1; i <= n; i++)
            cout << b[i] << " ";
        cout << endl;
        return;
    }

    for (int i = 1; i <= n; i++)
    {
        if (used[i]) continue;

        if (ind >= k)
        {
            if (!check(ind, i))
            {
                continue;
            }
        }

        used[i] += 1;

        b[ind] = a2[i];
        rec(ind+1);

        used[i] -= 1;
    }
}

void solve()
{
    cin >> n >> k >> x;
    for (int i = 1; i <= n; i++)
    {
        cin >> a[i];
        a2[i] = a[i];
    }

    sort(a2 + 1, a2 + n + 1);

    rec(1);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t; cin >> t;
    while (t--) solve();

    return 0;
}
/**
1
3 2 1
2 6 4

*/
