#include<bits/stdc++.h>
#include"game.h"

using namespace std;

int n, d;
int a[200005];
int segm[800005];

vector<int> gpos;
bool gub[200005];

void build_tree(int v, int le, int ri)
{
    if(le==ri) segm[v]=le;
    else
    {
        int mid=(le+ri)/2;
        build_tree(2*v, le, mid);
        build_tree(2*v+1, mid+1, ri);
        if(a[segm[2*v]]>a[segm[2*v+1]]) segm[v]=segm[2*v];
        else segm[v]=segm[2*v+1];
    }
}

void update(int v, int le, int ri, int pos, int val)
{
    if(le==ri)
    {
        a[pos]=val;
        return;
    }
    int mid=(le+ri)/2;
    if(pos<=mid) update(2*v, le, mid, pos, val);
    else update(2*v+1, mid+1, ri, pos, val);
    if(a[segm[2*v]]>a[segm[2*v+1]]) segm[v]=segm[2*v];
    else segm[v]=segm[2*v+1];
}

int query(int v, int le, int ri, int be, int en)
{
    if(le>en || ri<be) return 200004;
    if(be<=le && ri<=en) return segm[v];
    int mid=(le+ri)/2;
    int id1=query(2*v, le, mid, be, en);
    int id2=query(2*v+1, mid+1, ri, be, en);
    if(a[id1]>a[id2]) return id1;
    return id2;
}

queue<pair<int, int> > qu;

void solve_int()
{
    qu.push({0, n-1});
    while(!qu.empty())
    {
        int be=qu.front().first, en=qu.front().second;
        qu.pop();
        if(be>en) continue;
        int id=query(1, 0, n-1, be, en);
        gpos.push_back(id);
        gub[id]=1;
        qu.push({be, id-d-1});
        qu.push({id+d+1, en});
    }
}

void init(std::vector<int> A, int D)
{
    n=A.size();
    d=D;
    for(int i=0; i<n; i++) a[i]=A[i];
    build_tree(1, 0, n-1);
    solve_int();
}

int tid=0;

void updateValue(int index, int newValue)
{
    tid++;
    for(int i=0; i<gpos.size(); i++) gub[gpos[i]]=0;
    gpos.resize(0);
    update(1, 0, n-1, index, newValue);
    tid++;
}

bool isWinning(int startIndex)
{
    if(n<2000 || tid>=5) {solve_int(); tid=0;}
    return !gub[startIndex];
}
