#include <bits/stdc++.h>
#include "game.h"
using namespace std;

const int maxn = 2e5+2;
int myn, myd, a[maxn], maxx, pos, sum1, sum2;

void init(std::vector<int> A, int D)
{
    myn = (int)(A.size());
    myd = D;
    int i;
    for (i=0; i<myn; ++i)
    {
        a[i+1] = A[i];
        if (a[i+1] > maxx)
        {
            maxx = a[i+1];
            pos = i+1;
        }
    }
}

void updateValue(int index, int newValue)
{
    if (maxx == a[index+1])
    {
        a[index+1] = newValue;
        maxx = newValue, pos = index + 1;
        int i;
        for (i=1; i<=myn; ++i)
        {
            if (a[i] > maxx)
            {
                maxx = a[i];
                pos = i;
            }
        }
    }
    a[index+1] = newValue;
}

void play(int poss, bool player, int round)
{
    if (round > 8) return;

    int g1 = max (1, poss-myd);
    if (pos < g1) g1 = pos + myd + 1;
    int g2 = min (myn, poss+myd);
    if (pos > g2) g2 = pos - myd - 1;
    int i, idx, maximum = 0;
    for (i=g1; i<=g2; ++i)
    {
        if (i == poss) continue;
        if (a[i] > maximum)
        {
            maximum = a[i];
            idx = i;
        }
    }

    //cout << poss << "->" << idx << '\n';
    if (player)
    {
        sum1 += maximum;
        play(idx, 0, round+1);
    }
    else
    {
        sum2 += maximum;
        play(idx, 1, round+1);
    }
}

bool isWinning(int startIndex)
{
    if (pos == startIndex+1) return false;
    if (abs(pos-(startIndex+1)) <= myd) return true;
    sum1 = 0, sum2 = 0;
    play(startIndex+1, 1, 1);
    return (sum1 > sum2);
}