#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <unordered_map>
using namespace std;
const int MAXNUM=1e9;
const int MAXN=1e5+10;
long long a[MAXN], b[MAXN], y[MAXN];
vector <int> pr;
vector <pair <int,int> > vec[MAXN*2];
unordered_map <int,int> um;
bool er[MAXN];
int n;
void eratosten() {
    int gr=sqrt(MAXNUM);
    for (int i=2;i<=gr;i++) {
        if (!er[i]) {
            pr.push_back(i);
            for (int j=i*i;j<=gr;j+=i) er[j]=true;
        }
    }
}
void find_lex() {
    for (int i=0;i<n;i++) {
        for (int j=i+1;j<n;j++) {
            if (y[i]!=y[j]) continue;
            if (b[i]>b[j]) {
                swap(b[i],b[j]);
                swap(y[i],y[j]);
            }
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, k, x;
    cin >> t;
    eratosten();
    for (int test=0;test<t;test++) {
        cin >> n >> k >> x;
        int cnt=1;
        for (int i=0;i<n;i++) {
            cin >> a[i];
            b[i]=a[i];
            for (auto p:pr) {
                if (p>a[i]) break;
                if (a[i]%p!=0) continue;
                if (um[p]==0) {
                    um[p]=cnt;
                    cnt++;
                }
                int cur=um[p];
                vec[cur].push_back({i,1});
                while (a[i]%p==0) {
                    vec[cur][vec[cur].size()-1].second*=p;
                    a[i]/=p;
                }
            }
            if (a[i]>1) {
                if (um[a[i]]==0) {
                    um[a[i]]=cnt;
                    cnt++;
                }
                vec[um[a[i]]].push_back({i,a[i]});
            }
            y[i]=1;
        }
        for (int i=1;i<cnt;i++) {
            if (vec[i].size()>=k) {
                for (int j=0;j+k-1<vec[i].size();j++) {
                    y[vec[i][j].first]*=vec[i][j].second;
                }
                for (int j=vec[i].size()-k+1;j<vec[i].size();j++) {
                    y[vec[i][j].first]*=vec[i][vec[i].size()-k].second;
                }
            }
        }
        find_lex();
        for (int i=0;i<n;i++) cout << b[i] << ' ';
        cout << endl;
        if (!um.empty()) um.clear();
        for (int i=1;i<cnt;i++) if (!vec[i].empty()) vec[i].clear();
    }
}
