#include<bits/stdc++.h>
#include "game.h"

#define MAXN 200002

using namespace std;

vector<int> mas;
int n, lastT = 1, mnBnd, mxBnd = 1, d;
bool ans[MAXN];
struct segTree
{
    pair<int, int> arr[4 * MAXN];
    void build(int ind, int l, int r)
    {
        if(l == r)
        {
            arr[ind] = {mas[l], l};
            return;
        }
        int mid = (l + r) / 2;
        build((ind << 1) + 1, l, mid);
        build((ind << 1) + 2, mid + 1, r);
        arr[ind] = max(arr[(ind << 1) + 1], arr[(ind << 1) + 2]);
    }
    void update(int ind, int l, int r, int i, int v)
    {
        if(l == r)
        {
            arr[ind] = {v, l};
            return;
        }
        int mid = (l + r) / 2;
        if(i <= mid) update((ind << 1) + 1, l, mid, i, v);
        else update((ind << 1) + 2, mid + 1, r, i, v);
        arr[ind] = max(arr[(ind << 1) + 1], arr[(ind << 1) + 2]);
    }
    pair<int, int> query(int ind, int l, int r, int curL, int curR)
    {
        if(curL > r || curR < l) return {-1, -1};
        if(curL >= l && curR <= r) return arr[ind];
        int mid = (curL + curR) / 2;
        return max(query((ind << 1) + 1, l, r, curL, mid), query((ind << 1) + 2, l, r, mid + 1, curR));
    }
}tree;

void init(vector<int> A, int D)
{
    mas = A;
    n = A.size();
    d = D;
    mnBnd = 0;
    mxBnd = n - 1;
    tree.build(0, 0, n - 1);
}

void updateValue(int index, int newValue)
{
    tree.update(0, 0, n - 1, index, newValue);
    lastT = 1;
}

void rec(int l, int r)
{
    if(l > r || l >= n || r < 0) return;
    pair<int, int> cur = tree.query(0, l, r, 0, n - 1);
    int mxInd = cur.second;
    ans[mxInd] = 1;
    int bg = max(l, mxInd - d);
    int ed = min(r, mxInd + d);
    if(l == r) return;
    rec(l, mxInd - d - 1);
    rec(mxInd + d + 1, r);
}
bool isWinning(int startIndex)
{
    if(lastT)
    {
        memset(ans, 0, n);
        rec(0, n - 1);
    }
    lastT = 0;
    return !ans[startIndex];
}
