#include "game.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 200005;

int n;
int a[maxn];
int d;

vector<int> g[maxn];

bool dp[maxn][2];
int mem[maxn][2];

int tim = 1;

bool f(int pos, bool who)
{
    //cout << pos << " " << who << endl;
    if (g[pos].empty() == true)
    {
        return false;
    }

    //cout << pos << " " << who << " " << tim << " " << mem[pos][who] << endl;

    if (mem[pos][who] == tim)
    {
        return dp[pos][who];
    }

    mem[pos][who] = tim;

    for (int i = 0; i < g[pos].size(); ++i)
    {
        dp[pos][who] |= (!f(g[pos][i], 1 - who));
    }

    return dp[pos][who];
}

void init(vector<int> A, int D)
{
    n = A.size();
    d = D;

    for (int i = 1; i <= n; ++i)
    {
        a[i] = A[i - 1];
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i + 1; j <= min(n, i + d); ++j)
        {
            if (a[j] > a[i])
            {
                //cout << i << " -> " << j << endl;
                g[i].push_back(j);
            }
        }

        for (int j = i - 1; j >= max(1, i - d); --j)
        {
            if (a[j] > a[i])
            {
                //cout << i << " -> " << j << endl;
                g[i].push_back(j);
            }
        }
    }

    for (int i = 1; i <= n; ++i)
    {
        f(i, 1);
    }
}

bool was = false;

void updateValue(int index, int newValue)
{
    ++index;
    was = true;

    a[index] = newValue;

    int from = max(1, index - d);
    int to = min(n, index + d);

    for (int i = from; i <= to; ++i)
    {
        g[i].clear();
    }

    for (int i = from; i <= to; ++i)
    {
        for (int j = i + 1; j <= min(to, i + d); ++j)
        {
            if (a[j] > a[i])
            {
                //cout << i << " -> " << j << endl;
                g[i].push_back(j);
            }
        }

        for (int j = i - 1; j >= max(from, i - d); --j)
        {
            if (a[j] > a[i])
            {
                //cout << i << " -> " << j << endl;
                g[i].push_back(j);
            }
        }
    }

    /*cout << "after " << endl;

    for (int i = 1; i <= n; ++i)
    {
        for (auto j : g[i])
        {
            cout << i << " -> " << j << endl;
        }
    }*/

    from = max(1, index - 2 * d);
    to = min(n, index + d * 2);

    for (int i = from; i <= to; ++i)
    {
        dp[i][0] = dp[i][1] = 0;
    }

    ++tim;

    for (int i = from; i <= to; ++i)
    {
        f(i, 1);
    }

    //cout << "-------------------------------------------" << endl;
}

bool isWinning(int startIndex)
{
    return f(startIndex + 1, 1);
}
