/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, k;
llong a[MAXN];
llong b[MAXN];
int perm[MAXN];
int newB[MAXN];
int xCnt[MAXN];
llong xPows[MAXN];
int valsPtr[MAXN];
std::vector <llong> divs[MAXN];
std::vector <llong> vals[MAXN];
std::unordered_map <llong,int> cnt;
std::unordered_map <llong,int> compr;
llong x;

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        vals[i].clear();
        divs[i].clear();
        valsPtr[i] = 0;
    }
}

void solve()
{
    cnt.clear();
    xPows[0] = 1;
    for (int i = 1 ; i <= n ; ++i)
    {
        xCnt[i] = 0;
        divs[i].push_back(1);
        int cpy = a[i];

        for (int j = 2 ; j * j <= cpy ; j += 2)
        {
            int currD = 1;
            while (cpy % j == 0)
            {
                if (j == x) xCnt[i]++;
                if (j == x) xPows[xCnt[i]] = xPows[xCnt[i] - 1] * x;
                currD *= j;
                divs[i].push_back(currD);
                cpy /= j;
            }

            if (j == 2) j = 1;
        }

        if (cpy > 1)
        {
            if (cpy == x) xCnt[i]++;
            if (cpy == x) xPows[xCnt[i]] = xPows[xCnt[i] - 1] * x;
            divs[i].push_back(cpy);
        }

        xPows[xCnt[i] + 1] = xPows[xCnt[i]] * x;
        for (const int &d : divs[i])
        {
            cnt[d]++;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        int lcm = 1;
        for (const int &d : divs[i])
        {
            if (cnt[d] >= k) lcm = std::lcm(lcm, d);
        }

        b[i] = lcm;
    }

    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return b[x] < b[y];
    });

    int comprCnt = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (b[perm[i]] != b[perm[i - 1]]) comprCnt++;
        newB[perm[i]] = comprCnt;  
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        compr[b[i]] = newB[i];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        vals[compr[b[i]]].push_back(i);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::sort(vals[i].begin(), vals[i].end(), [&](int x, int y)
        {
            return a[x] < a[y];
        });
    }

    int idx = 0;
    int pos = n + 1;
    llong val = 1e18;
    if (x != 1)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            if (cnt[xPows[xCnt[i] + 1]] + 1 >= k)
            {
                llong newValA = a[i] * x;
                llong newValB = b[i] * x;
                if (vals[compr[newValB]].empty())
                {
                    continue;
                }

                int l = -1, r = vals[compr[newValB]].size(), mid;
                while (l < r - 1)
                {
                    mid = (l + r) / 2;
                    if (a[vals[compr[newValB]][mid]] <= newValA) l = mid;
                    else r = mid; 
                }

                if (r != vals[compr[newValB]].size())
                {
                    int tryPos = vals[compr[newValB]][r];
                    if (tryPos < pos || (tryPos == pos && newValA < val))
                    {
                        pos = tryPos;
                        val = newValA;
                        idx = i;
                    }
                }
                
                l = -1; r = vals[compr[newValB]].size();
                while (l < r - 1)
                {
                    mid = (l + r) / 2;
                    if (vals[compr[newValB]][mid] < i) l = mid;
                    else r = mid; 
                }

                if (r != vals[compr[newValB]].size())
                {
                    int tryPos = i;
                    llong tryVal = a[vals[compr[newValB]][r]];
                    if (tryPos < pos || (tryPos == pos && tryVal < val))
                    {
                        pos = tryPos;
                        val = tryVal;
                        idx = i;
                    }
                }
            }
        }
    }

    if (idx != 0)
    {
        b[idx] *= x;
        a[idx] *= x;
        for (int i = 1 ; i <= n ; ++i)
        {
            vals[i].clear();
        }

        std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
        {
            return b[x] < b[y];
        });

        int cnt = 0;
        compr.clear();
        for (int i = 1 ; i <= n ; ++i)
        {
            if (b[perm[i]] != b[perm[i - 1]]) cnt++;
            newB[perm[i]] = cnt;  
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            compr[b[i]] = newB[i];
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            vals[compr[b[i]]].push_back(i);
        }

        for (int i = 1 ; i <= n ; ++i)
        {
            std::sort(vals[i].begin(), vals[i].end(), [&](int x, int y)
            {
                return a[x] < a[y];
            });
        }
    }

    std::vector <int> sol(n + 1);
    for (int i = 1 ; i <= n ; ++i)
    {
        sol[i] = a[vals[compr[b[i]]][valsPtr[compr[b[i]]]++]];   
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << sol[i] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n >> k >> x;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIOI();
    std::cin >> tests;
    while (tests--)
    {
        reset();
        input();
        solve();
    }

    return 0;
}