#include "game.h"
#include <vector>
#include <iostream>
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0;}

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define endl "\n"
#define out(x) #x << " = " << x << "  "

typedef long long ll;
typedef long double ld;

const ll mod = 1e16 + 7;
const int MAX_N = 1e5 + 42;


//ll c[MAX_N][1024];
int cnt = 30023;
std::vector< ll > Prev;
std::vector< ll > curr;

std::vector< ll > A;

int n;
int D;

void init(std::vector<int> B, int _D){
	D = _D;

	n = (int)B.size();

	A.resize( n );
	Prev.resize( n );
	curr.resize( n );

	for( int i=0 ; i < n ; i++ ) A[i] = B[i];

	Prev = A;

	for( int d = 1 ; d < cnt ; d++ ){
		for( int i=0 ; i < n ; i++ ){
			ll currMax = -mod;
			for( int j=std::max( 0, i - D ) ; j <= std::min( n-1, i + D ) ; j++ ){
				if( i == j ) continue;
				chkmax( currMax, Prev[j] );
				
			}
			curr[i] = A[i] - currMax;

			//cerr << curr[i] << " ";
			if( curr[i] > 0 ) chkmin( curr[i], mod );
			else chkmax( curr[i], -mod );
		}
		Prev = curr;
		//cerr << endl;
	}

}

bool isWinning(int startIndex){
	for( auto j : curr ) cerr << j << " ";
	cerr << endl;

	if( Prev[startIndex] < 0 ) return true;
	return false;
}

void updateValue(int index, int newValue){

	A[index] = newValue;
	Prev = A;

	for( int d = 1 ; d < cnt ; d++ ){
		for( int i=0 ; i < n ; i++ ){
			ll currMax = -mod;
			for( int j=std::max( 0, i - D ) ; j <= std::min( n-1, i + D ) ; j++ ){
				if( i == j ) continue;
				chkmax( currMax, Prev[j] );
				
			}
			curr[i] = A[i] - currMax;
			if( curr[i] > 0 ) chkmin( curr[i], mod );
			else chkmax( curr[i], -mod );
		}
		Prev = curr;
	}
}
