#include "game.h"
#include <vector>
#include <iostream>
std::pair<int,int> tree[8000000+2];
int nums[200000+2],n,d,lastqueryind;
bool f[200000+2];
int closestLeft[2000000+2],closestRight[200000+2],gr,gl;
void build(int l, int r, int node)
{
    if(l>r)
    {
        return;
    }
    if(l==r)
    {
        tree[node].first=nums[l];
        tree[node].second=l;
         //std::cout<<"\n"<<node<<" "<<tree[node].first<<"\n";
        return;
    }
    int mid=(l+r)/2;
    build(l,mid,node*2);
    build(mid+1,r,node*2+1);
    tree[node]=std::max(tree[node*2],tree[node*2+1]);
}
std::pair<int,int> query(int ql,int qr,int l, int r,int node)
{
     //std::cout<<l<<" "<<r<<" "<<tree[node].first<<" "<<node<<"\n";
    if(ql==l && qr==r)
    {
//std::cout<<tree[node].first<<"<\n";
        return tree[node];
    }
    if(ql>qr or r<l or ql>r or qr<l)
    {
        return {-10000000,-1};
    }
    int mid=(r+l)/2;
    return std::max(query(ql, std::min(qr,mid),l,mid,node*2),query(std::max(ql,mid+1),qr,mid+1,r,node*2+1));
}
void pointupdate(int node,int ind, int l,int r,int val)
{
    int mid=(l+r)/2;
    if(l>r){return;}
//std::cout<<l<<" "<<r<<" "<<node<<"\n";
    if(l==ind && r==l)
    {
        //std::cout<<"\n"<<node<<" "<<val<<"\n";
        tree[node].first=val;
        tree[node].second=ind;
        nums[l]=val;
        return;
    }
    if(ind>=l && ind<=mid)
    {
        pointupdate(node*2,ind,l,mid,val);
        tree[node]=std::max(tree[node*2+1],tree[node*2]);
    }
    else if(ind<=r && ind>=mid+1)
    {
        pointupdate(node*2+1,ind,mid+1,r,val);
        tree[node]=std::max(tree[node*2],tree[node*2+1]);
    }
}
void updateValue(int index,int newValue)
{
    //index++;
    if(index<=gr && index>=gl){
    pointupdate(1,index+1,1,n,newValue);
    nums[index+1]=newValue;
//    for(int a=0;a<25;a++){
//        std::cout<<tree[a].first<<" "<<tree[a].second<<" ";
//    }std::cout<<"\n";
//        for(int a=0;a<=6;a++){
//        std::cout<<nums[a]<<" ";
//    }
    for(int a=std::max(index+1-d,gl);a<=std::min(index+1+d,gr);a++){
        if(nums[a]==query(std::max(gl,a-d),std::min(gr,a+d),1,n,1).first){
            f[a]=true;
        }else{
        f[a]=false;}
    }
    }
}
//for(int a=1;a<=n;a++){std::cout<<f[a];}
//std::cout<<"\n";

//bool f=true;
bool isWinning(int startIndex)
{

    //std::cout<<startIndex<<"\n";
    std::pair<int,int> q=query(std::max(gl,startIndex+1-d),std::min(gr,startIndex+1+d),1,n,1);
  //  std::cout<<q.first<<" "<<q.second<<" "<<startIndex<<"\n";
    // return true;
    if(f[startIndex+1])
    {//std::cout<<q.first<<"\n";
        return false;
    }
    else
    {
        for(int a=std::max(startIndex+1-d,gl);a<=std::min(startIndex+1+d,gr);a++){
                if(f[a]){
                    return true;
                }

        }
        gl=closestLeft[startIndex+1]+1;
        gr=closestRight[startIndex+1]-1;
        if(startIndex+1-gl==d && gr-startIndex==d){
            return false;
        }
        gl+=d;
        gr-=d;
             for(int a=gl;a<=gr;a++){
                    f[a]=false;
        if(nums[a]==query(std::max(gl,a-d),std::min(gr,a+d),1,n,1).first){
            f[a]=true;

        }
        }
        bool h=isWinning(startIndex);
      //  f=true;
        return h;
        }

}

void init(std::vector<int> nums1, int D)
{
    for(int a=1; a<=nums1.size(); a++)
    {
        nums[a]=nums1[a-1];
        //std::cout<<nums[a]<<" ";
    }
    n=nums1.size();
//for(int a=0;a<n;a++){
//    std::cout<<nums[a]<<" ";
//}
//std::cout<<"\n";
    build(1,n,1);
    d=D;
    int p=-1;
    for(int a=1;a<=n;a++){
        if(nums[a]==query(std::max(1,a-d),std::min(n,a+d),1,n,1).first){
            f[a]=true;

        }if(f[a]){   p=a;
                 closestLeft[a]=p;

        }
     //   std::cout<<f[a];
    }
        for(int a=1;a<=n;a++){


        if(f[n-a+1]){   p=n-a+1;
                 closestRight[n-a+1]=p;

        }
     //   std::cout<<f[a];
    }
   // std::cout<<"\n";
   gl=1;
   gr=n;
}

int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {std::cout<<"Update:\n";
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {std::cout<<"Check:\n";
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
