#include "game.h"
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
typedef long long ll;
using namespace std;
const int N = 2e3 + 10;
int n, d;
vector <int> a;
ll dp[N][N];
void init(vector<int> A, int D) {
	d = D;
	n = (int)A.size();
	a = A;
}
void updateValue(int index, int newValue) {
	a[index] = newValue;
}
bool isWinning(int startIndex) {
	for (int i = 0; i < n; i++) {
		dp[i][0] = a[i];
	}
	for (int j = 1; j <= n; j++) {
		for (int i = 0; i < n; i++) {
			ll mx = -(1e12 + 10);
			for (int k = max(0, i - d); k <= min(n - 1, i + d); k++) {
				if (k != i) mx = max(mx, dp[k][j - 1]);
			}
			dp[i][j] = a[i] - mx;
		}
	}
	for (int k = max(0, startIndex - d); k <= min(n - 1, startIndex + d); k++) {
		if (k == startIndex) continue;
		if (dp[k][(n / 2) * 2] >= 0) return true;
	}
	return false;
}
/*
int main() {
	init({ 1, 7, 4, 9, 30, 2 }, 2);
	cout << isWinning(0) << "\n";
	cout << isWinning(1) << "\n";
	updateValue(4, 8);
	cout << isWinning(0) << "\n";
	cout << isWinning(1) << "\n";
}*/
/*
9 15
2 4 2
2 1 3
1 2
4 5 7 6 1
1 4
1 4
2 4 8
2 9 7
1 8
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
107
*/