#include "game.h"
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
typedef long long ll;
using namespace std;
const int N = 2e5 + 10;
int n, d;
vector <int> a;
vector <int> order;
int dp[N];
int ind[N];
bool cmp(int x, int y) {
	return a[x] < a[y];
}
void updateValue(int index, int newValue) {

}
void init(vector<int> A, int D) {
	n = (int)A.size();
	a = A;
	order.clear();
	for (int i = 0; i < n; i++) {
		order.push_back(i);
	}
	sort(order.begin(), order.end(), cmp);
	for (int i = 0; i < n; i++) {
		ind[order[i]] = i;
	}
	for (int i = n - 1; i >= 0; i--) {
		dp[i] = 1;
		for (int j = max(0, order[i] - D); j <= min(n - 1, order[i] + D); j++) {
			if (ind[j] > i) {
				if (dp[j]) dp[i] = 0;
			}
		}
	}
}
bool isWinning(int startIndex) {	
	for (int i = max(0, startIndex - d); i <= min(n - 1, startIndex + d); i++) {
		if (!dp[ind[startIndex]]) return true;
	}
	return false;
}
/*
int main() {
	init({ 1, 7, 4, 9, 8, 2 }, 2);
	cout << isWinning(0) << "\n";
	cout << isWinning(1) << "\n";
}*/
/*
9 15
2 4 2
2 1 3
1 2
4 5 7 6 1
1 4
1 4
2 4 8
2 9 7
1 8
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
107
*/