#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
typedef long long ll;
using namespace std;
const int N = 2e5 + 10;
int gcd(int a, int b) {
	while (a && b) {
		if (a > b) a %= b;
		else b %= a;
	}
	return a + b;
}
int bitcount(int i) {
	int ans = 0;
	while (i > 0) {
		if (i & 1) ans++;
		i /= 2;
	}
	return ans;
}
bool ch(vector <int> a, vector <int> b, int k) {
	int n = (int)a.size();
	for (int i = 1; i < (1 << n); i++) {
		if (bitcount(i) != k) continue;
		int g1 = 0, g2 = 0;
		for (int j = 0; j < n; j++) {
			if (i & (1 << j)) {
				g1 = gcd(g1, a[j]);
				g2 = gcd(g2, b[j]);
			}
		}
		if (g1 != g2) return false;
	}
	return true;
	
}
void solve() {
	int n, k, x;
	cin >> n >> k >> x;
	vector <int> a(n), b(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		b[i] = a[i];
	}
	sort(b.begin(), b.end());
	if (ch(a, b, k)) {
		for (auto it : b) {
			cout << it << " ";
		}
		cout << "\n";
		return;
	}
	while (next_permutation(b.begin(), b.end())) {
		if (ch(a, b, k)) {
			for (auto it : b) {
				cout << it << " ";
			}
			cout << "\n";
			return;
		}
	}
}
int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}
/*
9 15
2 4 2
2 1 3
1 2
4 5 7 6 1
1 4
1 4
2 4 8
2 9 7
1 8
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
107
*/