#include "game.h"

#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <queue>
#include <assert.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define mpr make_pair

const int N = 200005;
bool ans[N];
vi g[N];
vi v;
int d;

void init(vector<int> vv, int dd) {

	v = vv;
	d = dd;
}

void updateValue(int ind, int new_val) {

	v[ind] = new_val;
}

bool isWinning(int ind) {
	
	for (int i = 0; i < v.size(); ++i) {
		ans[i] = false;
		g[i].clear();
	}
	for (int i = 0; i < v.size(); ++i) {
		for (int j = max(0, i - d); j <= min((int)v.size() - 1, i + d); ++j) {
			if (j == i) continue;
			if (v[j] > v[i]) {
				g[i].push_back(j);
			}
		}
	}
	vector<pii> a;
	for (int i = 0; i < v.size(); ++i) {
		a.push_back(mpr(v[i], i));
	}
	sort(a.begin(), a.end(), greater<pii>());
	for (int i = 0; i < a.size(); ++i) {
		int gag = a[i].second, val = a[i].first;
		if (g[gag].size() == 0) {
			ans[gag] = false;
		}
		else {
			//cout << gag << "     ";
			int ff = 0;
			for (auto u : g[gag]) {
				//cout << u << " ";
				if (!ans[u]) ++ff;
			}
			//cout << "\n";
			if (ff) {
				ans[gag] = true;
			}
			else {
				ans[gag] = false;
			}
		}
	}
	return ans[ind];
}