#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <queue>
#include <assert.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

#define mpr make_pair

ll gcd(ll a, ll b) {
	while (a && b) {
		if (a >= b) {
			a %= b;
		}
		else {
			b %= a;
		}
	}
	return a + b;
}

ll lcm(ll a, ll b) {
	return a * b / gcd(a, b);
}

int bpow(int a, int b) {
	int ans = 1;
	if (b == 0) {
		return 1;
	}
	while (b) {
		if (b & 1) {
			ans *= a;
		}
		b >>= 1;
		a *= a;
	}
	return ans;
}

///////////////////////////////////////////////////////////////////////////////////////

const int N = 100005;
int a[N];

void solve() {
	int n, k, x;
	cin >> n >> k >> x;
	assert(x == 1);
	vector<int> v;
	for (int i = 1; i <= n; ++i) {
		int x;
		cin >> x;
		v.push_back(x);
	}
	vector<int> ans = v;
	sort(v.begin(), v.end());
	vi mx;
	do {
		bool f = true;
		for (int m = 0; m < (1 << n); ++m) {
			int cp = m, qan = 0;
			vi c;
			for (int j = 0; j < n; ++j) {
				if (cp & 1) {
					c.push_back(j);
					++qan;
				}
				cp >>= 1;
			}
			if (qan != k) {
				continue;
			}
			int num1 = ans[c[0]], num2 = v[c[0]];
			for (int i = 1; i < c.size(); ++i) {
				num1 = gcd(num1, ans[c[i]]);
				num2 = gcd(num2, v[c[i]]);
			}
			if (num1 != num2) {
				f = false;
				break;
			}
		}
		if (f) {
			bool ff = false;
			for (int i = 0; i < v.size(); ++i) {
				if (v[i] > ans[i]) {
					break;
				}
				else if (v[i] < ans[i]) {
					ff = true;
					break;
				}
			}
			if (ff) ans = v;
		}
	} while (next_permutation(v.begin(), v.end()));
	for (auto i : ans) {
		cout << i << ' ';
	}
	cout << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}