#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <iomanip>


using namespace std;
#define ll long long
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define pii pair<int,int>
#define sz(x) x.size()
#define vpi vector<pii>
#define pb push_back
#define ff first
#define ss second

ll gcd(ll a, ll b){
    if(b == 0){
        return a;
    }
    return (b, a % b);
}

const int N = 2e5 + 10;
int a[N];
pii b[N];
vi v;
bool f = false;

void anum(int r, int ind, int cur, int n){
    if(ind == r){
        ll gcd1 = 0, gcd2 = 0;
        for(int i = 0; i < r; ++i){
            gcd1 = abs(gcd(gcd1, b[i].ff));
            gcd2 = abs(gcd(gcd2, a[b[i].ss]));
        }
        if(gcd1 != gcd2){
            f = true;
        }
        return;
    }
    if(cur >= n){
        return;
    }
    anum(r, ind + 1, cur, n);
    b[ind] = make_pair(v[cur], cur);
    anum(r, ind + 1, cur + 1, n);
}

void solve(){
    int n, k, x;
    cin >> n >> k >> x;
    for(int i = 0; i < n; ++i){
        cin >> a[i];
        v.pb(a[i]);
    }
    sort(all(v));
    do{
        f = false;
        anum(k, 0, 0, n - 1);
        if(!f){
            for(auto i : v){
                cout << i << ' ';
            }
            return;
        }
    }while(next_permutation(all(v)));
    cout << "\n";
}

int main(){
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}