#include <bits/stdc++.h>
#define pb push_back
#define ff first
#define ss second
#define rep(i, n) for (int i = 0; i < int(n); i++)
#define replr(i, l, r) for (int i = int(l); i <= int(r); i++) 
#define reprl(i, r, l) for (int i = int(r); i >= int(l); i--) 
using namespace std;
typedef pair<int, int> PII;
typedef vector<int> VI;
typedef vector<PII> VPI;
typedef vector<VI> VVI;
typedef long long ll;
typedef pair<ll, ll> PLL;
typedef vector<ll> VL;
typedef vector<PLL> VPL;
typedef vector<VL> VVL;

int n, m;
VVI gp;
VI cur, lavind;
VI P;
int lavcnt;
VI euler;

void dfs1(int u = 0, int p = -1) {
	euler.pb(u);
	rep(i, gp[u].size()) if (gp[u][i] == p) lavind[u] = (i+1)%(gp[u].size());
	if (u == 0) {
		for (int v : gp[u]) {
			dfs1(v, u);
			euler.pb(u);
		}
		return;
	}
	for (int i = lavind[u]; i < lavind[u] + gp[u].size()-1; i++) {
		int v = gp[u][i % int(gp[u].size())];
		dfs1(v, u);
		euler.pb(u);
	}
}

VI path;

void dfs2(int u = 0) {
	if (u == 0 && lavcnt == n) return;
	path.pb(u);
	int i = cur[u];
	if (cur[u] == lavind[u]) lavcnt--;
	cur[u] = (cur[u] + 1) % int(gp[u].size());
	if (cur[u] == lavind[u]) lavcnt++;
    dfs2(gp[u][i]);
}

void solve() {
    cin >> n >> m;
    gp = VVI(n);
    rep(i, n) {
        int k;
        cin >> k;
        gp[i] = VI(k);
        for (int& x : gp[i]) cin >> x, x--;
    }
    P = VI(m);
    for (int& x : P) cin >> x, x--;
    cur = VI(n);
	lavcnt = 0;
	lavind = VI(n);


    dfs1();
	euler.pop_back();
	rep(u, n) lavcnt += (lavind[u] == cur[u]);
	dfs2();

	int ans = 0;
	int prc = 0;
	for (int x : path) {
		ans++;
		if (x == P[prc]) prc++;
		if (prc == P.size()) break;
	}
	for (int i = 0;; i++) {
		ans++;
		if (euler[i%int(euler.size())] == P[prc]) prc++;
		if (prc == P.size()) break;
	}
	cout << ans << endl;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int t = 1;
    // cin >> t;
    while (t--) solve();
}

