#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include "game.h"
using namespace std;
using ll = long long;
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ff first
#define ss second
#define pub push_back
#define all(x) (x).begin(), (x).end()

const int N = 200005, MAX = 1000000007;
int type[N];
vi a;
int n, d;

void init(std::vector<int> A, int D) {
	n = A.size(), d = D;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		a[i] = A[i];
	}
	for (int i = 0; i < n; ++i) {
		type[i] = 1;
		for (int j = max(i - d, 0); j <= min(i + d, n - 1); ++j) {
			if (j == i) continue;
			if (a[j] > a[i]) type[i] = 0;
		}
	}
}

void updateValue(int index, int newValue) {
	a[index] = newValue;
	init(a, d);
}

bool isWinning(int startIndex) {
	int ind = startIndex;
	if (type[ind]) return true;
	int dist1 = 0, dist2 = 0;
	for (int i = ind; i < n; ++i) {
		if (type[i]) {
			dist1 = i - ind;
			break;
		}
	}
	for (int i = ind; i >= 0; --i) {
		if (type[i]) {
			dist2 = ind - i;
			break;
		}
	}
	if ((dist1 && dist1 % (d + 1)) || (dist2 && dist2 % (d + 1))) return true;
	return false;
}