#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <numeric>
#include <limits>
#include <climits>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) (v).begin(), (v).end()
#define mkp make_pair

const int INF = INT_MAX;
const long long LNF = LLONG_MAX;

const int N = 1003;
ll a[N], b[N];
int n, k, x;
vector<int> v;
vector<vector<int>> vx;

ll gcd(ll a, ll b) {
	if (a == 0LL || b == 0LL) return max(a, b);
	if (a >= b) return gcd(b, a % b);
	else return gcd(a, b % a);
}

void solve()
{
	v.clear();
	vx.clear();
	int i, j;
	cin >> n >> k >> x;

	for (i = 1; i <= n; i++) {
		cin >> a[i];
		v.pb(a[i]);
	}

	for (i = 0; i < 30; i++) {
		next_permutation(all(v));

		bool flag = true;
		for (j = 1; j < n; j++) {
			for (int k = j + 1; k <= n; k++) {
				if (gcd(a[j], a[k]) != gcd(v[j - 1], v[k - 1])) {
					flag = false;
					break;
				}
			}
			if (!flag) break;
		}

		if (flag) {
			vx.pb(v);
		}
	}

	sort(all(vx));
	for (j = 0; j < n; j++) {
		cout << vx[0][j] << ' ';
	}
	cout << "\n";

	return;
}

int main()
{
	int mt = 1;
	cin >> mt;
	while (mt--) {
		solve();
	}
	return 0;
}