#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <assert.h>
using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define pb push_back
#define sz(x) (int((x).size()))
#define clr(x) (x).clear()

// ------------------------------------------------- //

const int N = 500005, M = 500005;
int a[M];
vector<int> g[N];
int ind[N];
int n, m;

void solve()
{
	int i, j;
	int k;

	cin >> n >> m;

	for (i = 1; i <= n; i++) {
		cin >> k;

		g[i].resize(k);

		for (j = 0; j < k; j++) cin >> g[i][j];

		ind[i] = 0;
	}

	for (i = 1; i <= m; i++) cin >> a[i];

	int u = 1, v;
	ll ans = 0;

	for (i = 1; i <= n; i) {
		if (u == a[i]) i++;

		ans++;
		v = g[u][ind[u]];
		ind[u] = (ind[u] + 1) % sz(g[u]);

		u = v;
	}

	if (ans > 2500) assert(false);

	cout << ans << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}
