#include "game.h"


#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <assert.h>
using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define pb push_back
#define sz(x) (int((x).size()))
#define clr(x) (x).clear()

// ------------------------------------------------- //

const int N = 200005, LG = 20;
int a[N];
int n, lg, d;

pr<int, int> h[N];

void precalc()
{
	int i, j;

	h[1] = mpr(0, 1);

	for (i = 2; i <= 200003; i++) {
		h[i] = h[i - 1];

		if (h[i].ss * 2 <= i) {
			h[i].ff++;
			h[i].ss *= 2;
		}
	}

	return;
}

int t[N][LG];

void bld()
{
	int i, j;

	for (i = 1; i <= n; i++) t[i][0] = i;

	int g;

	for (j = 1; j <= lg; j++) {
		g = (1 << (j - 1));
		for (i = 1; i <= n - g * 2 + 1; i++) {
			if (a[t[i][j - 1]] >= a[t[i + g][j - 1]]) t[i][j] = t[i][j - 1];
			else t[i][j] = t[i + g][j - 1];
		}
	}

	return;
}

int qry(int l, int r)
{
	int len = r - l + 1;
	if (a[t[l][h[len].ff]] >= a[t[r - h[len].ss + 1][h[len].ff]]) return t[l][h[len].ff];
	return t[r - h[len].ss + 1][h[len].ff];
}

void init(vector<int> A, int D)
{
	int i, j;

	precalc();

	n = sz(A);
	d = D;

	for (i = 1; i <= n; i++) a[i] = A[i - 1];


	lg = 0;
	while ((1 << lg) <= n) lg++;
	lg--;

	bld();

	return;
}

void updateValue(int index, int newValue)
{
	return;
}

bool isWinning(int startIndex)
{
	int i, j;

	int e = startIndex + 1;

	int l = 1, r = n;

	while (1) {
		i = qry(l, r);
		//cout << l << ' ' << r << ' ' << i << "\n";

		if (e == i) return 0;
		if (abs(e - i) <= d) return 1;

		if (e > i + d) l = i + d + 1;
		else r = i - d - 1;
	}

	//assert(false);
}
