#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <math.h>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <chrono>

using namespace std;

#define ll long long
#define fr first
#define sc second
#define pb push_back

const int N = 500005;
const ll oo = 100000000000000000, MOD = 1000000007;

vector<int> g[N];
int p[N];
int n, m;
ll ans = 1, num[N], b[N], ans1[N];
ll sz[N];

void dfs(int u,int par) {
    int index = -1;
    if (u != 1) {
        for (int i = 0; i < g[u].size(); ++i) {
            int h = g[u][i];
            if (h != par) {
                dfs(h, u);
            }
            else {
                index = i;
            }
        }
        ll mx = sz[u];
        ans1[u] = 0;
        for (int i = 0; i < g[u].size(); ++i) {
            int h = g[u][i];
            if (i < index) {
                if (b[h] >= mx) {
                    mx = b[h];
                    ans1[u] = ans1[h] + 1;
                }
            }
            if (i > index) {
                if (b[h] + 1 >= mx) {
                    mx = b[h] + 1;
                    ans1[u] = ans1[h] + 1;
                }
            }
        }
        b[u] = mx;
    }
    else {
        ll mx = 0, f = 0;

        for (int i = 0; i < g[u].size(); ++i) {
            int h = g[u][i];
            if (h != par) {
                dfs(h, u);
                if (b[h] >= mx) {
                    mx = b[h];
                    ans1[u] = ans1[h] + 1;
                }
            }
        }
        f = mx * g[u].size();
        if (f <= sz[u]) {
            b[u] = sz[u];
            ans1[u] = 0;
        }
        else {
            b[u] = f;
        }
    }
    //cout << u << " " << b[u] << endl;
    //cout << u << " " << index << " " << cnt << endl;
}

void dfs1(int u, int par) {
    int cntson = g[u].size();
    if (u != 1) {
        cntson--;
    }
    if (u == 1) {
        ll tv = num[u] / cntson + ((num[u] % cntson) != 0);
        ll q = (num[u] - cntson * (tv - 1));
        ll sm = 0;
        for (int i = 0; i < g[u].size(); ++i) {
            int h = g[u][i];
            if (h != par) {
                ++sm;
                ans += 2 * tv;
                num[h] = tv;
                if (g[h].size() != 1) {
                    dfs1(h, u);
                }
                if (sm == q) {
                    --tv;
                }
            }
        }
    }
    else {
        int index = 0;
        for (int i = 0; i < g[u].size(); ++i) {
            int h = g[u][i];
            if (h == par) {
                index = i;
                break;
            }
        }
        for (int i = 0; i < index; ++i) {
            int h = g[u][i];
            num[h] = num[u];
            ans += 2 * num[h];
            if (g[h].size() != 1) {
                dfs1(h, u);
            }
        }
        for (int i = index + 1; i < g[u].size(); ++i) {
            int h = g[u][i];
            num[h] = max(num[u] - 1, 0LL);
            ans += 2 * num[h];
            if (g[h].size() != 1) {
                dfs1(h, u);
            }
        }
    }
}

void solve() {
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        int sz;
        cin >> sz;
        for (int j = 0; j < sz; ++j) {
            int v;
            cin >> v;
            g[i].pb(v);
        }
    }
    //cout << g[1][0] << " " << g[1][1] << endl;
    for (int i = 1; i <= m; ++i) {
        cin >> p[i];
        sz[p[i]]++;
    }
    dfs(1,-1);
    num[1] = b[1];
    ans = 1;
    //cout << num[1] << " " << ans1[1] << endl;
    dfs1(1, -1);
    cout << ans-ans1[1] << endl;
}


int main() {
    int tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}