#include <bits/stdc++.h>

#define ll long long
#define endl "\n"

using namespace std;
const ll MAX = 32005;
bool sieve[MAX];
vector<ll> pr;
void precomp()
{
    for (ll i = 1; i < MAX; i++)
        sieve[i] = true;
    for (ll i = 2; i < MAX; i++)
        if (sieve[i])
            for (ll j = i + i; j < MAX; j += i)
                sieve[j] = false;
    for (ll i = 2; i < MAX; i++)
        if (sieve[i])
            pr.push_back(i);
}
vector<ll> f(vector<ll> a, vector<ll> b, map<pair<ll, ll>, vector<ll>> &ps, ll k)
{
    a = b;
    ll n = a.size();
    for (auto [p, v] : ps)
        if (v.size() < k)
        {
            for (ll i : v)
                while (a[i] % p.first == 0)
                    a[i] /= p.second;
        }
    map<ll, vector<pair<ll, ll>>> mp;
    for (ll i = 0; i < n; i++)
        mp[a[i]].push_back(make_pair(b[i], i));
    for (auto [i, v] : mp)
    {
        sort(v.begin(), v.end());
        vector<ll> tmp;
        for (auto i : v)
            tmp.push_back(i.second);
        sort(tmp.begin(), tmp.end());
        for (ll i = 0; i < v.size(); i++)
            b[tmp[i]] = v[i].first;
    }
    return b;
}
void solve()
{
    ll n, k, x;
    cin >> n >> k >> x;
    vector<ll> a(n);
    for (ll &i : a)
        cin >> i;
    vector<ll> b(n), c(n);
    for (ll i = 0; i < n; i++)
        b[i] = c[i] = a[i];
    map<pair<ll, ll>, vector<ll>> ps;
    for (ll i = 0; i < n; i++)
    {
        ll tmp = a[i];
        for (ll x : pr)
        {
            if (x * x > tmp)
                break;
            if (tmp % x == 0)
            {
                ll pw = 1;
                while (tmp % x == 0)
                    tmp /= x, pw *= x, ps[make_pair(pw, x)].push_back(i);
                // s.insert(x);
            }
        }
        if (tmp > 1)
            ps[make_pair(tmp, tmp)].push_back(i);
    }
    for (auto [p, v] : ps)
        if (v.size() < k)
        {
            for (ll i : v)
                while (a[i] % p.first == 0)
                    a[i] /= p.second;
        }
    map<ll, vector<pair<ll, ll>>> mp;
    map<ll, vector<ll>> mp1;
    for (ll i = 0; i < n; i++)
        mp[a[i]].push_back(make_pair(b[i], i));
    for (auto [i, v] : mp)
    {
        sort(v.begin(), v.end());
        vector<ll> tmp;
        for (auto i : v)
            tmp.push_back(i.second);
        sort(tmp.begin(), tmp.end());
        mp1[i] = tmp;
        for (ll i = 0; i < v.size(); i++)
            b[tmp[i]] = v[i].first;
    }
    if (x > 1)
    {
        array<ll, 3> best = {(ll)1e9, (ll)1e9, (ll)1e9};
        ll pos;
        for (ll i = 0; i < n; i++)
        {
            ll tmp = c[i] * x, pw = 1;
            while (tmp % x == 0)
                pw *= x, tmp /= x;
            if (ps[make_pair(pw, x)].size() >= k)
            {
                pos = upper_bound(mp[a[i] * x].begin(), mp[a[i] * x].end(), make_pair(b[i], (ll)1e9)) - mp[a[i] * x].begin();
                if (array<ll, 3>{pos == mp1[a[i] * x].size() ? i : mp1[a[i] * x][pos], b[i], i} < best)
                    best = {pos == mp1[a[i] * x].size() ? i : mp1[a[i] * x][pos], b[i], i};
            }
        }
        // for (ll i : check)
        ll i = best[2];
        {
            ll tmp = c[i] * x, pw = 1;
            while (tmp % x == 0)
                pw *= x, tmp /= x;
            if (ps[make_pair(pw, x)].size() >= k)
            {
                c[i] *= x;
                a[i] *= x;
                ps[make_pair(pw, x)].push_back(i);
                b = min(b, f(a, c, ps, k));
                c[i] /= x;
                a[i] /= x;
                ps[make_pair(pw, x)].pop_back();
            }
        }
    }
    for (ll i : b)
        cout << i << " ";
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    precomp();
    cin >> t;
    for (ll i = 1; i <= t; i++)
        solve();
    cerr << "\nTime elapsed: " << clock() * 1000.0 / CLOCKS_PER_SEC << " ms\n";
}
