#include <bits/stdc++.h>
using namespace std;

#include "game.h"

const int N = 2e5 + 55;

bool is_win[N];

vector<int> a;

int d;

void init(std::vector<int> v, int D) {
    a = v;
    d = D;
    int mx = 0 , ind = 0 , n = a.size();
    bool used[n];
    for (int i = 0;i < n;i ++) {
        if (mx < a[i]) {
            mx = a[i];
            ind = i;
        }
        used[i] = false;
    }

    for (int i = 0;i < n;i ++) {
        if (is_win[i] == true) {
            continue;
        }
        bool as = true;
        for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
            if (a[j] > a[i]) {
                as = true;
                break;
            }
        }
        if (as == false) {
            for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
                is_win[j] = true;
                used[j] = true;
            }
            is_win[i] = false;
        }
    }
    for (int i = ind - 1;i >= 0;i --) {
        if (used[i] == true) {
            continue;
        } 
        for (int j = i + 1;j <= min(i + d , ind);j ++) {
            if(is_win[j] == false) {
                is_win[i] = true;
                break;
            }
        }
        used[i] = true;
    }
    for (int i = ind + 1;i < n;i ++) {
        if (is_win[i] == true) {
            continue;
        }
        for (int j = i - 1;j >= min(i - d , ind);j --) {
            if(is_win[j] == false) {
                is_win[i] = true;
                break;
            }
        }
        used[i] = true;
    }
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    int mx = 0 , ind = 0 , n = a.size();
    bool used[n];
    for (int i = 0;i < n;i ++) {
        if (mx < a[i]) {
            mx = a[i];
            ind = i;
        }
        used[i] = false;
    }

    for (int i = 0;i < n;i ++) {
        if (is_win[i] == true) {
            continue;
        }
        bool as = true;
        for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
            if (a[j] > a[i]) {
                as = true;
                break;
            }
        }
        if (as == false) {
            for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
                is_win[j] = true;
                used[j] = true;
            }
            is_win[i] = false;
        }
    }
    for (int i = ind - 1;i >= 0;i --) {
        if (used[i] == true) {
            continue;
        } 
        for (int j = i + 1;j <= min(i + d , ind);j ++) {
            if(is_win[j] == false) {
                is_win[i] = true;
                break;
            }
        }
        used[i] = true;
    }
    for (int i = ind + 1;i < n;i ++) {
        if (is_win[i] == true) {
            continue;
        }
        for (int j = i - 1;j >= min(i - d , ind);j --) {
            if(is_win[j] == false) {
                is_win[i] = true;
                break;
            }
        }
        used[i] = true;
    }
}

bool isWinning(int startIndex) {
    return is_win[startIndex];
}