#include <bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

const int MAX = 5e5 + 5;
int n , m;
vector<vector<int>> g(MAX);
vector<int> level(MAX , -1);
vector<vector<int>> cnt(MAX);

void detectlevel(int node){
    for(auto to : g[node]){
        if(level[to] == -1){
            level[to] = level[node] + 1;
            detectlevel(to);
        }
    }
}

void solve(){
    cin >> n >> m;
    for(int i=1 ; i<=n ; i++){
        int cnt;
        cin >> cnt;
        for(int j=1 ; j<=cnt ; j++){
            int node;
            cin >> node;
            g[i].push_back(node);
        }
    }
    for(int i=1 ; i<=m ; i++){
        int x;
        cin >> x;
    }
    int day = 0;
    level[1] = 1;
    detectlevel(1);
    for(int i=1 ; i<=n ; i++){
        cnt[level[i]].push_back(i);
    }
    int total = 1;
    int did = 1;
    while(did < m){
        for(int i=2 ; i<=n ; i++){
            if(did + cnt[i].size() > m){
                total += ((i-1)*2) * (m - did);
                did = m;
                break;
            }
            total += ((i-1)*2) * cnt[i].size();
            did += cnt[i].size();
            if(cnt[i].size() == 0){
                break;
            }
        }
    }
    cout << total << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
