#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("Ofast")

using namespace std;
using namespace __gnu_pbds;

const int N = 1e5+5;

mt19937_64 rng(2008);

gp_hash_table<long long, long long> ids;
vector<long long> v, ans, cur, oh, prim;
gp_hash_table<long long, int> fr;
gp_hash_table<long long, multiset<long long>> mp, mp2;


long long hsh(long long x)
{
    if(x == 1)  return 0;
    if(ids[x])    return ids[x];
    return ids[x] = (rng())%(long long)(4e18)+1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    int tc;
    cin >> tc;
    while(tc--)
    {
        fr.clear();
        mp.clear();
        mp2.clear();    
        long long n, k, x;
        cin >> n >> k >> x;
        v.resize(n);
        oh.resize(n);
        prim.resize(n);
        ids.clear();
        ans.resize(n);
        long long go = 0;
        for(int i = 0; i < n; i++)
        {
            cin >> v[i];
            go = __gcd(go, v[i]);
        }
        for(int i = 0; i < n; i++)  v[i] /= go;
        for(int i = 0; i < n; i++)
        {
            long long z = v[i];
            for(long long j = 2; j*j <= z; j++)
            {
                long long o = j;
                while(z%j == 0)
                {
                    fr[o]++;
                    o *= j;
                    z /= j;
                }
                if(j == x)  fr[o]++;
            }
            if(z > 1)   fr[z]++;
        }
        for(int i = 0; i < n; i++)
        {
            long long z = v[i];
            vector<long long> se;
            for(long long j = 2; j*j <= z; j++)
            {
                if(z%j == 0)    se.push_back(j);
                while(z%j == 0)
                {
                    z /= j;
                }
            }
            if(z > 1) se.push_back(z);
            sort(se.begin(), se.end());
            for(auto it : se)
            {
                long long h = it;
                while(v[i]%h == 0 && fr[h] >= k)
                {
                    h *= it;
                }
                h /= it;
                if(fr[h] >= k && v[i]%h == 0)  prim[i] ^= hsh(h);
            }
            mp[prim[i]].insert(i);
            mp2[prim[i]].insert(v[i]);
        }
        for(auto &[a, it]: mp)
        {
            auto it3 = mp2[a].begin();
            for(auto it2 : it)  
            {
                ans[it2] = (*it3);
                it3++;
            }
        } 
        for(int ok = 0+(x == 1 ? n : 0); ok < n; ok++)
        {
            long long z = v[ok];
            long long o = x;
            while(z%x == 0)
            {
                o *= x;
                z /= x;
            }
            fr[o]++;
            mp[prim[ok]].erase(mp[prim[ok]].find(ok));
            mp2[prim[ok]].erase(mp2[prim[ok]].find(v[ok]));
            if(fr[o] >= k)  prim[ok] ^= hsh(o/x);
            if(fr[o] >= k)  prim[ok] ^= hsh(o);
            mp[prim[ok]].insert(ok);
            mp2[prim[ok]].insert(v[ok]*x);
            for(auto &[a, it]: mp)
            {
                auto it3 = mp2[a].begin();
                for(auto it2 : it)  
                {
                    oh[it2] = (*it3);
                    it3++;
                }
            } 
            ans = min(ans, oh);
            mp[prim[ok]].erase(mp[prim[ok]].find(ok));
            mp2[prim[ok]].erase(mp2[prim[ok]].find(v[ok]*x));
            if(fr[o] >= k)  prim[ok] ^= hsh(o/x);
            if(fr[o] >= k)  prim[ok] ^= hsh(o);
            fr[o]--;
            mp[prim[ok]].insert(ok);
            mp2[prim[ok]].insert(v[ok]);
        }
               
        for(int i = 0; i < n; i++) cout << ans[i]*go << ' ';
        cout << '\n';
    }
    
}



