#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define endl '\n'
vector<pair<int,int>> pFactors(int n){
    vector<pair<int,int>> ret;
    int cnt = 0;
    while(n % 2 == 0){
        cnt ++;
        n >>= 1;
    }
    if(cnt) ret.push_back({2,cnt});
    for(int i=3;i*i<=n;i+=2){
        cnt = 0;
        while(n % i == 0){
            cnt ++;
            n /= i;
        }
        if(cnt) ret.push_back({i,cnt});
    }
    if(n > 1) ret.push_back({n,1});
    return ret;
}
void compress(vector<int> &a){
    int n = a.size();
    vector<pair<int,int>> tmp;
    for(int i=0;i<n;i++){
        tmp.push_back({a[i],i});
    }
    sort(tmp.begin(),tmp.end());
    int cnt = 1;
    a[tmp[0].second] = cnt;
    for(int i=1;i<n;i++){
        if(tmp[i].first == tmp[i-1].first){
            a[tmp[i].second] = a[tmp[i-1].second];
        }
        else {
            a[tmp[i].second] = ++cnt;
        }
    }
}
void solve(){
    int n,k,x;
    cin>>n>>k>>x;
    vector<int> a(n);
    for(auto &i:a) cin>>i;
    vector<int> anss(n,1e9);
    for(int ii=0;ii<n;ii++){
        a[ii] *= x;
        vector<int> b(n); 
        map<pair<int,int>,int> frq;
        for(int i=0;i<n;i++){
            vector<pair<int,int>> pfs = pFactors(a[i]);
            for(auto [p,f] : pfs){
                frq[{p,f}] ++; 
            }
        }
        for(int i=0;i<n;i++){
            int x = 1;
            vector<pair<int,int>> pfs = pFactors(a[i]);
            for(auto [p,f] : pfs){
                int cnt = 0;
                for(int j=30;j>=1;j--){
                    if(!frq.count({p,j})) continue;
                    cnt += frq[{p,j}];
                    if(cnt >= k){
                        for(int z=0;z<min(j,f);z++){
                            x *= p;
                        }
                        break;
                    }
                }
            }
            b[i] = x;
        }
        compress(b);
        vector<vector<int>> idx(n+1);
        vector<vector<int>> vals(n+1);
        for(int i=0;i<n;i++){
            idx[b[i]].push_back(i);
            vals[b[i]].push_back(a[i]);
        }
        vector<int> ans(n);
        for(int i=1;i<=n;i++){
            if(!vals[i].empty()) sort(vals[i].begin(),vals[i].end());
            for(int j=0;j<(int)vals[i].size();j++) ans[idx[i][j]] = vals[i][j];
        }
        a[ii] /= x;
        for(int i=0;i<n;i++){
            if(ans[i] < anss[i]) {
                anss = ans;
                break;
            }
            else if(ans[i] > anss[i]) break;
        }
    }
    for(auto i : anss) cout<<i<<' ';
    cout<<endl;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);      cout.tie(0);
    int t=1;
    cin>>t;
    while(t--){
        solve();
    }
}