#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;
#define int long long
int n, k, x;
vector <int> a, b, c;
map <int, vector <pair <int, int>>> dd;
map <int, vector <int>> pp;
vector <pair <int, int>> factorize (int x) {
    vector <pair <int, int>> ret;
    map <int, int> ehbed;
    for (int i = 2; i * i <= x; i++) {
        while (x % i == 0) {
            ehbed[i]++;
            x /= i;
        }
    }
    if (x > 1) ehbed[x]++;
    for (auto i : ehbed) ret.push_back(i);
    return ret;
}
int power (int a, int b) {
    if (!b) return 1;
    int u = power(a, b >> 1);
    u *= u;
    if (b & 1) u *= a;
    return u;
}
void resolve () {
    dd.clear(); pp.clear();
    for (int i = 0; i < n; i++) {
        auto g = factorize(a[i]);
        for (auto [x, y] : g) {
            dd[x].push_back({y, i});
        }
    }
    for (int i = 0; i < n; i++) b[i] = 1;
    for (auto i : dd) {
        auto h = i.second;
        sort(h.begin(), h.end());
        reverse(h.begin(), h.end());
        int pref[(int)h.size()] = {};
        for (int l = (int)h.size() - 1; l >= 0; l--) {
            if (l >= k - 1) pref[l] = h[l].first;
            if (l < (int)h.size() - 1) pref[l] = max(pref[l], pref[l + 1]);
        }
        for (int l = 0; l < (int)h.size(); l++) {
            b[h[l].second] *= power(i.first, pref[l]);
        }
    }
    for (int i = 0; i < n; i++) {
        pp[b[i]].push_back(a[i]);
    }
    for (auto &i : pp) {
        sort(i.second.begin(), i.second.end());
        reverse(i.second.begin(), i.second.end());
    }
    for (int i = 0; i < n; i++) {
        int z = pp[b[i]].back();
        pp[b[i]].pop_back();
        b[i] = z;
    }
}
void solve () {
    cin >> n >> k >> x;
    a.resize(n); b.resize(n); c.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (x == 1) {
        resolve();
        for (auto i : b) cout << i << " ";
        cout << '\n';
        return;
    }
    resolve();
    c = b;
    for (int i = 0; i < n; i++) {
        a[i] *= x;
        resolve();
        c = min(c, b);
        a[i] /= x;
    }
    for (auto i : c) cout << i << " ";
    cout << '\n';
}
signed main () {
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
}