#define pb push_back
#include <bits/stdc++.h>
#define ll long long
#define s second
#define f first
#include "game.h"
using namespace std;

const int N = 2e5 + 5;
int a[N],d,n;
map <int,bool> dp;

bool get(int i){
	if (dp.find(i) != dp.end()) return dp[i];
	
	bool win = 1;
	int x = a[i];
	
	for (int j = i + 1; j <= min(n - 1, i + d); j++){
		if (a[j] < a[i] || !get(j)) continue;
		win = 0;
		break;
	}
	
	for (int j=i-1;j>=max(0,i-d);j--){
		if (a[j] < a[i] || !get(j)) continue;
		win = 0;
		break;
	}
	
	return dp[i] = win;
}

void rebuild(){
	dp.clear();
	for (int i=0;i<n;i++)
		get(i);
}

void init(vector<int> A, int D){
	n = A.size();
	for (int i=0;i<A.size();i++)
		a[i] = A[i];
	d = D;
	rebuild();
}

void updateValue(int index, int newValue){
	a[index] = newValue;
	rebuild();
}

bool isWinning(int st){
	bool win = 0;
	for (int i = st + 1; i <= min(n - 1,st + d); i++){
		win |= get(i);
	}
	
	for (int i = st- 1; i >= max(0,st-d); i--){
		win |= get(i);
	}
	return win;
}

/*
6 2
1 7 4 9 30 2
5 
2 0 
2 1 
1 4 8 
2 0 
2 1
*/
//1 7 4 9 8 2
