#include <bits/stdc++.h>
#include "game.h";
using namespace std;
const int N = 2e5 + 1;
int n , q , d;
vector<int> win(N);
vector<pair<int , int>> t(4 * N);
void upd(int u , int l , int r , int pos , int x){
    if(l == r){
        t[u].first = x;
        t[u].second = l;
        return;
    }
    int m = (l + r) / 2;
    if(pos <= m)upd(u * 2 , l , m , pos , x);
    else upd(u * 2 + 1 , m + 1 , r , pos , x);
    t[u].first = max(t[u * 2].first , t[u * 2 + 1].first);
    t[u].second = (t[u].first == t[u * 2].first ? t[u * 2].second : t[u * 2 + 1].second);
}
pair<int , int> get(int u , int l , int r , int L , int R){
    if(l > r || r < L || l > R) return {0 , 0};
    if(L <= l && r <= R) return t[u];
    int m = (l + r) / 2;
    auto a = get(u * 2 , l , m , L , R);
    auto b = get(u * 2 + 1 , m + 1 , r , L , R);
    return {max(a.first , b.first) , (a.first > b.first ? a.second : b.second)};
}
bool solve(int l , int r , int pos){
    int mx_pos = get(1 , 1 , n , l , r).second;
    //cout << l << " " << r << " " << mx_pos << endl;
    if(mx_pos == pos){
        return 1;
    }
    if(pos - d <= mx_pos && mx_pos <= pos + d){
        return 0;
    }
    if(pos <= mx_pos - d - 1){
        return solve(l , mx_pos - d - 1 , pos);
    }
    return solve(mx_pos + d + 1 , r , pos);
}
void solve(int l , int r){
    if(l > r) return;
    int mx_pos = get(1 , 1 , n , l , r).second;
    win[mx_pos] = 1;
    solve(l , mx_pos - d - 1);
    solve(mx_pos + d + 1 , r);
}
void init(vector<int> A , int D){
    d = D;
    n = (int)A.size();
    for(int i = 1;i <= n;i ++){
        upd(1 , 1 , n , i , A[i - 1]);
    }
    solve(1 , n);
}
void updateValue(int ind , int val){
    ++ind;
    upd(1 , 1 , n , ind , val);
}
bool isWinning(int ind){
    ++ind;
    for(int i = max(1 , ind - d);i <= min(n , ind + d);i ++){
        if(i != ind){
            if(win[i]){
                return true;
            }
        }
    }
    return false;
}
