#include<bits/stdc++.h>
using namespace std;

bool can[200005];
int b[200005],c[200005],n,dist;
priority_queue<pair<int,int> > pq;

void init(std::vector<int> a, int d){
	n = a.size(); dist = d;
	while(pq.size()>0) pq.pop();
	for(int i = 0; i < a.size(); i++){
		can[i] = true; c[i] = 0;
		b[i] = a[i];
		pq.push({b[i],i});
	}
	while(pq.size() > 0){
		pair<int,int> p = pq.top(); pq.pop();
		if(c[p.second] == 1) continue;
		can[p.second] = false;
		for(int i = max((int)0,p.second - d); i <= min(n-1,p.second + d); i++){
			c[i] = 1;
		}
	}
}

void updateValue(int index, int newValue){
	b[index] = newValue;
	while(pq.size()>0) pq.pop();
	for(int i = 0; i < n; i++){
		can[i] = true; c[i] = 0;
		pq.push({b[i],i});
	}
	while(pq.size() > 0){
		pair<int,int> p = pq.top(); pq.pop();
		if(c[p.second] == 1) continue;
		can[p.second] = false;
		for(int i = max((int)0,p.second - dist); i <= min(n-1,p.second + dist); i++){
			c[i] = 1;
		}
	}
}

bool isWinning(int startIndex){
	return can[startIndex];
}
