#include <bits/stdc++.h>
using namespace std;

#define pb push_back

const int MAXN=2e5+5;
deque<int> g[MAXN];
int n,m,cnt=0,ff,timer=0;
vector<int> sequence[MAXN];
set<int> nodes;

void dfs(int v) {

	if(v == 1 and ff == g[v].front() and nodes.size() == n) {
		return;
	}

	nodes.insert(v);
	sequence[v].pb(timer++);
	auto x = g[v].front();
	g[v].pop_front();
	g[v].pb(x);
	dfs(x);
}

void solve() {
	cin>>n>>m;

	for(int i=1;i<=n;i++) {
		int k;
		cin>>k;
		for(int j=0;j<k;j++) {
			int x; cin>>x;
			g[i].pb(x);
		}
	} 
	
	vector<int> vv(m);

	for(int &i : vv) cin>>i;
	
	ff = g[1].front();

	dfs(1);

	int pos = 0,vPos=0,cycle=0;

	while(vPos < m) {

		int node = vv[vPos];
		auto x = lower_bound(sequence[node].begin(),sequence[node].end(),pos);

		if(x == sequence[node].end()) {
			cycle++;
			x = sequence[node].begin();
		}

		pos = *x;
		vPos++;
	} 
	
	cout<<cycle*timer + pos + 1<<'\n';
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	solve();
}