#include <bits/stdc++.h>
#define vc vector

using ll = long long;
using namespace std;
const int M = 1e8 + 543;
const int mod = M;
const int N = 5e5;
const int lg = 20;

vc <int> g[N];
vc <int> ip[N];
int ptr[N];
int tin[N], tout[N];
int P[N], up[N][lg], timer = 0;
map <int, int> where[N];

int when (int u, int k) {
    int res = 0;
    for (; ptr[u] != k; ptr[u] = (ptr[u] + 1) % g[u].size()) {
        int v = g[u][ptr[u]];
        res += when(v, ip[u][ptr[u]]) + 2;
    }
    return res;
}

void dfs (int u) {
    tin[u] = timer++;
    for (int j = 1; j < lg; ++j)
        up[u][j] = up[up[u][j - 1]][j - 1];
    for (int v : g[u]) {
        if (v != up[u][0]) {
            up[v][0] = u;
            dfs(v);
        }
    }
    tout[u] = timer;
}

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int v;
            cin >> v;
            g[i].push_back(v - 1);
            where[i][v - 1] = j;
        }
    }
    dfs(0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < g[i].size(); ++j) {
            ip[i].push_back(where[g[i][j]][i]);
        }
    }
    int ans = 0, cur = 0;
    for (int i = 0; i < m; ++i) {
        cin >> P[i];
        --P[i];
        int f = 0;
        if (!is_ancestor(cur, P[i])) {
            int x = cur;
            for (int j = lg - 1; j >= 0; --j) {
                if (!is_ancestor(up[x][j], P[i]))
                    x = up[x][j];
            }
            int p = up[x][0];
            ans += when(x, where[x][p]) + 1;
            ptr[p] = (ptr[p] + 1) % g[p].size();
            f = 1;
            cur = p;
        }
        if (!f && cur == P[i]) {
            int v = g[cur][ptr[cur]];
            ans += when(v, ip[cur][ptr[cur]]) + 2;
            ptr[cur] = (ptr[cur] + 1) % g[cur].size();
        } else if (cur != P[i]) {
            int p = up[P[i]][0];
            ans += when(up[P[i]][0], where[p][P[i]]) + 1;
        }
        cur = P[i];
    }
    cout << ans << '\n';
    return 0;
}