#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <iomanip>
#include <cassert>
#include <chrono>
#include <queue>

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define lb lower_bound
#define ub upper bound

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<char> vc;
typedef vector<vc> vvc;

template<typename t> bool minravno(t& a, t b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, t b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}

const int INF = 1e18;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;
	vector<queue<int>> g(n + 1);
	for (int i = 1; i <= n; ++i) {
		int k;
		cin >> k;
		while (k--) {
			int u;
			cin >> u;
			g[i].push(u);
		}
	}
	vi a(m);
	input(a);
	vb used(n + 1, false);
	int cnt = 0;
	int v = 1;
	vi arr;
	int j = 0;
	while (v != 1 || cnt != n) {
		arr.push_back(v);
		if (j < m && v == a[j])
			j++;
		if (j == m) {
			cout << arr.size() << '\n';
			return 0;
		}
		assert(arr.size() <= n * 10);
		if (!used[v])
			cnt++;
		used[v] = true;
		int u = g[v].front();
		g[v].pop();
		g[v].push(u);
		v = u;
	}
	vi arr2;
	used.assign(n + 1, false);
	cnt = 0;
	while (v != 1 || cnt != n) {
		arr2.push_back(v);
		if (!used[v])
			cnt++;
		used[v] = true;
		int u = g[v].front();
		g[v].pop();
		g[v].push(u);
		v = u;
	}
	vvi b(n + 1);
	for (int i = 0; i < arr2.size(); ++i)
		b[arr2[i]].push_back(i);
	int lapse = 0, ind = 0;
	for (; j < m; ++j) {
		int v = a[j];
		auto it = lb(all(b[v]), ind);
		if (it == b[v].end()) {
			lapse++;
			ind = 0; 
			it = lb(all(b[v]), ind);
		}
		ind = *it + 1;
		if (ind == arr2.size()) {
			lapse++;
			ind = 0;
		}
	}
	cout << (ll)arr.size() + (ll)arr2.size() * (ll)lapse + (ll)ind;
	return 0;
}