#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, k, X;
    cin >> n >> k >> X;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    auto solve = [&](auto self, vector<int> b) -> vector<int> {
        if (size(b) <= k) {
            sort(b.begin(), b.end());
            return b;
        }
        int m = size(b);
        vector<int> pref(m + 1), suf(m + 1);
        for (int i = 0; i < m; ++i) {
            pref[i + 1] = gcd(pref[i], b[i]);
        }
        for (int i = m - 1; i >= 0; --i) {
            suf[i] = gcd(suf[i + 1], b[i]);
        }
        int need = pref[m];
        vector<int> nxt;
        for (int i = 0; i < m; ++i) {
            int d = gcd(pref[i], suf[i + 1]);
            if (d == need) {
                nxt.push_back(b[i]);
            }
        }
        if (nxt.size() == m) {
            sort(b.begin(), b.end());
            return b;
        }
        auto res = self(self, nxt);
        for (int i = 0; i < m; ++i) {
            if (gcd(pref[i], suf[i + 1]) != need) {
                res.insert(res.begin() + i, b[i]);
            }
        }
        return res;
    };

    auto ans = solve(solve, a);
    for (int x : ans) {
        cout << x << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}