#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll binpow(ll a, ll st, ll mod) {
    if (st == 0) {
        return 1;
    }
    ll ans = binpow(a, st / 2, mod);
    ans = (ans * ans) % mod;
    if (st % 2) {
        ans = (ans * a) % mod;
    }
    return ans;
}
mt19937 rd(333);
bool check(ll x) {
    if (x % 2 == 0) {
        return x == 2;
    }
    ll st = x - 1;
    while (st % 2 == 0) {
        st /= 2;
    }
    for (int j = 0; j < 20; j++) {
        ll a = rd() % (x - 1) + 1;
        ll d = binpow(a, st, x);
        if (d != 1 && d != x - 1) {
            ll t = st;
            while (t != (x - 1)) {
                d = (d * d) % x;
                t *= 2;
                if (d == x - 1) {
                    break;
                }
            }
            if (d != x - 1) {
                return false;
            }
        }
    }
    return true;
}

ll gcd(ll a, ll b) {
    while (b != 0) {
        ll t = a % b;
        a = b;
        b = t;
    }
    return a;
}

ll f(ll a, ll b) {
    return (a * a + 1) % b;
}

vector<int> facto(int x) {
    if (x == 1) {
        return {};
    }
    ll y = sqrtl(x);
    if (y * y == x) {
        vector<int> d = facto(y);
        vector<int> d1 = d;
        for (auto el : d1) {
            d.push_back(el);
        }
        return d;
    }
    if (check(x)) {
        return {x};
    }
    if (x % 2 == 0) {
        vector<int> d = facto(x / 2);
        d.push_back(2);
        return d;
    }
    while (true) {
        ll y = rd() % x;
        ll y2 = y;
        for (int j = 0; j < 100; j++) {
            y = f(y, x);
            y2 = f(f(y2, x), x);
            ll g = gcd(abs(y - y2), x);
            if (g != 1 && g != x) {
                vector<int> d1 = facto(g);
                vector<int> d2 = facto(x / g);
                for (auto el : d2) {
                    d1.push_back(el);
                }
                return d1;
            }
        }
    }
}

void solve() {
    // for (ll i = 1; i <= 1e5; i++) {
    //     vector<ll> z1 = facto(i);
    //     sort(z1.begin(), z1.end());
    //     vector<ll> z2;
    //     ll x = i;
    //     for (ll j = 2; j * j <= i; j++) {
    //         while (x % j == 0) {
    //             z2.push_back(j);
    //             x /= j;
    //         }
    //     }
    //     if (x != 1) {
    //         z2.push_back(x);
    //     }
    //     cout << i << endl;
    //     assert(z1 == z2);
    // }
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    map<pair<int, int>, int> max_step;
    vector<vector<pair<int, int>>> had(n);
    for (int i = 0; i < n; i++) {
        vector<int> s = facto(a[i]);
        sort(s.begin(), s.end());
        for (int z = 0; z < s.size();) {
            int j = z;
            while (j != s.size() && s[j] == s[z]) {
                j++;
            }
            had[i].push_back({s[z], j - z});
            for (int f = 1; f <= j - z; f++) {
                max_step[{s[z], f}]++;
            }
            z = j;
        }
    }
    map<int, int> ogr;
    for (auto el : max_step) {
        if (el.second >= k) {
            ogr[el.first.first] = max(el.first.second, ogr[el.first.first]);
        }
    }
    for (auto& el : had) {
        for (auto& el2 : el) {
            el2.second = min(el2.second, ogr[el2.first]);
        }
        vector<pair<int, int>> an;
        for (auto el2 : el) {
            if (el2.second) {
                an.push_back(el2);
            }
        }
        el = an;
    }
    map<vector<pair<int, int>>, vector<int>> our;
    for (int i = 0; i < n; i++) {
        our[had[i]].push_back(i);
    }
    vector<ll> ans(n);
    for (auto el : our) {
        vector<ll> z;
        for (auto el2 : el.second) {
            z.push_back(a[el2]);
        }
        sort(z.begin(), z.end());
        for (int j = 0; j < z.size(); j++) {
            ans[el.second[j]] = z[j];
        }
    }
    for (auto el : ans) {
        cout << el << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
