#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<int>> graph;
vector<int> nextt;
vector<int> p;
int cnt = 0;
int steps = 0;

void dfs(int me)
{
    ++steps;
    if (me == p[cnt] - 1)
        ++cnt;
    if (cnt == p.size())
        return;
    ++nextt[me];
    if (nextt[me] == graph[me].size())
        nextt[me] = 0;
    dfs(graph[me][nextt[me]]);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    nextt.resize(n, -1);
    for (int i = 0; i < n; ++i)
    {
        int k;
        cin >> k;
        graph[i].resize(k);
        for (int j = 0; j < k; ++j)
        {
            cin >> graph[i][j];
            --graph[i][j];
        }
    }
    p.resize(m);
    for (int i = 0; i < m; ++i)
        cin >> p[i];
    dfs(0);
    cout << steps << '\n';
    return 0;
}
    