#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <iomanip>
#include <time.h>
#include <cstring>
#include <map>
#include <unordered_set>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<bool> isPrime(100001, true);
vector<int> p;

void compute()
{
    for (int i = 2; i * i <= 100000; ++i)
    {
        if (isPrime[i])
        {
            p.push_back(i);
            for (int j = i * i; j <= 100000; j += i)
            {
                isPrime[j] = false;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    compute();
    int tt;
    cin >> tt;
    for (int t = 0; t < tt; ++t)
    {
        int n, k, x;
        cin >> n >> k >> x;
        vector<int> a(n);
        for (int i = 0; i < n; ++i)
        {
            cin >> a[i];
        }
        vector<int> acpy = a;
        vector<unordered_map<int, vector<int>>> primes(31);
        vector<vector<pair<int, int>>> nums(n);
        for (int i = 0; i < n; ++i)
        {
            int b = a[i];
            for (int j : p)
            {
                if (j * j > b)
                    break;
                int cnt = -1;
                while (b % j == 0)
                {
                    ++cnt;
                    if (cnt == 0)
                    {
                        nums[i].emplace_back(j, 1);
                    }
                    else
                    {
                        ++nums[i].back().second;
                    }
                    primes[cnt][j].push_back(i);
                    b /= j;
                }
            }
            if (b != 1)
            {
                primes[0][b].push_back(i);
                nums[i].emplace_back(b, 1);
            }
        }
        vector<unordered_map<int, vector<int>>> init_primes = primes;
        for (int cnt = 30; cnt >= 0; --cnt)
        {
            for (const pair<int, vector<int>>& px : primes[cnt])
            {
                if (px.second.size() < k)
                {
                    for (int i : px.second)
                    {
                        a[i] /= px.first;
                    }
                }
            }
        }
        unordered_map<int, vector<int>> m;
        for (int i = 0; i < n; ++i)
        {
            m[a[i]].push_back(acpy[i]);
        }
        for (const pair<int, vector<int>>& px : m)
        {
            sort(m[px.first].begin(), m[px.first].end());
            reverse(m[px.first].begin(), m[px.first].end());
        }
        vector<int> res(n);
        for (int i = 0; i < n; ++i)
        {
            res[i] = m[a[i]].back();
            m[a[i]].pop_back();
        }
        if (x != 1)
        {
            for (int iii = 0; iii < n; ++iii)
            {
                a = acpy;
                primes = init_primes;
                int cn = 0;
                int b = acpy[iii];
                while (b % x == 0)
                {
                    ++cn;
                    b /= x;
                }
                if (cn > 30)
                    throw(0);
                primes[cn][x].push_back(iii);
                a[iii] *= x;
                acpy[iii] *= x;
                for (int cnt = 30; cnt >= 0; --cnt)
                {
                    for (const pair<int, vector<int>>& px : primes[cnt])
                    {
                        if (px.second.size() < k)
                        {
                            for (int i : px.second)
                            {
                                a[i] /= px.first;
                            }
                        }
                    }
                }
                unordered_map<int, vector<int>> newm;
                for (int i = 0; i < n; ++i)
                {
                    newm[a[i]].push_back(acpy[i]);
                }
                for (const pair<int, vector<int>>& px : newm)
                {
                    sort(newm[px.first].begin(), newm[px.first].end());
                    reverse(newm[px.first].begin(), newm[px.first].end());
                }
                vector<int> r(n);
                for (int i = 0; i < n; ++i)
                {
                    r[i] = m[a[i]].back();
                    m[a[i]].pop_back();
                }
                if (r < res)
                {
                    res = r;
                }
                acpy[iii] /= x;
            }
        }
        for (int i = 0; i < n; ++i)
        {
            cout << res[i] << ' ';
        }
        cout << '\n';
    }
    return 0;
}
