﻿#include <bits/stdc++.h>

#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}

void solve_case() {
    int n, k, X;
    cin >> n >> k >> X;
    // X = 1
    vector<int> a(n);
    vector<vector<pair<int, int>>> p(n);
    vector<int> primes;
    for (int i = 0; i < n; i++) {
        a[i] = 1 << 29;
        //cin >> a[i];
        int val = a[i];
        for (int x = 2; x * x <= val; x++) {
            if (val % x == 0) {
                int cnt = 0;
                while (val % x == 0) {
                    val /= x;
                    cnt += 1;
                }
                p[i].push_back({x, cnt});
                primes.push_back(x);
            }
        }
        if (val > 1) {
            p[i].push_back({val, 1});
            primes.push_back(val);
        }
    }
    sort(primes.begin(), primes.end());
    primes.erase(unique(primes.begin(), primes.end()), primes.end());
    vector<int> must(n, 1);
    vector<vector<pair<int, int>>> in(primes.size());
    vector<vector<int>> pws(primes.size(), {1});
    for (int i = 0; i < n; i++) {
        for (int id = 0; id < p[i].size(); id++) {
            p[i][id].fi = lower_bound(primes.begin(), primes.end(), p[i][id].fi) - primes.begin();
            in[p[i][id].fi].push_back({p[i][id].se, i});
            while (pws[p[i][id].fi].size() <= p[i][id].se) {
                pws[p[i][id].fi].push_back(primes[p[i][id].fi] * pws[p[i][id].fi].back());
            }
        }
    }
    for (int pid = 0; pid < primes.size(); pid++) {
        if (in[pid].size() < k) continue;
        vector<int> cnt(pws[pid].size());
        for (int i = 0; i < in[pid].size(); i++) {
            cnt[in[pid][i].fi]++;
        }
        int was = cnt.back(), kth = (int)pws[pid].size() - 1;
        while (was < k) {
            kth--;
            was += cnt[kth];
        }
        for (int i = 0; i < in[pid].size(); i++) {
            must[in[pid][i].se] *= min(pws[pid][kth], pws[pid][in[pid][i].fi]);
        }
    }
    vector<int> unq_must = must;
    sort(unq_must.begin(), unq_must.end());
    unq_must.erase(unique(unq_must.begin(), unq_must.end()), unq_must.end());
    vector<vector<int>> pos_must(unq_must.size());
    for (int i = 0; i < n; i++) {
        pos_must[lower_bound(unq_must.begin(), unq_must.end(), must[i]) - unq_must.begin()].push_back(i);
    }
    vector<int> ans(n);
    for (int id = 0; id < unq_must.size(); id++) {
        vector<int> pw = pos_must[id];
        sort(pw.begin(), pw.end(), [&](int l, int r){
            return a[l] < a[r];
        });
        for (int i = 0; i < pw.size(); i++) ans[pos_must[id][i]] = a[pw[i]];
    }
    //for (int i = 0; i < n; i++) cout << ans[i] << " \n"[i == n - 1];
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1; cin >> T;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}
