#include<bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        g[i].resize(k);
        for (auto& j : g[i]) cin >> j,--j;
    }
    vector<int> verts(m);
    for (auto& i : verts) cin >> i, --i;
    vector<int> sub(n, -1);
    vector<int> ord(n, -1);
    vector<int> parent(n, -1);
    {
        auto dfs = [&](auto dfs, int u, int par) -> void {
            parent[u] = par;
            for (auto to: g[u]) {
                if (to != par) {
                    sub[to] = sub[u];
                    dfs(dfs, to, u);
                }
            }
        };
        for (auto to: g[0]) {
            sub[to] = to;
            dfs(dfs, to, 0);
        }
        for (int i = 0; i < g[0].size(); ++i) {
            ord[g[0][i]] = i;
        }
    }
    vector<vector<int>> to_visit(n);
    vector<vector<int>> visit_ord(n);
    for (auto to : g[0]) {
        to_visit[to].push_back(to);
    }
    int ptr = 0;
    ll ans = 0;
    for (int i = 0; i < m; ) {
        if (verts[i] == 0) i++;
        int root = g[0][ptr];
        vector<int> now = to_visit[root];
        to_visit[root].clear();
        for (auto y : now) {
            auto dfs = [&](auto dfs, int u, int par) -> void {
                auto& v = visit_ord[sub[u]];
                int pos;
                if (par == 0) pos = 0;
                else pos = find(v.begin(), v.end(), par) + 1 - v.begin();
                if (par != 0) v.insert(pos + v.begin(), par);
                v.insert(pos + v.begin(), u);
                int k = find(g[u].begin(), g[u].end(), par) - g[u].begin();
                vector<int> now(g[u].begin(), g[u].begin() + k);
                vector<int> nnow(g[u].begin() + k + 1, g[u].end());
                reverse(now.begin(), now.end());
                reverse(nnow.begin(), nnow.end());
                for (auto to : now) {
                    dfs(dfs, to, u);
                }
                for (auto to : nnow) {
                    to_visit[sub[u]].push_back(to);
                }
            };
            dfs(dfs, y, parent[y]);
        }
        int num = -1;
        while (i < m) {
            int k = num + 1;
            while (k < visit_ord[root].size() && visit_ord[root][k] != verts[i]) k++;
            if (k < visit_ord[root].size() && k > num) {
                ans += k - num;
                num = k;
            } else {
                break;
            }
            i++;
        }
        if (i < m) {
            ans += visit_ord[root].size() - num;
        }
        ptr++;
        if (ptr == g[0].size()) ptr = 0;
    }
    cout << ans + 1;
}

/*
5 9
2 2 3
1 1
3 1 4 5
1 3
1 3
2 1 1 4 5 2 1 3 4
 */