#ifndef LOCAL
#pragma GCC target("arch=skylake")
#endif

#pragma GCC optimize("O3,inline")

#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ve<ll> gr[N];
ll arr[N],val[N],pr[N];

void dfs(ll s, ll p)
{
    val[s]=sz(gr[s]);
    
    for(ll i:gr[s])
    {
        if(i==p) continue;
        pr[i]=s;
        dfs(i,s);
        val[s]+=val[i];
    }
}

ll pos[N],cnt[N],st[N];
char fl[N];

void solve()
{
    ll n,m;
    cin>>n>>m;
    
    for(ll i=0;i<n;i++)
    {
        ll k;
        cin>>k;
        
        for(ll j=0;j<k;j++)
        {
            ll x;
            cin>>x;
            x--;
            gr[i].PB(x);
        }
    }
    
    dfs(0,0);
    
    for(ll i=1;i<n;i++)
    {
        if(sz(gr[i])==1)
        {
            fl[i]=1;
            cnt[pr[i]]++;
        }
    }
    
    for(ll i=0;i<m;i++)
    {
        cin>>arr[i];
        arr[i]--;
    }

    ll x=0,ans=1;
    
    for(ll i=0;i<m;i++)
    {
        if(i==0&&arr[i]==x)
            continue;
        
        do
        {
            if(fl[x])
            {
                ans+=val[x];
                x=pr[x];
            }
            
            else
            {
                ll to=gr[x][pos[x]];
                st[x]++;
                assert(x==0||st[x]<=sz(gr[x])*3);
                
                if(x!=0&&to==pr[x]&&cnt[x]==sz(gr[x])-1)
                {
                    fl[x]=1;
                    cnt[pr[x]]++;
                }
                
                pos[x]=(pos[x]+1)%sz(gr[x]);
                x=to;
                ans++;
            }
        }
        while(x!=arr[i]);
    }
    
    cout<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    solve();
    return 0;
}

/*
8 20
2 2 3
2 1 4
4 6 1 5 7
1 2
1 3
1 3
2 8 3
1 7
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
123
*/
