#ifndef LOCAL
#pragma GCC target("arch=skylake")
#endif

#pragma GCC optimize("O3,inline")

#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ve<ll> gr[N];
set<ll> st[N];
ll arr[N],pos[N],val[N],pr[N];
char fl[N];

void calc_pr(ll s, ll p)
{
    for(ll i:gr[s])
    {
        if(i==p) continue;
        pr[i]=s;
        calc_pr(i,s);
    }
}

void dfs(ll x)
{
    ll ans=val[x];
    
    for(ll i:st[x])
    {
        if(gr[x][(pos[x]-1+sz(gr[x]))%sz(gr[x])]!=pr[x]&&i<pos[x])
            continue;
        
        ll add=dfs(i)+2;
        ans+=add;
        
        if(st[i].empty())
        {
            val[x]+=add;
            st[x].erase(i);
        }
    }
    
    return ans;
}

void solve()
{
    ll n,m;
    cin>>n>>m;
    
    for(ll i=0;i<n;i++)
    {
        ll k;
        cin>>k;
        
        for(ll j=0;j<k;j++)
        {
            ll x;
            cin>>x;
            x--;
            gr[i].PB(x);
        }
    }
    
    for(ll i=0;i<m;i++)
    {
        cin>>arr[i];
        arr[i]--;
    }
    
    calc_pr(0,0);
    
    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<sz(gr[i]);j++)
        {
            if(gr[i][j]!=pr[i])
                st[i].insert(j);
        }
    }
    
    ll ans=1;
    
    for(ll i=0;i<m;i++)
    {
        ans+=dfs(gr[0][pos[0]])+1;
        pos[0]=(pos[0]+1)%sz(gr[0]);
    }
    
    cout<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    solve();
    return 0;
}
