#ifndef LOCAL
#pragma GCC target("arch=skylake")
#pragma GCC optimize("Ofast,inline")
#endif

#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ve<ll> gr[N],nxt[N];
ll arr[N],val[N],pr[N],fst[N];

void calc_pr(ll s, ll p)
{
    for(ll i:gr[s])
    {
        if(i==p) continue;
        pr[i]=s;
        calc_pr(i,s);
    }
}

ll dfs(ll x)
{
    ll ans=val[x],prv=0;
    
    for(ll i=fst[x];i<sz(gr[x]);i=nxt[x][i])
    {
        ll to=gr[x][i];
        
        if(to==pr[x])
        {
            if(i==fst[x]) fst[x]=nxt[x][i];
            else nxt[x][prv]=nxt[x][i];
            break;
        }
        
        ll add=dfs(to);
        ans+=add;
        
        if(fst[to]==sz(gr[to]))
        {
            val[x]+=add;
            if(i==fst[x]) fst[x]=nxt[x][i];
            else nxt[x][prv]=nxt[x][i];
        }
        
        prv=i;
    }
    
    return ans;
}

void solve()
{
    ll n,m;
    cin>>n>>m;
    
    for(ll i=0;i<n;i++)
    {
        ll k;
        cin>>k;
        nxt[i].assign(k,0);
        iota(all(nxt[i]),1);
        fst[i]=0;
        
        for(ll j=0;j<k;j++)
        {
            ll x;
            cin>>x;
            x--;
            gr[i].PB(x);
        }
    }
    
    for(ll i=0;i<m;i++)
    {
        cin>>arr[i];
        arr[i]--;
    }
    
    fill(val,val+n,2);
    calc_pr(0,0);
    ll pos=0,ans=1;
    
    for(ll i=0;i<m;i++)
    {
        if(i==0&&arr[i]==0) continue;
        ans+=dfs(gr[0][pos]);
        pos=(pos+1)%sz(gr[0]);
    }
    
    cout<<ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    //freopen("input.txt","r",stdin);
    
    solve();
    return 0;
}

/*
8 10
2 2 3
2 1 4
4 6 1 5 7
1 2
1 3
1 3
2 8 3
1 7
1 1 1 1 1 1 1 1 1 1
53
*/
