#include <bits/stdc++.h>
#include "game.h"

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef int ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=2e9+2;
const ll N=1e6+2;

ve<ll> arr,dp;
ll d;

ll rec(ll x)
{
    if(dp[x]!=2) return dp[x];
    
    for(ll i=max(0,x-d);i<=min(sz(arr)-1,x+d);i++)
    {
        if(i==x) continue;
        if(arr[i]>arr[x]&&!rec(i)) return dp[x]=1;
    }
    
    return dp[x]=0;
}

void init(ve<ll> _arr, ll _d)
{
    arr=_arr;
    d=_d;
    dp.assign(sz(arr),2);
}

void updateValue(ll k, ll x)
{
    arr[k]=x;
    dp.assign(sz(arr),2);
}

bool isWinning(ll x)
{
    return rec(x);
}

#ifdef LOCAL
#include <vector>
#include <iostream>

int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
#endif // LOCAL
