#ifndef LOCAL
#pragma GCC target("arch=skylake")
#endif

#pragma GCC optimize("O3,inline")

#include <bits/stdc++.h>

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e6+2;

ll arr[N],p[N];
char eq[N];

void solve()
{
    ll n,k,x;
    cin>>n>>k>>x;
    
    for(ll i=0;i<n;i++)
    {
        cin>>arr[i];
        p[i]=arr[i];
    }
    
    sort(p,p+n);
    
    do
    {
        fill(eq,eq+n,1);
        
        for(ll mask=0;mask<(1ll<<n);mask++)
        {
            ll g1=0,g2=0,cnt=0;
            
            for(ll i=0;i<n;i++)
            {
                if(!(mask&(1ll<<i))) continue;
                g1=__gcd(g1,arr[i]);
                g2=__gcd(g2,p[i]);
                cnt++;
            }
            
            if(g1!=g2) eq[cnt]=0;
        }
        
        if(eq[k])
        {
            for(ll i=0;i<n;i++)
                cout<<p[i]<<' ';
            
            cout<<endl;
            return;
        }
    }
    while(next_permutation(p,p+n));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    ll q;
    cin>>q;
    
    while(q--)
        solve();
    
    return 0;
}
