#include <bits/stdc++.h>

#ifdef LOCAL
#include "Lgrader.cpp"
#else
#include "game.h"
#endif // LOCAL

using namespace std;

#define pii pair < int, int >
#define F first
#define S second
#define pb push_back

int p[2000001];
vector < int > a;
int n, d;

void find_answers()
{
    vector < pii > vec;
    for (int i = 0; i < n; i++)
    {
        p[i] = -1;
        vec.pb({a[i], i});
    }
    sort(vec.rbegin(), vec.rend());
    for (auto to: vec)
    {
        int pos = to.S;
        if (p[pos] == 1) continue;
        p[pos] = 0;
        for (int i = max((int)0, pos - d); i <= min(n - 1, pos + d); i++)
            if (i != pos && p[i] == -1) p[i] = 1;
    }
}

void init(vector < int > A, int D)
{
    n = A.size();
    a = A;
    d = D;
    find_answers();
}

void updateValue(int index, int newValue)
{
    a[index] = newValue;
    find_answers();
}

bool isWinning(int startIndex)
{
    return p[startIndex];
}
