#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

const int N = 1e6 + 100;

vector <int> a[N];
vector <int> dep;
vector <int> tms;
int out[N];
int pos[N];
int tot_edge;
int n, m;

void Rec(int x, int y, int _tms, int _dep) {
    pos[x] = tms.size();
    tms.pb(_tms);
    dep.pb(_dep);
    int cur_tms = _tms;
    for (auto i : a[x]) {
        _tms += i == y;
        if (i != y) {
            Rec(i, x, _tms, _dep + 1);
            tms.pb(_tms);
            dep.pb(_dep);
        }
    }
    out[pos[x]] = tms.size() - 1;
}

int find_first_eq(int x, int vl) {
    for (int i = x; i < tot_edge; i++)
        if (dep[i] == vl) return i;
    return tot_edge;
}

int kol_less_or_eq(int l, int r, int vl) {
    int sum = 0;
    for (int i = l; i <= r; i++) sum += tms[i] <= vl;
    return sum;
}

main()
{
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) cin >> a[i][j], a[i][j]--;
    }
    Rec(0, -1, 0, 0);

    tms.pop_back();
    dep.pop_back();
    out[0]--;
    tot_edge = tms.size();
    int ps = 0;
    int lv = 0;
    int ans = 0;
    while (m--) {
        int x;
        cin >> x, x--;
        x = pos[x];
        if (ps > x) {
            if (out[x] >= ps) {
                int nx = find_first_eq(ps, dep[x]);
                if (nx == tot_edge) {
                    ans += kol_less_or_eq(ps, tot_edge - 1, lv) + 1;
                    ps = 0;
                    lv++;
                } else {
                    ans += kol_less_or_eq(ps, nx, lv);
                    ps = nx;
                }
                goto cont;
            }
            ans += kol_less_or_eq(ps, tot_edge - 1, lv);
            ps = 0;
            lv++;
        }
        while (lv < tms[x]) {
            ans += kol_less_or_eq(0, tot_edge - 1, lv);
            lv++;
        }
        ans += kol_less_or_eq(ps, x, lv);
        ps = x;
    cont:
        ps = (ps + 1) % tot_edge;
        lv += (ps == 0);
    }
    cout << ans << endl;
}

/*
7 3
2 2 3
3 4 5 1
3 6 7 1
1 2
1 2
1 3
1 3
1 1 1

5 3
2 2 3
2 1 4
2 5 1
1 2
1 3
5 3 4
*/
