#include <bits/stdc++.h>
#define int long long
#define pb push_back
#define f first
#define s second

using namespace std;

const int N = 1e6 + 100;

struct tree {
    tree *L = NULL;
    tree *R = NULL;

    int l, r;
    int mdl;
    int val = 0;

    tree(tree *a) {
        L = a -> L;
        R = a -> R;
        l = a -> l;
        r = a -> r;
        mdl = a -> mdl;
        val = a -> val;
    }

    tree(int _l, int _r) : l(_l), r(_r) {
        mdl = (l + r) >> 1;
        if (l == r) return;
        L = new tree(l, mdl);
        R = new tree(mdl + 1, r);
    }

    int sum(int _l, int _r) {
        if (_l > _r) return 0;
        if (_l == l && _r == r) return val;
        return L -> sum(_l, min(mdl, _r)) + R -> sum(max(mdl + 1, _l), _r);
    }

    tree *add1(int pos) {
        tree *t = new tree(this);
        t -> val++;
        if (l == r) return t;
        if (mdl < pos) t -> R = R -> add1(pos);
        else           t -> L = L -> add1(pos);
        return t;
    }
};

tree *tr[N];

vector <int> a[N];
vector <int> dep;
vector <int> tms;
vector <int> nom;
int out[N];
int pos[N];
int fr[N];
int tot_edge;
int n, m;

void Rec(int x, int y, int _tms, int _dep) {
//    cout << x << endl;
    pos[x] = tms.size();
    tms.pb(_tms);
    dep.pb(_dep);
    nom.pb(x);
    for (int i = 0; i <= a[x].size(); i++)
        if (i == a[x].size() || a[x][i] == y) {
            for (int j = i + 1; j < a[x].size(); j++) {
                Rec(a[x][j], x, _tms + 1, _dep + 1);
                tms.pb(_tms + 1);
                dep.pb(_dep);
                nom.pb(x);
            }
            for (int j = 0; j < i; j++) {
                Rec(a[x][j], x, _tms, _dep + 1);
                if (fr[pos[x]] == 0) fr[pos[x]] = tms.size();
                tms.pb(_tms);
                dep.pb(_dep);
                nom.pb(x);
            }
            out[pos[x]] = tms.size() - 1;
            return;
        }
}

int find_first_eq(int x, int vl) {
    for (int i = x; i < tot_edge; i++) {
        if (dep[i] == vl) return i;
    }
    return tot_edge;
}

int kol_less_or_eq(int l, int r, int vl) {
    int sum = 0;
    vl = min(vl, N - 1);
    return tr[vl] -> sum(l, r);
}

main()
{
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) cin >> a[i][j], a[i][j]--;
    }

    Rec(0, -1, 0, 0);

    tot_edge = tms.size();
    int ps = 0;
    int lv = 0;
    int ans = 0;

    vector <pair<int, int> > t;
    for (int i = 0; i < tms.size(); i++) t.pb({tms[i], i});
    sort(t.begin(), t.end());
    tr[0] = new tree(0, tot_edge - 1);
    int i = 0;
    for (int j = 0; j < N - 1; j++) {
        while (i < t.size() && t[i].f == j) {
            tr[j] = tr[j] -> add1(t[i].s);
            i++;
        }
        tr[j + 1] = tr[j];
    }

//    while (m--) {
//        int x;
//        cin >> x, x--;
//        bool g = 1;
//        while (g) {
//            if (tms[ps] <= lv) {
//                ans++;
//                if (x == nom[ps]) {
//                    g = 0;
//                }
//            }
//
//            ps = (ps + 1) % tot_edge;
//            if (ps == 0) {
//                ps++;
//                lv++;
//            }
//        }
//    }


    while (m--) {
        int x;
        cin >> x, x--;
        x = pos[x];
        if (ps > x) {
            if (out[x] >= ps) {
                int nx = find_first_eq(ps, dep[x]);
                if (tms[nx] <= lv) {
                    ans += kol_less_or_eq(ps, nx, lv);
                    ps = nx;
                    goto cont;
                }
                nx = fr[x];
                if (nx >= ps && tms[nx] <= lv) {
                    ans += kol_less_or_eq(ps, nx, lv);
                    ps = nx;
                    goto cont;
                }
            }
            ans += kol_less_or_eq(ps, tot_edge - 1, lv);
            ps = 1;
            lv++;
        }
        while (lv < tms[x]) {
            ans += kol_less_or_eq(ps, tot_edge - 1, lv);
            ps = 1;
            lv++;
        }
        ans += kol_less_or_eq(ps, x, lv);
        ps = x;
    cont:
        ps = (ps + 1) % tot_edge;
        if (ps == 0) {
            lv++;
            ps++;
        }
    }
    cout << ans << endl;
}

/*
7 3
2 2 3
3 4 5 1
3 6 7 1
1 2
1 2
1 3
1 3
1 1 1

5 3
2 2 3
2 1 4
2 5 1
1 2
1 3
5 3 4


5 3
1 2
2 3 1
3 4 2 5
1 3
1 3
4 3 3
*/
