#include <iostream>

#pragma GCC optimize ("O3")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

using namespace std;

const int N = 1e5 + 1;
using ll = long long;

int edge[2 * (N - 1)], l[N], r[N], n, m, p[N], k[N], id[N];

int res = 0;
void to (int& v) {
    int _v = v;
    v = edge[id[v]];
    if(++ id[_v] > r[_v]) id[_v] = l[_v];
    ++ res;
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    assert (n <= (int)1e5);
    assert (m <= (int)1e3);
    int stn = 0;
    for (int i = 1; i <= n; ++ i) {
        cin >> k[i];
        l[i] = stn, r[i] = stn + k[i] - 1;
        id[i] = stn;
        for (int j = l[i]; j <= r[i]; ++ j) cin >> edge[j];
        stn += k[i];
    }

    for (int i = 1; i <= m; ++ i) cin >> p[i];

    int v = 1;
    for (int i = 1; i <= m; ++ i) {
        while (v != p[i]) to(v);
        to (v);
    }

    cout << res << "\n";
    return 0;
}
