#include "game.h"
#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<int> a;
int d;
int n;

void init(std::vector<int> A, int D) {
    a = A;
    d = D;
    n = a.size();
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
}

int local_max(int i) {
    int lft = max(0, i - d), rth = min(n - 1, i + d);
    int mx = 0;
    for (int j = lft; j <= rth; j++) {
        mx = max(mx, a[j]);
    }
    return (mx == a[i]);
}

bool isWinning(int start_index) {
    if (local_max(start_index)) {
        return true;
    }

    vector<int> locals;

    for (int i = start_index - 1; i >= 0; i--) {
        if (local_max(i)) {
            locals.push_back(i);
            break;
        }
    }

    for (int i = start_index + 1; i < n; i++) {
        if (local_max(i)) {
            locals.push_back(i);
            break;
        }
    }

    bool normis = false;

    for (int i = start_index + 1; i <= min(start_index + d, n - 1); i++) {
        bool flag = true;
        for (int pos : locals) {
            flag &= (abs(pos - i) % (d + 1) == 0);
        }
        normis |= flag;
    }

    for (int i = start_index - 1; i >= max(0, start_index - d); i--) {
        bool flag = true;
        for (int pos : locals) {
            flag &= (abs(pos - i) % (d + 1) == 0);
        }
        normis |= flag;
    }

    return normis;
}
