#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using namespace std;

vector<int> get_min(vector<int> &l, vector<int> &r) {
    for (int i = 0; i < sz(l); i++) {
        if (l[i] < r[i]) {
            return l;
        } else if (l[i] > r[i]) {
            return r;
        }
    }
    return l;
}

void run_test(int test_case) {
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    for (int &i : a) {
        cin >> i;
    }
    vector<int> p(n);
    iota(all(p), 0);
    vector<int> ans;

    do {
        vector<int> b(n);
        for (int i = 0; i < n; i++) {
            b[i] = a[p[i]];
        }
        bool norm = true;

        for (int i = 0; i < (1 << n); i++) {
            if (__builtin_popcount(i) != k) continue;
            int l_gcd = 0, r_gcd = 0;
            for (int j = 0; j < n; j++) {
                if (i >> j & 1) {
                    l_gcd = __gcd(l_gcd, a[j]);
                    r_gcd = __gcd(r_gcd, b[j]);
                }
            }
            norm &= (l_gcd == r_gcd);
        }

        if (norm) {
            if (sz(ans) == 0) {
                ans = b;
            } else {
                ans = get_min(ans, b);
            }
        }
    } while(next_permutation(all(p)));

    for (int i : ans) {
        cout << i << ' ';
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int test_cases = 1;
    cin >> test_cases;

    for (int i = 1; i <= test_cases; i++) {
        run_test(i);
    }

    return 0;
}
