#include <bits/stdc++.h>
#include "game.h"

using namespace std;

using ll = long long;
const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;


int n;
vector<ll> a(MAX);
vector<pair<int, int>> g[MAX];
int d;
ll dp[MAX];
int tot = 0;

void recalcdp() {
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        dp[i] = 0;
        for (int j = max(0, i - d); j < i; j++) {
            if (!dp[j]) dp[i] = 1;
        }
    }
}

void init(std::vector<int> A, int D) {
    n = (int)(A.size());
    d = D;
    for (int i = 1; i <= n; i++) {
        a[i] = A[i - 1];
    }
    tot = n + 1;
    while (tot % 2 == 0) tot++;
    recalcdp();
}

void updateValue(int pos, int val) {
    pos++;
    a[pos] = val;
}

bool isWinning(int start) {
    start++;
    for (int i = 1; i <= n; i++) {
        ll mx = a[i];
        for (int j = max(1, i - d); j <= min(n, i + d); j++) {
            mx = max(mx, a[j]);
        }
        if (a[i] == mx) {
          //  cerr << start << ' ' << i << '\n';
            if (dp[abs(start - i)]) {
                return 1;
            }
        }
    }
    return 0;
}


