#include <bits/stdc++.h>
#include "game.h"

using namespace std;

using ll = long long;
const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;


int n;
vector<ll> a(MAX);
vector<int> g[MAX];
vector<int> dp(MAX, 0);
vector<bool> was(MAX, false);
vector<int> tps;
void dfs(int v) {
    if (was[v]) return;
    was[v] = true;
    for (auto to : g[v]) dfs(to);
    tps.push_back(v);
}
int d;

void rebuild() {
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        dp[i] = 0;
        was[i] = false;
    }
    for (int i = 1; i <= n; i++) {
        for (int j = max(1, i - d); j <= min(n, i + d); j++) {
            if (a[i] > a[j]) {
                g[i].push_back(j);
           //     cout << i << ' ' << j << '\n';
            }
        }
    }
    tps.clear();
    for (int i = 1; i <= n; i++) dfs(i);
    reverse(tps.begin(), tps.end());
    for (auto v : tps) {
        for (auto u : g[v]) {
            if (!dp[v]) dp[u] = 1;
        }
    }
  //  for (int i = 1; i <= n; i++) cout << dp[i] << ' ';
  //  cout << '\n';
}

void init(std::vector<int> A, int D) {
    n = (int)(A.size());
    d = D;
    for (int i = 1; i <= n; i++) {
        a[i] = A[i - 1];
    }
    rebuild();
}

void updateValue(int pos, int val) {
    pos++;
    a[pos] = val;
    rebuild();
}

bool isWinning(int start) {
    return dp[start + 1];
}


