#include "game.h"
#include <bits/stdc++.h>

using namespace std;

int n, d;
vector<int> a;

void init(std::vector<int> A, int D) {
    n = (int)A.size();
    a = A;
    d = D;
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
}

bool isWinning(int startIndex) {
    vector<bool> winning(n);

    vector<pair<int, int>> vals;
    for (int i = 0; i < n; i++) {
        vals.push_back({a[i], i});
    }
    sort(vals.rbegin(), vals.rend());

    for (int i = 0; i < n; i++) {
        int pos = vals[i].second;
        if (winning[pos]) continue;
        for (int j = max(0, pos - d); j < pos; j++) winning[j] = 1;
        for (int j = pos + 1; j <= min(n - 1, pos + d); j++) winning[j] = 1;
    }

    return winning[startIndex];
}
