#include "game.h"
#include <bits/stdc++.h>

using namespace std;

int n, d, qs;
vector<int> a;
vector<bool> winning;

void init(std::vector<int> A, int D) {
    n = (int)A.size();
    a = A;
    d = D;
    winning.resize(n);
    qs = 1;
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    qs++;
}

bool isWinning(int startIndex) {
    if (qs) {
        fill(winning.begin(), winning.end(), 0);

        vector<pair<int, int>> vals;
        for (int i = 0; i < n; i++) {
            vals.push_back({a[i], i});
        }
        sort(vals.rbegin(), vals.rend());

        for (int i = 0; i < n; i++) {
            int pos = vals[i].second;
            if (winning[pos]) continue;
            for (int j = max(0, pos - d); j < pos; j++) winning[j] = 1;
            for (int j = pos + 1; j <= min(n - 1, pos + d); j++) winning[j] = 1;
        }

        qs = 0;
    }

    return winning[startIndex];
}
