#include <bits/stdc++.h>
#include "game.h"

using namespace std;
//#define int long long
using ll = long long;
using ld = long double;
const ll INF = 1e9, N = 2e5 + 100, MOD = 1e9 + 7, K = 20;
mt19937 rnd(232234);
vector<int> a,  dp(N), used(N);
vector<vector<int>> g(N);
int d, n;
void dfs(int v) {
    used[v] = 1;
    if (g[v].empty()) {
        dp[v] = 0;
        return;
    }
    bool f = 1;
    for (auto to : g[v]) {
        if (!used[to]) dfs(to);
        f &= dp[to];
    }
    dp[v] = !f;
}
void init(std::vector<int> A, int D) {
    a = A, d = D;
    n = a.size();
    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - d); j <= min(n - 1, i + d); j++) {
            if (a[i] < a[j])
                g[i].push_back(j);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i);
    }
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    g.assign(n, {});
    used.assign(n, 0);

    for (int i = 0; i < n; i++) {
        for (int j = max(0, i - d); j <= min(n - 1, i + d); j++) {
            if (a[i] < a[j])
                g[i].push_back(j);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i);
    }
}

bool isWinning(int startIndex) {
    return dp[startIndex];
}



