#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define F first
#define S second
#define pb push_back
#define all(x) x.begin(), x.end()
const int N = 5e5 + 100;
deque<int> g[N];
vector<int> p;
bool used[N];
vector<int> order;

void dfs(int v, int par) {
    order.pb(v);
    for (int u: g[v]) {
        if (u == par) {
            return;
        }
        dfs(u, v);
        order.pb(v);
    }
}

vector<int> t[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        g[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> g[i][j];
        }
    }
    p.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> p[i];
    }
    reverse(all(p));
    int v = 1;
    ll ans = 1;
    int cnt = 0;
    while (!p.empty()) {
        if (v == p.back()) {
            p.pop_back();
        }
        if (v == 1 && cnt == n) {
            break;
        }
        if (!used[v]) {
            used[v] = true;
            cnt++;
        }
        int u = g[v][0];
        g[v].pop_front();
        g[v].push_back(u);
        v = u;
        ++ans;
    }
    if (p.empty()) {
        cout << ans - 1;
        return 0;
    }
    dfs(1, 1);
    for (int i = 0; i < order.size(); ++i) {
        t[order[i]].pb(i);
    }
    int l = 0;
    while ((!p.empty())) {
        int u = p.back();
        int x = upper_bound(all(t[u]), l) - t[u].begin();
        if (x == t[u].size()) {
            ans += 2 * n - 1 - l + t[u][0];
            l = t[u][0];
        } else {
            ans += t[u][x] - l;
            l = t[u][x];
        }
        p.pop_back();
    }
    cout << ans;
    return 0;
}