#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 5e5 + 1, logn = 19;
vector<int> g[maxn];
int sz[maxn], d[maxn];
int up[logn][maxn];
int tin[maxn], tout[maxn];
int T = 0;

void dfs(int v = 0, int p = -1) {
    for (int l = 1; l < logn; ++l) {
        up[l][v] = up[l - 1][up[l - 1][v]];
    }
    tin[v] = T++;
    sz[v] = 1;
    for (int u: g[v]) {
        if (p == u) continue;
        d[u] = d[v] + 1;
        up[0][u] = v;
        dfs(u, v);
        sz[v] += sz[u];
    }
    tout[v] = T;
}

int anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v)) return u;
    if (anc(v, u)) return v;
    for (int l = logn - 1; l >= 0; l--) {
        if (!anc(up[l][v], u)) v = up[l][v];
    }
    return up[0][v];
}

int dd(int u, int v) {
    int k = lca(u, v);
    return d[u] + d[v] - 2 * d[k];
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        while (k--) {
            int j;
            cin >> j, j--;
            g[i].emplace_back(j);
        }
    }
    dfs();
    int v = 0, ans = 1;
    while (m--) {
        int next;
        cin >> next, next--;
        if (v == next) continue;
        if (anc(v, next)) {
            ans += tin[next] - tin[v];
            v = next;
            continue;
        }
        if (anc(next, v)) {
            ans += tout[next] - tin[v] + 1;
            v = next;
            continue;
        }
        // int k = lca(next, v);
        if (tin[v] < tin[next]) {
            ans += tin[next] - tin[v];
            v = next;
            continue;
        }
        ans += n - tin[v] + tin[next];
        v = next;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
   // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}