#pragma GCC Optimize("O3")
#pragma GCC Optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define int long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e3 + 1;
ll a[maxn], add;
ll ans[maxn];
int n, k;
unordered_map<ll, ll> we[maxn];

void help() {
    for (int id = 0; id <= n; ++id) {
        ll x = a[id];
        for (ll i = 2; i * i <= x; i++) {
            if (x % i != 0) continue;
            ll y = 1;
            while (x % i == 0) x /= i, y *= i;
            we[id][i] = y;
        }
        if (x > 1) we[id][x] = x;
    }
}

unordered_map<int, set<pii>> d;

void ADD(int id) {
    for (auto &[x, f]: we[id])
        d[x].insert({f, id});
}

void change(int id, int ty) {
    if (ty > 0) {
        for (auto &[x, f]: we[n]) {
            if (we[id].find(x) == we[id].end()) {
                we[id][x] = f;
                continue;
            }
            we[id][x] *= f;
        }
        return;
    }
    for (auto &[x, f]: we[n]) {
        we[id][x] /= f;
        if (we[id][x] == 1) we[id].erase(x);
    }
}

void DEL(int id) {
    for (auto &[x, f]: we[id])
        d[x].erase({f, id});
}

void calc(int IND) {
    if (IND < n) {
        DEL(IND);
        change(IND, 1);
        ADD(IND);
    }
    vector<ll> base(n, 1);
    for (auto &[x, mas]: d) {
        if (sz(mas) < k) continue;
        int ost = k;
        auto it = mas.end();
        while (ost--) it--;
        int val = it->first;
        for (auto [f, i]: mas)
            base[i] *= min(f, val);
    }
    int cool = 0, bad = 0;
    for (int p = 0; p < n && !bad; ++p) {
        for (int i = p + 1; i < n; ++i) {
            if (a[p] <= a[i]) continue;
            if (a[i] % base[p] != 0) continue;
            if (a[p] % base[i] != 0) continue;
            swap(a[p], a[i]);
        }
        if (!cool && a[p] > ans[p]) bad = 1;
        if (a[p] < ans[p]) cool = 1;
    }
    if (IND < n) {
        DEL(IND);
        change(IND, -1);
        ADD(IND);
    }
    if (bad) return;
    for (int i = 0; i < n; ++i) {
        ans[i] = a[i];
    }
}

ll b[maxn];

void init() {
    for (int i = 0; i < n; ++i) {
        a[i] = b[i];
    }
}

void solve() {
    cin >> n >> k >> add;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
        ans[i] = a[i];
        we[i].clear();
    }
    we[n].clear();
    d.clear();
    a[n] = add;
    help();
    for (int i = 0; i < n; ++i) ADD(i);
    calc(n);
    if (add > 1) {
        for (int i = 0; i < n; ++i) {
            init();
            a[i] *= add;
            calc(i);
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}