#include <bits/stdc++.h>
#include "game.h"

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

ll n;
vector<ll> arr, win, ost;
ll D;

ll ma(ll l, ll r) {
    ll ans = LLONG_MIN;
    for (int i = l; i <= r; ++i)
        ans = max(ans, arr[i]);
    return ans;
}

void setLoose(ll u);

void setWin(ll u) {
    if (win[u] != -1)
        return;
    win[u] = 1;
    for (int i = max(0ll, u - D); i <= min(n - 1, u + D); ++i)
        if (!--ost[i])
            setLoose(i);
}

void setLoose(ll u) {
    if (win[u] != -1)
        return;
    win[u] = 0;
    for (int i = max(0ll, u - D); i <= min(n - 1, u + D); ++i)
        setWin(i);
}

void upd() {
    win.assign(n, -1);
    for (int i = 0; i < n; ++i)
        if (ma(max(0ll, i - D), min(n - 1, i + D)) == arr[i])
            setLoose(i);
    vector<ll> hh;
    for (int i = 0; i < n; ++i)
        if (win[i] == -1 && (i > 0 && win[i - 1] == 1 || i < n - 1 && win[i + 1] == 1))
            hh.push_back(i);

    ll t = 0;
    while (!hh.empty()) {
        for (int i = 0; i < hh.size(); ++i) {
            win[hh[i]] = t > 0;
            if (hh[i] > 0 && win[hh[i] - 1] == -1)
                hh[i]--;
            else if (hh[i] < n - 1 && win[hh[i] + 1] == -1)
                hh[i]++;
            else {
                swap(hh[i], hh.back());
                hh.pop_back();
                i--;
            }
        }
        t = (t + 1) % (D + 1);
    }
}

void init(vector<int> A, int _D) {
    n = A.size();
    ost.resize(n);
    for (int i = 0; i < n; ++i)
        ost[i] = min(n - 1, i + (ll) _D) - max(0, i - _D);
    arr.clear();
    for (int i: A)
        arr.push_back(i);
    D = _D;
    upd();
}

void updateValue(int index, int newValue) {
    arr[index] = newValue;
    upd();
}

bool isWinning(int startIndex) {
    return win[startIndex];
}

/*
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll d, h1, h2, q, h3;
    cin >> n >> d;
    vector<int> a(n);
    for (int &i: a)
        cin >> i;
    init(a, d);
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> h1 >> h2;
        if (h1 == 2)
            cout << isWinning(h2) << endl;
        else {
            cin >> h3;
            updateValue(h2, h3);
        }
    }
}*/
/*
6 2
1 7 4 9 30 2
5
2 0
2 1
1 4 8
2 0
2 1

*/
/*

*/
/*
Каждый ход точно будет в клетку с большим значением если она есть.
Если на расстоянии прыжка нет значения больше, то мы проиграли.

Если на расстоянии Д от клетки нет клеток больше значит она проигрышная.
Если мы можем прыгнуть в проигрышную клетку, мы на выигрышной клетке.
Если мы не можем прыгнуть на проигрышную клетку, мы на проигрышной клетке.

Сдам подгруппы 1, 2, 3.

*/
/*

*/
/*

*/