#include <bits/stdc++.h>
//#include "game.h"

using namespace std;
#define ll long long
#define F first
#define S second
mt19937 rnd(100);

ll n;
vector<ll> arr, win, ost;
set<ll> sts, ens;
ll D;

ll ma(ll l, ll r) {
    ll ans = LLONG_MIN;
    for (int i = l; i <= r; ++i)
        ans = max(ans, arr[i]);
    return ans;
}

void setLoose(ll u, ll a, ll b);

void setWin(ll u, ll a, ll b) {
    if (win[u] != -1)
        return;
    win[u] = 1;
    if (u + 1 <= b && win[u + 1] == -1)
        sts.insert(u + 1);
    if (u - 1 >= a && win[u - 1] == -1)
        ens.insert(u - 1);
    if (ens.count(u))
        ens.erase(u);
    if (sts.count(u))
        sts.erase(u);
    for (int i = max(a, u - D); i <= min(b, u + D); ++i)
        if (i != u && !--ost[i])
            setLoose(i, a, b);
}

void setLoose(ll u, ll a, ll b) {
    if (win[u] != -1)
        return;
    win[u] = 0;
    if (u + 1 <= b && win[u + 1] == -1)
        sts.insert(u + 1);
    if (u - 1 >= a && win[u - 1] == -1)
        ens.insert(u - 1);
    if (ens.count(u))
        ens.erase(u);
    if (sts.count(u))
        sts.erase(u);
    for (int i = max(a, u - D); i <= min(b, u + D); ++i)
        setWin(i, a, b);
}

void upd(ll a, ll b) {
    win.assign(n, -1);
    for (int i = 0; i < n; ++i)
        if (ma(max(a, i - D), min(b, i + D)) == arr[i])
            setLoose(i, a, b);
    while (!sts.empty()) {
        ll x = *sts.begin();
        ll y = *ens.begin();
        upd(x, y);
    }
}

void upd() {
    sts.insert(0);
    ens.insert(n - 1);
    upd(0, n - 1);
}

void init(vector<int> A, int _D) {
    n = A.size();
    ost.resize(n);
    for (int i = 0; i < n; ++i)
        ost[i] = min(n - 1, i + (ll) _D) - max(0, i - _D);
    arr.clear();
    for (int i: A)
        arr.push_back(i);
    D = _D;
    upd();
}

void updateValue(int index, int newValue) {
    arr[index] = newValue;
    upd();
}

bool isWinning(int startIndex) {
    return win[startIndex];
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll d, h1, h2, q, h3;
    cin >> n >> d;
    vector<int> a(n);
    for (int &i: a)
        cin >> i;
    init(a, d);
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> h1 >> h2;
        if (h1 == 2)
            cout << isWinning(h2) << endl;
        else {
            cin >> h3;
            updateValue(h2, h3);
        }
    }
}
/*
6 2
1 7 4 9 30 2
5
2 0
2 1
1 4 8
2 0
2 1

8 2
8 6 5 2 1 4 3 7
2
2 3
2 4

*/
/*

*/
/*
Каждый ход точно будет в клетку с большим значением если она есть.
Если на расстоянии прыжка нет значения больше, то мы проиграли.

Если на расстоянии Д от клетки нет клеток больше значит она проигрышная.
Если мы можем прыгнуть в проигрышную клетку, мы на выигрышной клетке.
Если мы не можем прыгнуть на проигрышную клетку, мы на проигрышной клетке.

Сдам подгруппы 1, 2, 3.

*/
/*

*/
/*

*/