#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long

void solve() {
    ll n, k, x;
    cin >> n >> k >> x;
    vector<ll> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> b = a;
    sort(b.begin(), b.end());
    do {
        bool ok = 1;
        for(int i = 0; i < (1 << n); ++i) {
            ll cnt = 0;
            for(int j = 0; j < n; ++j) {
                if ((i >> j) & 1) {
                    cnt++;
                }
            }
            if (cnt == k) {
                ll g1 = 0, g2 = 0;
                for(int j = 0; j < n; ++j) {
                    if ((i >> j) & 1) {
                        if (g1 == 0) {
                            g1 = a[j];
                            g2 = b[j];
                        } else {
                            g1 = __gcd(g1, a[j]);
                            g2 = __gcd(g2, b[j]);
                        }
                    }
                }
                if (g1 != g2) {
                    ok = 0;
                    break;
                }
            }

        }
        if (ok) {
            for(auto it : b) {
                cout << it << ' ';
            }
            return;
        }
    } while(next_permutation(b.begin(), b.end()));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
}
