#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <vector>
#include <stack>
#include <deque>
#include <iomanip>
#include <stdio.h>
//#include <queue>
//#include <map>
//#include <set>
//#include <unordered_map>
//#include <unordered_set>
//#include <random>
//#include <ctime>
//#include <cstdlib>
//#include <cassert>
//#include <iterator>
//#include <chrono>
//#include <array>
//#include <bitset>
//#define int long long
#define pii pair <long long, long long>
#define debug(x) cerr << (#x) << " " << (x) << endl
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define rall(vc) vc.rbegin(), vc.rend()
#define endl "\n"
#define fir first
#define sec second
using namespace std;

//mt19937 rnd(157);

vector<int> mm;
vector<vector<int>> gr;
vector<int> mem;
vector<int> hui;
int cur = 1;
vector<vector<int>> eul;

inline bool dfs(int v, vector<bool> &used, int cntus, int &sum, int pr) {
    if (!used[v])
        cntus++;
    used[v] = 1;
    if (v == 0 && cntus == used.size() && sum == used.size()) {
        return 1;
    }

    eul[v].push_back(cur);
    cur++;

    //ans++;
    //if (mm[id] == v) {
    //    id++;
    //}
    //if (id == mm.size()) {
    //    cout << ans;
    //    exit(0);
    //}

    for (int i = 0; i < gr[v].size(); i++) {
        int u = gr[v][mem[v]];
        if (u == pr && hui[v] == 0) {
            hui[v] = 1;
            sum++;
        }
        mem[v]++;
        mem[v] %= (int)(gr[v].size());
        bool fl = dfs(u, used, cntus, sum, v);
        if (fl)
            return 1;
        eul[v].push_back(cur);
        cur++;
    }
    return 0;
}


vector<vector<int>> realeul;

inline void euler(int v, int pr, int &curr) {
    realeul[v].push_back(curr);
    curr++;

    for (int i = mem[v]; i < gr[v].size(); i++) {
        int u = gr[v][i];
        if (u == pr)
            continue;
        euler(u, v, curr);
        realeul[v].push_back(curr);
        curr++;
    }

    for (int i = 0; i < mem[v] - 1; i++) {
        int u = gr[v][i];
        if (u == pr)
            continue;
        euler(u, v, curr);
        realeul[v].push_back(curr);
        curr++;
    }
    return;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    gr.resize(n);
    hui.resize(n);
    eul.resize(n);
    mem.resize(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            a--;
            gr[i].pb(a);
        }
    }

    mm.resize(m);
    for (int& i : mm) {
        cin >> i;
        i--;
    }

    vector<bool> used(n);
    int sum = 1;
    dfs(0, used, 0, sum, -1);

    //cout << cur << endl;

    int tek = 0;

    int id = -1;
    
    for (int i = 0; i < m; i++) {
        int v = mm[i];
        auto it = upper_bound(all(eul[v]), tek);
        if (it == eul[v].end()) {
            id = i;
            break;
        }
        tek = *it;
    }

    if (id == -1) {
        cout << tek;
        return 0;
    }

    realeul.resize(n);
    int curr = 0;
    euler(0, -1, curr);

    int full = 0;

    for (int i = id; i < m; i++) {
        int v = mm[i];
        auto it = upper_bound(all(realeul[v]), tek);
        if (it == realeul[v].end()) {
            full++;
            it = realeul[v].begin();
        }
        tek = *it;
    }

    cout << cur + full * curr + tek;
    return 0;
}