#include"game.h"
#include<bits/stdc++.h>
using namespace std;
template<class T>using vec=vector<T>;
template<class T>using vvec=vec<vec<T>>;
using vi=vec<int>;
using vb=vec<bool>;
using pii=pair<int,int>;
using vpii=vec<pii>;

vi A;
int n,D;

vb decided;
vb winning;

void calculate_winning()
{
    decided = vb(n, false);
    winning = vb(n);

    vpii Ap(n); for(int i = 0; i < n; ++i) Ap[i] = {-A[i], i};
    sort(Ap.begin(), Ap.end());
    for(auto[_, curr] : Ap)
    {
        if(decided[curr]) continue;
        decided[curr] = true;
        winning[curr] = false;
        for(int i = curr - D; i <= curr + D; ++i)
        {
            if(i < 0 || i >= n || i == curr) continue;
            if(!decided[i])
            {
                decided[i] = true;
                winning[i] = true;
            }
        }
    }
}

void init(vi _A, int _D)
{
    A = move(_A);
    D = _D;
    n = A.size();
    calculate_winning();
}

bool isWinning(int startIndex)
{
    return winning[startIndex];
}

void updateValue(int index, int newValue)
{
    A[index] = newValue;
    calculate_winning();
}
