#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

#define howmanyPrimes 33000
#define maxNumber 1000000000

vector <int> primes;
long long N, K, X;
vector <long long> numbers;

vector <int> calc2()
{
    map <int, long long> timesDevided;

    for (int a = 0; a < N; a++)
    {
        long long temp = numbers[a];

        for (int b = 0; b < primes.size() and temp >= primes[b]; b++)
        {
            int times = 0;
            int val = 1;

            while (temp % primes[b] == 0)
            {
                temp /= primes[b];
                times++;
                val *= primes[b];
                timesDevided[val]++;
            }
        }

        if (temp != 1)
            timesDevided[temp]++;
    }

    vector <pair <int, long long>> answer;
    for (int a = 0; a < N; a++)
        answer.push_back({ 1, numbers[a] });

    for (int a = 0; a < N; a++)
    {
        long long temp = numbers[a];
        for (int b = 0; b < primes.size() and temp >= primes[b]; b++)
        {
            int val = primes[b];

            while (temp % primes[b] == 0 and timesDevided[val] >= K)
            {
                temp /= primes[b];
                answer[a].first *= primes[b];
                val *= primes[b];
            }
        }

        //if (temp != 1 and timesDevided[temp] >= K)
        //    answer[a].first *= temp;
    }

    vector <vector <int>> sortAll;
    vector <int> counters, firstPlace;
    vector <long long> mini;
    map <int, int> place;

    for (int a = 0; a < N; a++)
    {
        if (place[answer[a].first] == 0)
        {
            place[answer[a].first] = sortAll.size() + 1;
            sortAll.push_back({});
            counters.push_back(0);
            firstPlace.push_back(a);
            mini.push_back(maxNumber);
        }

        mini[place[answer[a].first] - 1] = min(mini[place[answer[a].first] - 1], answer[a].second);
        sortAll[place[answer[a].first] - 1].push_back(answer[a].second);
    }

    for (int a = 0; a < sortAll.size(); a++)
        sort(sortAll[a].begin(), sortAll[a].end());

    for (int a = 0; a < N; a++)
    {
        answer[a].second = sortAll[place[answer[a].first] - 1][counters[place[answer[a].first] - 1]];
        counters[place[answer[a].first] - 1]++;
    }

    bool wasMul = false;
    for (int a = 0; a < N and !wasMul and X != 1; a++)
        if (place[answer[a].first * X] != 0 and mini[place[answer[a].first * X] - 1] < answer[a].second and firstPlace[place[answer[a].first * X] - 1] > a)
        {
            answer[a].first *= X;
            answer[a].second *= X;
            int placeRot = place[answer[a].first] - 1;
            sortAll[placeRot].push_back(answer[a].second);
            sort(sortAll[placeRot].begin(), sortAll[placeRot].end());
            int counter = 0;
            for (int b = 0; b < N; b++)
                if (answer[b].first == answer[a].first)
                {
                    answer[b].second = sortAll[placeRot][counter];
                    counter++;
                }
            wasMul = true;
        }

    vector <int> valueReturn;
    for (int a = 0; a < N; a++)
        valueReturn.push_back(answer[a].second);
    return valueReturn;
}


long long powerQuick(long long a, long long b, long long mod)
{
    long long ans = 1;
    while (b != 0)
    {
        if (b % 2 == 1)
            ans = ans * a % mod;
        a = a * a % mod;
        b /= 2;
    }
    return ans;
}

bool isPrime(long long number)
{
    for (int a = 0; a < 30; a++)
    {
        int ran = rand() % (number - 3);
        if (powerQuick(ran + 2, number - 1, number) != 1)
            return false;
    }
    return true;
}

vector <int> calc()
{
    map <int, long long> timesDevided;
    vector <vector <int>> devisions;

    for (int a = 0; a < N; a++)
    {
        long long temp = numbers[a];
        devisions.push_back({});

        //if (numbers[a] <= 10 or !(!isPrime(numbers[a]) and numbers[a] > howmanyPrimes))
        {
            for (int b = 0; b < primes.size() and temp >= primes[b]; b++)
            {
                int val = 1;

                while (temp % primes[b] == 0)
                {
                    temp /= primes[b];
                    val *= primes[b];
                    timesDevided[val]++;
                    devisions.back().push_back(primes[b]);
                }
            }
        }

        if (temp != 1)
        {
            timesDevided[temp]++;
            devisions.back().push_back(temp);
        }
    }

    vector <pair <int, long long>> answer;
    for (int a = 0; a < N; a++)
        answer.push_back({ 1, numbers[a] });

    for (int a = 0; a < N; a++)
    {
        long long temp = numbers[a];
        int val;
        for (int b = 0; b < devisions[a].size(); b++)
        {
            if (b == 0 or devisions[a][b] != devisions[a][b - 1])
                val = 1;
            val *= devisions[a][b];
            if (timesDevided[val] >= K)
                answer[a].first *= devisions[a][b];
        }
    }

    vector <vector <int>> sortAll;
    vector <vector <pair <int, int>>> temp;
    vector <int> counters;
    map <int, int> place;

    for (int a = 0; a < N; a++)
    {
        if (place[answer[a].first] == 0)
        {
            place[answer[a].first] = sortAll.size() + 1;
            sortAll.push_back({});
            temp.push_back({});
            counters.push_back(0);
        }

        sortAll[place[answer[a].first] - 1].push_back(answer[a].second);
    }

    for (int a = 0; a < sortAll.size(); a++)
        sort(sortAll[a].begin(), sortAll[a].end());

    for (int a = 0; a < N; a++)
    {
        answer[a].second = sortAll[place[answer[a].first] - 1][counters[place[answer[a].first] - 1]];
        temp[place[answer[a].first] - 1].push_back({ a, answer[a].second });
        counters[place[answer[a].first] - 1]++;
    }

    bool wasMul = false;
    for (int a = 0; a < N and !wasMul and X != 1; a++)
        if (place[answer[a].first * X] != 0)
        {
            pair <int, int> temp2 = { a, 0 };
            int temp3 = lower_bound(temp[place[answer[a].first * X] - 1].begin(), temp[place[answer[a].first * X] - 1].end(), temp2) - temp[place[answer[a].first * X] - 1].begin();
            int placeRot = place[answer[a].first * X] - 1;

            if ((temp3 == temp[placeRot].size() or temp[placeRot][temp3].second > answer[a].second) and (temp3 == 0 or temp[placeRot][temp3 - 1].second < answer[a].second * X))
                continue;

            answer[a].first *= X;
            answer[a].second *= X;
            sortAll[placeRot].push_back(answer[a].second);
            sort(sortAll[placeRot].begin(), sortAll[placeRot].end());
            int counter = 0;

            for (int b = 0; b < N; b++)
                if (answer[b].first == answer[a].first)
                {
                    answer[b].second = sortAll[placeRot][counter];
                    counter++;
                }

            wasMul = true;
        }

    vector <int> valueReturn;
    for (int a = 0; a < N; a++)
        valueReturn.push_back(answer[a].second);
    return valueReturn;
}

vector <int> getMin(vector <int> first, vector <int> second)
{
    for (int a = 0; a < first.size(); a++)
        if (first[a] < second[a])
            return first;
        else if (first[a] > second[a])
            return second;
    return first;
}

void solve()
{
    int c;
    cin >> N >> K >> X;
    int counter = 0;
    //while (true)
    {
        numbers = {};
        for (int a = 0; a < N; a++)
        {
            cin >> c;
            //c = rand() % 20 + 1;
            numbers.push_back(c);
        }
        vector <int> temp = calc();
        for (int a : temp)
            cout << a << " ";
        //cout << '\n';
        //vector <int> temp2 = calc2();
        /*for (int a = 0; a < temp.size(); a++)
            if (temp[a] != temp2[a])
            {
                //2 8 15 1 10
                cout << "problem!" << '\n';
                for (int b : numbers)
                    cout << b << " ";
                cout << '\n' << '\n';
                for (int b : temp)
                    cout << b << " ";
                cout << '\n' << '\n';
                for (int b : temp2)
                    cout << b << " ";
                cout << '\n' << '\n';
                cin >> temp2[0];
            }
        counter++;
        if (counter % 1000 == 0)
            cout << counter << '\n';//*/
    }
}
//*
int main()
{
    srand(time(NULL));
    vector <int> was(howmanyPrimes + 9, false);
    for (int a = 2; a < howmanyPrimes; a++)
    {
        if (!was[a])
            primes.push_back(a);
        for (int b = 0; b < primes.size() and a * primes[b] <= howmanyPrimes; b++)
            was[a * primes[b]] = true;
    }
    /*for (int a = 5; a < maxNumber; a++)
    {
        bool isP = true;
        for (int b = 0; b < primes.size() and isPrime; b++)
            if (a % primes[b] == 0)
                isP = false;
        if (isPrime(a) != isP)
            cout << a << " ";
    }*/
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T;
    cin >> T;
    for (int a = 0; a < T; a++)
        solve();
}
//*/