#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
#define howmanyPrimes 100000
#define maxNumber 1000000000
vector <int> primes;
vector <long long> numbers;
long long N, K, X, c;
vector <long long> solve()
{
    map <long long, long long> timesDevided;

    for (int a = 0; a < N; a++)
    {
        long long temp = numbers[a];

        for (int b = 0; b < primes.size(); b++)
        {
            long long times = 0;
            long long val = 1;

            while (temp % primes[b] == 0)
            {
                temp /= primes[b];
                times++;
                val *= primes[b];
                timesDevided[val]++;
            }
        }

        if (temp != 1)
            timesDevided[temp]++;
    }

    vector <pair <long long, long long>> answer;
    for (int a = 0; a < N; a++)
        answer.push_back({ 1, numbers[a] });

    for (int a = 0; a < N; a++)
    {
        long long temp = numbers[a];
        for (int b = 0; b < primes.size(); b++)
        {
            long long val = primes[b];

            while (temp % primes[b] == 0 and timesDevided[val] >= K)
            {
                temp /= primes[b];
                answer[a].first *= primes[b];
                val *= primes[b];
            }
        }
    }

    vector <vector <long long>> sortAll;
    vector <int> counters;
    map <int, int> place;

    for (int a = 0; a < N; a++)
    {
        if (place[answer[a].first] == 0)
        {
            place[answer[a].first] = sortAll.size() + 1;
            sortAll.push_back({});
            counters.push_back(0);
        }

        sortAll[place[answer[a].first] - 1].push_back(answer[a].second);
    }

    for (int a = 0; a < sortAll.size(); a++)
        sort(sortAll[a].begin(), sortAll[a].end());

    for (int a = 0; a < N; a++)
    {
        answer[a].second = sortAll[place[answer[a].first] - 1][counters[place[answer[a].first] - 1]];
        counters[place[answer[a].first] - 1]++;
    }

    vector <long long> ans;
    for (int a = 0; a < N; a++)
        ans.push_back(answer[a].second);
    return ans;
}

vector <long long> getBig(vector <long long> first, vector <long long> second)
{
    for (int a = 0; a < first.size(); a++)
        if (first[a] > second[a])
            return second;
        else if (second[a] > first[a])
            return first;
    return second;
}

int main()
{
    vector <int> was(howmanyPrimes + 9, false);
    for (int a = 2; a < howmanyPrimes; a++)
    {
        if (!was[a])
            primes.push_back(a);
        for (int b = 0; b < primes.size() and a * primes[b] <= howmanyPrimes; b++)
            was[a * primes[b]] = true;
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T;
    cin >> T;
    for (int a = 0; a < T; a++)
    {
        cin >> N >> K >> X;
        numbers = {};
        for (int a = 0; a < N; a++)
        {
            cin >> c;
            numbers.push_back(c);
        }
        auto t = solve();
        int tempi = X;
        X = 1;
        if (tempi != 1)
        {
            for (int a = 0; a < numbers.size(); a++)
            {
                numbers[a] *= tempi;
                vector <long long> temp = solve();
                numbers[a] /= tempi;
                t = getBig(t, temp);
            }
        }
        for (int a : t)
            cout << a << " ";
        cout << '\n';
    }
}