#include<bits/stdc++.h>
typedef long long ll;
using namespace std;

ll gcd(ll a, ll b){
    if(a % b == 0) return b;
    return gcd(b, a % b);
}

vector<ll> min_gcd(vector<ll> &a, vector<ll> &b, ll k, ll n){
    for(ll i = 0; i < n-k+1; i++){
        ll gcd_a = gcd(a[i], a[i+1]), gcd_b = gcd(b[i], b[i+1]);
        for(ll j = i+1; j < i+k-1; j++) gcd_a = gcd(gcd_a, a[j]), gcd_b = gcd(gcd_b, b[j]);
        if(gcd_a < gcd_b) return a;
        if(gcd_b < gcd_a) return b;
    }
    return a;
}

vector<ll> my_next_permutation(vector<ll> &v, ll n){
    vector<ll> u(n);
    for(ll i = 1; i <= n; i++) u[i-1] = v[i%n];
    return u;
}

int main(){
    ll t; cin >> t;
    while(t--){
        ll n, k, x; cin >> n >> k >> x;
        vector<ll> v(n);
        for(ll i = 0; i < n; i++) cin >> v[i];
        vector<ll> ans = v;
        for(ll i = 0; i < n; i++){
            v = my_next_permutation(v, n);
            ans = min_gcd(ans, v, k, n);
        }
        for(ll i : ans) cout << i << " ";
    }
}
