#include <bits/stdc++.h>

using namespace std;

vector<int> edge;
vector<int> edgeSiz;
vector<map<int, set<int>>> pass;

vector<vector<int>> g;
vector<int> iter;
queue<int> lst;

int solveInt(int cur) {
    if (cur == lst.front()) lst.pop();
    if (lst.empty())
        return 0;
    int prev = iter[cur];
    iter[cur]++;
    iter[cur] %= g[cur].size();
    int d= solveInt(edge[g[cur][prev]]);
    return d + 1;
}

//TODO SMALL TO LARGE
int dfs(int cur, int ed) {
    int tar = iter[cur];
    int siz = (tar >= g[cur].size() ? edgeSiz[g[cur][tar - g[cur].size()]] : edgeSiz[g[cur][tar]]);
    if (iter[cur] >= g[cur].size()) {
        int pos = iter[cur] - g[cur].size();
        if (g[cur][pos] != ed) {
            edge[ed] = edge[g[cur][pos]];

            for (const auto& [x,times] : pass[g[cur][pos]]) {
                for (auto y : times) {
                    pass[ed][x].emplace(y + edgeSiz[ed]);
                }
            }
            edgeSiz[ed] += edgeSiz[g[cur][pos]];
            pass[g[cur][pos]].clear();
        }
        g[cur][pos] = ed;
        tar = pos;
    }
    int t = 0;
    while (!lst.empty() && pass[g[cur][tar]].count(lst.front())) {
        auto &s = pass[g[cur][tar]][lst.front()];
        if (s.upper_bound(t) == s.end()) break;
        t = *s.upper_bound(t);
        lst.pop();
    }
    if (lst.empty())
        return t;


    iter[cur]++;
    return dfs(edge[g[cur][tar]],g[cur][tar]) + siz;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    int n = 16, m = 1;
    while (true) {
        g.resize(n + 1);
        int edgeCounter = 0;
        iter.resize(n + 1,0);
        edge.clear();
        edgeSiz.clear();
        pass.clear();
        g.clear();
        iter.clear();


        for (int i = 1; i <= n;i++) {
            vector<int> td = {i * 2, i * 2 + 1};
            if (i * 2 + 1 > n) td.clear();
            if (i != 1) td.push_back(i / 2);

            for (auto t : td) {
                edge.push_back(t);
                map<int, set<int>> ma;
                ma[t].emplace(1);
                pass.push_back(ma);
                g[i].push_back(edgeCounter++);
            }
        }

        edgeSiz.resize(edgeCounter,1);

        for (int i = 0; i < m;i++) {
            int x = rand() % n + 1;
            lst.emplace(x);
        }
        auto copy = lst;
        if (lst.front() == 1) lst.pop();

        int sol1= solveInt(1) + 1;

        cout << sol1;
        return 0;
        lst = copy;
        iter.clear();
        iter.resize(n + 1);
        int sol2 = dfs(1,-1) + 1;

        if (sol1 != sol2) {
            cout << "ERROR";
        }
    }
    return 0;
}
