#include <bits/stdc++.h>

using namespace std;

vector<int> edge;
vector<int> edgeSiz;
vector<map<int, set<int>>> pass;

vector<vector<int>> g;
vector<int> iter;
queue<int> lst;

int solveInt(int cur) {
    if (cur == lst.front()) lst.pop();
    if (lst.empty())
        return 0;
    int prev = iter[cur];
    iter[cur]++;
    iter[cur] %= g[cur].size();
    int d= solveInt(edge[g[cur][prev]]);
    return d + 1;
}

//TODO SMALL TO LARGE
int dfs(int cur, int ed) {
    int tar = iter[cur];
    int siz = (tar >= g[cur].size() ? edgeSiz[g[cur][tar - g[cur].size()]] : edgeSiz[g[cur][tar]]);
    if (iter[cur] >= g[cur].size()) {
        int pos = iter[cur] - g[cur].size();
        if (g[cur][pos] != ed) {
            edge[ed] = edge[g[cur][pos]];

            for (const auto& [x,times] : pass[g[cur][pos]]) {
                for (auto y : times) {
                    pass[ed][x].emplace(y + edgeSiz[ed]);
                }
            }
            edgeSiz[ed] += edgeSiz[g[cur][pos]];
            pass[g[cur][pos]].clear();
        }
        g[cur][pos] = ed;
        tar = pos;
    }
    int t = 0;
    while (!lst.empty() && pass[g[cur][tar]].count(lst.front())) {
        auto &s = pass[g[cur][tar]][lst.front()];
        if (s.upper_bound(t) == s.end()) break;
        t = *s.upper_bound(t);
        lst.pop();
    }
    if (lst.empty())
        return t;


    iter[cur]++;
    return dfs(edge[g[cur][tar]],g[cur][tar]) + siz;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    ios_base::sync_with_stdio(false); cin.tie(nullptr);

    int n, m; cin >> n >> m;
    g.resize(n + 1);
    int edgeCounter = 0;
    iter.resize(n + 1,-1);

    for (int i = 1; i <= n;i++) {
        int k; cin >> k;
        for (int j = 0; j < k;j++) {
            int t; cin >> t;
            edge.push_back(t);
            map<int, set<int>> ma;
            ma[t].emplace(1);
            pass.push_back(ma);
            g[i].push_back(edgeCounter++);
        }
    }
    edgeSiz.resize(edgeCounter,1);

    for (int i = 0; i < m;i++) {
        int x; cin >> x;
        lst.emplace(x);
    }
    //if (lst.front() == 1) lst.pop();

    cout << solveInt(1) + 1;
    return 0;
}
