#include <bits/stdc++.h>

using namespace std;

vector<bool> val;

using pii = pair<int,int>;
set<int> winning;

vector<int> A;
int D;

void init(std::vector<int> a2, int d5) {
    A = a2;
    D = d5;
    vector<pii> data(A.size());
    for (int i = 0; i  <A.size();i++) {
        data[i] = {A[i],i};
    }
    sort(data.begin(),data.end());
    reverse(data.begin(),data.end());

    vector<int> store;

    for (auto [v, i] : data) {
        auto l = winning.lower_bound(i - D);
        if (l == winning.end() || *l > i + D)
            winning.insert(i);
    }
}
void updateValue(int index, int newValue) {
    winning.clear();
    A[index] = newValue;
    vector<pii> data(A.size());
    for (int i = 0; i  <A.size();i++) {
        data[i] = {A[i],i};
    }
    sort(data.begin(),data.end());
    reverse(data.begin(),data.end());

    vector<int> store;

    for (auto [v, i] : data) {

        auto l = winning.lower_bound(i - D);
        if (l == winning.end() || *l > i + D)
            winning.insert(i);
    }
}
bool isWinning(int startIndex) {
    return !winning.count(startIndex);
}

#if DEBUG
int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
#endif