#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
using namespace std;
#define rep(i,s,e) for(int i=s;i<e;i++)
#define all(a) a.begin(),a.end()
typedef long long ll;

//A4 - travel

vector<deque<int>>vec;
vector<int>sed;

int dfs(int v, int t) {
    if (v == sed.back())
        sed.pop_back();
    if (sed.empty())
        return t;
    int u = vec[v].front();
    vec[v].pop_front();
    vec[v].push_back(u);
    return dfs(u, t + 1);
}

int main() {
    int n, m;
    cin >> n >> m;
    vec.resize(n);
    rep(i, 0, n) {
        int k;
        cin >> k;
        vec[i].resize(k);
        rep(j, 0, k) {
            cin >> vec[i][j];
            vec[i][j]--;
        }
    }
    sed.resize(m);
    rep(i, 0, m) {
        cin >> sed[i];
        sed[i]--;
    }
    reverse(all(sed));
    cout << dfs(0, 1);
}


//A5 - game
/*
#include "game.h"

vector<int>ans, vec;
int n, d;

void init(vector<int> A, int D) {
    d = D;
    vec = A;
    n = vec.size();
    ans.clear();
    ans.resize(n, -1);
    rep(i, 0, n) {
        bool flag = true;
        rep(j, i + 1, min(n, i + d + 1)) {
            if (vec[j] > vec[i]) {
                flag = false;
                break;
            }
        }
        rep(j, max(i - d, 0), i) {
            if (vec[j] > vec[i]) {
                flag = false;
                break;
            }
        }
        if (flag)
            ans[i] = 0;
    }
    vector<pair<int,int>>sv(n);
    rep(i, 0, n) {
        sv[i].first = vec[i];
        sv[i].second = i;
    }
    sort(all(sv));
    reverse(all(sv));
    rep(h, 0, n) {
        int i = sv[h].second;
        if (ans[i] == -1) {
            int mis = 0;
            rep(j, i + 1, min(n, i + d + 1)) {
                if (ans[j]==0) {
                    mis = 1;
                    break;
                }
            }
            rep(j, max(i - d, 0), i) {
                if (ans[j] == 0) {
                    mis = 1;
                    break;
                }
            }
            ans[i] = mis;
        }
    }

}
void updateValue(int index, int val) {
    vec[index] = val;
    ans.clear();
    ans.resize(n, -1);
    rep(i, 0, n) {
        bool flag = true;
        rep(j, i + 1, min(n, i + d + 1)) {
            if (vec[j] > vec[i]) {
                flag = false;
                break;
            }
        }
        rep(j, max(i - d, 0), i) {
            if (vec[j] > vec[i]) {
                flag = false;
                break;
            }
        }
        if (flag)
            ans[i] = 0;
    }
    vector<pair<int, int>>sv(n);
    rep(i, 0, n) {
        sv[i].first = vec[i];
        sv[i].second = i;
    }
    sort(all(sv));
    reverse(all(sv));
    rep(h, 0, n) {
        int i = sv[h].second;
        if (ans[i] == -1) {
            int mis = 0;
            rep(j, i + 1, min(n, i + d + 1)) {
                if (ans[j] == 0) {
                    mis = 1;
                    break;
                }
            }
            rep(j, max(i - d, 0), i) {
                if (ans[j] == 0) {
                    mis = 1;
                    break;
                }
            }
            ans[i] = mis;
        }
    }
}
bool isWinning(int i) {
    return ans[i];
}


int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}*/