#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll, ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    ll N, M;
    cin >> N >> M;
    vector<deque<ll>> graph(N);
    for (ll i= 0 ; i < N; i++)
    {
        ll k;
        cin >> k;
        for (ll j= 0 ; j < k; j++)
        {
            ll cur;
            cin >> cur;
            cur--;
            graph[i].pb(cur);
        }
    }
    v cities(M);
    for (ll i =0 ; i < M; i++) {cin >> cities[i]; cities[i]--;}
    v parent(N, -1);
    stack<p> dfs;
    dfs.emplace(0, -1);
    while (!dfs.empty())
    {
        auto top = dfs.top();
        dfs.pop();
        parent[top.f] = top.s;
        for (ll x : graph[top.f]) if (x != top.s) dfs.emplace(x, top.f);
    }
    vb finished(N, false);
    ll finishedCnt = 0;
    for (ll i =0 ; i < N; i++)
    {
        if (graph[i].back() == parent[i])
        {
            finished[i] = true;
            finishedCnt++;
        }
    }
    ll first = graph[0][0];
    ll friendIndex = 0;
    ll steps = 1;
    while (finishedCnt < N - 1)
    {
        ll cur = 0;
        bool done = false;
        while (cur != 0 || graph[cur][0] != first || !done)
        {
            done = true;
            ll next = graph[cur][0];
            graph[cur].pop_front();
            graph[cur].push_back(next);
            if (next == parent[cur] && !finished[cur])
            {
                finished[cur] = true;
                finishedCnt++;
            }
            if (cur == cities[friendIndex])
            {
                friendIndex++;
                if (friendIndex == M) break;
            }
            steps++;
            cur = next;
        }
        if (friendIndex == M) break;
    }
    if (friendIndex == M)
    {
        cout << steps << "\n";
        return 0;
    }
    v order;
    ll cur = 0;
    while (cur != 0 || graph[cur][0] != first || order.empty())
    {
        order.pb(cur);
        ll next = graph[cur][0];
        graph[cur].pop_front();
        graph[cur].push_back(next);
        cur = next;
    }
    vv orderIndices(N);
    for (ll i = 0; i < order.size(); i++) orderIndices[order[i]].pb(i);
    steps--;
    cur = -1;
    for (;friendIndex < M; friendIndex++)
    {
        if (orderIndices[cities[friendIndex]].back() <= cur)
        {
            steps += order.size() - 1 - cur;
            cur = -1;
        }
        auto ptr = upper_bound(all(orderIndices[cities[friendIndex]]), cur);
        steps += *ptr - cur;
        cur = *ptr;
    }
    cout << steps << "\n";
    return 0;
}