#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll, ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

#include "game.h"

v A;
ll D;
vb winning;
ll N;

void init(std::vector<int> iA, int iD)
{
    for (auto x : iA) A.pb(x);
    D = iD;
    N = A.size();
    winning = vb(N, false);
    vb visited(N, false);
    vp aSorted;
    for (ll i = 0; i < N; i++) aSorted.eb(A[i], i);
    sort(all(aSorted),greater<p>());
    for (auto x : aSorted)
    {
        for (ll i = max(0ll, x.s - D); i <= min(N - 1, x.s + D); i++) if (!winning[i] && visited[i]) winning[i] = true;
        visited[x.s] = true;
    }
    
}
void updateValue(int index, int newValue)
{
    A[index] = newValue;
    winning = vb(N, false);
    vb visited(N, false);
    vp aSorted;
    for (ll i = 0; i < N; i++) aSorted.eb(A[i], i);
    sort(all(aSorted),greater<p>());
    for (auto x : aSorted)
    {
        if (visited[x.s]) continue;
        visited[x.s] = true;
        winning[x.s] = false;
        for (ll i = max(0ll, x.s - D); i <= min(N - 1, x.s + D); i++)
        {
            if (visited[i]) continue;
            visited[i] = true;
            winning[i] = true;
        }
    }
}
bool isWinning(int startIndex)
{
    return winning[startIndex];
}
/*
int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
/**/