#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> v;
typedef vector<v> vv;
typedef vector<vv> vvv;
typedef pair<ll, ll> p;
typedef vector<p> vp;
typedef vector<vp> vvp;
typedef vector<vvp> vvvp;
typedef pair<ll, p> tri;
typedef vector<tri> vtri;
typedef vector<vtri> vvtri;
typedef vector<vvtri> vvvtri;
typedef vector<bool> vb;
typedef vector<vb> vvb;
typedef vector<vvb> vvvb;

#define f first
#define s second
#define pb push_back
#define eb emplace_back
#define all(v) (v).begin(),(v).end()

const ll INF = 1e18;
const ll mod = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
    ll T;
    cin >> T;
    while (T--)
    {
        ll N, K, X;
        cin >> N >> K >> X;
        v a(N);
        for (ll i =0 ; i < N; i++) cin >> a[i];
        vv factors(N);
        for (ll i =0 ; i < N; i++)
        {
            for (ll j = 1; j * j <= a[i]; j++)
            {
                if (a[i] % j == 0)
                {
                    factors[i].pb(j);
                    if (j * j != i) factors[i].pb(a[i] / j);
                }
            }
        }
        map<ll, v> byFactor;
        for (ll i = 0; i < N; i++) for (ll x : factors[i]) byFactor[x].pb(i);
        vv constraints;
        for (auto x : byFactor)
        {
            if (x.s.size() >= K) constraints.pb(x.s);
        }
        vv appearsIn(N);
        for (ll i =0 ; i <constraints.size(); i++)
        {
            for (ll x : constraints[i]) appearsIn[x].pb(i);
        }
        vv possible(N);
        for (ll i = 0; i < N; i++)
        {
            v cur(N);
            for (ll i= 0 ; i < N; i++) cur[i] = i;
            for (ll x : appearsIn[i])
            {
                v inter;
                set_intersection(all(cur),all(constraints[x]),back_inserter(inter));
                cur = inter;
            }
            possible[i] = cur;
        }
        vv possibleInPos(N);
        for (ll i =0 ; i < N; i++) for (ll x : possible[i]) possibleInPos[x].pb(i);
        v perm(N, -1);
        vb visited(N, false);
        for (ll i = 0; i < N; i++)
        {
            sort(all(possibleInPos[i]),[&a](ll i, ll j){return a[i] < a[j];});
            for (ll x : possibleInPos[i])
            {
                if (!visited[x])
                {
                    visited[x] = true;
                    perm[i] = x;
                    break;
                }
            }
        }
        for (ll x : perm) cout << a[x] << " ";
        cout << "\n";
    }
    return 0;
}