#include <bits/stdc++.h>
#include "game.h"
using namespace std;
typedef long long ll;


vector<int> arr;
vector<set<ll>> bgr;
int mx;
int d;


void init(vector<int> a, int D)
{
    arr = a;
    mx = 0;
    d = D;
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] > mx) mx = a[i];
        bgr.push_back({});
        for (int j = i - d; j <= i + d; j++)
        {
            if (j < 0 || j > a.size() - 1 || j == i) continue;
            if (a[j] > a[i]) bgr[i].insert(j);
        }
    }
}


bool isWinning(int ind)
{
    if (bgr[ind].empty()) return false;

    bool tmp = false;

    for (ll i : bgr[ind])
    {
        tmp = tmp || (!isWinning(i));
    }

    return tmp;
}

void updateValue(int ind, int val)
{
    for (int i = ind - d; i <= ind + d; i++)
    {
        if (i < 0 || i > arr.size() || i == ind) continue;

        if (arr[ind] > arr[i] && val < arr[i]) bgr[i].erase(ind);
    }

    arr[ind] = val;     
}



// int main()
// {
//     int n, D, q;

//     std::vector<int> nums;

//     scanf("%d %d", &n, &D);

//     for (int i = 1; i <= n; i++)
//     {
//         int x;
//         scanf("%d", &x);
//         nums.push_back(x);
//     }

//     init(nums, D);

//     scanf("%d", &q);

//     for (int i = 1; i <= q; i++)
//     {
//         int cm;

//         scanf("%d", &cm);

//         if (cm == 1)
//         {
//             int ind, val;

//             scanf("%d %d", &ind, &val);

//             updateValue(ind, val);
//         }
//         else
//         {
//             int ind;

//             scanf("%d", &ind);

//             printf("%d\n", (int)isWinning(ind));
//         }
//     }

//     return 0;
// }
