#include <bits/stdc++.h>
// #include "game.h"
using namespace std;


vector<int> arr;
vector<set<int>> bgr;
int d;


void init(vector<int> a, int D)
{
    arr = a;
    d = D;
    for (int i = 0; i < a.size(); i++)
    {
        bgr.push_back({});
        for (int j = i - d; j <= i + d; j++)
        {
            if (j < 0 || j > a.size() - 1 || j == i) continue;
            if (a[j] > a[i]) bgr[i].insert(j);
        }
    }
}


bool isWinning(int ind)
{
    if (bgr[ind].empty()) return false;

    bool tmp = false;

    for (int i : bgr[ind])
    {
        tmp = tmp || (!isWinning(i));
    }

    return tmp;
}

void updateValue(int ind, int val)
{
    for (int i = ind - d; i <= ind + d; i++)
    {
        if (i < 0 || i >= arr.size() || i == ind) continue;

        if (arr[ind] > arr[i] && val < arr[i]) bgr[i].erase(ind);
        else if (arr[ind] < arr[i] && val > arr[i]) bgr[i].insert(ind);
    }

    arr[ind] = val;     
}


