#include <bits/stdc++.h>
#include "game.h"
using namespace std;


vector<int> arr;
vector<int> mxs;
vector<bool> win;
vector<bool> bn;
int d;


void init(vector<int> a, int D)
{
    win.resize(a.size());
    bn.resize(a.size());
    arr = a;
    d = D;

    for (int i = 0; i < a.size(); i++)
    {
        mxs.push_back(i);
        for (int j = i - d; j <= i + d; j++)
        {
            if (j < 0 || j >= arr.size() || j == i) continue;

            if (arr[j] > arr[i])
            {
                mxs.pop_back();
                break;
            }
        }
    }

    for (int mx : mxs)
    {
        win[mx] = false;
        bn[mx] = true;
        for (int i = mx - d; i <= mx + d; i++)
        {
            if (i < 0 || i >= arr.size() || i == mx) continue;
            win[i] = true;
            bn[i] = true;
        }
    }
}


bool isWinning(int ind)
{
    if (bn[ind]) return win[ind];

    bool tmp = false;

    for (int i = ind - d; i <= ind + d; i++)
    {
        if (i < 0 || i >= arr.size() || i == ind) continue;
        if (arr[i] > arr[ind]) tmp = tmp || !isWinning(i);
    }

    bn[ind] = true;
    win[ind] = tmp;
    return tmp;
}

void updateValue(int ind, int val)
{
    arr[ind] = val;     
}



// int main()
// {
//     freopen("input.txt", "r", stdin);

//     int n, D, q;

//     std::vector<int> nums;

//     scanf("%d %d", &n, &D);

//     for (int i = 1; i <= n; i++)
//     {
//         int x;
//         scanf("%d", &x);
//         nums.push_back(x);
//     }

//     init(nums, D);

//     scanf("%d", &q);

//     for (int i = 1; i <= q; i++)
//     {
//         int cm;

//         scanf("%d", &cm);

//         if (cm == 1)
//         {
//             int ind, val;

//             scanf("%d %d", &ind, &val);

//             updateValue(ind, val);
//         }
//         else
//         {
//             int ind;

//             scanf("%d", &ind);

//             printf("%d\n", (int)isWinning(ind));
//         }
//     }

//     return 0;
// }
