#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<vector<ll>> gds;
map<ll, ll> ind;

bool isEq(ll a, ll b)
{
    for (ll i = 0; i < gds.size(); i++)
    {
        if (a == i || b == i) continue;

        if (gds[a][i] != gds[b][i]) return false;
    }

    return true;
}


bool cmp(ll a, ll b)
{
    ll ia = ind[a], ib = ind[b];

    return isEq(ia, ib) ? a < b : ia < ib;
}


ll gcd(ll a, ll b)
{
    return b == 0 ? a : gcd(b, a % b);
}

ll gcd(vector<ll> &arr)
{
    if (arr.size() == 0) return 0;
    if (arr.size() == 1) return arr[0];
    vector<ll> gs;
    for (ll i = 0; i < (arr.size() >> 1); i++) gs.push_back(gcd(arr[i << 1], arr[(i << 1) + 1]));
    if (arr.size() % 2) gs.push_back(arr.back());
    return gcd(gs);
}

void setup(vector<ll> &a, ll n)
{
    gds.resize(n, vector<ll> (n));

    for (ll i = 0; i < n; i++)
    {
        ind[a[i]] = i;
        for (ll j = i; j < n; j++)
        {
            gds[i][j] = gcd(a[i], a[j]);
            gds[j][i] = gds[i][j];
        }
    }
}




int main()
{
    //freopen("C:\\Users\\Default\\Desktop\\iati day 2\\input.txt", "r", stdin);          

    ll t;
    cin >> t;

    while (t--)
    {
        ll n, k, x;
        cin >> n >> k >> x;
        vector<ll> a(n), b(n);
        for (ll i = 0; i < n; i++)
        {
            cin >> a[i];
            b[i] = a[i];
        }
        setup(b, n);
        sort(b.begin(), b.end(), cmp);

        for (ll i : b) cout << i << ' ';
        cout << '\n';
    }


    return 0;
}