#include <iostream>
#include <queue>
#include <vector>
using namespace std;

vector<deque<int>> g;
vector<int> f;
int n, m;

void solve() {
	// tree
	// go to first friend and then to second and so on. calc changes on the way (maybe with deque)
	// naive O(ans)


	int cur = 0, pos = 0, cnt = 0;
	while (pos < m) {
		if (cur == f[pos] - 1)
			++pos;

		int tmp = g[cur].front();
		g[cur].pop_front();
		g[cur].push_back(tmp);
		cur = tmp;
		
		cnt++;
	}
	cout << cnt;	
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);
	cin >> n >> m;

	g.resize(n); f.resize(m);

	int k, j;
	for (int i = 0; i < n; ++i)
		for (cin >> k; k--; g[i].push_back(j - 1))
			cin >> j;
	
	for (int& i : f) cin >> i;
	solve();

	return 0;
}