#include "game.h"
#include <vector>
#include <iostream>
#include <queue>
using namespace std;

#define s second
#define f first

typedef pair<int, int> ii;

vector<int> a;
int d;

void init(std::vector<int> A, int D) {
	a = A;
	d = D;
}

void updateValue(int index, int newValue) {
	a[index] = newValue;
}

bool isWinning(int startIndex) {
	int n = (int)a.size();

	priority_queue<ii> pq;
	for (int i = 0; i < n; ++i) pq.emplace(a[i], i);

	vector<int> v(n); // 0 - none, 1 - win, 2 - lose

	while (!pq.empty()) {
		ii front = pq.top(); pq.pop();
		if (v[front.s]) continue;

		v[front.s] = 2;

		for (int i = max(0, front.s - d); i <= min(n - 1, front.s + d); ++i)
			if (i != front.s)
				v[i] = 1;
	}

	return v[startIndex] == 1;
}