#include <bits/stdc++.h>

#include "game.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
//#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

vector <int> a, dp;

int d, n;

void solve(){
    vector <ar<int,2>> t;
    for ( int i = 0; i < n; i++ ){
        t.pb({-a[i], i});
    }
    sort(all(t));
    for ( auto &[val, i]: t ){
        dp[i] = 0;
        for ( int j = max(0, i - d); j < min(n, i + d + 1); j++ ){
            if ( a[j] > a[i] ){
                dp[i] |= !dp[j];
            }
        }
    }
}

void init(vector<int> A, int D){
    a = A, d = D;
    n = a.size();
    dp.resize(n);
    solve();
}

void updateValue(int index, int newValue){
    a[index] = newValue;
    solve();
}

bool isWinning(int startIndex){
    return dp[startIndex];
}

