#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

void solve(){
    int n, k, x; cin >> n >> k >> x;
    vector <int> a(n), t;
    for ( auto &u: a ) cin >> u;
    for ( int mask = 0; mask < 1 << n; mask++ ){
        if ( __builtin_popcount(mask) == k ){
            t.pb(mask);
        }
    }
    auto b = a;
    sort(all(b));
    do{
        bool bad = false;
        for ( auto &mask: t ){
            int l = 0, r = 0;
            for ( int i = 0; i < n; i++ ){
                if ( mask >> i & 1 ){
                    l = __gcd(l, a[i]);
                    r = __gcd(r, b[i]);
                }
            }
            bad |= (l != r);
        }
        if ( !bad ){
            for ( auto &u: b ){
                cout << u << " ";
            } cout << ln;
            return;
        }
    } while ( next_permutation(all(b)) );
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t; cin >> t;
    while ( t-- ){
        solve();
    }

    cout << '\n';
}
