#include <bits/stdc++.h>

using ll = long long;
using pii = std::pair<int, int>;

std::vector < std::vector < int > > g;
std::vector < int > pointer;

bool done;
int T = 0;

void Go(int v, int &to) {
    if (v == to) {
        done = true;
        return;
    }

    while (1) {
        T++;

        if (pointer[v] == g[v].size())
            pointer[v] = 0;

        Go(g[v][pointer[v]++], to);

        if (pointer[v] == g[v].size())
            pointer[v] = 0;

        if (done)
            return;
    }
}

int main(){
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    int n, m; std::cin >> n >> m;

    g.resize(n + 1);
    pointer.resize(n + 1);

    for (int i = 1, k; i <= n; i++) {
        std::cin >> k;

        for (int j; k--; ) {
            std::cin >> j;

            g[i].push_back(j);
        }
    }

    int vertex = 1;

    for (int i = 1, to; i <= m; i++) {
        std::cin >> to;

        if (i > 1 && vertex == to) {
            T++;

            vertex = g[vertex][pointer[vertex]];

            pointer[vertex]++;

            if (pointer[vertex] == g[vertex].size())
                pointer[vertex] = 0;
        }

        done = false;
        Go(vertex, to);
        vertex = to;
    }

    std::cout << T + 1 << "\n";
}
