#include <bits/stdc++.h>

using ll = long long;
using pii = std::pair<int, int>;

int main(){
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    int n, m; std::cin >> n >> m;

    std::vector < int > g[n + 1];
    int k[n + 1] { };

    for (int i = 1; i <= n; i++) {
        std::cin >> k[i];

        for (int cnt = 1, j; cnt <= k[i]; cnt++) {
            std::cin >> j;

            g[i].push_back(j);
        }
    }

    std::vector < int > dp1(n + 1, 1), dp2(n + 1, 1);

    std::function < void(int, int) > DFS = [&](int v, int p) {
        for (auto u : g[v])
            if (u != p)
                DFS(u, v);

        for (auto u : g[v]) {
            if (u == p)
                break;

            dp1[v] += 1 + dp1[u];
        }

        for (auto u : g[v])
            if (u != p)
                dp2[v] += 1 + dp2[u];
    };

    DFS(1, 1);

    int T = 0;
    int id = 0, cycle = 0;

    for (int i = 1, to; i <= m; i++) {
        std::cin >> to;

        if (i == 1)
            continue;

        if (cycle) {
            T += 1 + dp2[g[1][id]];
        } else {
            T += 1 + dp1[g[1][id]];
        }

        id++;

        if (id == k[1]) {
            cycle++;
            id = 0;
        }
    }

    std::cout << T + 1 << "\n";
}
