#include <bits/stdc++.h>

using ll = long long;
using pii = std::pair<int, int>;

int main(){
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    int n, m; std::cin >> n >> m;

    std::vector < int > g[n + 1];
    int k[n + 1] { };

    for (int i = 1; i <= n; i++) {
        std::cin >> k[i];

        for (int cnt = 1, j; cnt <= k[i]; cnt++) {
            std::cin >> j;

            g[i].push_back(j);
        }
    }

    std::vector < int > dp1(n + 1, 1);

    std::vector < int > depth(n + 1);
    std::vector < std::set < int > > s(n + 1);

    std::function < void(int, int) > DFS = [&](int v, int p) {
        depth[v] = depth[p] + 1;

        for (auto u : g[v])
            if (u != p)
                DFS(u, v);

        for (auto u : g[v]) {
            if (u == p)
                break;

            dp1[v] += 1 + dp1[u];
        }
    };

    DFS(1, 1);

    for (auto v : g[1]) {
        s[v].insert(v);
    }

    ll T = 0;
    int id = 0;

    std::vector < ll > sum(n + 1);

    for (int i = 1, to; i <= m; i++) {
        std::cin >> to;

        if (i == 1)
            continue;

        ll cur = sum[g[1][id]];

        for (auto v : s[g[1][id]]) {
            cur += 1 + dp1[v];
            sum[g[1][id]] += 1 + dp1[v];
        }

        T += cur;

        std::set < int > nextS;

        for (auto v : s[g[1][id]]) {
            bool add = false;

            for (auto u : g[v]) {
                if (add)
                    nextS.insert(u);

                if (u == v)
                    add = true;
            }
        }

        s[g[1][id]] = nextS;

        id++;

        if (id == k[1])
            id = 0;
    }

    std::cout << T + 1 << "\n";
}

/*
4 6
2 2 3
1 1
2 1 4
1 3
1 1 1 1 1 1
*/
