#include <bits/stdc++.h>

using ll = long long;
using pii = std::pair<int, int>;

int main(){
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    int tests;

    for (std::cin >> tests; tests--; ) {
        int n, k, x; std::cin >> n >> k >> x;

        std::vector < int > a(n + 1);

        for (int i = 1; i <= n; i++)
            std::cin >> a[i];

        std::map < int, std::vector < pii > > m;

        for (int i = 1; i <= n; i++) {
            int x = a[i];

            for (ll j = 2; j * j <= x; j++)
                if (x % j == 0) {
                    int prod = 1;

                    while (x % j == 0)
                        x /= j, prod *= j;

                    m[j].push_back({ prod, i });
                }

            if (x > 1)
                m[x].push_back({ x, i });
        }

        for (int i = 1; i <= n; i++)
            for (auto it = m.begin(); it != m.end(); it++)
                if (a[i] % it->first)
                    it->second.push_back({ 1, i });

        std::vector < bool > fixed(n + 1);

        for (auto it = m.begin(); it != m.end(); it++) {
            std::sort(it->second.begin(), it->second.end(), std::greater < pii >());

            for (int i = k; i < (int)it->second.size(); i++)
                fixed[it->second[i].second] = true;
        }

        std::multiset < int > free;

        for (int i = 1; i <= n; i++)
            if (!fixed[i])
                free.insert(a[i]);

        for (int i = 1; i <= n; i++)
            if (fixed[i]) {
                std::cout << a[i] << " ";
            } else {
                std::cout << *free.begin() << " ";

                free.erase(free.begin());
            }

        std::cout << "\n";
    }
}
