#include <bits/stdc++.h>

using ll = long long;
using pii = std::pair<int, int>;

int main(){
    std::ios::sync_with_stdio(0); std::cin.tie(0);

    int tests;

    for (std::cin >> tests; tests--; ) {
        int n, k, x; std::cin >> n >> k >> x;

        std::vector < int > a(n + 1);

        for (int i = 1; i <= n; i++)
            std::cin >> a[i];

        auto ans = a;
        auto b = a;

        std::sort(b.begin() + 1, b.end());

        do {
            bool ok = true;

            for (int mask = 1; mask < (1 << n); mask++) {
                int cnt = 0, g1 = 0, g2 = 0;

                for (int i = 0; i < n; i++)
                    if (mask >> i & 1) {
                        cnt++;

                        g1 = std::__gcd(g1, a[i + 1]);
                        g2 = std::__gcd(g2, b[i + 1]);
                    }

                if (cnt == k)
                    ok &= g1 == g2;
            }

            if (ok)
                ans = std::min(ans, b);
        } while (std::next_permutation(b.begin() + 1, b.end()));

        for (int i = 1; i <= n; i++)
            std::cout << ans[i] << " ";

        std::cout << "\n";

        /*std::vector < int > p;

        for (int i = 1; i <= n; i++) {
            int x = a[i];

            for (ll j = 2; j * j <= x; j++)
                if (x % j == 0) {
                    while (x % j == 0)
                        x /= j;

                    p.push_back(j);
                }
        }

        std::sort(p.begin(), p.end());
        p.erase(std::unique(p.begin(), p.end()), p.end());

        std::vector < bool > fixed(n + 1);

        for (auto cur : p) {
            std::vector < pii > v;

            for (int i = 1; i <= n; i++) {
                int cnt = 0, x = a[i];

                while (x % cur == 0)
                    cnt++, x /= cur;

                v.push_back({ cnt, i });
            }

            std::sort(v.begin(), v.end(), std::greater < pii >());

            for (int i = k; i < n; i++)
                fixed[v[i].second] = true;
        }

        std::multiset < int > free;

        for (int i = 1; i <= n; i++)
            if (!fixed[i])
                free.insert(a[i]);

        for (int i = 1; i <= n; i++)
            if (fixed[i]) {
                std::cout << a[i] << " ";
            } else {
                std::cout << *free.begin() << " ";

                free.erase(free.begin());
            }

        std::cout << "\n";*/
    }
}
