#include <bits/stdc++.h>
#include "game.h"
#include "Lgrader.cpp"

using namespace std;

vector<int> dp;

void init(std::vector<int> A, int D) {
    int n = A.size();
    vector<int> v = A;
    int d = D;
    dp.resize(n);
    int j_m = 0;
    for (int i = 0; i < n; i++) {
        if (v[i] > v[j_m]) {
            j_m = i;
        }
    }
    dp[j_m] = 0;
    queue<int> q;
    vector<bool> used(n + 1);
    q.push(j_m);
    used[j_m] = 1;
    while (!q.empty()) {
        int j = q.front(); q.pop();
        for (int i = 1; i <= d; i++) {
            if (j + i < n) {
                dp[j + i] = 1;
            }
            if (j - i >= 0) {
                dp[j - i] = 1;
            }
        }
        int r = j + d + 1;
        int l = j - d - 1;
        if (r < n and !used[r]) {
            q.push(r);
            used[r] = 1;
        }
        if (l >= 0 and !used[l]) {
            q.push(l);
            used[l] = 1;
        }
    }
}

void updateValue(int index, int newValue) {
    // A[index] = newValue
}

bool isWinning(int startIndex) {
    return dp[startIndex];
}
