#include "game.h"
#include <queue>
#include <iostream>
#include <vector>
#include <stdlib.h>
using namespace std;
vector<int>Aa;
vector <bool> result;
queue <int> indexi;
queue <int> big;
bool wasfilled=false;
int lastSaved;
int d;
bool checked=false;
int comp(const void * a, const void * b){
    return (*(int*)a- *(int*)b);
}
void init(vector<int> A, int D){
    Aa=A;
    d=D;
    result.resize(A.size());
}
void updateValue(int index, int newValue){
    if (!wasfilled){
        Aa[index]=newValue;
    }
    else{
        if (result[index]==true){
            if(newValue>Aa[index]){
                Aa[index]=newValue;
                checked=false;
            }
        }
        else{
            if(newValue<Aa[index]){
                Aa[index]=newValue;
                checked=false;
            }
        }
    }
}
int ffind(int l, int r){
    if(l==r){
        result[l]=false;
        return 0;
    }
    lastSaved=l;
    indexi.push(l);
    int mini[d+1];
    while(!indexi.empty()){
        int c=0;
        int l=indexi.front();
        indexi.pop();
        for (int i=l; i<min(l+d+1, r+1); i++){
            mini[c]=(Aa[i]);
            c++;
        }
        qsort(mini, size_t(min((d+1), r-l+1)), sizeof(int), comp);
        if (mini[min((r-l), d)]==Aa[l]){
            for (int q=max(0, l-d); q<min(l+d+1, r+1); q++){
                result[q]=true;
            }
            if((l+d+1)<=r){
                indexi.push(l+d+1);
            }
            if(((l-d-1)-lastSaved)>=0){
                big.push(lastSaved);
                big.push(l-d-1);
            }
            lastSaved=l+d+1;
            result[l]=false;
        }
        else{
            for(int i=l; i<min(l+d+1, r+1); i++){
                if (Aa[i]==mini[min((r-l), d)]){
                    indexi.push(i);
                }
            }
        }
    }
    return 1;
}
int verify(){
    if (Aa.size()==1){
        result[0]=true;
        return 0;
    }
    else{
            big.push(0);
            big.push(Aa.size()-1);
            while(!big.empty()){
                int eq=big.front();
                big.pop();
                int ew=big.front();
                big.pop();
                ffind(eq, ew);
            }
    }
    wasfilled=true;
    return 0;
}
bool isWinning(int startIndex){
    if(!checked){
        verify();
        checked=true;
    }
    return result[startIndex];
}
