#include "game.h"
#include <bits/stdc++.h>
using namespace std ;

const int N = 2e5+5 ;

int n , d ;
int a[N] ;
bool ans[N] , vis[N] ;

void init ( vector <int> v , int D){
	n = v.size() ; d = D ;
	for ( int i = 0 ; i < n ; i ++ ) a[i] = v[i] ;
}

void updateValue ( int ind , int x ){
	a[ind] = x ;
}

bool dfs ( int ind ){
	if ( vis[ind] ) return ans[ind] ;
	vis[ind] = 1 ;
	bool f = 1 ;
	for ( int i = ind+1 ; i < min ( n , ind+d+1 ) ; i ++ ){
		if ( a[i] < a[ind] ) continue ;
		if ( dfs(i) ) f = 0 ;
	}
	for ( int i = ind-1 ; i >= max ( 0 , ind-d ) ; i -- ){
		if ( a[i] < a[ind] ) continue ;
		if ( dfs(i) ) f = 0 ;
	} ans[ind] = f ;
	return f ;
}

bool isWinning( int ind ){
	return !dfs(ind) ;
}
/*
int main(){
	ios_base::sync_with_stdio(0) ; cin.tie(0) ;
    int n, D, q;
    vector<int> nums;
    scanf("%d %d", &n, &D);
    for (int i = 1; i <= n; i++){
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }
    init(nums, D);
    scanf("%d", &q);
    for (int i = 1; i <= q; i++){
        int cm;
        scanf("%d", &cm);
        if (cm == 1){
            int ind, val;
            scanf("%d %d", &ind, &val);
            updateValue(ind, val);
        }
        else{
            int ind;
            scanf("%d", &ind);
            cerr << "ans " << endl ;
            printf("%d\n", (int)isWinning(ind));
        }
    }
}
//*/
