#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "game.h"
using namespace std;
#define all(x) x.begin(), x.end()
#define size(x) (int)x.size()

template<class S, class T>
bool chmin(S& a, const T& b) {
  return a > b ? (a = b) == b : false;
}
template<class S, class T>
bool chmax(S& a, const T& b) {
  return a < b ? (a = b) == b : false;
}

const int inf = 1e9;
vector<int> a, res;
int d, n;

void init(vector<int> A, int D) {
  a = A, d = D, n = size(a);
  res.resize(n);
}

void updateValue(int id, int delta) {
  a[id] = delta;
}

int check(int i) {
  if (res[i] != -1) return res[i];
  res[i] = 0;
  for (int j = max(i - d, 0); j <= min(n - 1, i + d); ++j) {
    if (j == i || a[j] < a[i]) continue;
    res[i] |= !check(j);
  }
  return res[i];
}

bool isWinning(int id) {
  fill(all(res), -1);
  return check(id);
}