#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
 
#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define rnd(l, r) uniform_int_distribution<int>(l, r)(rng)
 
using namespace std;

void fp(string name){freopen((name+".in").c_str(),"r",stdin); freopen((name+".out").c_str(),"w",stdout);} 
int pow(int a,int b,int m){int ans=1;while(b){if(b&1){ans=(ans*a)%m;}b>>=1;a=(a*a)%m;}return ans;}
int binpow(int a,int b){int ans=1;while(b){if(b&1){ans=(ans*a);}b>>=1;a=(a*a);}return ans;}
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
 
const int N = 5e5 + 10, inf = 1e9;

deque <int> g[N];
int par[N];
vector <int> in[N];

int tin[N], tout[N];
int sz[N];

int timer;

void dfs(int v, int p){
    tin[v] = ++timer;
    par[v] = p;
    sz[v] = 1;
    for(auto to : g[v]){
        if(to == p){
            continue;
        }
        dfs(to, v);
        sz[v] += sz[to];
    }
    tout[v] = ++timer;
}
bool comp(int a, int b){
    return tin[a] < tin[b];
}

main(){
    iostream::sync_with_stdio(false);	
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        int sz;
        cin >> sz;
        for(int j = 1; j <= sz; j++){
            int x;
            cin >> x;
            g[i].pb(x);
        }
    }
    vector <int> fr(m);
    for(int i = 0; i < m; i++){
        cin >> fr[i];
    }
    dfs(1, 1);
    for(int i = 1; i <= n; i++){
        for(int j = 0; j < (int)g[i].size(); j++){
            if(g[i][j] == par[i]){
                in[j + 1].pb(i);
            }
        }
    }
    for(int i = 1; i <= n; i++){
        sort(all(in[i]), comp);
    }
    int visited = 0, ans = 0;
    for(int i = 1; i <= n; i++){
        int l = 0;
        visited++;
        ans++;
        if(visited == m){
			break;
		}
        for(auto to : g[1]){
			visited++;
			ans += sz[to];
			 int ltin = inf, ltout = inf;
			while(l < (int)in[i].size()){
				if(!(tin[to] <= tin[in[i][l]] && tout[to] >= tout[in[i][l]]))break; 
				if(ltin <= tin[in[i][l]] && ltout >= tout[in[i][l]]){
					l++;
					continue;
				}
				ans -= sz[in[i][l]] - 1;
				ltin = tin[in[i][l]];
				ltout = tout[in[i][l]];
				l++;
			}
			if(visited == m){
				break;
			}
		}
		//cout << i << endl;
        //cout << endl;
    }
    cout << ans << endl;
}	
/*
 * Before implementing the problem:
    
    Do I understand the problem correctly?
    Which places are tricky? What do I need to remember to implement them correctly?
    Which place is the heaviest by implementation? Can I do it simpler?
    Which place is the slowest? Where do I need to be careful about constant factors and where I can choose slower but simpler implementation?
    ----------------------------------
    If not AC:
 
    Did you remember to do everything to handle the tricky places you thought about before?
    Is the solution correct?
    Do I understand the problem correctly?
    ----------------------------------
    If you have a test on which the solution gives wrong answer:
 
    Is the solution doing what it was supposed to do?
    Is the problem in the code or in the idea?
*/
