#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>

using namespace std;

#define int long long

int gcd(int a, int b)
{
    if(a < b)
    {
        swap(a, b);
    }
    if(b == 0)
    {
        return a;
    }
    if(a == b)
    {
        return a;
    }
    return gcd(a%b, b);
}

int lcm(int a, int b)
{
    return a*b/gcd(a, b);
}

vector<int> primes;
int lp[100005];

int n, k;
const int N = 10;
int a[N+5];

bool can_swap(int x, int y)
{
    int l = 1;
    int l2 = 1;
    for(int b = 0; b < 1<<n; b++)
    {
        if(__builtin_popcount(b) != k-1 || (b&(1<<x)) != 0 || (b&(1<<y)) != 0)
        {
            continue;
        }
        int g = 0;
        for(int j = 0; j < n; j++)
        {
            if((b&(1<<j)) != 0)
            {
                g = gcd(a[j], g);
            }
        }
        l = lcm(g, l);
        l2 = lcm(gcd(g, a[x]), l2);
    }
    if(gcd(a[x], l) == gcd(a[y], l) && a[y]%l2 == 0)
    {
        return true;
    }
    else
    {
        return false;
    }
}

map<pair<int, int>, bool> can;

void solve()
{
    can.clear();
    int x;
    cin >> n >> k >> x;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    for(int i = 0; i < n; i++)
    {
        for(int j = i+1; j < n; j++)
        {
            if(can_swap(i, j) && can_swap(j, i))
            {
                can[{a[i], a[j]}] = true;
                can[{a[j], a[i]}] = true;
            }
        }
    }
    for(int i = 0; i < n; i++)
    {
        int mn = a[i];
        int idx = -1;
        for(int j = i+1; j < n; j++)
        {
            if(can[{a[i], a[j]}] && a[j] < mn)
            {
                mn = a[j];
                idx = j;
            }
        }
        if(idx != -1)
        {
            swap(a[i], a[idx]);
        }
    }
    for(int i = 0; i < n; i++)
    {
        cout << a[i] << " ";
    }
    cout << endl;
}

int32_t main()
{
//    for(int i = 2; i <= 100000; i++)
//    {
//        if(lp[i] == 0)
//        {
//            primes.push_back(i);
//            for(int j = 2*i; j <= 100000; j+=i)
//            {
//                lp[j] = 1;
//            }
//        }
//    }
    int t = 1;
    cin >> t;
    while(t--)
    {
        solve();
    }
}

/*
2
3 2 1
2 6 4
4 2 3
7 9 6 3
 */
