//               _
//   ^ ^        //
// >(O_O)<_____//
//   \ __ __   /
//    \\ \\ \\\\

#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

#define int long long
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define pi pair<int,int>
#define f first
#define s second
#define all(x) x.begin(),x.end()


const int N=5e5+5;
vector<int> adj[N];
int ptr[N];

int vis[N];
int a[N];
int z=0;

int par[N];
int ind[N]; int nxt=0;
int rind[N];
int sz[N];
int r[N];
void dfs(int u, int p) {
	par[u]=p;
	ind[u]=nxt++;
	rind[ind[u]]=u;
	r[u]=ind[u];
	int ok=0;
	sz[u]=1;
	for(auto&v:adj[u]) {
		ok|=v==p;
		if (v==p) continue;
		if (ok) dfs(v,u);
		sz[u]+=sz[v];
		r[u]=max(r[u],r[v]);
	}
	for(auto&v:adj[u]) {
		if (v==p) break;
		dfs(v,u);
		sz[u]+=sz[v];
		r[u]=max(r[u],r[v]);
	}
}

int n,m; 
int tot=0;
int ans=1;
vector<int> s;

struct BIT {
	vector<int> t; int n;
	BIT(int n) {
		this->n=n; t.assign(n,0);
	}
	void add(int i, int x) {for(;i<n;i=i|(i+1))t[i]+=x;}
	int sum(int r) {int q=0;for(;r>=0;r=(r&(r+1))-1)q+=t[r];return q;}
	int sum(int l, int r) {return sum(r)-sum(l-1);}
};

BIT ft(N);

void go(int u) {
	vis[u]=1;
	++tot;
	ft.add(ind[u],1);
	for(auto&v:adj[u]) {
		if (v==par[u]) {
			s.pb(u);
			return;
		}
		go(v);
	}
}

void solve() {

	cin>>n>>m;
	forn(i,n) {
		int k; cin>>k;
		forn(j,k) {
			int v; cin>>v; --v; adj[i].pb(v);
		}
	}
	dfs(0,-1);
	forn(i,m) {
		cin>>a[i]; --a[i];
	}
	z=1; vis[0]=1;
	for(auto&v:adj[0]) {
		go(v);
		ans+=2*ft.sum(ind[v],r[v]);
		++z;
		if (z==m) {
			cout<<ans<<'\n'; return;
		}
	}
	//cout<<ans<<' '<<z<<' '<<tot<<'\n';
	//for(auto&x:s) cout<<x<<' '; cout<<'\n';
	while (tot<n-1 && z<m) {
		vector<pi> v; for(auto&x:s) v.pb({ind[x],x});
		sort(all(v));
		s.clear();
		int c=0;
		int Q=adj[0][c];
		for(auto&it:v) {
			int u=it.s;
			if (ind[u]>r[Q]) {
				ans+=2*ft.sum(ind[Q],r[Q]);
				++z;
				if (z==m) {
					cout<<ans<<'\n'; return;
				}
				++c;
				Q=adj[0][c];
			}
			for(auto&v:adj[u]) {
				if (!vis[v]) go(v);
			}
		}
		while(c<adj[0].size()) {
			//cout<<"??? "<<Q<<' '<<ind[Q]<<' '<<r[Q]<<"  "<<ft.sum(ind[Q],r[Q])<<'\n';
			ans+=2*ft.sum(ind[Q],r[Q]);
			++c; Q=adj[0][c];
			++z;
			if (z==m) {
				cout<<ans<<'\n'; return;
			}
		}
	}
	//cout<<"? "<<ans<<' '<<z<<' '<<tot<<'\n';
	forn(i,m) {
		ans+=2*sz[adj[0][i%(adj[0].size())]];
		++z;
		if (z==m) break;
	}
	cout<<ans<<'\n';

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	solve();
}