//               _
//   ^ ^        //
// >(O_O)<_____//
//   \ __ __   /
//    \\ \\ \\\\

#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

#define int long long
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define pi pair<int,int>
#define f first
#define s second
#define all(x) x.begin(),x.end()


const int N=5e5+5;
vector<int> adj[N];
int ptr[N];

int vis[N];
int a[N];
int z=0;

int par[N];
int tin[N],tout[N],t=0;
void dfs(int u, int p) {
	par[u]=p;
	tin[u]=t++;
	int ok=0;
	for(auto&v:adj[u]) {
		ok|=v==p;
		if (v==p) continue;
		if (ok) dfs(v,u);
	}
	for(auto&v:adj[u]) {
		if (v==p) break;
		dfs(v,u);
	}
	tout[u]=t++;
}
int isanc(int u, int v) {
	//esli u predok v
	return tin[u]<=tin[v] && tout[v]<=tout[u];
}

int n,m; 
int tot=0;
int ans=1;
vector<int> s;

struct BIT {
	vector<int> t; int n;
	BIT(int n) {
		this->n=n; t.assign(n,0);
	}
	void add(int i, int x) {for(;i<n;i=i|(i+1))t[i]+=x;}
	int sum(int r) {int q=0;for(;r>=0;r=(r&(r+1))-1)q+=t[r];return q;}
	int sum(int l, int r) {if (l>r) return 0; return sum(r)-sum(l-1);}
};

BIT ft(2*N);
int now=0;

int in=1;
void go(int u) {
	vis[u]=1;
	++tot;
	++ans;
	now=u;
	ft.add(tin[u],1);
	ft.add(tout[u],1);
	if (a[z]==u) {
		++z;
		if (z==m) {
			cout<<ans<<'\n'; exit(0);
		}
	}
	for(auto&v:adj[u]) {
		if (v==par[u]) {
			in=0;
			s.pb(u);
			return;
		}
		go(v);
		++ans;
		now=u;
		if (a[z]==u) {
			++z;
			if (z==m) {
				cout<<ans<<'\n'; exit(0);
			}
		}
	}
}

void solve() {

	cin>>n>>m;
	forn(i,n) {
		int k; cin>>k;
		forn(j,k) {
			int v; cin>>v; --v; adj[i].pb(v);
		}
	}
	dfs(0,-1);
	forn(i,m) {
		cin>>a[i]; --a[i];
	}
	
	vis[0]=1; ft.add(tin[0],1); //ft.add(tout[0],1);
	if (a[z]==0) {
		++z;
		if (z==m) {cout<<ans<<'\n'; return;}
	}
	for(auto&v:adj[0]) {
		go(v);
		ans++;
		now=0;
		if (a[z]==0) {
			++z;
			if (z==m) {cout<<ans<<'\n'; return;}
		}
	}

	while (tot<n-1 && z<m) {
		vector<pi> v; for(auto&x:s) v.pb({tin[x],x});
		sort(all(v));
		s.clear();

		for(auto&it:v) {
			int u=it.s;

			while (vis[a[z]]) {
				if (in) {
					if (tin[now] < tin[a[z]] && tin[a[z]]<=tin[u]) {
						ans += ft.sum(tin[now]+1,tin[a[z]]);
						now=a[z];
						++z;
						if (z==m) {cout<<ans<<'\n'; return;}
					} else if (tin[now] < tout[a[z]] && tout[a[z]]<tin[u]) {
						ans += ft.sum(tin[now]+1,tout[a[z]]-1);
						now=a[z];
						in=0;
						++z;
						if (z==m) {cout<<ans<<'\n'; return;}
					} else break;
				} else {
					if (tout[now] < tin[a[z]] && tin[a[z]]<=tin[u]) {
						ans += ft.sum(tout[now],tin[a[z]]);
						now=a[z];
						in=1;
						++z;
						if (z==m) {cout<<ans<<'\n'; return;}
					} else if (tout[now] <= tout[a[z]] && tout[a[z]] < tin[u]) {
						ans += ft.sum(tout[now],tin[a[z]]);
						now=a[z];
						++z;
						if (z==m) {cout<<ans<<'\n'; return;}
					} else break;
				}
			}

			if (in) {
				ans+=ft.sum(tin[now]+1, tin[u]);
				now=u;
			} else {
				ans+=ft.sum(tout[now],tin[u]);
				now=u;
			}
			in=1;

			for(auto&v:adj[u]) {
				if (!vis[v]) go(v);
			}
		}
	}
	while (vis[a[z]]) {
		int u=0;
		if (in) {
			if (tin[now] < tin[a[z]] && tin[a[z]]<=tin[u]) {
				ans += ft.sum(tin[now]+1,tin[a[z]]);
				now=a[z];
				++z;
				if (z==m) {cout<<ans<<'\n'; return;}
			} else if (tin[now] < tout[a[z]] && tout[a[z]]<tin[u]) {
				ans += ft.sum(tin[now]+1,tout[a[z]]-1);
				now=a[z];
				in=0;
				++z;
				if (z==m) {cout<<ans<<'\n'; return;}
			} else break;
		} else {
			if (tout[now] < tin[a[z]] && tin[a[z]]<=tin[u]) {
				ans += ft.sum(tout[now],tin[a[z]]);
				now=a[z];
				in=1;
				++z;
				if (z==m) {cout<<ans<<'\n'; return;}
			} else if (tout[now] <= tout[a[z]] && tout[a[z]] < tin[u]) {
				ans += ft.sum(tout[now],tin[a[z]]);
				now=a[z];
				++z;
				if (z==m) {cout<<ans<<'\n'; return;}
			} else break;
		}
	}
	int u=0;
	if (in) {
		ans+=ft.sum(tin[now]+1, tin[u]);
		now=u;
	} else {
		ans+=ft.sum(tout[now],tin[u]);
		now=u;
	}
	int last=0;
	for(int j=z; j<m; ++j) {
		if (tin[a[j]] > last) {
			ans+=tin[a[j]]-last;
			last=tin[a[j]];
		} else {
			ans+=2*(n-1) + tin[a[j]]-last;
		}
	}
	cout<<ans+1<<'\n';

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	solve();
}