//               _
//   ^ ^        //
// >(O_O)<_____//
//   \ __ __   /
//    \\ \\ \\\\

#include "game.h"
#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define pi pair<int,int>
#define f first
#define s second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

const ll inf=1e18;

const int N=2e5+5;
int a[N];
int n,d;
int win[N][2];
int loose[N][2];
int vis[N][2];
ll score[N][2];

void dfs(int i, int p) {
	if (vis[i][p]) return;
	vis[i][p]=1;
	score[i][p]=-inf;
	int ok=1;
	int ok2=1;
	for(int j=i-d; j<=i+d; ++j) {
		if (j<0 || j>=n || j==i) continue;
		ok&=a[j]<a[i];
		ok2&=a[j]<=a[i];
	}
	if (ok) {
		loose[i][p]=1;
		return;
	}
	if (p==1) {
		if (ok2) {
			loose[i][p]=1; return;
		}
	}

	int bad=1;
	for(int j=i-d; j<=i+d; ++j) {
		if (j<0 || j>=n || j==i) continue;
		if (a[j] < a[i]) continue;
		
		/*
		if (a[j]==a[i] && p==1) {
			score[i][p]=max(score[i][p],0ll);
			dfs(j,p^1);
			if (loose[j][p^1]) {
				win[i][p]=1; return;
			}
			if (win[j][p^1]) continue;
			score[i][p]=max(score[i][p],a[j]-score[j][p^1]);
		}
		*/
		if (a[j]==a[i]) {
			score[i][p]=max(score[i][p],0ll);
			dfs(j,p^1);
			if (loose[j][p^1]) {
				win[i][p]=1; return;
			}
			if (win[j][p^1]) continue;
			bad=0;
			score[i][p]=max(score[i][p],a[j]-score[j][p^1]);
		}
		
		if (a[j] > a[i]) {
			dfs(j,p^1);
			if (loose[j][p^1]) {
				win[i][p]=1; return;
			}
			if (win[j][p^1]) continue;
			bad=0;
			score[i][p]=max(score[i][p],a[j]-score[j][p^1]);
		}
	}
}

void init(vector<int> _a, int _d) {
	n=_a.size(); d=_d;
	forn(i,n) a[i]=_a[i];
	//vector<pi> v; forn(i,n) v.pb({a[i],i});
	//sort(rall(v));
	forn(i,n) dfs(i,0);
	forn(i,n) dfs(i,1);
	//forn(i,n) cout<<win[i][0]; cout<<'\n';
	//forn(i,n) cout<<win[i][1]; cout<<'\n';
	//forn(i,n) cout<<loose[i][0]; cout<<'\n';
	//forn(i,n) cout<<loose[i][1]; cout<<'\n';
	//forn(i,n) cout<<score[i][0]<<' '; cout<<'\n';
	//forn(i,n) cout<<score[i][1]<<' '; cout<<'\n';
}
void updateValue(int index, int newValue) {

}
bool isWinning(int i) {
	if (win[i][0]) return 1;
	if (loose[i][0]) return 0;
	return score[i][0]>=0;
}