//               _
//   ^ ^        //
// >(O_O)<_____//
//   \ __ __   /
//    \\ \\ \\\\

//#include "game.h"
#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

//#define int long long
using ll = long long;
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define pi pair<int,int>
#define f first
#define s second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

const ll inf=1e18;

const int N=2e5+5;
int a[N];
int n,d;
int win[N][2];
int loose[N][2];
int vis[N][2];
ll score[N][2];

void dfs(int i, int p) {
	if (vis[i][p]) return;
	vis[i][p]=1;
	score[i][p]=-inf;
	int ok=1;
	int ok2=1;
	for(int j=i-d; j<=i+d; ++j) {
		if (j<0 || j>=n || j==i) continue;
		ok&=a[j]<a[i];
		ok2&=a[j]<=a[i];
	}
	if (ok) {
		loose[i][p]=1;
		return;
	}
	if (p==1) {
		if (ok2) {
			loose[i][p]=1; return;
		}
	}

	int bad=1;
	for(int j=i-d; j<=i+d; ++j) {
		if (j<0 || j>=n || j==i) continue;
		if (a[j] < a[i]) continue;
		
		/*
		if (a[j]==a[i] && p==1) {
			score[i][p]=max(score[i][p],0ll);
			dfs(j,p^1);
			if (loose[j][p^1]) {
				win[i][p]=1; return;
			}
			if (win[j][p^1]) continue;
			score[i][p]=max(score[i][p],a[j]-score[j][p^1]);
		}
		*/
		if (a[j]==a[i]) {
			score[i][p]=max(score[i][p],0ll);
			dfs(j,p^1);
			if (loose[j][p^1]) {
				win[i][p]=1; return;
			}
			if (win[j][p^1]) continue;
			bad=0;
			score[i][p]=max(score[i][p],a[j]-score[j][p^1]);
		}
		
		if (a[j] > a[i]) {
			dfs(j,p^1);
			if (loose[j][p^1]) {
				win[i][p]=1; return;
			}
			if (win[j][p^1]) continue;
			bad=0;
			score[i][p]=max(score[i][p],a[j]-score[j][p^1]);
		}
	}
}

void init(vector<int> _a, int _d) {
	n=_a.size(); d=_d;
	forn(i,n) a[i]=_a[i];
	forn(i,n) dfs(i,0);
	forn(i,n) dfs(i,1);
}
void updateValue(int index, int newValue) {
	a[index]=newValue;
	forn(i,n) forn(j,2) win[i][j]=loose[i][j]=vis[i][j]=0;
	forn(i,n) dfs(i,0);
	forn(i,n) dfs(i,1);
}
bool isWinning(int i) {
	if (win[i][0]) return 1;
	if (loose[i][0]) return 0;
	return score[i][0]>=0;
}


void solve() {

	int n,d; cin>>n>>d;
	vii(a,n);
	init(a,d);
	int q; cin>>q;
	forn(it,q) {
		int t; cin>>t;
		if (t&1) {
			int i,x; cin>>i>>x; updateValue(i,x);
		} else {
			int i; cin>>i; cout<<isWinning(i)<<'\n';
		}
	}

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1; //cin>>t;
	while (t--) solve();
}