//               _
//   ^ ^        //
// >(O_O)<_____//
//   \ __ __   /
//    \\ \\ \\\\

#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("popcnt")

#define int long long
#define forn(i,n) for(int i=0;i<n;++i)
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];
#define pb push_back
#define pi pair<int,int>
#define f first
#define s second
#define all(x) x.begin(),x.end()

int lcm(int a, int b) {
	int g=__gcd(a,b);
	return a/g*b;
}
vector<int> primes;
const int A=32000;
int isp[A];

vector<int> z(vector<int> a, int k) {
	int n=a.size();
	map<int,vector<int>> pos;
	forn(i,n) {
		int x=a[i];
		for(auto&z:primes) {
			if (z*z>x) break;
			if (x%z) continue;
			int q=0;
			while (x%z==0) {
				++q; x/=z;
			}
			int p=1;
			forn(j,q) {
				p*=z;
				pos[p].pb(i);
			}
		}
		if (x>1) pos[x].pb(i);
	}
	vector<int> b(n,1);
	for(auto&it:pos) {
		if (it.s.size()>=k) {
			for(auto&x:it.s) b[x]=lcm(b[x],it.f);
		}
	}
	if (n>1000) exit(0);
	//forn(i,n) cout<<a[i]<<' '; cout<<'\n';
	//forn(i,n) cout<<b[i]<<' '; cout<<'\n';

	vector<pi> v;
	forn(i,n) v.pb({a[i],i});
	sort(all(v));
	vector<int> p(n);
	forn(i,n) p[v[i].s]=i;
	forn(i,n) {
		int l=0,r=n-1;
		while (l<r) {
			int m=(l+r)>>1;
			if (v[m].f<b[i]) l=m+1;
			else r=m;
		}
		//cout<<"? "<<i<<' '<<a[i]<<' '<<b[i]<<' '<<r<<"  "<<v[r].f<<'\n';
		for(int j=r; j<n; ++j) {
			if (v[j].f >= a[i]) break;
			if (v[j].s<i) continue;
			if (v[j].f%b[i]==0 && a[i]%b[v[j].s]==0) {
				//cout<<"! "<<i<<' '<<a[i]<<' '<<b[i]<<"  "<<v[j].s<<' '<<v[j].f<<' '<<b[v[j].s]<<'\n';
				swap(a[i],a[v[j].s]); 
				swap(v[p[i]].s,v[j].s);
				swap(p[i],p[v[p[i]].s]);
				//forn(i,n) cout<<v[i].f<<','<<v[i].s<<"  "; cout<<'\n';
				//forn(i,n) cout<<p[i]<<' '; cout<<'\n';
				break;
			}
		}
	}
	return a;
}

void solve() {

	int n,k,x; cin>>n>>k>>x;
	vii(a,n);

	auto ans=z(a,k);
	if (x>1) forn(i,n) {
		a[i]*=x;
		auto t=z(a,k);
		a[i]/=x;
		int ok=1;
		forn(j,n) {
			ok&=t[j]<=ans[j];
			if (t[j]!=ans[j]) break;
		}
		if (ok) forn(j,n) ans[j]=t[j];
	}
	
	forn(i,n) cout<<ans[i]<<' '; cout<<'\n';

}

int32_t main() {
	forn(i,A) isp[i]=1;
	for(int i=2; i<A; ++i) {
		if (!isp[i]) continue;
		primes.pb(i);
		for(int j=i*i; j<A; j+=i) isp[j]=0;
	}
	//cout<<"! "<<primes.size()<<'\n';

	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1; cin>>t;
	while (t--) solve();
}