#include "game.h"
#include "Lgrader.cpp"
#include<bits/stdc++.h>
#define print(n) cout<<n<<endl;
#define pb(n) push_back(n);
#define len(s) s.size()
#define vec(tp) vector<tp>
#define for_(i,m,n) for(int i=m;i<n;i++)
#define for__(i,m,n) for(int i=m;i>n;i--)
#define input(tp,n) tp n;cin>>n;
#define dict(n,m) unordered_map<n,m>
using namespace std;

vec(int)A;
int D;

int min(int a, int b){
	if(a<b){
		return a;
	}
	return b;
}

int front(int chip) {
	int limit=min((chip+D+1),len(A));
	int mx=INT_MIN;
	int ind;
	for_(i,chip+1,limit){
		if(A[i]>=mx){
			mx=A[i];
			ind=i;
		}
	}
	return ind;
}

int back(int chip) {
	int mx,ind;
	if(chip<D){
		mx=INT_MIN;
		ind;
		for_(i,0,chip){
			if(A[i]>=mx){
				mx=A[i];
				ind=i;
			}
		}
	}
	else{
		mx=INT_MIN;
		ind;
		for__(i,chip-1,chip-D-1){
			if(A[i]>=mx){
				mx=A[i];
				ind=i;
			}
		}
	}
	return ind;
}

void updateValue(int index, int newValue){
	A[index]=newValue;
}

bool isWinning(int startIndex){
	int chip=startIndex;
	int x=0,m,k;
	vec(int)freq(len(A),0);
	while(true){
		//print(chip)
		freq[chip]++;
		if(freq[chip]==10){
			//cout<<"------> "<<m<<' '<<k<<endl;
			if(A[m]>=A[k]){
				return true;
			}
			else{
				return false;
			}
		}
		int a=back(chip);
		int b=front(chip);
		if(A[a]>=A[b]){
			chip=a;
		}
		else{
			chip=b;
		}
		if(x%2==0){
			m=chip;
		}
		else{
			//cout<<x<<' '<<chip<<endl;
			k=chip;
		}
		x++;
	}
}

void init(vec(int)ls, int a){
	D=a;
	A=ls;
}
