#include <iostream>
#include <numeric>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;
#define int long long
int const N=1e5+10,LG=20;
int sp[N][LG]={};
int get(int l,int r)
{
    int lg=log2(r-l+1);
    return gcd(sp[l][lg],sp[r-(1<<lg)+1][lg]);
}
int n,k,x;
inline vector<int> sol(vector<int>a,int n)
{
    vector<int>ans(n);
    for  (int i=0;i<n;i++)
        sp[i][0]=a[i];
    for (int i=1;i<LG;i++)
        for (int j=0;j+(1<<i)-1<n;j++)
            sp[j][i]=gcd(sp[j][i-1],sp[j+(1<<(i-1))][i-1]);
    int gc=get(0,k-1);
    for (int i=0;i<k;i++)
        ans[i]=gc;
    for (int i=1;i<=n-k;i++)
    {
        int z=get(i,i+k-1);
        ans[i+k-1]=z;
        for (int j=i;j<i+k-1;j++)
            ans[j]=lcm(ans[j],z);
    }
    map<int,vector<int>>d;
    for (int i=0;i<n;i++)
    	d[ans[i]].push_back(a[i]);
   	for (auto& i:d)
   		sort(rbegin(i.second),rend(i.second));
   	for (auto& i:ans)
   	{
   		int z=i;
   		i=d[z].back();
   		d[z].pop_back();
   	}
    return ans;
}
void solve()
{
    cin>>n>>k>>x;
    vector<int>a(n);
    for(auto& i:a)
        cin>>i;
    vector<int>ans=sol(a,n);
    if (x!=1)
    {
        for (int i=0;i<n;i++)
        {
            a[i]*=x;
            ans=min(ans,sol(a,n));
            a[i]/=x;
        }
    }
    for (auto i:ans)
        cout<<i<<' ';
    cout<<endl;
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);cout.tie(NULL);
    int t;
    cin>>t;
    while (t--)
        solve();
}