#include <bits/stdc++.h>

using namespace std;

const int nmax = 5e5;

int n,m;
int p[nmax + 5];

vector<int> G[nmax + 5], A[nmax + 5];

int poz = 0;
int rez = 0;

int cnt = 0;

bool sel[nmax + 5];
int nrsel = 0;

vector<int> l[nmax + 5];

void root_tree(int nod, int dad = 0)
{
    if(nod == 1)
    {
        for(auto it : G[nod])
        {
            A[nod].push_back(it);
        }
    }
    else
    {
        int poz = 0;
        for(int i=0; i<G[nod].size(); i++)
        {
            if(G[nod][i] == dad)
            {
                poz = i;
                break;
            }
        }
        for(int i=poz+1;i<G[nod].size();i++)
        {
            A[nod].push_back(G[nod][i]);
        }
        for(int i=0;i<poz;i++)
        {
            A[nod].push_back(G[nod][i]);
        }
    }
    for(auto it : A[nod])
    {
        root_tree(it, nod);
    }
}

void dfs_brut(int nod, int dad = 0)
{
    if(poz > m)
    {
        return;
    }
    ++cnt;
    if(nod == p[poz])
    {
        ++poz;
        rez = cnt;
    }
    if(sel[nod])
    {
        for(auto it : A[nod])
        {
            dfs_brut(it, nod);
            if(nod == 1 && it == A[nod].back())
            {
                break;
            }
            ++cnt;
            if(nod == p[poz])
            {
                ++poz;
                rez = cnt;
            }
        }
    }
    else
    {
        ++nrsel;
        sel[nod] = true;
        for(auto it : G[nod])
        {
            if(it == dad)
            {
                break;
            }
            dfs_brut(it,nod);
            ++cnt;
            if(nod == p[poz])
            {
                ++poz;
                rez = cnt;
            }
        }
    }
}

int nr_nod = 0;

void euler(int nod)
{
    ++nr_nod;
    l[nod].push_back(nr_nod);
    for(auto it : A[nod])
    {
        euler(it);
        if(nod == 1 && it == A[nod].back())
        {
            break;
        }
        ++nr_nod;
        l[nod].push_back(nr_nod);
    }
}

int get_poz(int poz, int val)
{
    if(l[val].back() <= poz)
    {
        return l[val].front();
    }
    int st = 0;
    int dr = l[val].size();
    int crez = 0;
    while(st <= dr)
    {
        int mij = (st + dr) >> 1;
        if(l[val][mij] > poz)
        {
            dr = mij - 1;
            crez = mij;
        }
        else
        {
            st = mij + 1;
        }
    }
    return l[val][crez];
}

void brut(int nod)
{
    sel[1] = true;
    nrsel = 1;
    while(nrsel != n)
    {
        dfs_brut(1);
        if(poz > m)
        {
            break;
        }
    }
    if(poz > m)
    {
        cout<<rez<<'\n';
        return;
    }
    euler(1);
    int len = 2 * (n - 1);
    int ind = 1;
    rez = cnt + 1;
    if(p[poz] == 1)
    {
        ++poz;
    }
    for(int i=poz+1;i<=m;i++)
    {
        int new_ind = get_poz(ind, p[i]);
        if(new_ind <= ind)
        {
            rez += len - ind;
            rez += new_ind;
        }
        else
        {
            rez += new_ind - ind;
        }
        ind = new_ind;
    }
    cout<<rez<<'\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // home
    cin>>n>>m;
    for(int i=1; i<=n; i++)
    {
        int nr;
        cin>>nr;
        for(int j=1; j<=nr; j++)
        {
            int x;
            cin>>x;
            G[i].push_back(x);
        }
    }
    for(int i=1;i<=m;i++)
    {
        cin>>p[i];
    }
    root_tree(1);
    poz = 1;
    brut(1);
    return 0;
}
