#include <bits/stdc++.h>
#include "game.h"

using namespace std;

const int nmax = 2e5;

int n,d;
vector<int> v;

bool state[nmax + 5];

void calc_states()
{
    vector<pair<int,int>> l;
    for(int i=0;i<n;i++)
    {
        l.push_back({v[i], i});
    }
    sort(l.begin(),l.end(),greater<pair<int,int>>());
    for(auto it : l)
    {
        int val = it.first;
        int poz = it.second;
        state[poz] = true;
        for(int i=max(0, poz - d);i<=poz+d && i<n;i++)
        {
            if(i == poz)
            {
                continue;
            }
            if(v[i] > val)
            {
                state[poz] &= (!state[i]);
            }
        }
    }
}

void updateValue(int poz, int val)
{
    v[poz] = val;
    calc_states();
}

bool isWinning(int poz)
{
    for(int i=max(0, poz - d);i<=poz+d && i<n;i++)
    {
        if(i == poz)
        {
            continue;
        }
        if(state[i])
        {
            return true;
        }
    }
    return false;
}

void init(vector<int> AA, int D)
{
    d = D;
    v = AA;
    n = v.size();
    calc_states();
}
