#include <bits/stdc++.h>
#define int long long

using namespace std;

const int nmax = 1e5;
const int lim = 32000;

int n,k;
int a[nmax + 5];

int v[nmax + 5];

int sp[nmax + 5];
vector<pair<int,int>> f[nmax + 5];

vector<int> l[lim + 5];

map<int,int> fr;

map<int,set<int>> s;

int rez[nmax + 5];

void get_fact(int x, int poz)
{
    int d = 2;
    while(x != 1 && d * d <= x && d <= lim)
    {
        int p = 0;
        while(x % d == 0)
        {
            x /= d;
            ++p;
        }
        if(p != 0)
        {
            f[poz].push_back({d, p});
            l[d].push_back(p);
        }
        ++d;
    }
    if(x == 1)
    {
        return;
    }
    if((double)(sqrt(x)) == (int)(sqrt(x)))
    {
        x = sqrt(x);
        if(x <= lim)
        {
            f[poz].push_back({x, 2});
            l[x].push_back(2);
        }
        else
        {
            sp[poz] = x;
            ++fr[x];
        }
        return;
    }
    if(x != 1)
    {
        if(x <= lim)
        {
            f[poz].push_back({x, 1});
            l[x].push_back(1);
        }
        else
        {
            sp[poz] = x;
            ++fr[x];
        }
    }
}

int get_mul(int poz)
{
    int x = v[poz];
    int val = 1;
    for(auto it : f[poz])
    {
        int d = it.first;
        int e = it.second;
        int exp = e;
        if(l[d].size() >= k)
        {
            exp = min(exp, l[d][k - 1]);
        }
        else
        {
            exp = 0;
        }
        for(int i=1;i<=exp;i++)
        {
            val *= d;
        }
    }
    return val;
}

bool can_swap(int pozx, int pozy)
{
    int x = v[pozx];
    int y = v[pozy];
    for(auto it : f[pozx])
    {
        int d = it.first;
        int e = it.second;
        int p = 0;
        while(y % d == 0)
        {
            y /= d;
            ++p;
        }
        if(e > p)
        {
            if(l[d].size() < k)
            {
                continue;
            }
            if(l[d][k - 1] > p)
            {
                return false;
            }
        }
    }
    if(sp[pozx])
    {
        int d = sp[pozx];
        if(sp[pozy] != d)
        {
            if(fr[d] >= k)
            {
                return false;
            }
        }
    }
    return true;
}

void debug(vector<int> a)
{
    for(auto it : a)
    {
        cerr<<it<<' ';
    }
    cerr<<'\n';
}

void my_swap(int i, int j)
{
    auto er1 = s[v[i]].lower_bound(i);
    s[v[i]].erase(er1);
    auto er2 = s[v[j]].lower_bound(j);
    s[v[j]].erase(er2);
    swap(v[i], v[j]);
    s[v[i]].insert(i);
    s[v[j]].insert(j);
}

void verif()
{
    for(int i=1; i<=n; i++)
    {
        get_fact(v[i], i);
        s[v[i]].insert(i);
    }
    for(int i=2; i<=lim; i++)
    {
        sort(l[i].begin(),l[i].end(),greater<int>());
    }
    for(int i=1; i<=n; i++)
    {
        int poz = 0;
        int div = get_mul(i);
        for(int val=div;val<v[i];val+=div)
        {
            auto it = s[val].upper_bound(i);
            if(it != s[val].end())
            {
                int aux = *it;
                if(!can_swap(aux, i))
                {
                    continue;
                }
                poz = *it;
                break;
            }
        }
        if(poz)
        {
            my_swap(i, poz);
        }
    }
    for(int i=2; i<=lim; i++)
    {
        l[i].clear();
    }
    for(int i=1; i<=n; i++)
    {
        s[v[i]].clear();
        f[i].clear();
        sp[i] = 0;
    }
    fr.clear();
    bool ok = false;
    if(rez[1] == 0)
    {
        ok = true;
    }
    else
    {
        for(int i=1;i<=n;i++)
        {
            if(v[i] < rez[i])
            {
                ok = true;
                break;
            }
            if(v[i] > rez[i])
            {
                break;
            }
        }
    }
    if(ok)
    {
        for(int i=1;i<=n;i++)
        {
            rez[i] = v[i];
        }
    }
}

void solve_test()
{
    int x;
    cin>>n>>k>>x;
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
    }
    rez[1] = 0;
    if(x == 1)
    {
        for(int i=1; i<=n; i++)
        {
            v[i] = a[i];
        }
        verif();
    }
    else
    {
        for(int i=1;i<=n;i++)
        {
            v[i] = a[i];
        }
        verif();
        for(int i=1;i<=n;i++)
        {
            for(int j=1;j<=n;j++)
            {
                v[j] = a[j];
                if(j == i)
                {
                    v[j] = 1LL * a[j] * x;
                }
            }
            verif();
        }
    }
    for(int i=1;i<=n;i++)
    {
        cout<<rez[i]<<' ';
    }
    cout<<'\n';
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
#ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
#endif // home
    int t;
    cin>>t;
    for(int test=1; test<=t; test++)
    {
        solve_test();
    }
    return 0;
}
