#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll INF=1e9;
ll n,m,par[1000005],curpoz[1000005],qnodes[1000005];
vector<ll> ord[1000005];
vector<ll> muchii[1000005];
vector<ll> edges[1000005];
bool done[1000005];
ll v[1000005],timp;
vector<ll> where[1000005];
int aib[1000005];
int lsb(int x)
{
    return x&(-x);
}
void update(int poz,int val)
{
    for(int i=poz;i<=timp;i+=lsb(i))
        aib[i]+=val;
}
int suma(int poz)
{
    int rez=0;
    for(int i=poz;i>=1;i-=lsb(i))
        rez+=aib[i];
    return rez;
}
struct date
{
    /// tip = 0 -> doar nod, tip = 1 -> interval
    ll tip,l,r;
};
vector<date> vals;
void initdfs(int nod)
{
    for(int i:muchii[nod])
        if(i!=par[nod])
        {
            par[i]=nod;
            initdfs(i);
        }
}
void buildpre(int nod)
{
    timp++;
    v[timp]=nod;
    for(int i:muchii[nod])
        if(i!=par[nod])
        {
            buildpre(i);
            timp++;
            v[timp]=nod;
        }
}
void solve(int nod)
{
    vals.push_back({0,nod,nod});
    for(int i:where[nod])
        update(i,1);
    for(int i:ord[nod])
    {
        if(i==par[nod])
            break;
        solve(i);
        vals.push_back({0,nod,nod});
    }
}
ll plsfind(ll l,ll r, ll nod)
{
    int st=0;
    int dr=where[nod].size();
    dr--;
    int poz=1e9;
    while(st<=dr)
    {
        int mij=(st+dr)/2;
        if(where[nod][mij]>=l)
        {
            poz=where[nod][mij];
            dr=mij-1;
        }
        else
            st=mij+1;
    }
    if(poz<=r)
        return poz;
    return INF;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        ll cnt;
        cin>>cnt;
        for(int j=1;j<=cnt;j++)
        {
            ll x;
            cin>>x;
            ord[i].push_back(x);
            muchii[i].push_back(x);
        }
    }
    for(int i=1;i<=m;i++)
    {
        ll x;
        cin>>x;
        qnodes[i]=x;
    }
    if(n==1)
    {
        cout<<m;
        return 0;
    }
    initdfs(1);
    edges[1]=ord[1];
    for(int i=2;i<=n;i++)
    {
        vector<ll> aux;
        ll p=0;
        ll lg=ord[i].size();
        for(int j=0;j<ord[i].size();j++)
            if(ord[i][j]==par[i])
            {
                p=j;
                break;
            }
        p=(p+1)%lg;
        while(aux.size()<ord[i].size())
        {
            aux.push_back(ord[i][p]);
            p=(p+1)%lg;
        }
        edges[i]=aux;
    }
    for(int i=1;i<=n;i++)
        muchii[i]=edges[i];
    buildpre(1);
    for(int i=1;i<=timp;i++)
        where[v[i]].push_back(i);
    for(int i:where[1])
        update(i,1);
    ll poz=1;
    while(true)
    {
        if(poz==2&&suma(timp)==timp)
            break;
        ll st=poz;
        ll dr=timp;
        ll p=timp+1;
        while(st<=dr)
        {
            ll mij=(st+dr)/2;
            if(suma(mij)-suma(poz-1)<(mij-poz+1))
            {
                p=mij;
                dr=mij-1;
            }
            else
                st=mij+1;
        }
        if(p>timp)
        {
            if(poz<=timp)
                vals.push_back({1,poz,timp});
            poz=2;
            continue;
        }
        if(p>poz)
            vals.push_back({1,poz,p-1});
        ll nod=v[p];
        solve(nod);
        poz=where[nod].back();
        poz++;
    }
    ll ans=0;
    poz=1;
    for(date z:vals)
    {
        if(poz>m)
        {
            cout<<ans;
            return 0;
        }
        if(z.tip==0)
        {
            ans++;
            if(z.l==qnodes[poz])
                poz++;
            continue;
        }
        int l=z.l,r=z.r;
        while(l<=r&&poz<=m)
        {
            int x=plsfind(l,r,qnodes[poz]);
            if(x>timp)
            {
                ans+=r-l+1;
                break;
            }
            ans+=x-l+1;
            poz++;
            l=x+1;
        }
    }
    while(poz<=m)
    {
        ll l=2;
        ll r=timp;
        while(poz<=m&&l<=r)
        {
            int x=plsfind(l,r,qnodes[poz]);
            if(x>timp)
            {
                ans+=r-l+1;
                break;
            }
            ans+=x-l+1;
            poz++;
            l=x+1;
        }
    }
    cout<<ans;
    return 0;
}
