#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;
bool c[100005];
ll t,n,v[100005],k,X,comp[100005],sol[100005],best[100005];
int nrcomp;
vector<pii> desc[100005];
vector<int> primes;
vector<int> have;
vector<vector<pii>> who;
vector<int> me[100005];
vector<pii> getdesc(int x)
{
    vector<pii> rez;
    int poz=0;
    while(x>1&&poz<primes.size())
    {
        int d=primes[poz];
        int p=0;
        while(x%d==0)
        {
            x/=d;
            p++;
        }
        if(p>0)
            rez.push_back({d,p});
        poz++;
        d=primes[poz];
        if(1LL*d*d>x)
        {
            if(x!=1)
                rez.push_back({x,1});
            break;
        }
    }
    return rez;
}
int getind(int x)
{
    int st=0;
    int dr=have.size();
    dr--;
    while(st<=dr)
    {
        int mij=(st+dr)/2;
        if(have[mij]==x)
            return mij;
        if(have[mij]>x)
            dr=mij-1;
        else
            st=mij+1;
    }
    return -1;
}
bool byfr(pii a, pii b)
{
    return a.second<b.second;
}
bool bycomp(int a,int b)
{
    return comp[a]<comp[b];
}
map<int,int> nrm;
void solve()
{
    have.clear();
    who.clear();
    nrcomp=1;
    for(int i=1;i<=n;i++)
    {
        comp[i]=1;
        for(int j=0;j<desc[i].size();j++)
            have.push_back(desc[i][j].first);
    }
    sort(have.begin(),have.end());
    have.erase(unique(have.begin(),have.end()),have.end());
    who.resize(have.size());
    for(int i=1;i<=n;i++)
    {
        for(pii p:desc[i])
        {
            int ind=getind(p.first);
            who[ind].push_back({i,p.second});
        }
    }
    for(int z=0;z<have.size();z++)
    {
        int total=who[z].size();
        if(total<k)
            continue;
        sort(who[z].begin(),who[z].end(),byfr);
        for(int i=0;i<who[z].size();i++)
        {
            vector<int> nodes;
            int j=i;
            while(j<who[z].size()&&who[z][i].second==who[z][j].second)
            {
                nodes.push_back(who[z][j].first);
                j++;
            }
            total-=(int)nodes.size();
            if(total<k)
            {
                while(j<who[z].size())
                {
                    nodes.push_back(who[z][j].first);
                    j++;
                }
            }
            i=j-1;
            sort(nodes.begin(),nodes.end(),bycomp);
            for(int p=0;p<nodes.size();p++)
            {
                int q=p;
                nrcomp++;
                int aux=comp[nodes[p]];
                while(q<nodes.size()&&aux==comp[nodes[q]])
                {
                    comp[nodes[q]]=nrcomp;
                    q++;
                }
                p=q-1;
            }
        }
    }
    nrm.clear();
    vector<int> vals;
    for(int i=1;i<=n;i++)
    {
        vals.push_back(comp[i]);
        me[i].clear();
    }
    sort(vals.begin(),vals.end());
    vals.erase(unique(vals.begin(),vals.end()),vals.end());
    for(int i=0;i<vals.size();i++)
        nrm[vals[i]]=i+1;
    for(int i=1;i<=n;i++)
    {
        comp[i]=nrm[comp[i]];
        me[comp[i]].push_back(i);
    }
    for(int z=1;z<=vals.size();z++)
    {
        vector<int> nrs;
        for(int i:me[z])
            nrs.push_back(v[i]);
        sort(nrs.begin(),nrs.end());
        for(int i=0;i<nrs.size();i++)
            sol[me[z][i]]=nrs[i];
    }
}
void update()
{
    bool better=0;
    for(int i=1;i<=n;i++)
    {
        if(best[i]==sol[i])
            continue;
        if(sol[i]<best[i])
        {
            better=1;
            break;
        }
        return;
    }
    if(!better)
        return;
    for(int i=1;i<=n;i++)
        best[i]=sol[i];
}
void plsadd(int ind)
{
    v[ind]*=X;
    for(int i=0;i<desc[ind].size();i++)
        if(desc[ind][i].first==X)
        {
            desc[ind][i].second++;
            return;
        }
    desc[ind].push_back({X,1});
}
void plsrem(int ind)
{
    v[ind]/=X;
    for(int i=0;i<desc[ind].size();i++)
        if(desc[ind][i].first==X)
        {
            desc[ind][i].second--;
            if(desc[ind][i].second==0)
                desc[ind].pop_back();
            return;
        }
}
void plssolve()
{
    cin>>n>>k>>X;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
        desc[i].clear();
        desc[i]=getdesc(v[i]);
        best[i]=v[i];
    }
    solve();
    update();
    if(X!=1)
    {
        for(int i=1;i<=n;i++)
        {
            plsadd(i);
            solve();
            update();
            plsrem(i);
        }
    }
    for(int i=1;i<=n;i++)
        cout<<best[i]<<' ';
    cout<<'\n';
}
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    for(int i=2;i<=40000;i++)
        if(c[i]==0)
        {
            primes.push_back(i);
            for(int j=i*2;j<=40000;j+=i)
                c[j]=1;
        }
    cin>>t;
    while(t--)
        plssolve();
    return 0;
}
