#include <iostream>
#include <queue>
#include <vector>

using namespace std;

const int N = 5e5;
int sz[N], v[N], viz[N];

queue <int> q[N + 10];

vector <int> poz[N + 10];

int n, m;

int cnt;

int cb ( int st, int dr, int x, int val ) {

    while ( dr - st > 1 ) {

        int mij = ( st + dr ) / 2;

        if ( val >= poz[x][mij] )
            st = mij + 1;
        else
            dr = mij - 1;
    }

    return st;
}

int solve () {

    int node = 1, dist = 0;

    int n1 = 0;

    int k = 1;

    while ( cnt < n && k <= m ) {

        if ( viz[node] == 0 ) {
             viz[node] = 1;
             cnt++;
        }

        if ( node == v[k] )
            k++;

        n1++;

        dist++;

        int copie = node;

        node = q[node].front();
        q[copie].push ( q[copie].front() );
        q[copie].pop();

    }

    if ( k <= m ) {

        int n2 = 0;
        cnt = 0;

        while ( cnt < n ) {

            if ( viz[node] == 1 ) {
                 viz[node] = 2;
                 cnt++;
            }

            poz[node].push_back (n2);

            n2++;

            int copie = node;

            node = q[node].front();
            q[copie].push ( q[copie].front() );
            q[copie].pop();

        }

        for ( int i = 1; i <= n; i++ )
            poz[i].push_back( poz[i][0] + n2 );

        int pozitie = n2 - 1;

        while ( k <= m ) {

            int i = cb ( 0, poz[v[k]].size() - 1, v[k], pozitie );

            dist = dist + poz[v[k]][i] - pozitie;
            node = v[k];

            pozitie = poz[v[k]][i] % n2;

            k++;
        }
    }

    return dist;
}

int main() {

    int x;

    cin >> n >> m;

    for ( int i = 1; i <= n; i++ ) {
        cin >> sz[i];

        for ( int j = 0; j < sz[i]; j++ ){
            cin >> x;
            q[i].push(x);
        }
    }

    for ( int i = 1; i <= m; i++ )
        cin >> v[i];

    cout << solve ();


    return 0;
}
