#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "
#define int ll

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 100001;
const int MOD = 1009;
const int MOD2 = 1007;
const int base = 234;
const int base2 = 29;

int inv[NMAX];
int fact[NMAX];

map <int, int> mp;
map <int, int> sterg;
int v[NMAX];

int lgput(int n, int p) {
    int r = 1;
    while(p) {
        if(p&1) {
            r = (1LL * r * n) % MOD;
        }
        n = (1LL * n * n) % MOD;
        p/=2;
    }
    return r;
}
int lgput2(int n, int p) {
    int r = 1;
    while(p) {
        if(p&1) {
            r = (1LL * r * n) % MOD2;
        }
        n = (1LL * n * n) % MOD2;
        p/=2;
    }
    return r;
}

int comb(int n, int k) {
    if(n < k)
        return 0;
    return (1LL * (1LL * fact[n] * inv[k]) % MOD * inv[n - k]) % MOD;
}

vector <int> divs[NMAX];

void add(int &x, int val) {
    if(val > 0)
    val %= MOD;
    x += val;
    if(x < 0)
        x += MOD;
    if(x >= MOD)
        x -= MOD;
}

vector <pair <pii, int> > sol;
int ini[NMAX];

bool cmp(int a, int b) {
    return ini[a] < ini[b];
}

signed main() {
#ifdef HOME
    ifstream cin(".in");
    ofstream cout(".out");
#endif // HOME
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    fact[0] = 1;
    inv[0] = 1;
    for(int i = 1; i < NMAX; i++) {
        fact[i] = (1LL * fact[i - 1] * i) % MOD;
    }
    for(int i = 1; i < NMAX; i++) {
        inv[i] = lgput(fact[i], MOD - 2);
    }
    while(t--) {
        sol.clear();
        int n, i, k, x;
        cin >> n >> k >> x;
        mp.clear();
        for(i = 1; i <= n; i++) {
            divs[i].clear();
            cin >> v[i];
            ini[i] = v[i];
            int d = 1;
            while(d * d < v[i]) {
                if(v[i] % d == 0) {
                    mp[d]++;
                    divs[i].push_back(v[i] / d);
                    divs[i].push_back(d);
                    mp[v[i] / d]++;
                }
                d++;
            }
            if(d * d == v[i]) {
                mp[d]++;
                divs[i].push_back(d);
            }
            sort(divs[i].begin(), divs[i].end()); /// VEDEM
            reverse(divs[i].begin(), divs[i].end());
        }
        sol.clear();
        for(i = 1; i <= n; i++) {
            int hsh = 0;
            int hsh2 = 0;
            sterg.clear();
            for(auto x : divs[i]) {
                int acum = (comb((mp[x] - 1), k - 1));
                int s = -(sterg[x]%MOD);
                add(acum, s);
                add(hsh, (1LL * acum * lgput(base, x)) % MOD);
                add(hsh2, (1LL * acum * lgput2(base2, x)) % MOD2);
                for(int j = divs[i].size() - 1; j; j--) {
                    int y = divs[i][j];
                    if(y >= x) break;
                    if(x % y == 0){
                        add(sterg[y], acum);
                    }
                }
            }
            sol.push_back({(pii){hsh, hsh2}, i});
        }
        sort(sol.begin(), sol.end());
        pii lst = {-1, -1};
        vector <int> indici, doi;
        for(auto x : sol) {
            if(x.first != lst && lst.first != -1) {
                doi = indici;
                sort(doi.begin(), doi.end(), cmp);
                for(int i = 0; i < doi.size(); i++) {

                    v[indici[i]] = ini[doi[i]];
                }
                indici.clear();
            } else {
                indici.push_back(x.second);
            }
            lst = x.first;
        }
        if(indici.size()) {
            doi = indici;
            sort(doi.begin(), doi.end(), cmp);
            for(int i = 0; i < doi.size(); i++) {
                v[indici[i]] = ini[doi[i]];
            }
        }
        indici.clear();
        for(i = 1; i <= n; i++) {
            cout << v[i] << " ";
        }
        cout << "\n";
    }
    return 0;
}
