#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e5;
bool vis[MAX_N];
int a[MAX_N], ans[MAX_N];
unordered_map<int, int> desc[MAX_N];
map<int, map<int, int>> countGreater;
vector<int> adj[MAX_N];

vector<int> pos, val;
void dfs( int u ) {
	vis[u] = true;
	pos.push_back( u );
	val.push_back( u );
	for ( int v: adj[u] ) {
		if ( !vis[v] )
			dfs( v );
	}
}

int main() {
	cin.tie( NULL );
	ios_base::sync_with_stdio( false );
	int t;
	
	cin >> t;
	while ( t-- ) {
		int n, k, x;
		cin >> n >> k >> x;
		
		for ( int i = 0; i < n; i++ ) {
			cin >> a[i];
			desc[i].clear();
			adj[i].clear();
			vis[i] = false;
			
			int x = a[i], d = 2;
			while ( d * d <= x ) {
				while ( x % d == 0 ) {
					x /= d;
					desc[i][d]++;
				}
				d++;
			}
			if ( x > 1 )
				desc[i][x]++;
				
			for ( auto p: desc[i] )
				countGreater[p.first][p.second]++;
		}
		
		for ( auto p: countGreater ) {
			int cnt = 0;
			for ( auto q: p.second ) {
				cnt += q.second;
				countGreater[p.first][q.first] = cnt;
			}
			for ( auto q: p.second ) 
				countGreater[p.first][q.first] = cnt - countGreater[p.first][q.first];
		}
		
		for ( int i = 0; i < n; i++ ) {
			for ( int j = 0; j < i; j++ ) {
				bool ok = true;
				for ( auto p: desc[i] ) {
					int d = p.first;
					if ( desc[i][d] != desc[j][d] && (countGreater[d][desc[i][d]] >= k || countGreater[d][desc[j][d]] >= k) )
						ok = false;
				}
				if ( ok ) {
					adj[i].push_back( j );
					adj[j].push_back( i );
					//printf( "adj %d %d\n", i, j );
				}
			}
		}
		
		for ( int i = 0; i < n; i++ ) {
			if ( !vis[i] ) {
				pos.clear();
				dfs( i );
				sort( pos.begin(), pos.end() );
				val = pos;
				sort( val.begin(), val.end(), []( int i, int j ) {
					return a[i] < a[j];
				} );
				
				for ( int j = 0; j < (int)pos.size(); j++ )
					ans[pos[j]] = a[val[j]];
			}
		}
		
		for ( int i = 0; i < n; i++ )
			cout << ans[i] << " ";
		cout << "\n";
	}
	
	return 0;
}
