#include <bits/stdc++.h>
using namespace std;

int n, m;
deque <int> g[500005];
int father[500005];
int sz;
vector <int> P[500005];
set <int> P_[500005];
int aint[2000007];
int friends[500005];
bitset <500005> f;
bitset <2000005> K;

void add(int pos) {

    for (int i = pos; i <= 2000004; i += i & -i)
        aint[i]++;
}

int get(int pos) {

    int ret = 0;
    for (int i = pos; i; i -= i & -i)
        ret += aint[i];
    return ret;
}

void dfs(int node, int p = 0) {

    father[node] = p;

    sz++;
    P[node].push_back(sz);

    if (node == 1) {

        for (auto &i : g[node]) {

            dfs(i, node);

            sz++;
            P[node].push_back(sz);
        }

        return;
    }

    int idx = 0;

    while (g[node][idx] != p)
        idx++;

    for (int i = idx + 1; i < g[node].size(); i++) {

        dfs(g[node][i], node);

        sz++;
        P[node].push_back(sz);
    }

    for (int i = 0; i < idx; i++) {

        dfs(g[node][i], node);

        sz++;
        P[node].push_back(sz);
    }
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++) {

        int sz;
        cin >> sz;

        for (int j = 1; j <= sz; j++) {

            int x;
            cin >> x;

            g[i].push_back(x);
        }
    }

    for (int i = 1; i <= m; i++)
        cin >> friends[i];

    dfs(1);

    deque <int> Q1, Q2;

    Q1.push_back(1);
    f[1] = true;

    int idx = 1;
    int total = 0;

    bool init = false;

    while (idx <= m) {

        while (!Q1.empty()) {

            int node = Q1.front();
            Q1.pop_front();

            add(P[node][0]);
            K[P[node][0]] = true;

            if (father[node]) {

                add(P[node].back() + 1);
                K[P[node].back() + 1] = true;
            }

            bool ok = false;

            for (auto &i : g[node]) {

                if (i == father[node]) {

                    ok = true;
                    continue;
                }

                if (!ok) {

                    if (!f[i]) {

                        Q1.push_back(i);
                        f[i] = true;
                    }
                }
                else
                    Q2.push_back(i);
            }
        }

        int aux = init;

        while (true) {

            int node = friends[idx];

            if (!f[node])
                break;

            int l = 0, r = P[node].size() - 1, pos = -1;

            while (l <= r) {

                int mij = (l + r) >> 1;

                if (P[node][mij] > aux)  {

                    pos = mij;
                    r = mij - 1;
                }
                else
                    l = mij + 1;
            }

            if (pos == -1)
                break;

            while (pos < P[node].size() && !K[P[node][pos]])
                pos++;

            if (pos == P[node].size())
                break;

            pos = P[node][pos];

            total += get(pos) - get(aux);
            aux = pos;
            idx++;

            if (idx == m + 1) {

                cout << total;
                return 0;
            }
        }

        total += get(2000005) - get(aux); // FIXME !!!!

        // final

        Q1 = Q2;

        while (!Q2.empty())
            f[Q2.front()] = true, Q2.pop_front();

        init = true;
    }

    return 0;
}
