#include <iostream>
#include <vector>
#include <queue>

#define nmax 200001
using namespace std;

int v[nmax], d, n, update = 0, dp[nmax];

vector <int> qst, qdr;

void init(vector<int> A, int D) {
    int i;
    n = A.size();
    for( i = 0; i < n; i++ )
        v[i] = A[i];
    d = D;

    int st, dr, maxx, ok, j, mutst = 1, mutdr = 1, p = 0;
    dr = n - 1;
    for( st = 0; st < n - d; ) {
        ok = 1;
        i = st - 1;
        while( ok == 1 ) {
            i++;
            maxx = 0;
            //cout << max(st, i - d) << " " <<  min(dr, i + d) << "\n";
            for( j = max(st, i - d); j <= min(dr, i + d); j++ )
                maxx = max( maxx, v[j] );
            if( maxx == v[i] )
                ok = 0;
        }
        dp[i] = 1;
        qst.push_back(i);
        st = i + d + 1;
    }
    /*cout << "q";
    for( i = 0; i < qst.size(); i++ )
        cout << qst[i] << " ";*/
    st = 0;
    for( dr = n - 1; dr >= d; ) {
        ok = 1;
        i = dr + 1;
        while( ok == 1 ) {
            i--;
            maxx = 0;
            for( j = max(st, i - d); j <= min(dr, i + d); j++ )
                maxx = max( maxx, v[j] );
            if( maxx == v[i] )
                ok = 0;
        }
        qdr.push_back(i);
        dp[i] = 1;
        dr = i - d - 1;
    }
    /*cout << "\n";
    for( i = 0; i < qst.size(); i++ )
        cout << qst[i] << " ";
    cout << "\n";*/
}

void updateValue(int index, int newValue) {
    v[index] = newValue;
}

bool isWinning(int startIndex) {
    int st, dr, maxx, ok, i, j, mutst = 1, mutdr = 1, p = 0, ist = 0, idr = 0, indmaxx;
    for( i = max(startIndex - d, 0); i <= startIndex + d; i++ ) {
        if( dp[i] == 1 ) {
            if( i == startIndex )
                return false;
            return true;
        }
    }
    //cout << "*****";
    st = 0;
    dr = n - 1;

    while( 1 ) {
        //cout << mutst << " " << mutdr << " " << st << " " << dr << "\n";
        if( mutst == 1 ) {
            if( ist < qst.size() )
                i = qst[ist];
            else
                i = n;
            ist++;
            if( i + d + 1 > startIndex )
                mutst = 0;
            else
                st = i + d + 1;
            //cout << "i" << i << " ";
        }
        if( mutdr == 1 ) {
            if( idr < qdr.size() )
                i = qdr[ist];
            else
                i = -1;
            idr++;
            if( i - d - 1 < startIndex )
                mutdr = 0;
            else
                dr = i - d - 1;
            //cout << "i" << i << " ";
        }
        if( mutdr == 0 && mutst == 0 ) {
            //cout << "st dr" << st << " " << dr << "\n";
            mutst = mutdr = 1;
            while( 1 ) {
                //cout << mutst << " " << mutdr << " " << st << " " << dr << "\n";
                if( mutst == 1 ) {
                    ok = 1;
                    i = st - 1;
                    while( ok == 1 ) {
                        i++;
                        maxx = 0;
                        //cout << max(st, i - d) << " " <<  min(dr, i + d) << "\n";
                        for( j = max(st, i - d); j <= min(dr, i + d); j++ )
                            maxx = max( maxx, v[j] );
                        if( maxx == v[i] )
                            ok = 0;
                    }
                    if( i + d + 1 > startIndex )
                        mutst = 0;
                    else {
                        //dp[i] = 1;
                        st = i + d + 1;
                    }
                    //cout << "i" << i << " ";
                }
                if( mutdr == 1 ) {
                    ok = 1;
                    i = dr + 1;
                    while( ok == 1 ) {
                        i--;
                        maxx = 0;
                        for( j = max(st, i - d); j <= min(dr, i + d); j++ )
                            maxx = max( maxx, v[j] );
                        if( maxx == v[i] )
                            ok = 0;
                    }
                    if( i - d - 1 < startIndex )
                        mutdr = 0;
                    else {
                        //dp[i] = 1;
                        dr = i - d - 1;
                    }
                    //cout << "i" << i << " ";
                }
                if( mutdr == 0 && mutst == 0 ) {
                    //cout << "st dr" << st << " " << dr << "\n";
                    if( st == dr )
                        return false;
                    maxx = 0;
                    for( j = max(startIndex - d, st); j <= min(startIndex + d, dr); j++ ) {
                        if( maxx < v[j] )
                            indmaxx = j;
                        maxx = max( maxx, v[j] );
                    }
                    //dp[indmaxx] = 1;
                    if( maxx == v[startIndex] )
                        return false;
                    return true;
                }
            }
        }
    }
    return true;
}
