#include "game.h"

using namespace std;

int n, a[200010], i, d, pr[200010], pl[200010];

void calcP(int i)
{
    pr[i] = min(i+d, n) + 1;
    for (int j = i+1; j <= min(i+d, n); j++) {
        if (a[j] > a[i]) {
            pr[i] = j;
            break;
        }
    }
    pl[i] = max(1, i-d) - 1;
    for (int j = i-1; j >= max(1, i-d); j--) {
        if (a[j] > a[i]) {
            pl[i] = j;
            break;
        }
    }
}

void init(vector<int> A, int D)
{
    n = A.size();
    for (int i = 1; i <= n; i++) {
        a[i] = A[i-1];
    }
    d = D;

    for (int i = 1; i <= n; i++) {
        calcP(i);
    }
}

void updateValue(int index, int newValue)
{
    index++;
    a[index] = newValue;
    for (int i = max(1, index-d); i <= min(n, index+d); i++) {
        calcP(i);
    }
}

bool isWinning(int startIndex)
{
    startIndex++;
    if (startIndex != 1) {
        int i = 1;
        while (pr[i] < startIndex) {
            i = pr[i];
        }
        if (i >= startIndex - d && a[i] > a[startIndex]) return true;
    }
    if (startIndex != n-1) {
        int i = n;
        while (pl[i] > startIndex) {
            i = pl[i];
        }
        if (i <= startIndex + d && a[i] > a[startIndex]) return true;
    }
    return false;
}
