#include "game.h"

using namespace std;

int n, a[200010], i, d, pr[200010], pl[200010];
bool ans[200010];

void calcP(int i)
{
    pr[i] = min(i+d, n) + 1;
    for (int j = i+1; j <= min(i+d, n); j++) {
        if (a[j] > a[i]) {
            pr[i] = j;
            break;
        }
    }
    pl[i] = max(1, i-d) - 1;
    for (int j = i-1; j >= max(1, i-d); j--) {
        if (a[j] > a[i]) {
            pl[i] = j;
            break;
        }
    }
}

void init(vector<int> A, int D)
{
    n = A.size();
    for (int i = 1; i <= n; i++) {
        a[i] = A[i-1];
    }
    d = D;

    for (int i = 1; i <= n; i++) {
        calcP(i);
    }
    int i = 1;
    for (int j = 2; j <= n; j++) {
        while (pr[i] < j) i = pr[i];
        if (i >= j-d && a[i] > a[j]) ans[j] = true;
    }
    i = n;
    for (int j = n-1; j >= 1; j--) {
        while (pl[i] > j) i = pl[i];
        if (i <= j+d && a[i] > a[j]) ans[j] = true;
    }
}

void updateValue(int index, int newValue)
{
    index++;
    a[index] = newValue;
    for (int i = max(1, index-d); i <= min(n, index+d); i++) {
        calcP(i);
    }
}

bool isWinning(int startIndex)
{
    if (n <= 2001) {
        startIndex++;
        if (startIndex != 1) {
            int i = 1;
            while (pr[i] < startIndex) {
                i = pr[i];
            }
            if (i >= startIndex - d && a[i] > a[startIndex]) return true;
        }
        if (startIndex != n) {
            int i = n;
            while (pl[i] > startIndex) {
                i = pl[i];
            }
            if (i <= startIndex + d && a[i] > a[startIndex]) return true;
        }
        return false;
    }
    return ans[startIndex];
}
