#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100000;
const int P_MAX = 31700;

int N, K, X;
int A[N_MAX + 2];

vector <int> primes;

map <int, vector <int>> with_prime;

int ex[N_MAX + 2];
vector <pair <int, int>> code[N_MAX + 2];

int order[N_MAX + 2];

bool is_prime[P_MAX + 2];
vector <int> small_primes;

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    mt19937 rnd(0);

    fill(is_prime + 2, is_prime + P_MAX + 1, true);
    for (int p = 2; p * p <= P_MAX; p++) {
        if (is_prime[p] == true) {
            for (int q = p * p; q <= P_MAX; q += p) {
                is_prime[q] = false;
            }
        }
    }
    for (int p = 2; p <= P_MAX; p++) {
        if (is_prime[p] == true) {
            small_primes.push_back(p);
        }
    }

    int t;
    cin >> t;
//    t = 100;
    while (t--) {
        cin >> N >> K >> X;
//        N = 1000; K = 10; X = 1;
        for (int i = 1; i <= N; i++) {
            cin >> A[i];
//            A[i] = rnd() % (int) 1e9 + 1;
            int x = A[i];
            for (int p : small_primes) {
                if ((long long) p * p > x) {
                    p = x;
                }
                if (x % p == 0) {
                    primes.push_back(p);
                    with_prime[p].push_back(i);
                    do {
                        x /= p;
                    } while (x % p == 0);
                }
                if (x == 1) {
                    break;
                }
            }
        }
        sort(primes.begin(), primes.end());
        primes.resize(unique(primes.begin(), primes.end()) - primes.begin());
        for (int p : primes) {
            vector <int> v = with_prime[p];
            int cnt[30];
            fill(cnt, cnt + 30, 0);
            int max_e = 0;
            for (int i : v) {
                int x = A[i];
                ex[i] = 0;
                do {
                    x /= p;
                    ex[i]++;
                } while (x % p == 0);
                cnt[ex[i]]++;
                max_e = max(max_e, ex[i]);
            }
            for (int e = max_e - 1; e >= 0; e--) {
                cnt[e] += cnt[e + 1];
            }
            while (max_e > 0 && cnt[max_e] < K) {
                max_e--;
            }
            if (max_e > 0 && cnt[max_e] < N) {
                for (int i : v) {
                    code[i].push_back({p, min(ex[i], max_e)});
                }
            }
        }
        iota(order + 1, order + N + 1, 1);
        sort(order + 1, order + N + 1, [&] (const int &i, const int &j) {
            return make_pair(code[i], i) < make_pair(code[j], j);
        });
        for (int l = 1; l <= N; l++) {
            int r = l;
            while (r < N && code[order[r + 1]] == code[order[l]]) {
                r++;
            }
            vector <int> a;
            for (int i = l; i <= r; i++) {
                a.push_back(A[order[i]]);
            }
            sort(a.begin(), a.end());
            for (int i = l; i <= r; i++) {
                A[order[i]] = a[i - l];
            }
            l = r;
        }
//        for (int i = 1; i <= N; i++) {
//            cout << A[i] << " ";
//        }
//        cout << "\n";
        for (int p : primes) {
            with_prime[p].clear();
        }
        primes.clear();
        for (int i = 1; i <= N; i++) {
            code[i].clear();
        }
    }

    return 0;
}
