#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll 

#define sz(x) ((int)(x).size())
using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int nmax = 5e5 + 5;

vector<int> g[nmax];
int deg[nmax];
int eqtozero;

unordered_map<int,int> urmval[nmax];

signed main() {
	int n, m;
	cin >> n >> m;
	for(int i = 1; i <= n; i++) {
		int L;
		cin >> L;
		g[i].assign(L, 0);
		for(auto &x : g[i]) cin >> x;
	}
	
	eqtozero = n + 1;
	int notfirst = 0;
	int node = 1, last = 0;
	g[0].resize(100);
	vector<int> euler;
	while(deg[1] != 0 || !notfirst || node != 1) {
		int nxt = g[node][deg[node]];
		deg[node] = (deg[node] + 1) % sz(g[node]);
		euler.emplace_back(node);
		last = node;
		node = nxt;
		notfirst = 1;
	}
	notfirst = 0;
	while(deg[1] != 0 || !notfirst || node != 1) {
		int nxt = g[node][deg[node]];
		deg[node] = (deg[node] + 1) % sz(g[node]);
		euler.emplace_back(node);
		last = node;
		node = nxt;
		notfirst = 1;
	}
	
	int stddim = sz(euler);
	auto T = euler; copy(all(T), back_inserter(euler));
	
	vector<int> P(m);
	for(auto &x : P) cin >> x;
	
	for(int i = sz(euler) - 2; i >= 0; i--) {
		urmval[i] = urmval[i + 1];
		urmval[i][euler[i + 1]] = i + 1;
	}
	assert(sz(urmval[stddim - 1]) == n);
	
	int p = stddim - 1;
	ll total = 0;
	for(auto x : P) {
		int nval = urmval[p][x];
		total += nval - p;
		p = nval % stddim;
	}
	
	cout << total << '\n';
	
	
}
