#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

#define int ll 

#define sz(x) ((int)(x).size())
using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int nmax = 5e5 + 5;

vector<int> g[nmax];

vector<int> euler;
vector<int> timeappear;

void dfs(int node, int f, int sum) {
	euler.emplace_back(node);
	timeappear.emplace_back(sum);
	int A = sum;
	for(auto x : g[node]) {
		if(x == f) { sum++; continue; }
		if(sum == A) continue;
		dfs(x, node, sum);
		euler.emplace_back(node);
		timeappear.emplace_back(sum);
	}
	sum = A;
	for(auto x : g[node]) {
		if(x == f) { sum++; continue; }
		if(sum != A) continue;
		dfs(x, node, sum);
		euler.emplace_back(node);
		timeappear.emplace_back(sum);
	}
	return;
}

vector<int> pozappear[nmax];
set<int> positions[nmax];

#define lsb(p) (p & -p)
struct AIB {
	vector<int> tree;
	void init(int n) {
		tree.assign(n + 3, 0);
	}
	int query(int p) {
		p++;
		int sum = 0;
		while(p > 0) sum += tree[p], p -= lsb(p);
		return sum;
	}
	void upd(int p, int x) {
		p++;
		while(p < sz(tree)) tree[p] += x, p += lsb(p);
	}
} aib;

signed main() {
	
	auto START_TIME = clock();
	
	int n, m;
	cin >> n >> m;
	for(int i = 1; i <= n; i++) {
		int L;
		cin >> L;
		g[i].assign(L, 0);
		for(auto &x : g[i]) cin >> x;
	}
	
	dfs(1, -1, 0);
	euler.pop_back();
	timeappear.pop_back();
	
	int lastTime = 0;
	
	for(int i = 0; i < sz(euler); i++) {
		pozappear[timeappear[i]].emplace_back(i);
		lastTime = max(lastTime, timeappear[i]);
		
		// cerr << euler[i] << ' ' << timeappear[i] << '\n';
	}
	
	// exit(0);
	
	aib.init(sz(euler));
	
	int ourlevel = -1, totalOnLevel = 0;
	ll total = 0;
	int poz = -1;
	
	vector<int> P(m);
	for(auto &x : P) {
		cin >> x;
		
		while(1) {
			auto it = positions[x].upper_bound(poz);
			if(it == positions[x].end()) {
				total += totalOnLevel - aib.query(poz);
				poz = -1;
					
				if(ourlevel < lastTime) {
					ourlevel++;
					for(auto newinsert : pozappear[ourlevel]) {
						positions[euler[newinsert]].insert(newinsert);
						aib.upd(newinsert, 1);
					}
					totalOnLevel += sz(pozappear[ourlevel]);
				}
			}
			else {
				total += aib.query(*it) - aib.query(poz);
				poz = *it;
				break;
			}
		}
		// cerr << setprecision(8) << fixed << ((double)clock() - (double)START_TIME) / (double)CLOCKS_PER_SEC << '\n';
	}

	cout << total << '\n';
		// cerr << setprecision(8) << fixed << ((double)clock() - (double)START_TIME) / (double)CLOCKS_PER_SEC << '\n';
	
	
}
