#include <bits/stdc++.h>
#include "game.h"

using namespace std;

int n,d;
vector<int>a;
vector<bool> state;

void init(vector<int> A,int D)
{
    n = A.size();
    state.resize(n);
    a = A;
    d = D;
    vector<pair<int,int>> vals;
    for (int i = 0; i < n; i++)
        vals.push_back({a[i],i});
    sort(vals.begin(),vals.end());
    reverse(vals.begin(),vals.end());
    for (auto it : vals)
    {
        int pos = it.second,val = it.first;
        state[pos] = false;
        for (int i = max(0,pos - d); i <= min(n - 1,pos + d); i++)
            if (a[i] > val and state[i] == false)
                state[pos] = true;
    }
}

void updateValue(int index, int newValue)
{
    a[index] = newValue;
    for (int i = 0; i < n; i++)
        state[i] = false;
    vector<pair<int,int>> vals;
    for (int i = 0; i < n; i++)
        vals.push_back({a[i],i});
    sort(vals.begin(),vals.end());
    reverse(vals.begin(),vals.end());
    for (auto it : vals)
    {
        int pos = it.second,val = it.first;
        state[pos] = false;
        for (int i = max(0,pos - d); i <= min(n - 1,pos + d); i++)
            if (a[i] > val and state[i] == false)
                state[pos] = true;
    }
}

bool isWinning(int startIndex)
{
    return state[startIndex];
}
