#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()

using ll = long long;

#define pii pair<int, int>
#define fr first
#define sc second

const int NMAX = 1e5, VALMAX = 1e9, SQMAX = (int)sqrt(1e9);

pair<ll, ll> a[NMAX + 5];
int sieve[NMAX + 5];
ll ans[NMAX + 5];
vector<pii> divz[NMAX + 5];
vector<int> prime;

void ciur()
{
    for(int i = 2; i <= SQMAX; i ++)
    {
        if(sieve[i] == 0)
        {
            prime.push_back(i);
            for(int j = i * i; j <= SQMAX; j += i)
                sieve[j] = 1;
        }
    }
}

map<int, vector<pii>> umap;
map<ll, vector<pair<int, ll>>> mp2;

int n, k, x, nrx, expx;

vector<ll> solve()
{

    umap.clear();
    mp2.clear();
    for(int i = 0; i < n; i ++)
        for(auto j : divz[i])
            umap[j.fr].push_back({j.sc, i});

    for(auto vec : umap)
    {
        sort(all(vec.sc), greater<pii>());
        int exp = 0, nr = 0;
        for(auto i : vec.sc)
        {
            nr ++;
            exp = i.fr;
            if(nr >= k) //la valoarea asta ii aducem
                break;
        }
        if(nr < k)
            exp = 0;
        if(vec.fr == x)
            expx = exp;
        //cout << vec.fr << " " << nr << " " << exp << '\n';
        for(auto i : vec.sc)
        {
            if(i.fr > exp && vec.fr == x)
                nrx ++;

            while(i.fr > exp)
            {
                i.fr --;
                a[i.sc].sc /= vec.fr;
            }
        }
    }

    for(int i = 0; i < n; i ++)
    {
        mp2[a[i].sc].push_back({i, a[i].fr});
//        for(auto j : divz[i])
//            cout << j.fr << " " << j.sc << '\n';
//        cout << a[i].sc << '\n';
    }
    //cout << '\n';

    for(auto vec : mp2)
    {

        auto v = vec.sc;
        vector<int> v1;
        vector<ll> v2;

        for(auto i : v)
            v1.push_back(i.fr);
        for(auto i : v)
            v2.push_back(i.sc);

        sort(all(v1));
        sort(all(v2));

        for(int i = 0; i < v1.size(); i ++)
            ans[v1[i]] = v2[i];

    }

    vector<ll> ret;

    for(int i = 0; i < n; i ++)
        ret.push_back(ans[i]);

    //de facut RESETARE

    for(int i = 0; i < n; i ++)
        a[i].sc = a[i].fr;

    return ret;
}


bool cmp(pair<int, ll> a, pair<int, ll> b)
{
    if(a.sc != b.sc)
        return a.sc < b.sc;
    return a.fr < b.fr;
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ciur();
    int t;
    cin >> t;
    while(t --)
    {
        cin >> n >> k >> x;
        nrx = expx = 0;
        for(int i = 0; i < n; i ++)
        {
            divz[i].clear();
            cin >> a[i].fr;
            a[i].sc = a[i].fr;
            int ca = a[i].fr;
            for(auto j : prime)
                while(ca % j == 0)
                {
                    if(divz[i].empty() || divz[i].back().fr != j)
                        divz[i].push_back({j, 0});
                    divz[i].back().sc ++;
                    ca /= j;
                }
            if(ca > 1)
                divz[i].push_back({ca, 1});
        }

        vector<ll> best = solve();
        if(x == 1)
        {
            for(auto i : best)
                cout << i << " ";
            cout << '\n';
            continue;
        }

        vector<pair<int, int>> locuri_schimbate;

        //for(auto vec : mp2) cout << "SUS: " << vec.sc.size() << '\n';

        for(auto i : mp2)
        {
            //iteram prin a[i].sc-uri   avem acum pozitiile SI valorile de la acea pozitie
            if(i.sc.empty() || mp2[i.fr * x].empty())
                continue;

            //altfel avem de treaba

            auto mic1 = i.sc;
            auto mare1 = mp2[i.fr * x];
            auto mic2 = mic1;
            auto mare2 = mare1;
            sort(all(mic2), cmp);
            sort(all(mare2), cmp);

            /*cout << i.fr << " " << x * i.fr << '\n';

            for(auto j : mic1)
                cout << j.fr << " ";
            cout << '\n';
            for(auto j : mare1)
                cout << j.fr << " ";
            cout << '\n' << '\n';*/

            //prima pozitie in care asta mic face ceva util cu viata


            int p1 = 0, p2 = 0;
            for(p1 = 0; p1 < mic1.size(); p1 ++)
            {
                while(p2 < mare1.size() && mare1[p2].fr < mic1[p1].fr)
                    p2 ++;
                if(p2 == mare1.size())
                    break;
                if(mic2[p1].sc > mare2[p2].sc) //cel mai mic care se afla in dreapta lui p1 in sirul final
                {
                    //atunci aici se face frumos
                    locuri_schimbate.push_back({mic1[p1].fr, mic1[p1].fr});
                    break;
                }
            }
            p1 = 0, p2 = 0; //altfel vrem sa vedem daca ne ajuta sa ducem unul de jos in sus
            for(p2 = 0; p2 < mare1.size(); p2 ++)
            {
                while(p1 < mic1.size() && mic1[p1].fr < mare1[p2].fr) //ne fixam pozitia mare, ne trebuie un om mic din dreapta care sa poata sa fie mai mic ca pozitia setata
                    p1 ++;
                if(p1 == mic1.size())
                    break;
                if(mic2[p1].sc * x < mare2[p2].sc)
                {
                    locuri_schimbate.push_back({mare1[p2].fr, mic1[p1].fr});
                    break;
                }
            }
        }

        sort(all(locuri_schimbate));

        for(int j = 0; j < min(2, (int)locuri_schimbate.size()); j ++)
        {
            int i = locuri_schimbate[j].sc;
            vector<ll> incerc;
            if(a[i].fr % x != 0)
            {
                a[i].fr *= x;
                a[i].sc *= x;
                divz[i].push_back({x, 1});

                incerc = solve();

                a[i].fr /= x;
                a[i].sc /= x;
                divz[i].pop_back();
            }
            else
            {
                a[i].fr *= x;
                a[i].sc *= x;
                //divz[i].push_back({x, 1});
                for(auto &j : divz[i])
                    if(j.fr == x)
                        j.sc ++;

                incerc = solve();

                a[i].fr /= x;
                a[i].sc /= x;

                for(auto &j : divz[i])
                    if(j.fr == x)
                        j.sc --;
                //divz[i].pop_back();
            }

            int ok = 0;
            for(int i = 0; i < n; i ++)
            {
                if(incerc[i] == best[i])
                    continue;
                if(incerc[i] < best[i])
                    ok = 1;
                break;
            }

            if(ok)
                swap(best, incerc);

        }

        /*if(x != 1)
        {
            int ok = 0;
            for(int i = 0; i < n; i ++)
            {
                vector<ll> incerc;
                if(a[i].fr % x != 0)
                {
                    a[i].fr *= x;
                    a[i].sc *= x;
                    divz[i].push_back({x, 1});

                    incerc = solve();

                    a[i].fr /= x;
                    a[i].sc /= x;
                    divz[i].pop_back();
                }
                else
                {
                    a[i].fr *= x;
                    a[i].sc *= x;
                    //divz[i].push_back({x, 1});
                    for(auto &j : divz[i])
                        if(j.fr == x)
                            j.sc ++;

                    incerc = solve();

                    a[i].fr /= x;
                    a[i].sc /= x;

                    for(auto &j : divz[i])
                        if(j.fr == x)
                            j.sc --;
                    //divz[i].pop_back();
                }

                int ok = 0;
                for(int i = 0; i < n; i ++)
                {
                    if(incerc[i] == best[i])
                        continue;
                    if(incerc[i] < best[i])
                        ok = 1;
                    break;
                }

                if(ok)
                    swap(best, incerc);

            }
        }*/

        for(auto i : best)
            cout << i << " ";
        cout << '\n';

    }
}
