#include <bits/stdc++.h>
#include "game.h"

using namespace std;

using vi = vector<int>;
using ii = pair<int, int>;

vi A, W;
int n, D;

void brut() {
    W.assign(n, 0);
    vi activ(n, 1);
    vector<ii> V;
    for(int i = 0; i < n; ++i)
        V.push_back({A[i], i});
    sort(V.rbegin(), V.rend());
    for(auto [v, p] : V) {
        if(activ[p]) {
            for(int i = max(0, p - D); i < min(n, p + D + 1); ++i) {
                if(activ[i]) {
                    activ[i] = 0;
                    W[i] = (i != p);
                }
            }
        }
    }
}
void init(vi A0, int D0) {
    A = A0;
    D = D0;
    n = A.size();
    brut();
}

void updateValue(int p, int v) {
    A[p] = v;
    brut();
}

bool isWinning(int p) {
    return W[p];
}
