#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")

using namespace std;

#define int ll
using ll = long long;
using vi = vector<int>;
using ii = pair<int, int>;

vi Prime;

void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    vi A0(n), A;
    vector<ii> Desc;
    vector<vector<ii> > V(n);

    for(int i = 0; i < n; ++i) 
        cin >> A0[i];
    auto simu = [&]() {
        for(int i = 0; i < n; ++i) {
            int v = A[i], e0 = 0;
            for(auto d : Prime) {
                if(d * d > v) break;
                if(v % d == 0) {
                    int e = 0;
                    while(v % d == 0) {
                        ++e;
                        v /= d;
                    }
                    V[i].push_back({d, e});
                }
            }
            if(v != 1) {
                V[i].push_back({v, 1});
            } 
            for(auto [v, e] : V[i])
                Desc.push_back({v, e});
        }
        sort(Desc.begin(), Desc.end());

        map<int, int> ExpMax;

        for(int i = 0; i < Desc.size(); ++i) {
            int dr = i;
            while(dr + 1 < Desc.size() && Desc[dr + 1].first == Desc[i].first) ++dr;
            vi E;
            for(int j = i; j <= dr; ++j)
                E.push_back(Desc[j].second);
            sort(E.rbegin(), E.rend());
            if(E.size() < k) {
                i = dr;
                continue;
            }
            ExpMax[Desc[i].first] = E[k - 1];
            i = dr;
        }
        
        vector<ii> SRad;
        for(int i = 0; i < n; ++i) {
            int rad = 1;
            for(auto [v, e] : V[i]){ 
                for(int j = 0; j < min(e, ExpMax[v]); ++j)
                    rad *= v;
            }
            SRad.push_back({rad, i});
        }
        sort(SRad.begin(), SRad.end());
        for(int i = 0; i < SRad.size(); ++i) {
            int dr = i;
            while(dr + 1 < SRad.size() && SRad[dr + 1].first == SRad[i].first) ++dr;
            vi P;
            for(int j = i; j <= dr; ++j)
                P.push_back(SRad[j].second);
            vi VP;
            for(auto it : P) VP.push_back(A[it]);
            sort(VP.begin(), VP.end());
            for(int j = 0; j < P.size(); ++j)
                A[P[j]] = VP[j];
            i = dr;
        }
    };

    if(x == 1) {
        A = A0;
        simu();
        for(auto it : A) cout << it << " ";
        cout << "\n";
    } else {
        A = A0;
        simu();
        vi Re = A;
        for(int i = 0; i < n; ++i) {
            A = A0;
            A[i] *= x;
            simu();
            Re = min(Re, A);
        }
        for(auto it : Re) cout << it << " ";
        cout << "\n";
    }
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    ///ciur
    const int MV = 1e5;
    vector<bool> On(MV, true);
    for(int i = 2; i < MV; ++i) {
        if(On[i]) Prime.push_back(i);
        for(ll j = 1ll * i * i; j < MV; j += i)
            On[j] = 0;
    }

    int te;
    cin >> te;
    while(te--) solve();
    return 0;
}
