#include <iostream>
#include <vector>

#pragma GCC target("avx2")
#pragma GCC optimize("Ofast", "unroll-loops")

using namespace std;

const int NMAX = 1e5;

vector<int> g[NMAX + 1];
int k[NMAX + 1];
int rem[NMAX + 1];


int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0); cout.tie(0);

  int n, m;
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    cin >> k[i];
    rem[i] = 0;
    for (int j = 0, x; j < k[i]; j++) {
      cin >> x;
      g[i].push_back(x);
    }
  }

  int old = 1, wanted;
  int T = 1;

  for (int i = 0; i < m; i++) {
    cin >> wanted;
    int node = old, nxt;
    if (wanted == 1 && i == 0)
      continue;
    do {
      T++;
      nxt = g[node][rem[node]];
      rem[node]++;
      if (rem[node] == k[node])
        rem[node] = 0;
      node = nxt;
    } while (node != wanted);
    old = wanted;
  }

  cout << T;

  return 0;
}
