#include <bits/stdc++.h>
#pragma GCC optimize( "Ofast, unroll-loops" )

using namespace std;

const int NMAX = 1000;

long long up[NMAX + 1][NMAX + 1];
int depth[NMAX + 1];
int cnt[NMAX + 1];
int father[NMAX + 1];

deque <int> edges[NMAX + 1];
int n;

int v[NMAX + 1];

int all, op;

void dfs( int node, int p = 0 ) {
    while ( all > 0 ) {
        if ( cnt[node] > 0 ) {
            cnt[node] --;
            all --;
        }
        if ( all == 0 ) break;
        op ++;
        dfs( edges[node][0], node );
    }
}

mt19937 rng( 0 );

int main() {
    int m, last = -1;
    cin >> n >> m;
    for ( int i = 1, k; i <= n; i ++ ) {
        cin >> k;
        for ( int j = 1, b; j <= k; j ++ ) {
            cin >> b;
            edges[i].push_back( b );
        }
    }
    for ( int i = 1; i <= m; i ++ ) {
        cin >> v[i];
    }
    dfs( 1 );
    int minim = 1e9, run = 0;
    while ( (double)clock() / CLOCKS_PER_SEC < 0.995 ) {
        for ( int i = 1; i <= n; i ++ ) {
            shuffle( edges[i].begin(), edges[i].end(), rng );
        }
        op = 1;
        int node = 1, idx = 1;
        while ( idx <= m ) {
            if ( node == v[idx] ) {
                idx ++;
                all --;
            }
            if ( all == 0 ) break;
            int newNode = edges[node][0];
            op ++;
            edges[node].push_back( newNode );
            edges[node].pop_front();
            node = newNode;
        }
        minim = min( minim, op );
    }
    cout << minim;
    return 0;
}
