#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1000;

map <int, int> f;

int n, k;

int v[NMAX + 1];
int a[NMAX + 1];

void descomp( int i, int caz ) {
    int x = v[i];
    for ( int d = 2; d * d <= x; d ++ ) {
        if ( x % d ) continue;
        int p = 1;
        while ( x % d == 0 ) {
            p *= d;
            x /= d;
            if ( caz == 1 ) f[p] ++;
            else if ( f[p] >= k ) a[i] *= p;
        }
    }
    if ( x > 1 ) {
        if ( caz == 1 ) f[x] ++;
        else if ( f[x] >= k ) a[i] *= x;
    }
}

int ans[NMAX + 1];

void solve() {
    int x;
    cin >> n >> k >> x;
    f.clear();
    for ( int i = 1; i <= n; i ++ ) {
        cin >> v[i];
        a[i] = 1;
        descomp( i, 1 );
    }
    vector <int> ord1, ord2;
    for ( int i = 1; i <= n; i ++ ) {
        descomp( i, 2 );
        ord1.push_back( i );
        ord2.push_back( i );
    }
    sort( ord1.begin(), ord1.end(), []( int i, int j ) {
        if ( a[i] != a[j] ) return a[i] < a[j];
        return v[i] < v[j];
    } );
    sort( ord2.begin(), ord2.end(), []( int i, int j ) {
        if ( a[i] != a[j] ) return a[i] < a[j];
        return i < j;
    } );
    for ( int i = 0; i < n; i ++ ) {
        ans[ord2[i]] = v[ord1[i]];
    }
    for ( int i = 1; i <= n; i ++ ) cout << ans[i] << ' ';
    cout << '\n';
}
int main() {
    ios_base::sync_with_stdio( false );
    cin.tie( NULL );
    cout.tie( NULL );
    int t;
    cin >> t;
    while ( t-- ) solve();
    return 0;
}
/**
1
3 2 1
38 28 14
**/
