#include <bits/stdc++.h>
#define int long long

using namespace std;

const int NMAX = 1e5;

unordered_map <int, int> f;

vector <int> prime;

bool ciur[NMAX + 1];

int n, k, xPrim;

int v[NMAX + 1];
int a[NMAX + 1];

void descomp( int i, int caz ) {
    int x = v[i];
    if ( xPrim != 1 ) {
        int p = 1;
        while ( x % xPrim == 0 ) {
            p *= xPrim;
            x /= xPrim;
            if ( caz == 1 ) f[p] ++;
            else if ( f[p] >= k ) a[i] *= xPrim;
        }
    }
    for ( int j = 0; prime[j] * prime[j] <= x; j ++ ) {
        int d = prime[j];
        if ( x % d ) continue;
        int p = 1;
        while ( x % d == 0 ) {
            p *= d;
            x /= d;
            if ( caz == 1 ) f[p] ++;
            else if ( f[p] >= k ) a[i] *= d;
        }
    }
    if ( x > 1 ) {
        if ( caz == 1 ) f[x] ++;
        else if ( f[x] >= k ) a[i] *= x;
    }
}

int ans[NMAX + 1];
int best[NMAX + 1];

void solve() {
    f.clear();
    for ( int i = 1; i <= n; i ++ ) {
        a[i] = 1;
        descomp( i, 1 );
    }
    vector <int> ord1, ord2;
    for ( int i = 1; i <= n; i ++ ) {
        descomp( i, 2 );
        ord1.push_back( i );
        ord2.push_back( i );
    }
    sort( ord1.begin(), ord1.end(), []( int i, int j ) {
        if ( a[i] != a[j] ) return a[i] < a[j];
        return v[i] < v[j];
    } );
    sort( ord2.begin(), ord2.end(), []( int i, int j ) {
        if ( a[i] != a[j] ) return a[i] < a[j];
        return i < j;
    } );
    for ( int i = 0; i < n; i ++ ) {
        ans[ord2[i]] = v[ord1[i]];
    }
}

bool smaller() {
    for ( int i = 1; i <= n; i ++ ) {
        if ( ans[i] != best[i] ) return ans[i] < best[i];
    }
    return false;
}
signed main() {
    ios_base::sync_with_stdio( false );
    cin.tie( NULL );
    cout.tie( NULL );

    for ( int i = 2; i * i <= NMAX; i ++ ) {
        if ( !ciur[i] ) {
            for ( int j = i * i; j <= NMAX; j += i ) {
                ciur[j] = true;
            }
        }
    }
    for ( int i = 2; i <= NMAX; i ++ ) {
        if ( !ciur[i] ) prime.push_back( i );
    }
    int t;
    cin >> t;
    while ( t-- ) {
        cin >> n >> k >> xPrim;
        for ( int i = 1; i <= n; i ++ ) cin >> v[i];
        solve();
        for ( int i = 1; i <= n; i ++ ) best[i] = ans[i];
        for ( int i = 1; i <= n; i ++ ) {
            v[i] *= xPrim;
            solve();
            if ( smaller() ) {
                for ( int i = 1; i <= n; i ++ ) best[i] = ans[i];
            }
            v[i] /= xPrim;
        }
        for ( int i = 1; i <= n; i ++ ) cout << best[i] << ' ';
        cout << '\n';
    }
    return 0;
}
