#include <bits/stdc++.h>
#define int long long

using namespace std;

const int NMAX = 1e5;

unordered_map <int, int> f;

vector <int> prime;

bool ciur[NMAX + 1];

int n, k, xPrim;

int v[NMAX + 1];
int a[NMAX + 1];
int exponent[NMAX + 1];
int maxExp;

void descomp( int i, int caz ) {
    int x = v[i];
    for ( int j = 0; prime[j] * prime[j] <= x; j ++ ) {
        int d = prime[j];
        if ( x % d ) continue;
        int p = 1;
        while ( x % d == 0 ) {
            if ( d == xPrim ) exponent[i] ++;
            p *= d;
            x /= d;
            if ( caz == 1 ) f[p] ++;
            else if ( f[p] >= k ) a[i] *= p;
        }
    }
    if ( x > 1 ) {
        if ( x == xPrim ) exponent[i] ++;
        if ( caz == 1 ) f[x] ++;
        else if ( f[x] >= k ) a[i] *= x;
    }
    maxExp = max( maxExp, exponent[i] );
}

int lgput( int a, int b ) {
    int p = 1;
    while ( b > 0 ) {
        if ( b % 2 == 1 ) {
            p *= a;
        }
        a *= a;
        b /= 2;
    }
    return p;
}
int ans[NMAX + 1];
int aux[NMAX + 1];

unordered_map <int, int> minim;

bool smaller() {
    for ( int i = 1; i <= n; i ++ ) {
        if ( aux[i] != ans[i] ) return aux[i] < ans[i];
    }
    return false;
}
void solve() {
    cin >> n >> k >> xPrim;
    f.clear();
    minim.clear();
    for ( int i = 1; i <= n; i ++ ) {
        cin >> v[i];
        a[i] = 1;
        descomp( i, 1 );
    }
    vector <int> ord1, ord2;
    for ( int i = 1; i <= n; i ++ ) {
        descomp( i, 2 );
        ord1.push_back( i );
        ord2.push_back( i );
        if ( minim.find( a[i] ) == minim.end() || v[i] < minim[a[i]] ) minim[a[i]] = v[i];
    }
    sort( ord1.begin(), ord1.end(), []( int i, int j ) {
        if ( a[i] != a[j] ) return a[i] < a[j];
        return v[i] < v[j];
    } );
    sort( ord2.begin(), ord2.end(), []( int i, int j ) {
        if ( a[i] != a[j] ) return a[i] < a[j];
        return i < j;
    } );
    for ( int i = 0; i < n; i ++ ) {
        ans[ord2[i]] = v[ord1[i]];
    }
    for ( int i = 1; i <= n; i ++ ) {
        if ( exponent[i] + 1 > maxExp ) continue;
        int factor = lgput( xPrim, exponent[i] + 1 );
        if ( f[factor] + 1 <= k ) continue;
        //if ( minim[a[i] * xPrim] <= ans[i] ) {
            //bool ok = false;
            //if ( minim[a[i] * xPrim] < ans[i] ) ok = true;
            v[i] *= xPrim;
            a[i] *= xPrim;
            sort( ord1.begin(), ord1.end(), []( int i, int j ) {
                if ( a[i] != a[j] ) return a[i] < a[j];
                return v[i] < v[j];
            } );
            sort( ord2.begin(), ord2.end(), []( int i, int j ) {
                if ( a[i] != a[j] ) return a[i] < a[j];
                return i < j;
            } );
            for ( int i = 0; i < n; i ++ ) {
                aux[ord2[i]] = v[ord1[i]];
            }
            if ( smaller() ) {
                for ( int i = 1; i <= n; i ++ ) ans[i] = aux[i];
            }
            v[i] /= xPrim;
            a[i] /= xPrim;
            //if ( ok ) break;
        //}
    }
    for ( int i = 1; i <= n; i ++ ) cout << ans[i] << ' ';
    cout << '\n';
}
/*
1
3 2 1
2 6 4
4 2 3
7 3 6 9
*/
signed main() {
    ios_base::sync_with_stdio( false );
    cin.tie( NULL );
    cout.tie( NULL );

    for ( int i = 2; i * i <= NMAX; i ++ ) {
        if ( !ciur[i] ) {
            for ( int j = i * i; j <= NMAX; j += i ) {
                ciur[j] = true;
            }
        }
    }
    for ( int i = 2; i <= NMAX; i ++ ) {
        if ( !ciur[i] ) prime.push_back( i );
    }
    int t;
    cin >> t;
    while ( t-- ) solve();
    return 0;
}
/**
1
3 2 7
6 28 70

1
4 2 3
7 3 6 9
3 2 1
2 6 4

**/
