#include "game.h"
#include "bits/stdc++.h"
using namespace std;
using ll = long long;

vector<int> v;
vector<vector<int>> ans;
int D;
vector<bool> vis;

void dfs(int i) {
	if (ans[i][0] != -1) {
		return;
	}
	vis[i] = 1;
	int d = D;
	int mx = 0;
	int n = v.size();
	for (int j = max(0, i - d); j < min(n, i + d + 1); j++) {
		if (i != j) {
			mx = max(mx, v[j]);
		}
	}
	if (mx < v[i]) {
		ans[i][0] = 1;
		ans[i][1] = 1;
		return;
	}
	bool dd1 = 0;
	bool dd2 = 0;
	int tr = 0, dn = 0;
	for (int j = max(0, i - d); j < min(n, i + d + 1); j++) {
		if (i != j && v[j] == mx) {
			if (ans[j][0] == -1 && !vis[j]) {
				dfs(j);
			}
			if (ans[j][1] == 2) {
				dd1 = 1;
			}
			if (ans[j][0] == 2) {
				dd2 = 1;
			}
			tr++;
			if (ans[j][0] == -1 || ans[j][0] == 3) {
				dn++;
			}
		}
	}
	if (dd1) {
		ans[i][0] = 1;
	} else {
		ans[i][0] = 2;
	}
	if (dd2) {
		ans[i][1] = 1;
	} else {
		ans[i][1] = 2;
	}
	if (tr == dn) {
		ans[i][1] = 1;
		ans[i][0] = 2;
	}
	return;
}

void init(std::vector<int> a, int d) {
    D = d;
    v = a;
    ans.resize(a.size(), vector<int> (2, -1));
    vis.resize(a.size(), 0);
    vector<int> rec;
    int n = a.size();
    vector<pair<int, int>> sa;
    for (int i = 0; i < n; i++) {
    	sa.push_back({a[i], i});
    }
    sort(sa.rbegin(), sa.rend());
    for (int j = 0; j < n; j++) {
    	int i = sa[j].second;
    	if (ans[i][0] != -1) {
    		continue;
    	}
    	dfs(i);
    }
}

void updateValue(int index, int newValue) {
    
}

bool isWinning(int startIndex) {
	return (ans[startIndex][0] == 2);
}

// int main()
// {
//     int n, D, q;

//     std::vector<int> nums;

//     scanf("%d %d", &n, &D);

//     for (int i = 1; i <= n; i++)
//     {
//         int x;
//         scanf("%d", &x);
//         nums.push_back(x);
//     }

//     init(nums, D);

//     scanf("%d", &q);

//     for (int i = 1; i <= q; i++)
//     {
//         int cm;

//         scanf("%d", &cm);

//         if (cm == 1)
//         {
//             int ind, val;

//             scanf("%d %d", &ind, &val);

//             updateValue(ind, val);
//         }
//         else
//         {
//             int ind;

//             scanf("%d", &ind);

//             printf("%d\n", (int)isWinning(ind));
//         }
//     }

//     return 0;
// }
