#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll n, m, q, k, x, y, a, b, c;
ll tt=1;

vector<ll> get(vector<ll> v, vector<ll> def) {
    unordered_map< ll, multiset<ll> > mp;
    unordered_map< ll, set<ll> > mpi;
    for (int i = 0; i < n; i++) {
        // cout << def[i] << ' ';
        mp[def[i]].insert(v[i]);
        mpi[def[i]].insert(i);
    }
    // cout << '\n';
    for (auto i : mp) {
        ll x = i.first;
        // cout << x << endl;
        while (mp[x].size() > 0) {
            // cout << (*mpi[x].begin()) << ' ' << (*mp[x].begin()) << endl;
            v[(*mpi[x].begin())] = (*mp[x].begin());
            mp[x].erase(mp[x].begin());
            mpi[x].erase(mpi[x].begin());
        }
    }
    return v;
}

vector<ll> min(vector<ll> &a, vector<ll> &b) {
    for (int i = 0; i < n; i++) {
        if (a[i] < b[i]) {
            return a;
        }
        if (a[i] > b[i]) {
            return b;
        }
    }
    return a;
}

void solve() {
    cin >> n >> k >> x;
    vector<ll> v(n);
    vector<ll> ans;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector<ll> def(n, 1);
    set<ll> divs;
    for (int i = 0; i < n; i++) {
        ll x = v[i];
        for (int j = 2; j * j <= x; j++) {
            // cout << v[i] << ' ' << j << endl;
            if (x % j == 0) {
                divs.insert(j);
                while (x % j == 0) {
                    x /= j;
                }
            }
        }
        if (x != 1) {
            divs.insert(x);
        }
    }
    for (auto i : divs) {
        // cout << i << '\n';
        set<ll> st;
        for (int j = 0; j < n; j++) {
            st.insert(j);
        }
        for (ll j = i; ; j *= i) {
            // cout << '\t' << j << endl;
            set<ll> stn;
            for (ll e : st) {
                if (v[e] % j == 0) {
                    stn.insert(e);
                }
            }
            swap(st, stn);
            if (st.size() < k) {
                break;
            }
            for (ll e : st) {
                def[e] *= i;
            }
        }
    }
    ans = get(v, def);
    for (int i = 0; i < n; i++) {
        v[i] *= x;
        def[i] *= x;
        auto vec = get(v, def);
        // for (auto j : vec) {
        //     cout << j << ' ';
        // }
        // cout << '\n';
        ans = min(ans, vec);
        v[i] /= x;
        def[i] /= x;
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> tt;
    while (tt-->0) {
        solve();
    }
}