// Ignut

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 5e5 + 123;
const ll M = 5e5 + 123;

ll n, m;

ll eInd[N] = {};
vector<ll> g[N];

ll friendIndex = 0;
ll p[M];

// ========================= //

// ll day = 0;

// ll res = -1;

// void dfs(ll v) {
//     if (res != -1) return;
//     day ++;
//     if (v == p[friendIndex]) {
//         friendIndex ++;
//         if (friendIndex == m) {
//             res = day;
//             return;
//         }
//     }
//     eInd[v] ++;
//     eInd[v] %= g[v].size();
//     dfs(g[v][eInd[v]]);
// }

ll depth[N];

void calc(ll v, ll d) {
    depth[v] = d;
    for (ll to : g[v])
        if (depth[to] == -1)
            calc(to, d + 1);
}

ll cntFull = 0;
ll total = 0;

bool used[N] = {};

void dfs(ll v, ll lim) {
    if (depth[v] < lim) return;
    used[v] = true;
    total ++;
    eInd[v] ++;
    eInd[v] %= g[v].size();
    cntFull += g[v].size();
    dfs(g[v][eInd[v]], lim);
}

vector<ll> order;


void dfs0(ll v) {
    if (!used[v]) {
        order.push_back(v);
        return;
    }
    for (ll to : g[v])
        if (depth[to] > depth[v])
            dfs0(to);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0), cout.tie(0);

    // freopen("input123.txt", "r", stdin);
    // freopen("output123.txt", "w", stdout);

    cin >> n >> m;
    for (ll i = 0; i < n; i ++) {
        eInd[i] = -1;
        ll k; cin >> k;
        for (ll j = 0; j < k; j ++) {
            ll v; cin >> v; v --;
            g[i].push_back(v);
        }
    }
    for (ll i = 0; i < m; i ++) {
        cin >> p[i]; p[i] --;
    }

    for (ll i = 0; i < n; i ++) depth[i] = -1;
    calc(0, 0);

    
    vector<pair<vector<ll>, ll>> g0, next;
    ll ind = 0;

    for (ll i = 0; i < g[0].size(); i ++)
        g0.push_back({{g[0][i]}, 0});

    ll day = 1;

    for (ll i = 1; i < m; i ++) {
        day += g0[ind].second;
        next.push_back({{}, 0});
        for (ll j = 0; j < g0[ind].first.size(); j ++) {
            order.clear();
            cntFull = 0;
            total = 0;
            dfs(g0[ind].first[j], depth[g0[ind].first[j]]);
            day += total;
            for (ll v : order)
                next.back().first.push_back(v);
            next.back().second += cntFull;
        }
        day ++;

        ind ++;
        if (ind == g0.size()) {
            ind = 0;
            g0 = next;
            next.clear();
        }
        // cout << day << '\n';
    }

    cout << day << '\n';
    return 0;
}

/*
*/