// Ignut

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n, d;
vector<int> a;

vector<int> w;

void init(std::vector<int> A, int D) {
    a = A;
    n = A.size();
    d = D;

    w.assign(n, 0);
    vector<pair<int, int>> v;
    for (int i = 0; i < n; i ++) v.push_back({a[i], i});
    sort(v.begin(), v.end()), reverse(v.begin(), v.end());

    for (auto [val, pos] : v) {
        // already used
        if (w[pos] == 1) continue;

        for (int i = pos + 1; i <= min(n - 1, pos + d); i ++) {
            if (w[i] == 1) break;
            w[i] = 1;
        }
        for (int i = pos - 1; i >= max(0, pos - d); i --) {
            if (w[i] == 1) break;
            w[i] = 1;
        }
    }

    return;
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    int LEN = 200;
    int l = max(0, index - LEN);
    int r = min(n - 1, index + LEN);
    // init(a, d);
    for (int i = l; i <= r; i ++) w[i] = 0;
    vector<pair<int, int>> v;
    for (int i = l; i <= r; i ++) v.push_back({a[i], i});
    sort(v.begin(), v.end()), reverse(v.begin(), v.end());

    for (auto [val, pos] : v) {
        // already used
        if (w[pos] == 1) continue;

        for (int i = pos + 1; i <= min(r, pos + d); i ++) {
            if (w[i] == 1) break;
            w[i] = 1;
        }
        for (int i = pos - 1; i >= max(l, pos - d); i --) {
            if (w[i] == 1) break;
            w[i] = 1;
        }
    }
}

bool isWinning(int startIndex) {
    return w[startIndex];
}
