// Ignut

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int n, d;
vector<int> a;

vector<int> w;

// <left, peak, right>
multiset<tuple<int, int, int>> ms;

void init(std::vector<int> A, int D) {
    a = A;
    n = A.size();
    d = D;

    w.assign(n, 0);
    vector<pair<int, int>> v;
    for (int i = 0; i < n; i ++) v.push_back({a[i], i});
    sort(v.begin(), v.end()), reverse(v.begin(), v.end());

    for (auto [val, pos] : v) {
        // already used
        if (w[pos] == 1) continue;

        int l = pos, r = pos;

        for (int i = pos + 1; i <= min(n - 1, pos + d); i ++) {
            if (w[i] == 1) break;
            w[i] = 1;
            r ++;
        }
        for (int i = pos - 1; i >= max(0, pos - d); i --) {
            if (w[i] == 1) break;
            w[i] = 1;
            l --;
        }

        ms.insert({l, pos, r});
    }

    return;
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    int LEN = 100;

    int l, r;
    auto it1 = ms.lower_bound({index - LEN, -1, -1});
    l = get<0>(*it1);
    auto it2 = ms.lower_bound({index + LEN, -1, -1});
    if (it2 == ms.end()) it2 --;
    r = get<2>(*it2);


    // cout << "l, r = " << l << ' ' << r << '\n';

    while (true) {
        auto it = ms.lower_bound({l, -1, -1});
        if (it != ms.end() && get<0>(*it) <= r) ms.erase(it);
        else break;
    }

    // init(a, d);
    for (int i = l; i <= r; i ++) w[i] = 0;
    vector<pair<int, int>> v;
    for (int i = l; i <= r; i ++) v.push_back({a[i], i});
    sort(v.begin(), v.end()), reverse(v.begin(), v.end());

    for (auto [val, pos] : v) {
        // already used
        if (w[pos] == 1) continue;

        int L = pos, R = pos;

        for (int i = pos + 1; i <= min(r, pos + d); i ++) {
            if (w[i] == 1) break;
            w[i] = 1;
            R ++;
        }
        for (int i = pos - 1; i >= max(l, pos - d); i --) {
            if (w[i] == 1) break;
            w[i] = 1;
            L --;
        }

        ms.insert({L, pos, R});
    }
}

bool isWinning(int startIndex) {
    // for (auto [a, b, c] : ms) {
    //     cout << a << '-' << b << '-' << c << '\n';
    // }
    return w[startIndex];
}
