// Ignut

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1e5 + 123;

bool prime[N];

vector<int> pr;

int sz;

void Sieve() {
    for (int i = 0; i < N; i ++) prime[i] = true;
    prime[0] = prime[1] = false;
    for (int i = 2; i < N; i ++) {
        if (!prime[i]) continue;
        pr.push_back(i);
        for (ll j = 1ll * i * i; j < N; j += i)
            prime[j] = false;
    }
    sz = pr.size();
}

// =================================================== //

const int NN = 5e5 + 123;
int n, k, x;

int a[NN];

vector<int> Solve() {
    int additionalIndex[n];
    for (int i = 0; i < n; i ++) additionalIndex[i] = -1;

    vector<vector<int>> powers;
    powers.assign(sz, {});

    auto GetPower = [](int &val, int p) -> int {
        int pw = 0;
        while (val % p == 0) {
            pw ++;
            val /= p;
        }
        return pw;
    };

    for (int i = 0; i < n; i ++) {
        int save_a = a[i];
        for (int ind = 0; ind < pr.size(); ind ++) {
            int p = pr[ind];
            if (a[i] < p) break;
            if (a[i] % p != 0) continue;
            int pw = GetPower(a[i], p);
            powers[ind].push_back(pw);
        }
        if (a[i] > 1) {
            additionalIndex[i] = sz ++;
            powers.push_back({1});
        }
        a[i] = save_a;
    }

    for (int ind = 0; ind < sz; ind ++) {
        if (powers[ind].size() < k) {
            powers[ind] = {0}; continue;
        }
        sort(powers[ind].begin(), powers[ind].end());
        reverse(powers[ind].begin(), powers[ind].end());
        powers[ind] = {powers[ind][k - 1]};
    }

    // =================================================== //


    //     <needVal, actualVal>
    multiset<pair<int, int>> ms;

    int gt[n];

    for (int i = 0; i < n; i ++) {
        int save_a = a[i];
        int getVal = a[i];
        for (int ind = 0; ind < pr.size(); ind ++) {
            int p = pr[ind];
            if (a[i] < p) break;
            if (a[i] % p != 0) continue;
            int pw = GetPower(a[i], p);
            while (pw > powers[ind][0]) {
                pw --;
                getVal /= p;
            }
        }
        if (a[i] > 1 && powers[additionalIndex[i]][0] == 0) {
            getVal /= a[i];
        }
        a[i] = save_a;
        ms.insert({getVal, a[i]});
        gt[i] = getVal;
    }

    // ======================================================= //

    // for (auto [a, b] : ms) {
    //     cout << a << '_' << b << ' ';
    // }
    // cout << '\n';

    vector<int> res;
    for (int i = 0; i < n; i ++) {
        int getVal = gt[i];
        auto it = ms.lower_bound({getVal, -1});
        res.push_back((*it).second);
        ms.erase(it);
    }

    // for (int r : res) cout << r << ' ';
    // cout << '\n';

    return res;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0), cout.tie(0);

    // freopen("input123.txt", "r", stdin);
    // freopen("output123.txt", "w", stdout);

    Sieve();

    int t; cin >> t;
    while (t --> 0) {
        cin >> n >> k >> x;
        for (int i = 0; i < n; i ++) cin >> a[i];

        vector<int> res = Solve();
        for (int i = 0; i < n; i ++) {
            if (1ll * a[i] * x > 1e9) continue;
            a[i] *= x;
            res = min(res, Solve());
            a[i] /= x;
        }


        for (int r : res) cout << r << ' ';
        cout << '\n';
    }
    return 0;
}

/*
*/