#include <bits/stdc++.h>

using namespace std;

constexpr int K = 31622 + 10;
constexpr int N = 1e5 + 10;

int ld[K] = {};
vector<int> pr[N];
int a[N];
int n, k, x;
map<int, int> cnt;

int divs(int ind, int j, bool comp) {
    if (j == pr[ind].size()) {
        return 1;
    }
    int num = a[ind];
    int l = pr[ind][j];
    int p = 0;
    while (num % l == 0) {
        num /= l;
        p++;
    }
    int ans = divs(ind, j + 1, comp);
    int cur = 1;
    for (int i = 0; i < p; i++) {
        cur *= l;
        if (comp) {
            if (cnt[cur] >= k) {
                ans *= l;
            }
        }
        else {
            cnt[cur]++;
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<int> primes;
    primes.reserve(K);
    for (int i = 2; i < K; i++) {
        if (ld[i] == 0) {
            primes.push_back(i);
            for (int j = i; j < K; j += i) {
                ld[j] = i;
            }
        }
    }


    int T;
    cin >> T;
    while (T--) {
        cnt.clear();
        
        cin >> n >> k >> x;
        int b[n];
        for (int i = 0; i < n; i++) {
            pr[i].clear();
            cin >> a[i];
            b[i] = 1;
        }
        
        for (int i = 0; i < n; i++) {
            int num = a[i];
            for (int p : primes) {
                if (num % p == 0) {
                    pr[i].push_back(p);
                    while (num % p == 0) {
                        num /= p;
                    }
                }
            }
            if (num != 1) {
                pr[i].push_back(num);
            }
            divs(i, 0, false);
        }
        map<int, multiset<int>> mp;
        for (int i = 0; i < n; i++) {
            b[i] = divs(i, 0, true);
            mp[b[i]].insert(a[i]);
        }

        for (int i = 0; i < n; i++) {
            printf("%i ", *mp[b[i]].begin());
            mp[b[i]].erase(mp[b[i]].begin());
        }
        printf("\n");
    }
}