#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int K = 31622 + 10;
constexpr int N = 1e5 + 10;

int ld[K] = {};
vector<int> pr[N];
int a[N];
int n, k, x;
map<int, int> cnt;

int divs(int ind, int j, bool comp, bool chosen) {
    if (j == pr[ind].size()) {
        return 1;
    }
    int num = a[ind];
    ll l = pr[ind][j];
    int p = 0;
    while (num % l == 0) {
        num /= l;
        p++;
    }
    if (chosen) {
        int xnum = x;
        while (xnum % l == 0) {
            xnum /= l;
            p++;
        }
    }
    int ans = divs(ind, j + 1, comp, chosen);
    ll cur = 1;
    for (int i = 0; i < p; i++) {
        cur *= l;
        if (cur > INT_MAX) break;
        if (comp) {
            if (cnt[cur] >= k) {
                ans *= l;
            }
        }
        else {
            cnt[cur]++;
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    vector<int> primes;
    primes.reserve(K);
    for (int i = 2; i < K; i++) {
        if (ld[i] == 0) {
            primes.push_back(i);
            for (int j = i; j < K; j += i) {
                ld[j] = i;
            }
        }
    }


    int T;
    cin >> T;
    while (T--) {
        
        
        cin >> n >> k >> x;
        
        for (int i = 0; i < n; i++) {
            pr[i].clear();
            cin >> a[i];
        }

        vector<int> xpr;
        int xnum = x;
        for (int p : primes) {
            if (xnum % p == 0) {
                xpr.push_back(p);
                while (xnum % p == 0) {
                    xnum /= p;
                }
            }
        }
        if (xnum != 1) {
            xpr.push_back(xnum);
        }
        
        for (int i = 0; i < n; i++) {
            int num = a[i];
            for (int p : primes) {
                if (num % p == 0) {
                    pr[i].push_back(p);
                    while (num % p == 0) {
                        num /= p;
                    }
                }
            }
            if (num != 1) {
                pr[i].push_back(num);
            }
            
        }

        ll ans[n] = {};
        fill(ans, ans + n, LLONG_MAX);

        for (int chosen = -1; chosen < n; chosen++) {
            cnt.clear();
            if (chosen != -1) {
                for (int pri : xpr) {
                    if (a[chosen] % pri != 0) {
                        pr[chosen].push_back(pri);
                    }
                }
            }
            int b[n];
            for (int i = 0; i < n; i++) {
                divs(i, 0, false, (i == chosen));
            }
            map<int, multiset<ll>> mp;
            for (int i = 0; i < n; i++) {
                b[i] = divs(i, 0, true, (i == chosen));
                ll num = i == chosen ? ((ll)a[i]) * x : a[i];
                mp[b[i]].insert(num);
            }

            ll here[n];

            bool found = false, cool = true;

            for (int i = 0; i < n; i++) {
                here[i] = *mp[b[i]].begin();
                if (!found && here[i] != ans[i]) {
                    found = true;
                    if (here[i] < ans[i]) {
                        cool = true;
                    }
                    else {
                        cool = false;
                    }
                }
                if (!cool) break;
                mp[b[i]].erase(mp[b[i]].begin());
            }
            if (cool) {
                for (int i = 0; i < n; i++) {
                    ans[i] = here[i];
                }
            }
            if (chosen != -1) {
                while (!pr[chosen].empty() && a[chosen] % pr[chosen].back() != 0) {
                    pr[chosen].pop_back();
                }
            }
        }

        for (int i = 0; i < n; i++) {
            printf("%lld ", ans[i]);
        }
        printf("\n");
    }
}