#include "game.h"
#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int N = 2e5 + 128;
int n, d;
bool dp[N], hasB[N];
int was[N];
int a[N];

void rec(int idx) {
    if (was[idx] == 2)
        return;
    was[idx] = 1;
    if (!hasB[idx]) {
        dp[idx] = false;
        was[idx] = 2;
        return;
    }
    for (int nxt = max(0, idx - d); nxt <= min(n - 1, idx + d); nxt++)
        if (idx != nxt) {
            if (was[nxt] == 1)
                continue;
            rec(nxt);
            dp[idx] |= !dp[nxt];
        }
    was[idx] = 2;
}

void init(std::vector<int> A, int D) {
    n = (int)A.size();
    for (int i = 0; i < n; i++)
        a[i] = A[i];
    d = D;

    for (int i = 0; i < n; i++)
        for (int j = max(0, i - d); j <= min(n - 1, i + d); j++)
            hasB[i] |= a[j] > a[i];

    for (int i = 0; i < n; i++)
        rec(i);
}

void updateValue(int index, int newValue) {
    a[index] = newValue;

    for (int i = 0; i < n; i++)
        was[i] = dp[i] = hasB[i] = 0;

    for (int i = 0; i < n; i++)
        for (int j = max(0, i - d); j <= min(n - 1, i + d); j++)
            hasB[i] |= a[j] > a[i];

    for (int i = 0; i < n; i++)
        rec(i);
}

bool isWinning(int startIndex) {
    return dp[startIndex];
}
