#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int n, m;
int k[MAXN + 5];
int p[MAXN + 5];
int idx[MAXN + 5];
int used[MAXN + 5];
vector<int> G[MAXN + 5];
vector<int> pos[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> k[i];
        for (int j = 1; j <= k[i]; ++ j)
        {
            int u;
            cin >> u;
            G[i].push_back(u);
        }
    }

    for (int i = 1; i <= m; ++ i)
    {
        cin >> p[i];
    }

    vector<int> vis;
    int u = 1, cnt = n, br = 40;
    while (true)
    {
        ///cout << u << " ";
        vis.push_back(u);
        int v = G[u][idx[u]];
        if (idx[u] == 0) cnt--;
        idx[u]++;
        idx[u] %= k[u];
        if (idx[u] == 0) cnt++;
        u = v;
        if (u == 1 and cnt == n) break;
    }
    ///return 0;

    int sz = vis.size();
    for (int i = 0; i < sz; ++ i)
    {
        pos[vis[i]].push_back(i);
    }

    long long t = 0, p0 = -1, p1;
    for (int i = 1; i <= m; ++ i)
    {
        if (pos[p[i]].back() <= p0)
        {
            t += sz - p0;
            p0 = 0;
        }
        p1 = lower_bound(pos[p[i]].begin(), pos[p[i]].end(), p0 + 1) - pos[p[i]].begin();
        p1 = pos[p[i]][p1];
        t += p1 - p0;
        p0 = p1;
    }
    cout << t << endl;

    return 0;
}
