#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int n, m;
int k[MAXN + 5];
int p[MAXN + 5];
int idx[MAXN + 5];
vector<int> G[MAXN + 5], e;

void DFS(int u, int p)
{
    e.push_back(u);

    int i0 = -1;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (G[u][i] == p) i0 = i;
    }
    for (int i = i0 + 1; i < G[u].size(); ++ i)
    {
        DFS(G[u][i], u);
        e.push_back(u);
    }
    for (int i = 0; i < i0; ++ i)
    {
        DFS(G[u][i], u);
        e.push_back(u);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> k[i];
        for (int j = 1; j <= k[i]; ++ j)
        {
            int u;
            cin >> u;
            G[i].push_back(u);
        }
    }

    for (int i = 1; i <= m; ++ i)
    {
        cin >> p[i];
    }

    DFS(1, -1);

    int i = 0, t = 0, u = 1;
    int sze = e.size() - 1, pos = 0;
    while (i <= m)
    {
        t++;
        if (u == p[i]) i++;
        if (e[pos] == u) pos++;
        if (pos == sze) break;
        int v = G[u][idx[u]];
        idx[u]++;
        idx[u] %= k[u];
        u = v;
    }

    if (i == m + 1) cout << t << endl;

    return 0;
}
