#include <iostream>
#include <chrono>
#include <vector>
#include <queue>

#define maxn 500005
#define pb(x) push_back(x)
#define endl '\n'
#define mod 1000000007

using namespace std;

int p[maxn];
int n , m;
deque <int> v[maxn];
int vi[maxn];
int steps = 0;
int last = 1;

void dfs(int node)
{
    //cout << node << endl;
    steps++;
    if(last == m + 1)
        return;
    if(node == p[last])
        last++;
    if(last == m + 1)
        return;
    v[node].push_back(v[node].front());
    v[node].pop_front();
    dfs(v[node].back());
    if(last == m + 1)
        return;
}



void read()
{
    cin >> n >> m;

    int k;

    for(int i = 1; i <= n; i++)
    {
        cin >> k;
        int x;

        for(int j = 1; j <= k; j++)
        {
            cin >> x;
            v[i].push_back(x);
        }
    }

    for(int i = 1; i <= n; i++)
        cin >> p[i];

    dfs(1);

    cout << steps << endl;
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    read();

    return 0;
}
