#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxm = 1e5+5;
const int maxn = 2005;

int n,m,fri[maxm];

queue<int>q[maxn];

int par[maxn],br[maxn],loshi;
vector<int>g[maxn];
vector<int>path;

int siz,euler[maxn];
vector<int>v[maxn];

void read()
{
    cin >> n >> m;
    loshi = n-1;
    int sz,nb;
    for(int i = 1; i <= n; i++)
    {
        cin >> sz;
        for(int j = 1; j <= sz; j++)
        {
            cin >> nb;
            q[i].push(nb);
            g[i].push_back(nb);
        }
    }
    for(int i = 1; i <= m; i++) cin >> fri[i];
}

void dfs_tree(int beg, int pa)
{
    par[beg] = pa;
    for(int nb:g[beg]) if(nb!=pa) dfs_tree(nb,beg);
}

void dfs_route(int beg, int pa)
{
    if(par[beg]==pa) br[beg]++;
    if(br[beg]==2) loshi--;

    if(beg==1 && !loshi) return;

    path.push_back(beg);/// edinicata ot loshiq put ne se dobavq
    int nb = q[beg].front();
    q[beg].pop();
    q[beg].push(nb);
    dfs_route(nb,beg);
}

void dfs_euler(int beg, int pa)
{
    euler[++siz] = beg;
    for(int nb : g[beg])
    {
        if(nb!=pa)
        {
            dfs_euler(nb,beg);
            euler[++siz] = beg;
        }
    }
}

pair<int,int> bin_s(int idx, int x)
{
    int l = 0, r = v[idx].size()-1;
    int mid;
    while(l<=r)
    {
        mid = (l+r)/2;
        if(x<v[idx][mid]) r = mid-1;
        else l = mid+1;
    }
    pair<int,int>res;
    if(l == v[idx].size())
    {
        res.first = v[idx][0];
        res.second = v[idx][0] + (siz-x);
    }
    else
    {
        res.first = v[idx][l];
        res.second = v[idx][l] - x;
    }
    return res;
}

void solve()
{
    dfs_tree(1,1);
    path.push_back(1e9);/////////////
    dfs_route(1,1);


    ///for(int i = 0; i < path.size(); i++) cout << path[i] << " ";
    ///cout << endl;
    int pos = 1;

    long long ans = 0;
    for(int i = 1; i < path.size(); i++)
    {
        if(fri[pos]==path[i]) pos++;
        if(pos > m)
        {
            cout << i << endl;
            return;
        }
    }

    ans = path.size() - 1;/////////
    for(int i = 1; i <= n; i++)
    {
        g[i].clear();
        while(!q[i].empty())
        {
            g[i].push_back(q[i].front());
            q[i].pop();
        }
    }
    siz = 0;
    dfs_euler(1,1);
    euler[siz] = 0;
    siz--;
    ///for(int i = 1; i <= siz; i++) cout << euler[i] << " ";
    ///cout << endl;

    for(int i = 1; i <= siz; i++) v[euler[i]].push_back(i);
    int last = 0;
    for(int i = pos; i <= m; i++)
    {
        pair<int,int> pom = bin_s(fri[pos],last);
        ans += pom.second;
        last = pom.first;
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}

/*
10 15
3 4 3 2
3 5 1 6
4 8 7 1 9
2 10 1
1 2
1 2
1 3
1 3
1 3
1 4
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
*/
