#include <bits/stdc++.h>
#include "game.h"
#define LOG 22
#define MAXN 200008
using namespace std;

int d;
int rmq[MAXN][LOG];
int a[MAXN];
int loglen[MAXN];
int n;
//vector<int> edges[MAXN];
bool ready[MAXN];
bool ans[MAXN];
int interval(int l, int r)
{
    int len = ( r - l + 1);
    int k = loglen[len];
    return max( rmq[l][k], rmq[r-(1<<k)+1][k] );
}
int query(int ind, int d)
{
    int ret = 0;
    ret += interval(ind-d, ind-1);
    ret += interval(ind+1, ind+d);
    return ret;
}
pair<int,int> sorted[MAXN];
void init(std::vector<int> A, int D)
{
    d = D;
    n = A.size();

    ///complexing
    for (int i=0; i<n; i++)
    {
        sorted[i+1] = { A[i], i };
    }
    sort(sorted+1, sorted+1+n);
    int cnt = 0;
    for (int i=1; i<=n; i++)
    {
        cnt += ( sorted[i-1].first != sorted[i].first );
        a[ sorted[i].second ] = cnt;
    }

    ///sparse table
    for (int i=0; i<n; i++)
    {
        rmq[i][0] = a[i];
    }

    loglen[0] = 1;
    for (int i=1; i<=n; i++)
        loglen[i] = loglen[i-1] + 1;

    for (int j=1; j<LOG-1; j++)
        for (int i=0; i+(1<<j)+1<n; i++)
        {
            rmq[i][j] = max( rmq[i][j-1], rmq[i+(1<<j)][j-1] );
        }
}
void updateValue(int index, int newValue)
{

}
bool dfs(int s, int p, bool hod)
{
    if ( !ready[s] )
    {
        int e = query(s, d);
        //   edges[s].push(e);
        if ( e == p )
        {
            if ( hod )
            {
                if ( s > e )
                {
                    ans[s] = true;
                    ans[e] = false;
                    return false;
                }
                else
                {
                    ans[s] = false;
                    ans[e] = true;
                    return true;
                }
            }
            else
            {
                if ( s > e )
                {
                    ans[s] = false;
                    ans[e] = true;
                    return true;
                }
                else
                {
                    ans[s] = true;
                    ans[e] = false;
                    return false;
                }
            }
        }
        ans[s] = dfs(e, s, hod^1);
        return ans[s]^1;
    }
    else
    {
        return ans[s]^1;
    }
}
bool isWinning(int startIndex)
{
    int ind = startIndex;

    if ( ready[ind] ) return ans[a[ind]];
    else
    {
        ans[a[ind]] = dfs(a[ind], -1, 1);
        ready[ a[ind] ] = true;
        return ans[a[ind]];
    }
}
