#include <bits/stdc++.h>
#include "game.h"
#define LOG 22
#define MAXN 900008
using namespace std;

int d;
int rmq[MAXN][LOG];
int a[MAXN];
int loglen[MAXN];
int n;
vector<int> edges[MAXN];
bool ready[MAXN];
//pair<bool,int> //ans[MAXN];
int interval(int l, int r)
{
    int len = ( r - l + 1);
    int k = loglen[len];
    return max( rmq[l][k], rmq[r-(1<<k)+1][k] );
}
int query(int ind, int d)
{
    int ret = 0;

    int indmd = ind-d, indm1 = ind-1;
    if ( ind-d < 0 ) indmd = 0;
    if ( ind-1 < 0 ) indm1 = 0;
    ret += interval(indmd, indm1);

    int indpd = ind+d, indp1 = ind+1;
    if (  ind+d > n-1 ) indpd=n-1;
     if (  ind+1 > n-1 ) indp1=n-1;
    ret += interval(indp1, indpd);
    return ret;
}
pair<int,int> sorted[MAXN];
int indA[MAXN];
void init(std::vector<int> A, int D)
{
    d = D;
    n = A.size();

    ///complexing
    for (int i=0; i<n; i++)
    {
        sorted[i+1] = { A[i], i };
    }
    sort(sorted+1, sorted+1+n);
    int cnt = 0;
    for (int i=1; i<=n; i++)
    {
        cnt += ( sorted[i-1].first != sorted[i].first );
        a[ sorted[i].second ] = cnt;
        indA[cnt] = sorted[i].second;
    }

    ///sparse table
    for (int i=0; i<n; i++)
    {
        rmq[i][0] = a[i];
    }

    loglen[0] = 1;
    for (int i=1; i<=n; i++)
        loglen[i] = loglen[i-1] + 1;

    for (int j=1; j<LOG-1; j++)
        for (int i=0; i+(1<<j)-1<n; i++)
        {
            rmq[i][j] = max( rmq[i][j-1], rmq[i+(1<<j)][j-1] );
        }
}
void updateValue(int indA, int newValue)
{

}
bool dfs(int s, int p, int hod)
{

    if ( !edges[s].size() )
    {
        int e = query(indA[s], d);
        edges[s].push_back(e);
        if ( e == p )
        {
            if ( hod )
            {
                if ( s > e )
                {
                    //ans[s] = true;
                    //ans[e] = false;
                    return false;
                }
                else
                {
                    //ans[s] = false;
                    //ans[e] = true;
                    return true;
                }
            }
            else
            {
                if ( s > e )
                {
                    //ans[s] = false;
                    //ans[e] = true;
                    return true;
                }
                else
                {
                    //ans[s] = true;
                    //ans[e] = false;
                    return false;
                }
            }

        }


    }
    else
    {
        int e = edges[s][0];
        if ( e == p )
        {
            if ( hod )
            {
                if ( s > e )
                {
                    //ans[s] = true;
                    //ans[e] = false;
                    return false;
                }
                else
                {
                    //ans[s] = false;
                    //ans[e] = true;
                    return true;
                }
            }
            else
            {
                if ( s > e )
                {
                    //ans[s] = false;
                    //ans[e] = true;
                    return true;
                }
                else
                {
                    //ans[s] = true;
                    //ans[e] = false;
                    return false;
                }
            }

        }

    }
    return dfs(edges[s][0], s, hod^1);
}
bool isWinning(int startIndex)
{
    int ind = startIndex;


    return dfs(a[ind], -1, 1);

}
