#include <iostream>
#include <vector>
#include "game.h"
using namespace std;
const int MAXN = 1e5+7;
int rangeMax[MAXN];
int rangeSecMax[MAXN];
int maxInRange[MAXN]; /// za vseki index pazim dali v range-a mu ima chislo koeto e max v svoq range
int D;
bool winning[MAXN];
bool losing[MAXN];
vector<int> val;
vector<int> newVal;
int n;
void calculate(){
  int firstpos = 0;
  int firstmax,secmax;
  for(int i = 0;i<n;i++){
    firstpos = max(i-D,0);
    if(newVal[firstpos]>newVal[firstpos+1]){
      firstmax = firstpos;
      secmax = firstpos+1;
    }else{
      firstmax = firstpos+1;
      secmax = firstpos;
    }
    for(int j = firstpos+2;j<=min(i+D,n-1);j++){
      if(newVal[j]>newVal[firstmax]){
      secmax = firstmax;
      firstmax = j;
      }else if(newVal[j]>newVal[secmax]){
        secmax = j;
      }
    }
    rangeMax[i]=firstmax;
    rangeSecMax[i]=secmax;
  }
}
void uwp(int pos){
    if(losing[pos] or winning[pos]) return;
    losing[pos]=true;
    for(int j = max(pos-D,0);j<=min(pos+D,n-1);j++){
        if(pos!=j and !losing[j]){
          winning[j]=true;
          newVal[j]=0;
        }
    }
}
void evaluate(){
  for(int i=0;i<n;i++){
    maxInRange[i]=-1;
    losing[i]=false;
    winning[i]=false;
  }
  for(int i=0;i<n;i++){
    if(rangeMax[i]==i){
      uwp(i);
    }
  }
  /*for(int i=0;i<n;i++){
    if(winning[i]) cerr<<1<<" ";
    else if(losing[i]) cerr<<-1<<" ";
  }cout<<"\n";*/
}
void init(vector<int> originalA, int originalD){
  D = originalD;
  val = originalA;
  newVal = val;
  n = val.size();
  calculate();
  evaluate();
  calculate();
  evaluate();
}
void updateValue(int index, int newValue){
  val[index]=newValue;
  newVal=val;
  calculate();
  evaluate();
  calculate();
  evaluate();
}
bool isWinning(int startIndex){
  int igrach = 0;
  int ind = startIndex;
  if(losing[ind]) return 0;
  return 1;
}
