#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 5;
queue <int> v[MAXN];
int n, m, t[MAXN];
int times = 0;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    int ki,x;

    cin >> n >> m;

    for(int i = 1 ; i <= n ; i++)
    {
        cin >> ki;

        for(int j = 1 ; j <= ki ; j++)
        {
            cin >> x;
            v[i].push(x);
        }
    }

    for(int i = 1 ; i <= m ; i++)
    {
        cin >> t[i];
    }

}

void dfs(queue <int> path[MAXN], int node, int ras, int i)
{
    int nb;

        if(path[node].empty() == false)
        {
            nb = path[node].front();

            cout << node << ' ' << nb << ' ' << path[node].size() <<endl;

            path[node].pop();

            if(nb == t[i])
            {
                dfs(path, nb, ++ras, ++i);
                times++;
            }
            else
            {
                dfs(path, nb, ++ras, i);
                times++;
            }
        }
        path[node].push(nb);
}

int main()
{
    speed();
    read();
    dfs(v, 1, times, 1);
    cout << times <<endl;
    return 0;
}
/*
5 3
2 2 4
1 5
1 4
2 3 1
1 1
4 1 3
*/
