#include <iostream>
#include <vector>
#include <queue>
//#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 5;
queue <int> path[MAXN];
int n, m, t[MAXN];
int times = 0;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    int ki,x;

    cin >> n >> m;

    for(int i = 1 ; i <= n ; i++)
    {
        cin >> ki;

        for(int j = 1 ; j <= ki ; j++)
        {
            cin >> x;
            path[i].push(x);
        }
    }

    for(int i = 1 ; i <= m ; i++)
    {
        cin >> t[i];
    }
    
    int p = path[1].front();
    
    cout << (2 * m - 1) <<endl;

}

void bfs(int start)
{
    queue <int> q;

    q.push(start);

    int nb, node;
    int destIndex = 1;

    while(q.empty() == false)
    {
        int node = q.front();
        q.pop();

        if(path[node].empty() == false)
        {
            nb = path[node].front();

            cout << node << ' ' <<nb <<endl;

            if(nb == t[destIndex])
                destIndex++;

            if(destIndex == n)
                break;

            path[node].pop();
            path[node].push(nb);

            q.push(nb);

            times++;
        }
    }
    cout <<times <<endl;
}

int main()
{
    speed();
    read();
    
    return 0;
}
/*
5 3
2 2 4
1 5
1 4
2 3 1
1 1
4 1 3
*/
