#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 5;
queue <int> path[MAXN];
int n, m;
int times = 0;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void read()
{
    int ki,x;

    cin >> n >> m;

    for(int i = 1 ; i <= n ; i++)
    {
        cin >> ki;

        for(int j = 1 ; j <= ki ; j++)
        {
            cin >> x;
            path[i].push(x);
        }
    }

    for(int i = 1 ; i <= m ; i++)
    {
        cin >> x;
    }

}

void dfs(int node, int i, int dist)
{
    times = dist;
    int nb = path[node].front();

    path[node].pop();
    path[node].push(nb);

    //cout << node << ' ' << nb <<endl;

    if(nb == 1)
        i++;

    if(i == n)
        return;

    dfs(nb, i, ++dist);
}

int main()
{
    speed();
    read();
    dfs(1, 0, 0);
    cout << times <<endl;
    return 0;
}
/*
5 3
2 2 4
1 5
1 4
2 3 1
1 1
4 1 3

3 4
2 2 3
2 1 3
2 1 2
1 1 1 1
*/
