#include <bits/stdc++.h>
#include "game.h"
#define endl '\n'
using namespace std;
const int MAXN = 2e3 + 10;
int n, d, a[MAXN];
int losing[MAXN];
void init(std::vector<int> A, int D)
{
    n = A.size();
    d = D;
    memset(losing, 0, sizeof(losing));
    priority_queue < pair < int, int > > q;

    for (int i = 0; i < n; ++ i)
    {
        a[i] = A[i];
        q.push(make_pair(a[i], i));
    }
    int w, i;
    while(!q.empty())
    {
        w = q.top().first;
        i  = q.top().second;
        q.pop();
        if(losing[i])continue;
        for (int j = max(0, i-d); j < i; ++ j)
            losing[j] = 1;
        for (int j = i+1; j <= min(n-1, i+d); ++ j)
        {
            losing[j] = 1;
        }
    }
}
void updateValue(int index, int newValue)
{
    a[index] = newValue;
    memset(losing, 0, sizeof(losing));
     priority_queue < pair < int, int > > q;

    for (int i = 0; i < n; ++ i)
    {

        q.push(make_pair(a[i], i));
    }
    int w, i;
    while(!q.empty())
    {
        w = q.top().first;
        i  = q.top().second;
        q.pop();
        if(losing[i])continue;
        for (int j = max(0, i-d); j < i; ++ j)
            losing[j] = 1;
        for (int j = i+1; j <= min(n-1, i+d); ++ j)
        {
            losing[j] = 1;
        }
    }
}
bool isWinning(int startIndex)
{
    int maxx = 0, i = startIndex;
    for (int j = max(0, i-d); j < i; ++ j)
        if(!losing[j])maxx = 1;
    for (int j = i+1; j <= min(n-1, i+d); ++ j)
    {
        if(!losing[j])maxx = 1;
    }
    return maxx;
}
