#include <algorithm>
#include <iostream>
#include <utility>
#include <queue>

using namespace std;

const int MAX_N = 1000;

queue <int> nodes[MAX_N];
queue <int> friends;

int n, m;
int pos = 0;
int cnt = 0;

void update_friends() {
    if (friends.empty()) { cout << cnt; exit(0); }
    if (friends.front() == pos) friends.pop();
}

void update_pos() {
    int new_n = nodes[pos].front();
    nodes[pos].pop();
    nodes[pos].push(new_n);
    pos = new_n;
}

int main() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int t; cin >> t; t--;
            nodes[i].push(t);
        }
    }

    for (int i = 0; i < m; i++) {
        int t; cin >> t; t--;
        friends.push(t);
    }

    while (true) {
        update_friends();
//        cout << pos + 1 << " ";
        cnt++;
        update_pos();
    }
}
