#include <iostream>
#include <algorithm>
using namespace std;
const int MAXN = 1e5 + 1;
int arr[MAXN], pos[MAXN], srr[MAXN], brr[MAXN];
bool usng[MAXN];
int gcd(int a, int b) {
    if (a < b) {
        swap(a, b);
    }
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}
bool check(int ind, int used, int n, int k) {
    if (ind == n + 1) {
        if (used != k) {
            return true;
        }
        int gr1 = 0, gr2 = 0;
        for (int i = 1; i <= n; i++) {
            if (usng[i]) {
                gr1 = gcd(gr1, arr[i]);
                gr2 = gcd(gr2, brr[i]);
            }
        }
        if (gr1 == gr2) {
            return true;
        } else {
            return false;
        }
    }
    usng[ind] = 0;
    if (!check(ind + 1, used, n, k)) {
        return false;
    }
    usng[ind] = 1;
    if (!check(ind + 1, used + 1, n, k)) {
        return false;
    }
    return true;
}
bool permute(int ind, int n, int k) {
    for (int i = 1; i <= n; i++) {
        bool ok = true;
        for (int j = 1; j < ind; j++) {
            if (brr[j] == srr[i]) {
                ok = false;
                break;
            }
        }
        if (ok) {
            brr[ind] = srr[i];
            if (ind == n) {
                if (check(1, 0, n, k)) {
                    for (int i = 1; i <= n; i++) {
                        cout << brr[i] << ' ';
                    }
                    cout << '\n';
                    return true;
                }
            } else {
                if (permute(ind + 1, n, k)) {
                    return true;
                }
            }
        }
    }
    return true;
}
void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    for (int i = 1; i <= n; i++) {
        cin >> arr[i];
        srr[i] = arr[i];
    }
    sort(srr + 1, srr + n + 1);
    permute(1, n, k);
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}
