#include <iostream>
#include <vector>
#include <algorithm>
#include "game.h"
//#include "Lgrader.cpp"

using namespace std;
vector<int> A;
int bigInd;
int D;
vector<bool> state;

void printState(){
    for(int i=0; i<state.size(); i++){
        cout<<state[i]<<" ";
    }
    cout<<"\n";
}
void findLocals(int l, int r, bool small){
    vector<int> locals;
    if(l == r){
        //return;
    }
    for(int i=l; i<=r; i++){
        int biggest = -1;
        for(int off=-D; off<=D; off++){
            if(i+off >= l && i+off <= r){
                biggest = max(biggest, A[i+off]);
            }
        }
        if(biggest == A[i]){
            state[i] = 1;
            locals.push_back(i);
        }
    }
    ///printState();
    if(!small){
        ///sort(locals.begin(), locals.end());
        if(locals[0]-D-1 >= l){
            findLocals(l, locals[0]-D-1, false);
        }
        for(int i=0; i<locals.size()-1; i++){
            if(locals[i]+D+1 <= locals[i+1]-D-1){
                findLocals(locals[i]+D+1, locals[i+1]-D-1, false);
            }
        }
        if(locals[locals.size()-1]+D+1 <= r){
            findLocals(locals[locals.size()-1]+D+1, r, false);
        }
    }
}
void init(vector<int> v, int d){
    A = v;
    D = d;
    state.resize(A.size(), 0);
    findLocals(0, A.size()-1, false);
    ///printState();
}
bool isWinning(int startIndex){
    //printState();
    return !state[startIndex];

}
void updateValue(int index, int newValue){
    A[index] = newValue;
    state = {};
    state.resize(A.size(), 0);
    ///locals = {};
    findLocals(0, A.size()-1, false);
    ///printState();
}
/*
6 2
1 7 4 9 30 2
1
1 4 8

6 2
1 7 4 9 30 2
5
2 0
2 1


10 2
29 28 3 5 1 7 4 9 30 2
*/

