#include "game.h"
#include<bits/stdc++.h>
using namespace std;

vector<int> values;
vector<pair<int, int> > sorted;
bool winning[100001];
bool filled[100001];
int d;
bool cmp(pair<int, int> a, pair<int, int> b) {

    return a.first > b.first;
}
void init(vector<int> A, int D) {
    values = A;
    d = D;
    for(int i = 0; i < A.size(); i++) {
        sorted.push_back(make_pair(A[i], i));
    }
    sort(sorted.begin(), sorted.end(), cmp);
    for(auto x:sorted) {
        for(int i = x.second - d; i <= x.second + d; i++) {
            if(i < 0) continue;
            if(i > values.size()) break;
            if(i == x.second && !filled[i]) {
                winning[i] = false;
            } else if (!filled[i]) {
                winning[i] = true;
            }
            filled[i] = true;

        }
    }


}

void updateValue(int index, int newValue) {
    fill(filled, filled+values.size(), false);
    sorted.clear();
    values[index] = newValue;

    for(int i = 0; i < values.size(); i++) {
        sorted.push_back(make_pair(values[i], i));
    }
    sort(sorted.begin(), sorted.end(), cmp);
    for(auto x:sorted) {
        for(int i = x.second - d; i <= x.second + d; i++) {
            if(i < 0) continue;
            if(i > values.size()) break;
            if(i == x.second && !filled[i]) {
                winning[i] = false;
            } else if (!filled[i]) {
                winning[i] = true;
            }
            filled[i] = true;

        }
    }

}

bool isWinning(int pos) {

    return winning[pos];
}