#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll Size=5e5+1;

queue<ll> adj[Size];
ll base_cost[Size],first_cost[Size],location[Size];
bool visited[Size];

void dfs(ll curr_node,ll prev_node){
    visited[curr_node]=true;
    ll next_node=adj[curr_node].front();
    ll init_node=next_node;
    adj[curr_node].pop();
    adj[curr_node].push(next_node);
    while(next_node!=prev_node){
        base_cost[curr_node]+=base_cost[next_node];
        first_cost[curr_node]+=first_cost[next_node];
        next_node=adj[curr_node].front();
        adj[curr_node].pop();
        adj[curr_node].push(next_node);
    }
    next_node=adj[curr_node].front();
    adj[curr_node].pop();
    adj[curr_node].push(next_node);
    while(next_node!=init_node){
        base_cost[curr_node]+=base_cost[next_node];
        next_node=adj[curr_node].front();
        adj[curr_node].pop();
        adj[curr_node].push(next_node);
    }
    base_cost[curr_node]+=2;
    first_cost[curr_node]+=2;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n,m;
    cin>>n>>m;
    for(ll i=1;i<=n;i++){
        queue<ll> tmp;
        ll l;
        cin>>l;
        for(ll j=0;j<l;j++){
            ll to;
            cin>>to;
            tmp.push(to);
        }
        adj[i]=tmp;
    }
    dfs(1,-1);
    for(ll i=0;i<m;i++){
        cin>>location[i];
    }
    if(m==1){
        cout<<0<<endl;
    }else{
        cout<<first_cost[1]+(m-2)*base_cost[1];
    }
    return 0;
}
/*
5 3
2 2 4
2 3 1
1 2
2 1 5
1 4
*/
