#include<bits/stdc++.h>
#include "game.h"

using namespace std;

const int MAXN=2e5+5;

int n;
vector<int> a;
int d;
int tree[4*MAXN];
int win[MAXN];
int pref[MAXN];

int combine(int ind1,int ind2)
{
    if(ind1<0) return ind2;
    if(a[ind1]>a[ind2]) return ind1;
    return ind2;
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=l;
        return;
    }
    int mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node]=combine(tree[2*node],tree[2*node+1]);
}

int query(int node,int l,int r,int b,int e)
{
    if(b<=l && r<=e) return tree[node];
    int mid=(l+r)/2;
    int ret=-1;
    if(b<=mid) ret=combine(ret, query(2*node,l,mid,b,e));
    if(mid<e) ret=combine(ret, query(2*node+1,mid+1,r,b,e));
    return ret;
}

void rec(int l,int r)
{
    if(r<0) return;
    if(l>=n) return;
    if(l>r) return;

    int ind=query(1,0,n-1,l,r);
    win[ind]=1;
    rec(l,ind-d-1);
    rec(ind+d+1,r);
}

void init(std::vector<int> A, int D)
{
    a=A;
    d=D;
    n=a.size();
    build(1,0,n-1);

    rec(0,n-1);

    pref[0]=win[0];
    for(int i=1;i<n;i++) pref[i]=pref[i-1]+win[i];

    //for(int i=0;i<n;i++) cout<<win[i]<<" ";
    //cout<<endl;
}

void updateValue(int index, int newValue)
{
    return;
}

bool isWinning(int st)
{
    int l,r;
    if(st>0)
    {
        l=max(0, st-d);
        r=st-1;
        if(pref[r]-(l>0 ? pref[l-1] : 0)>0) return 1;
    }
    if(st<n-1)
    {
        l=st+1;
        r=min(n-1, st+d);
        if(pref[r]-pref[l-1]>0) return 1;
    }
    return 0;
}
