#include<bits/stdc++.h>
#include "game.h"

using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10;

int a[maxn], d, n, state[maxn];
set < pair < int, int > > values;
void init(vector < int > A, int D)
{
    n = A.size();
    d = D;
    for (int i = 0; i < n; i ++)
    {
        a[i] = A[i];
        values.insert({-a[i], i});
    }
}

void updateValue(int index, int newValue)
{
    values.erase({-a[index], index});
    a[index] = newValue;
    values.insert({-a[index], index});
}

bool isWinning(int startIndex)
{
    for (int i = 0; i < n; i ++)
    {
        state[i] = 2;
    }

    for (pair < int, int > cur : values)
    {
        int id = cur.second;
        if (state[id] == 1)
            continue;
        state[id] = 0;
        for (int j = max(0, id - d); j < min(n, id + d + 1); j ++)
        {
            if (state[j] == 2)
                state[j] = 1;
        }
    }

    return state[startIndex];
}
