#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;
const int maxa = 1e9 + 10, block = sqrt(maxa) + 10;
int n, a[maxn], k, x;
unordered_map < int, vector < int > > to;
unordered_map < int, int > cnt;

int prime[block], ps[block];
void eratosten()
{
    prime[0] = prime[1] = 1;
    for (int i = 2; i < block; i ++)
    {
        if (prime[i])
            continue;
        ps[i] = i;
        for (int j = i * 2; j < block; j += i)
            prime[j] = 1, ps[j] = i;
    }
    for (int j = 0; j < block; j ++)
    {
        prime[j] ^= 1;
    }
}

bool is_prime(int x)
{

    if (x == 1)
        return false;

    int b = sqrt(x);
    for (int i = 2; i <= b; i ++)
        if (x % i == 0)
            return false;

    return true;
}

void get_divisors(int x, int id)
{
    int b = sqrt(x);


    for (int i = 1; i <= b; i ++)
    {

        if (x % i == 0)
        {
            if (prime[i])
            {
                int j = i;
                while((x / i) % j == 0)
                {
                    to[j].push_back(id);
                    cnt[j] ++;
                    j = j * i;
                }
                to[j].push_back(id);
                cnt[j] ++;

            }


        }
    }

    int d = 2;
    while(d <= b)
    {
        while(x % d == 0)
            x /= d;
        d ++;
    }

    if (x > 1)
    {
        to[x].push_back(id);
        cnt[x] ++;
    }
}

int mst[maxn];
int used[maxn], p[maxn];

unordered_map < int, multiset < int > > tk;
void solve()
{
    to.clear();
    cnt.clear();

    cin >> n >> k >> x;
    for (int i = 1; i <= n; i ++)
    {
        cin >> a[i];
        get_divisors(a[i], i);
    }

    for (int i = 1; i <= n; i ++)
        mst[i] = 1;

    unordered_map < int, int > :: iterator it;
    for (it = cnt.begin(); it != cnt.end(); it ++)
    {
        if (it -> second >= k)
        {
            for (int i : to[it -> first])
            {

                if (it -> first > block)
                    mst[i] = it -> first * mst[i];
                else
                    mst[i] = ps[it -> first] * (mst[i]);

            }
        }
    }

    tk.clear();
    for (int i = 1; i <= n; i ++)
    {
        tk[mst[i]].insert(a[i]);
    }

    for (int i = 1; i <= n; i ++)
        used[i] = 0;
    for (int i = 1; i <= n; i ++)
    {
        p[i] = *tk[mst[i]].begin();
        tk[mst[i]].erase(tk[mst[i]].find(p[i]));

        //used[mx] = 1;
        //p[i] = a[mx];
    }

    for (int i = 1; i <= n; i ++)
        cout << p[i] << " ";
    cout << endl;
}

int main()
{
    eratosten();
    speed();
    int t;
    cin >> t;
    while(t --)
        solve();
    return 0;
}
/**
1
4 2 3
7 3 6 9
*/
