#include <iostream>
#include <algorithm>
#include <vector>
#include <assert.h>
using namespace std;
const int MAXN=5e5+10;
const long long INF=(1ll<<31)-1;
vector <int> v[MAXN], newv[MAXN], ine[MAXN], path;
int ind[MAXN], fath[MAXN], p[MAXN], n;
bool used[MAXN];
void dfs(int x, int p) {
    for (auto i:v[x]) {
        if (i==p) continue;
        fath[i]=x;
        dfs(i,x);
    }
}
void roll_vec() {
    for (auto i:v[1]) newv[1].push_back(i);
    for (int i=2;i<=n;i++) {
        int start;
        for (int j=0;j<v[i].size();j++) {
            if (v[i][j]==fath[i]) {
                start=(j+1)%v[i].size();
                break;
            }
        }
        for (int j=start;;j=(j+1)%v[i].size()) {
            newv[i].push_back(v[i][j]);
            if (v[i][j]==fath[i]) break;
        }
    }
}
void euler(int x, int p) {
    for (auto i:newv[x]) {
        if (i==p) continue;
        ine[x].push_back(path.size());
        path.push_back(x);
        euler(i,x);
    }
    if (x!=1) {
        ine[x].push_back(path.size());
        path.push_back(x);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int m, k;
    cin >> n >> m;
    for (int i=1;i<=n;i++) {
        cin >> k;
        if (n==1) break;
        v[i].resize(k);
        for (int j=0;j<k;j++) cin >> v[i][j];
        ind[i]=0;
    }
    for (int i=0;i<m;i++) cin >> p[i];
    dfs(1,-1);
    roll_vec();
    euler(1,-1);
    int curp=0;
    long long ans=0;
    int cur=1, cnt=0;
    while (true) {
        if (cur==1 && cnt==n) break;
        ans++;
        if (cur==p[curp]) curp++;
        if (curp==m) break;
        if (!used[cur]) {
            used[cur]=true;
            cnt++;
        }
        int c=cur;
        cur=v[cur][ind[cur]];
        ind[c]=(ind[c]+1)%v[c].size();
    }
    if (curp==m) {
        cout << ans << endl;
        return 0;
    }
    for (int i=2;i<=n;i++) {
        if (v[i].size()>1) assert(v[i][ind[i]]==newv[i][1]);
        //cout << i << endl;
    }
    int pos=-1;
    for (int i=curp;i<m;i++) {
        if (ine[p[i]].back()<=pos) {
            ans+=(long long)(path.size()-pos+ine[p[i]].front());
            pos=ine[p[i]].front();
        } else {
            auto j=upper_bound(ine[p[i]].begin(),ine[p[i]].end(),pos);
            ans+=(long long)((*j)-pos);
            pos=(*j);
        }
        //cout << p << ' ' << ans << ' ' << pos << ' ' << fl << endl;
    }
    cout << ans << endl;
    return 0;
}
/*
4 9
2 2 3
1 1
2 1 4
1 3
2 1 1 4 1 3 2 4 3
*/
