#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <unordered_map>
using namespace std;
const long long INF=1e18;
const int MAXNUM=1e9;
const int MAXN=1e5+10;
long long real[MAXN],a[MAXN], b[MAXN], y[MAXN], ans[MAXN];
vector <int> pr, idx[MAXN], s[MAXN];
vector <pair <long long,long long> > vec[MAXN*2];
unordered_map <long long,long long> um, um2;
bool er[MAXN];
int n, k;
void eratosten() {
    int gr=sqrt(MAXNUM)+10;
    for (int i=2;i<=gr;i++) {
        if (!er[i]) {
            pr.push_back(i);
            for (int j=i*i;j<=gr;j+=i) er[j]=true;
        }
    }
}
void find_lex() {
    int cnt=1;
    for (int i=0;i<n;i++) {
        if (um2[y[i]]==0) {
            um2[y[i]]=cnt;
            cnt++;
        }
        s[um2[y[i]]].push_back(b[i]);
        idx[um2[y[i]]].push_back(i);
    }
    for (int i=1;i<cnt;i++) {
        sort(s[i].begin(),s[i].end());
        for (int j=0;j<s[i].size();j++) {
            b[idx[i][j]]=s[i][j];
        }
        s[i].clear();
        idx[i].clear();
    }
    if (!um2.empty()) um2.clear();
}
bool cmp() {
    for (int i=0;i<n;i++) {
        if (b[i]<ans[i]) return true;
        if (b[i]>ans[i]) return false;
    }
    return false;
}
void solve(bool fl) {
    for (int i=0;i<n;i++) a[i]=real[i];
    int cnt=1;
    for (int i=0;i<n;i++) {
        b[i]=a[i];
        for (auto p:pr) {
            if (p>a[i]) break;
            if (a[i]%p!=0) continue;
            if (um[p]==0) {
                um[p]=cnt;
                cnt++;
            }
            int cur=um[p];
            vec[cur].push_back({1,i});
            while (a[i]%p==0) {
                vec[cur][vec[cur].size()-1].first*=p;
                a[i]/=p;
            }
        }
        if (a[i]>1) {
            if (um[a[i]]==0) {
                um[a[i]]=cnt;
                cnt++;
            }
            vec[um[a[i]]].push_back({a[i],i});
        }
        y[i]=1;
    }
    for (int i=1;i<cnt;i++) {
        sort(vec[i].begin(),vec[i].end());
        if (vec[i].size()>=k) {
            for (int j=0;j+k-1<vec[i].size();j++) {
                y[vec[i][j].second]*=vec[i][j].first;
            }
            for (int j=vec[i].size()-k+1;j<vec[i].size();j++) {
                y[vec[i][j].second]*=vec[i][vec[i].size()-k].first;
            }
        }
    }
    find_lex();
    if (fl && cmp()) {
        for (int i=0;i<n;i++) ans[i]=b[i];
    }
    if (!um.empty()) um.clear();
    for (int i=1;i<cnt;i++) if (!vec[i].empty()) vec[i].clear();
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, x;
    cin >> t;
    eratosten();
    for (int test=0;test<t;test++) {
        cin >> n >> k >> x;
        for (int i=0;i<n;i++) {
            cin >> real[i];
            ans[i]=INF+10;
        }
        if (x==1) {
            solve(0);
            for (int i=0;i<n;i++) ans[i]=b[i];
        }
        else {
            for (int i=0;i<n;i++) {
                real[i]*=x;
                solve(1);
                real[i]/=x;
            }
        }
        for (int i=0;i<n;i++) cout << ans[i] << ' ';
        cout << endl;
    }
}
