#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;

int n, m;

deque<int> g[maxn];

int friends[maxn];
bool visited[maxn];
int cntVisited = 0;
vector<int> tour;

vector<long long> byTime[maxn];
int val[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    for (int i = 1; i <= n; ++i)
    {
        int cnt;
        cin >> cnt;

        for (int j = 0; j < cnt; ++j)
        {
            int nb;
            cin >> nb;
            g[i].push_back(nb);
        }
    }

    for (int i = 1; i <= m; ++i)
    {
        cin >> friends[i];
    }

    int node = 1;
    int tim = 1;

    visited[node] = true;
    cntVisited = 1;

    tour.push_back(node);
    byTime[node].push_back(tim);

    int cntBeg = 0;

    while (true)
    {
        //cout << node << endl;
        int nxt = g[node].front();
        g[node].pop_front();
        g[node].push_back(nxt);

        node = nxt;

        if (node == 1)
        {
            ++cntBeg;
        }

        if (cntBeg == 7 * n)
        {
            break;
        }

        if (visited[node] == false)
        {
            ++cntVisited;
            visited[node] = true;
        }

        tour.push_back(node);
        ++tim;
        byTime[node].push_back(tim);
    }

    long long cycles = 0;
    long long ans = 0;
    long long tourSz = tour.size();

    /*for (auto x : byTime[1])
    {
        cout << x << endl;
    }
*/
    //cout << "look " << tourSz << endl;

    for (int i = 1; i <= m; ++i)
    {
        int node = friends[i];

        int pos = upper_bound(byTime[node].begin(), byTime[node].end(), ((ans % tourSz == 0 && ans > 0) ? tourSz : ans % tourSz)) - byTime[node].begin();

        if (pos == byTime[node].size())
        {
            ++cycles;
            ans = byTime[node][0] + cycles * tourSz;
        }
        else
        {
            ans = byTime[node][pos] + cycles * tourSz;
        }

        //cout << i << " :: " << cycles << " " << ans << endl;
    }

    cout << ans << endl;

    return 0;
}
/*
5 4
2 3 2
2 5 1
2 1 4
1 3
1 2
2 1 4 3

4 16
2 2 3
1 1
2 1 4
1 3
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
*/
