#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int a[maxn];
int b[maxn];

void solve()
{
    int n, k, x;
    cin >> n >> k >> x;

    for (int i = 1; i <= n; ++i)
    {
        b[i] = i;
        cin >> a[i];
    }

    do
    {
        bool good = true;

        for (int mask = 0; mask < (1 << n); ++mask)
        {
            if (__builtin_popcount(mask) == k)
            {
                int gcd1 = 0, gcd2 = 0;

                for (int i = 0; i < n; ++i)
                {
                    if ((mask & (1 << i)) != 0)
                    {
                        gcd1 = __gcd(gcd1, a[i + 1]);
                        gcd2 = __gcd(gcd2, a[b[i + 1]]);
                    }
                }

                if (gcd1 != gcd2)
                {
                    good = false;
                    break;
                }
            }
        }

        if (good == false) continue;

        bool ok = false;

        for (int i = 1; i <= n; ++i)
        {
            if (b[i] != i)
            {
                ok = true;
                break;
            }
        }

        if (!ok) continue;

        for (int i = 1; i <= n; ++i)
        {
            cout << a[b[i]] << ' ';
        }

        cout << "\n";
        return;
    } while (next_permutation(b + 1, b + n + 1));
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int q;
    cin >> q;

    while (q--)
    {
        solve();
    }

    return 0;
}
