/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, m;
int a[MAXN];
int ptr[MAXN];
int nodes[MAXN];
std::vector <int> tour;
std::vector <int> g[MAXN];
std::set <int> goodNodes;
int cntZeroes;

void solve()
{   
    int node = 1;
    cntZeroes = n;
    while (true)
    {
        tour.push_back(node);
        int next = g[node][ptr[node]];
        if (ptr[node] == 0) cntZeroes--;
        ptr[node]++;
        if (ptr[node] == g[node].size()) ptr[node] = 0;
        if (ptr[node] == 0) cntZeroes++;
        node = next;
        
        if (cntZeroes == n)
        {
            if (goodNodes.count(node))
            {
                break;
            }
            
            goodNodes.insert(node);
        }
    }

    std::cout << tour.size() << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 1 ; i <= n ; ++i)
    {
        int sz;
        std::cin >> sz;
        g[i].resize(sz);

        for (int j = 0 ; j < sz ; ++j)
        {
            std::cin >> g[i][j];
        }
    }

    for (int i = 1 ; i <= m ; ++i)
    {
        std::cin >> nodes[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}