/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include "game.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <cassert>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, d;
int a[MAXN];
int perm[MAXN];
bool win[MAXN];

void init(std::vector <int> A, int D)
{
    n = A.size();
    d = D;

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
    }

    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return a[x] > a[y];
    });

    for (int i = 1 ; i <= n ; ++i)
    {
        int index = perm[i];
        if (!win[index])
        {
            for (int j = std::max(1, index - d) ; j <= std::min(n, index + d) ; ++j)
            {
                win[j] = true;
            }

            win[index] = false;
        }
    }
}

bool isWinning(int index)
{
    return win[index + 1];
}

void updateValue(int index, int value)
{
    index++;
    a[index] = value;

    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return a[x] > a[y];
    });

    std::fill(win + 1, win + 1 + n, false);
    for (int i = 1 ; i <= n ; ++i)
    {
        int index = perm[i];
        if (!win[index])
        {
            for (int j = std::max(1, index - d) ; j <= std::min(n, index + d) ; ++j)
            {
                win[j] = true;
            }
        }

        win[index] = false;
    }
}
