/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, k, x;
int a[MAXN];
int b[MAXN];
int perm[MAXN];
int newB[MAXN];
int valsPtr[MAXN];
std::vector <int> divs[MAXN];
std::vector <int> vals[MAXN];
std::unordered_map <int,int> cnt;
std::unordered_map <int,int> beenThere;

void reset()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        vals[i].clear();
        divs[i].clear();
        valsPtr[i] = 0;
    }
}

void solve()
{
    cnt.clear();
    beenThere.clear();
    for (int i = 1 ; i <= n ; ++i)
    {
        if (beenThere[a[i]])
        {
            divs[i] = divs[beenThere[a[i]]];
            for (const int &val : divs[i])
            {
                cnt[val]++;
            }

            continue;
        }

        beenThere[a[i]] = i;
        for (int j = 1 ; j * j <= a[i] ; ++j)
        {
            if (a[i] % j == 0)
            {
                cnt[j]++;
                divs[i].push_back(j);
                if (a[i] / j != j) 
                {
                    divs[i].push_back(a[i] / j);
                    cnt[a[i] / j]++;
                }
            }
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        int lcm = 1;
        for (const int &d : divs[i])
        {
            if (cnt[d] >= k) lcm = std::lcm(lcm, d);
        }

        b[i] = lcm;
    }

    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](int x, int y)
    {
        return b[x] < b[y];
    });

    int cnt = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (b[perm[i]] != b[perm[i - 1]]) cnt++;
        newB[perm[i]] = cnt;  
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        b[i] = newB[i];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        vals[b[i]].push_back(a[i]);
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::sort(vals[i].begin(), vals[i].end());
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = vals[b[i]][valsPtr[b[i]]++];
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        std::cout << a[i] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n >> k >> x;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int tests;
int main()
{
    fastIOI();
    std::cin >> tests;
    while (tests--)
    {
        reset();
        input();
        solve();
    }

    return 0;
}