/*
    Vuv tebe vsichko mamka mu e top top top
    Habibi e top top
    Krakata ti top top
    Ochite ti top top
    Kosite ti top top
    Ustata ti top top
*/

#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <queue>
#include <stack>
#include <chrono>
#include <random>
#include <set>
#include <map>

typedef long long llong;
const llong MAXN = 100000 + 10;
const llong INF  = 1e9;

llong n, k, x;
llong a[MAXN];
llong b[MAXN];
llong perm[MAXN];
llong newB[MAXN];
llong valsPtr[MAXN];
std::vector <llong> vals[MAXN];
std::vector <llong> divs[MAXN];
std::unordered_map <llong,llong> cnt;

void bigReset()
{
    for (llong i = 1 ; i <= n ; ++i)
    {
        divs[i].clear();
    }
}

void reset()
{
    for (llong i = 1 ; i <= n ; ++i)
    {
        vals[i].clear();
        valsPtr[i] = 0;
    }
}

void precalc()
{
    cnt.clear();
    for (llong i = 1 ; i <= n ; ++i)
    {
        for (llong j = 1 ; j * j <= a[i] ; ++j)
        {
            if (a[i] % j == 0)
            {
                cnt[j]++;
                divs[i].push_back(j);
                if (a[i] / j != j) 
                {
                    divs[i].push_back(a[i] / j);
                    cnt[a[i] / j]++;
                }
            }
        }
    }
}

std::vector <llong> solve()
{
    for (llong i = 1 ; i <= n ; ++i)
    {
        llong lcm = 1;
        for (const llong &d : divs[i])
        {
            if (cnt[d] >= k) lcm = std::lcm(lcm, d);
        }

        b[i] = lcm;
    }

    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](llong x, llong y)
    {
        return b[x] < b[y];
    });

    llong cnt = 0;
    for (llong i = 1 ; i <= n ; ++i)
    {
        if (b[perm[i]] != b[perm[i - 1]]) cnt++;
        newB[perm[i]] = cnt;  
    }

    for (llong i = 1 ; i <= n ; ++i)
    {
        b[i] = newB[i];
    }

    for (llong i = 1 ; i <= n ; ++i)
    {
        vals[b[i]].push_back(a[i]);
    }

    for (llong i = 1 ; i <= n ; ++i)
    {
        std::sort(vals[i].begin(), vals[i].end());
    }

    std::vector <llong> solution;
    for (llong i = 1 ; i <= n ; ++i)
    {
        solution.push_back(vals[b[i]][valsPtr[b[i]]++]);
    }

    return solution;
}

void input()
{
    std::cin >> n >> k >> x;
    for (llong i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

llong tests;
signed main()
{
    fastIOI();
    std::cin >> tests;
    while (tests--)
    {
        bigReset();
        reset();
        input();
        precalc();

        std::vector <llong> min = solve();
        if (x != 1)
        {
            for (llong i = 1 ; i <= n ; ++i)
            {
                reset();
                a[i] *= x;
                std::vector <llong> newDivs;
                std::vector <llong> oldDivs = divs[i];
                for (const llong &d : divs[i])
                {
                    newDivs.push_back(d);
                    newDivs.push_back(d * x);
                }

                divs[i] = newDivs;
                std::vector <llong> curr = solve();
                a[i] /= x;

                for (llong j = 0 ; j < n ; ++j)
                {
                    if (min[j] != curr[j])
                    {
                        if (min[j] > curr[j]) min = curr;
                        break;
                    }
                }

                divs[i] = oldDivs;
            }
        }

        for (const llong &val : min)
        {
            std::cout << val << ' ';
        }

        std::cout << '\n';
    }

    return 0;
}