#include "game.h"
#include <vector>
#include <iostream>
#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0;}

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define endl "\n"
#define out(x) #x << " = " << x << "  "

typedef long long ll;
typedef long double ld;

const int mod = 1e9 + 7;
const int MAX_N = 1e5 + 42;


ll c[MAX_N][1024];
int cnt = 1022;

std::vector< int > A;

int n;
int D;

void init(std::vector<int> B, int _D){
	D = _D;

	A = B;
	n = (int)A.size();

	for( int i=0 ; i < n ; i++ ) c[i][0] = A[i];

	for( int d = 1 ; d < cnt ; d++ ){
		for( int i=0 ; i < n ; i++ ){
			int currMax = -mod;
			//cerr << out( i ) << out( d ) << endl;
			for( int j=std::max( 0, i - D ) ; j <= std::min( n-1, i + D ) ; j++ ){
				if( i == j ) continue;
				chkmax( currMax, c[j][d-1] );
				//cerr << out( c[j][d-1] ) << out( currMax ) << endl;
				
			}
			//cerr << out( currMax ) << endl;
			c[i][d] = A[i] - currMax;
			if( c[i][d] > 0 ) chkmin( c[i][d], mod );
			else chkmax( c[i][d], -mod );
		}
	}

	/*
	for( int j=0 ; j < n ; j++ ){
		for( int i=cnt - 15 ; i < cnt ; i+= 1 ){
			cerr << setw( 4 ) << c[j][i] << " ";
		}
		cerr << endl;
	}
	*/
}

bool isWinning(int startIndex){
	cerr << out( c[startIndex][cnt-1]  ) << endl;
	if( c[startIndex][cnt-1] < 0 ) return true;
	cerr << "anansko" << endl;
	return false;
}

void updateValue(int index, int newValue){

	A[index] = newValue;
	for( int i=0 ; i < n ; i++ ) c[i][0] = A[i];

	for( int d = 1 ; d < cnt ; d++ ){
		for( int i=0 ; i < n ; i++ ){
			int currMax = -mod;
			//cerr << out( i ) << out( d ) << endl;
			for( int j=std::max( 0, i - D ) ; j <= std::min( n-1, i + D ) ; j++ ){
				if( i == j ) continue;
				chkmax( currMax, c[j][d-1] );
				//cerr << out( c[j][d-1] ) << out( currMax ) << endl;
				
			}
			//cerr << out( currMax ) << endl;
			c[i][d] = A[i] - currMax;
			if( c[i][d] > 0 ) chkmin( c[i][d], mod );
			else chkmax( c[i][d], -mod );
		}
	}
}
