#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0;}

#ifndef LOCAL
#define cerr if(false) cerr
#endif

#define endl "\n"
#define out(x) #x << " = " << x << "  "

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e5 + 42;
bool prime[MAX_N];

ll fastPow( ll base, int step ){
	ll nas = 1;
	ll curr = base;
	while( step ){
		if( step & 1 ) nas *= curr;
		curr *= curr;
		step >>= 1;
	}

	return nas;
}

std::vector< int > primes;
int a[MAX_N];
int b[MAX_N];

int main (){
#ifndef LOCAL
	std::ios_base::sync_with_stdio( false ); std::cin.tie( NULL ); std::cout.tie( NULL );
#endif

	for( int i=2 ; i < MAX_N ; i++ ){
		if( prime[i] ) continue;
		primes.push_back( i );
		for( ll j=i + i ; j < MAX_N ; j += i ) prime[j] = true;
	}

	int n, k, x;
	std::cin >> n >> k >> x;

	for( int i=0 ; i < n ; i++ ){
	       	std::cin >> a[i];
		b[i] = a[i];
	}

	for( auto j : primes ){
		std::vector< int > cnt( 32 );
		for( auto& j : cnt ) j = 0;

		for( int i=0 ; i < n ; i++ ){
			int currCnt = 0;
			int curr = a[i];
			while( curr % j == 0 ){
				currCnt++;
				curr /= j;
			}

			cnt[currCnt] ++;
		}

		int mxStep = 0;
		for( int j=0 ; j < cnt.size() ; j++ ){
			if( cnt[j] >= k ) mxStep = j;
		}

		for( int i=0 ; i < n ; i++ ){
			int currCnt = 0;
			while( b[i] % j == 0 ){
				currCnt++;
				b[i] /= j;
			}
			b[i] *= fastPow( j, std::min( mxStep, currCnt ) );
			cerr << b[i] << " ";

		}
		cerr << endl;
	}

	std::vector< int > nas( n );
	std::iota( nas.begin(), nas.end(), 0 );
	std::sort( nas.begin(), nas.end(), []( int A, int B ){
			if( b[A] == b[B] ) return a[A] < a[B];
			return false;
			});

	for( int i=0 ; i < n ; i++ ) std::cout << a[nas[i]] << " ";
	std::cout << endl;


	return 0;
}
// GYATT level 5 