#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

int n,m,t[MAXN],pt,days,ans,k,a;
bool active[MAXN];
vector<int> v[MAXN];
vector<int> act[MAXN],normal[MAXN];
vector<int> level[MAXN];
int parent[MAXN];

void dfs(int x,int p,int dep){
    level[dep].push_back(x);
    parent[x]=p;

    bool par=false;
    for(int i=0;i<v[x].size();i++){
        if(v[x][i]==p){
            par=true; continue;
        }

        if(!par){
            dfs(v[x][i],x,dep);
            normal[x].push_back(v[x][i]);
        }else{
            dfs(v[x][i],x,dep+1);
            act[x].push_back(v[x][i]);
        }
    }
}

int lastx;

void add(int x){
    if(x==1 and lastx==1)return;

    lastx=x;
    days++;
    if(x==t[pt]){
        pt++;
        if(pt==m+1)ans=days;
    }
}

int tim;

void path(int x){
    add(x);

    if(active[x]){
        for(int i:act[x]){
            path(i);
            add(x);
        }
    }

    for(int i:normal[x]){
        path(i);
        add(x);
    }

    active[x]=true;
}

int ptr,last,fr[MAXN],curr;
vector<int> euler,poss[MAXN];
int update[MAXN];

void construct(int x){
    euler.push_back(x);
    ptr++; fr[x]=ptr-1;
    poss[x].push_back(ptr-1);

    if(active[x]){
        for(int i:act[x]){
            construct(i);

            euler.push_back(x);
            ptr++;
            poss[x].push_back(ptr-1);
        }
    }

    for(int i:normal[x]){
        construct(i);

        euler.push_back(x);
        ptr++;
        poss[x].push_back(ptr-1);
    }
}

int main(){

   // ios_base::sync_with_stdio(0);
  // cin.tie(0);
   // cout.tie(0);

    cin>>n>>m;
    for(int i=1;i<=n;i++){
        cin>>k;
        for(int f=1;f<=k;f++){
            cin>>a;
            v[i].push_back(a);
        }
    }

    dfs(1,0,1);
    construct(1);
    euler.pop_back();

    for(int i=1;i<=m;i++){
        cin>>t[i];
    }

    curr=0; tim=1; pt=1;
    last=1;

    while(pt<=m){

        if(fr[euler[curr]]==curr and update[euler[curr]]>last){
            path(euler[curr]);
        }else{
            add(euler[curr]);
        }

        curr++;
        if(curr==euler.size()){
            curr=0;
            tim++;
            for(int i:level[tim]){
                active[parent[i]]=true;
                update[parent[i]]=tim;
            }
        }
    }

    cout<<ans<<"\n";

    return 0;
}
