#include<bits/stdc++.h>
#define MAXN 2007
using namespace std;

const long long inf=1e15;

int n,s;

long long dp[MAXN][2];
long long a[MAXN];

deque< pair<long long, int >  > l,r;
int ptl,ptr;

void calcdp(){
    for(int pos=0;pos<n;pos++)dp[pos][0]=0;

    for(int steps=1;steps<=10*n;steps++){

        while(!l.empty())l.pop_back();
        while(!r.empty())r.pop_back();
        ptl=0; ptr=1;

        for(int pos=0;pos<n;pos++){

            while(ptl<pos){
                if(steps%2==0){
                    while(!l.empty() and dp[ptl][1-steps%2]+a[ptl]>=l.back().first){
                        l.pop_back();
                    }
                    l.push_back({dp[ptl][1-steps%2]+a[ptl],ptl});
                }else{
                    while(!l.empty() and dp[ptl][1-steps%2]-a[ptl]<=l.back().first){
                        l.pop_back();
                    }
                    l.push_back({dp[ptl][1-steps%2]-a[ptl],ptl});
                }
                ptl++;
            }

            while(ptr<=min(pos+s,n-1)){
                if(steps%2==0){
                    while(!r.empty() and dp[ptr][1-steps%2]+a[ptr]>=r.back().first){
                        r.pop_back();
                    }
                    r.push_back({dp[ptr][1-steps%2]+a[ptr],ptr});
                }else{
                    while(!r.empty() and dp[ptr][1-steps%2]-a[ptr]<=r.back().first){
                        r.pop_back();
                    }
                    r.push_back({dp[ptr][1-steps%2]-a[ptr],ptr});
                }
                ptr++;
            }

            while(!l.empty() and l.front().second<pos-s)l.pop_front();
            if(!r.empty() and r.front().second==pos)r.pop_front();

            if(steps%2==0){
                if(r.empty())dp[pos][steps%2]=l.front().first;
                else if(l.empty())dp[pos][steps%2]=r.front().first;
                else dp[pos][steps%2]=max(l.front().first,r.front().first);
            }else{
                if(r.empty())dp[pos][steps%2]=l.front().first;
                else if(l.empty())dp[pos][steps%2]=r.front().first;
                else dp[pos][steps%2]=min(l.front().first,r.front().first);
            }
        }
    }
}

void init(vector<int> A, int D){
    n=int(A.size());
    s=D;

    for(int i=1;i<=n;i++){
        a[i-1]=A[i-1];
    }

    calcdp();
}

void updateValue(int index, int newValue){
    a[index]=newValue;
    calcdp();
}

bool isWinning(int startIndex){
    if(dp[startIndex][0]>=0)return true;
    else return false;
}

/*
int main(){
    init({1, 7, 4, 9, 30, 2}, 2);

    cout<<isWinning(0) << " "<<isWinning(1)<<"\n";
    updateValue(4, 8);
        cout<<isWinning(0) << " "<<isWinning(1)<<"\n";

}

*/
