#include "game.h"
#include <vector>
#include <iostream>
std::pair<int,int> tree[8000000+2];
int nums[200000+2],n,d,lastqueryind;
void build(int l, int r, int node)
{
    if(l>r)
    {
        return;
    }
    if(l==r)
    {
        tree[node].first=nums[l];
        tree[node].second=l;
         //std::cout<<"\n"<<node<<" "<<tree[node].first<<"\n";
        return;
    }
    int mid=(l+r)/2;
    build(l,mid,node*2);
    build(mid+1,r,node*2+1);
    tree[node]=std::max(tree[node*2],tree[node*2+1]);
}
std::pair<int,int> query(int ql,int qr,int l, int r,int node)
{
     //std::cout<<l<<" "<<r<<" "<<tree[node].first<<" "<<node<<"\n";
    if(ql==l && qr==r)
    {
//std::cout<<tree[node].first<<"<\n";
        return tree[node];
    }
    if(ql>qr or r<l or ql>r or qr<l)
    {
        return {-10000000,-1};
    }
    int mid=(r+l)/2;
    return std::max(query(ql, std::min(qr,mid),l,mid,node*2),query(std::max(ql,mid+1),qr,mid+1,r,node*2+1));
}
void pointupdate(int node,int ind, int l,int r,int val)
{
    int mid=(l+r)/2;
    if(l>r){return;}
//std::cout<<l<<" "<<r<<" "<<node<<"\n";
    if(l==ind && r==l)
    {
        //std::cout<<"\n"<<node<<" "<<val<<"\n";
        tree[node].first=val;
        tree[node].second=ind;
        nums[l]=val;
        return;
    }
    if(ind>=l && ind<=mid)
    {
        pointupdate(node*2,ind,l,mid,val);
        tree[node]=std::max(tree[node*2+1],tree[node*2]);
    }
    else if(ind<=r && ind>=mid+1)
    {
        pointupdate(node*2+1,ind,mid+1,r,val);
        tree[node]=std::max(tree[node*2],tree[node*2+1]);
    }
}
void updateValue(int index,int newValue)
{
    //index++;
    pointupdate(1,index+1,1,n,newValue);
    nums[index+1]=newValue;
//    for(int a=0;a<25;a++){
//        std::cout<<tree[a].first<<" "<<tree[a].second<<" ";
//    }std::cout<<"\n";
//        for(int a=0;a<=6;a++){
//        std::cout<<nums[a]<<" ";
//    }
}
bool f=true;
bool isWinning(int startIndex)
{

    //std::cout<<startIndex<<"\n";
    std::pair<int,int> q=query(std::max(1,startIndex+1-d),std::min(n,startIndex+1+d),1,n,1);
  //  std::cout<<q.first<<" "<<q.second<<" "<<startIndex<<"\n";
    // return true;
    if(nums[startIndex+1]==q.first)
    {
        return false;
    }
    else
    {
        bool h=!isWinning(q.second-1);
        f=true;
        return h;
    }
}
void init(std::vector<int> nums1, int D)
{
    for(int a=1; a<=nums1.size(); a++)
    {
        nums[a]=nums1[a-1];
        //std::cout<<nums[a]<<" ";
    }
    n=nums1.size();
//for(int a=0;a<n;a++){
//    std::cout<<nums[a]<<" ";
//}
//std::cout<<"\n";
    build(1,n,1);
    d=D;
}
