#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
typedef long long ll;
using namespace std;
const int N = 1e5 + 10;
vector <vector<int>> G;
int uxx[N];
int cur_ans;
void dfs(int v, int b) {
	if (v == b && cur_ans > 0) return;
	cur_ans++;
	int k = G[v][uxx[v]];
	uxx[v] = (uxx[v] + 1) % (int)G[v].size();
	dfs(k, b);
}
int f(int a, int b) {
	cur_ans = 0;
	dfs(a, b);
	return cur_ans;
}
int main() {
	int n, m;
	cin >> n >> m;
	G.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		int k;
		cin >> k;
		while (k--) {
			int x;
			cin >> x;
			G[i].push_back(x);
		}
		uxx[i] = 0;
	}
	int prevv = 1;
	ll ans = 1;
	for (int i = 1; i <= m; i++) {
		int a;
		cin >> a;
		ans = ans + 1ll * f(prevv, a);
		prevv = a;
	}
	cout << ans << "\n";
}