#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <queue>
#include <assert.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pi;
typedef vector<int> vi;

const int N = 500005;
int a[N];
vi g[N];
int ind[N];
int han = 0;
int o = 0;
int n, m;

void dfs(int v) {
	++o;
	if (v == a[han + 1]) {
		++han;
		if (han == m) return;
	}
	//cout << v << ' ' << han << ' ' << ind[v] << ' ' << g[v][ind[v]] << "\n";
	int prev = ind[v];
	ind[v] = (prev + 1) % g[v].size();
	dfs(g[v][prev]);
}

void solve() {
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		int qan;
		cin >> qan;
		for (int j = 1; j <= qan; ++j) {
			int x;
			cin >> x;
			g[i].push_back(x);
		}
	}
	for (int i = 1; i <= m; ++i) {
		cin >> a[i];
	}
	dfs(1);
	cout << o << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}