#include "bits/stdc++.h"
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 5e5 + 7;
ll n, m, k;
vector<int>g[N];
vector<int>vals;
vector<vector<int>>p,hert;
vector<int>sz;
int par[N];
int poshert[N];
int comp[N];
bool elrakchi[N];
int raklevel[N];

void find_par(int v, int pr){
    par[v]=pr;
    for(int to:g[v]){
        if(to!=pr){
            find_par(to,v);
        }
    }
}

void fillhert(int ii, int v){
    hert[ii].push_back(v);
    poshert[v]=hert[ii].size()-1;
    int parind = 0;
    for(int i=0;i<g[v].size();i++){
        if(par[v]==g[v][i]){
            parind=i;
            break;
        }
    }
    for(int i=parind+1;i<g[v].size();i++){
        fillhert(ii,g[v][i]);
    }
    for(int i=0;i<parind;i++){
        fillhert(ii,g[v][i]);
    }
}

void fillraklevel(int i){
    int cur=1;
    while(true){
        if(p[i].size()==0)return;
        vector<int>nxtp;
        for(int ii=0;ii<p[i].size();ii++){
            int v=p[i][ii];
            raklevel[v] = cur;
            bool hand = false;
            for(int to:g[v]){
                if(to==par[v]){
                    hand = true;
                }
                else if(hand){
                    nxtp.push_back(to);
                }
                else {
                    p[i].push_back(to);
                }
            }
        }
        p[i]=nxtp;
        cur++;
    }
}

int iter(int i){
    if(p[i].size()==0)return sz[i];
    vector<int>nxtp;
    for(int ii=0;ii<p[i].size();ii++){
        int v=p[i][ii];
        elrakchi[v]=true;
        sz[i]+=2;
        bool hand = false;
        for(int to:g[v]){
            if(to==par[v]){
                hand = true;
            }
            else if(hand){
                nxtp.push_back(to);
            }
            else {
                p[i].push_back(to);
            }
        }
    }
    p[i]=nxtp;
    return sz[i];
}

int voronir(int i, int v){
    int cnt=0;
    for(int ii=0;ii<hert[i].size();ii++){
        if(elrakchi[hert[i][ii]]){
            cnt++;
        }
        if(hert[i][ii]==v){
            return cnt;
        }
    }
    return cnt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++){
        int len;
        cin>>len;
        for(int j=0;j<len;j++){
            int u;
            cin>>u;
            g[i].push_back(u);
        }
    }
    for(int i=0;i<m;i++){
        int x;
        cin>>x;
        vals.push_back(x);
    }
    reverse(vals.begin(),vals.end());
    find_par(1,1);
    for(int v:g[1]){
        hert.push_back(vector<int>());
        fillhert(hert.size()-1,v);
        p.push_back(vector<int>());
        p.back().push_back(v);
        fillraklevel(p.size()-1);
        p.back().clear();
        p.back().push_back(v);
        sz.push_back(0);
    }
    ll ans=1;
    int i=0;
    while(m>0){
        m--;
        int v=vals.back();
        if(vals.size()==1){
            if(!elrakchi[v]){
                int lst=0;
                while(!elrakchi[v]){
                    lst=iter(i);
                    ans+=lst;
                    i++;
                    if(i==g[1].size()){
                        i=0;
                    }
                }
                ans-=lst;
                i--;
                if(i<0)i+=g[1].size();
                ans+=voronir(i,v);
                cout<<ans<<endl;
                return 0;
            }
            while(i!=comp[v]){
                ans+=iter(i);
                i++;
                if(i==g[1].size()){
                    i=0;
                }
            }
            ans+=voronir(i,v);
            cout<<ans<<endl;
            return 0;
        }
        int u=vals[vals.size()-2];
        if(comp[v]==comp[u]){
            if((elrakchi[v]&&elrakchi[u]&&poshert[v]<poshert[u])
            ||(raklevel[v]==raklevel[u]&&poshert[v]<poshert[u])){
                vals.pop_back();
                continue;
            }
        }
        if(!elrakchi[v]){
            while(!elrakchi[vals.back()]){
                ans+=iter(i);
                i++;
                if(i==g[1].size()){
                    i=0;
                }
            }
        }
        else{
            while(i!=comp[v]){
                ans+=iter(i);
                i++;
                if(i==g[1].size()){
                    i=0;
                }
            }
            ans+=iter(i);
            i++;
            if(i==g[1].size()){
                i=0;
            }
        }
        vals.pop_back();
    }
    cout<<ans<<endl;
}
