#include "game.h"
#include <vector>
#include <iostream>
#include <map>
using namespace std;

const int N = 200010;
int win[N];
int ynd, n;

int s[N * 4];
vector<int> a;

void build(int p, int lp, int rp)
{
	if (lp == rp)
	{
		s[p] = a[lp];
		return;
	}
	int m = (lp + rp) / 2;
	build(p * 2, lp, m);
	build(p * 2 + 1, m + 1, rp);
	s[p] = max(s[p * 2], s[p * 2 + 1]);
}

int get_max(int p, int lp, int rp, int l, int r)
{
	if (l > r)
		return 0;
	if (lp == l && rp == r)
		return s[p];
	int m = (lp + rp) / 2;
	return max(get_max(p * 2, lp, m, l, min(r, m)), get_max(p * 2 + 1, m + 1, rp, max(m + 1, l), r));
}

void update(int p, int lp, int rp, int ind)
{
	if (lp == rp)
	{
		s[p] = 0;
		return;
	}
	int m = (lp + rp) / 2;
	if (ind <= m)
		update(p * 2, lp, m, ind);
	else
		update(p * 2 + 1, m + 1, rp, ind);
	s[p] = max(s[p * 2], s[p * 2 + 1]);
}

map<int, int> ma;
int d;

void init(vector<int> hmmm, int dkop)
{
	d = dkop;
	a = hmmm;
	n = a.size();
	ynd = d;
}

void updateValue(int index, int newValue)
{
	a[index] = newValue;
}

bool isWinning(int startIndex)
{
	ma.clear();
	for (int i = 0; i < a.size(); i++)
	{
		ma[a[i]] = i;
	}
	int i, j;
	build(1, 0, n - 1);
	for (int h = 0; h < a.size(); h++)
	{
		int gt = get_max(1, 0, n - 1, 0, n - 1);
		if (gt == 0)break;
		gt = ma[gt];
		win[gt] = 1;
		for (j = -d; j <= d; j++)
		{
			if (j + gt < 0 || j + gt >= n)continue;
			update(1, 0, n - 1, j + gt);
		}
	}
	int st = 0;
	for (int j = -ynd; j <= ynd; j++)
	{
		if (startIndex + j < 0 || startIndex + j >= n || j == 0)continue;
		st = max(st, win[j + startIndex]);
	}
	return st;
}