#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include "game.h"
using namespace std;
using ll = long long;
#define vi vector<int>
#define vll vector<ll>
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ff first
#define ss second
#define pub push_back
#define all(x) (x).begin(), (x).end()

const int N = 200005, MAX = 1000000007;
int type[N], used[N][2];
bool ret[N][2];
vi a;
int n, d, l, r;

void init(std::vector<int> A, int D) {
	n = A.size(), d = D;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		a[i] = A[i];
	}
	for (int i = 0; i < n; ++i) {
		type[i] = 1;
		for (int j = max(i - d, 0); j <= min(i + d, n - 1); ++j) {
			if (j == i) continue;
			if (a[j] > a[i]) type[i] = 0;
		}
	}
}

void updateValue(int index, int newValue) {
	a[index] = newValue;
	init(a, d);
}

bool rec(int ind, int turn) {
	if (used[ind][turn]) return ret[ind][turn];
	used[ind][turn] = 1;
	if (turn == 0) {
		ret[ind][turn] = false;
		for (int i = max(ind - d, 0); i <= min(n - 1, ind + d); ++i) {
			if (i == ind || a[i] < a[ind]) continue;
			if (rec(i, turn ^ 1)) {
				ret[ind][turn] = true;
				break;
			}
		}
		return ret[ind][turn];
	}
	ret[ind][turn] = true;
	for (int i = max(ind - d, 0); i <= min(n - 1, ind + d); ++i) {
		if (i == ind || a[i] < a[ind]) continue;
		if (!rec(i, turn ^ 1)) {
			ret[ind][turn] = false;
			break;
		}
	}
	return ret[ind][turn];
}

bool isWinning(int startIndex) {
	int ind = startIndex;
	if (type[ind]) return true;
	l = r = ind;
	for (int i = ind; i < n; ++i) {
		if (type[i]) {
			l = i;
			break;
		}
	}
	for (int i = ind; i >= 0; --i) {
		if (type[i]) {
			r = i;
			break;
		}
	}
	for (int i = 0; i < n; ++i) {
		used[i][0] = used[i][1] = 0;
		ret[i][0] = ret[i][1] = true;
	}
	if (rec(ind, 0)) return true;
	return false;
}