#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <string>
#include <numeric>
#include <limits>
#include <climits>
using namespace std;

typedef long long ll;

#define pb push_back
#define all(v) (v).begin(), (v).end()
#define mkp make_pair

const int INF = INT_MAX;
const long long LNF = LLONG_MAX;

const int N = 1003;
int x[N], k[N][N], p[N];
int n, m, ind, ans;

vector<int> g[N];

void dfs(int v)
{
	ans++;
	if (p[ind] == v) {
		ind++;
		if (ind > n) return;
	}
	
	int u = g[v][0];
	g[v].erase(g[v].begin());
	g[v].push_back(u);

	dfs(u);
	return;
}

void solve()
{
	int i, j;

	cin >> n >> m;
	for (i = 1; i <= n; i++) {
		cin >> x[i];
		for (j = 1; j <= x[i]; j++) {
			cin >> k[i][j];
			g[i].pb(k[i][j]);
		}
	}

	for (i = 1; i <= m; i++) {
		cin >> p[i];
	}

	ans = 0LL;
	ind = 1;
	dfs(1);

	cout << ans << "\n";
	return;
}

int main()
{
	int mt = 1;
	//cin >> mt;
	while (mt--) {
		solve();
	}
	return 0;
}