#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <assert.h>
#include <stack>
#include <bitset>
using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define pb push_back
#define sz(x) (int((x).size()))
#define clr(x) (x).clear()
#define all(x) (x).begin(), (x).end()

// -------------------------------------------------------------- //

const int N = 500005, M = 500005;
int a[M];
vector<int> g[N];
int n, m;

ll dfs(int u, int p, int x)
{
	//cout << u << ' ' << x << ".\n";

	int i, j;
	int v;

	if (sz(g[u]) == 1 && u != 1) return x;

	for (i = 0; i < sz(g[u]); i++) if (g[u][i] == p) break;

	int ind = i;

	if (ind == sz(g[u])) {
		//cout << u << ' ' << p << "\n";
		assert(false);
	}

	ll ans = 0;

	for (i = 0; i < sz(g[u]); i++) {
		v = g[u][i];

		if (i < ind) ans += dfs(v, u, x) + x;
		else if (i == ind) ans += x;
		else {
			if (x > 1) ans += dfs(v, u, x - 1) + x - 1;
		}
	}

	return ans;
}

void solve()
{
	int i, j;
	int k;

	cin >> n >> m;

	for (i = 1; i <= n; i++) {
		cin >> k;

		g[i].resize(k);

		for (j = 0; j < k; j++) cin >> g[i][j];
	}

	for (i = 1; i <= m; i++) cin >> a[i];


	ll ans = m;

	int e = (m - 1) % sz(g[1]);

	for (i = 0; i < sz(g[1]); i++) {
		if (i < e) ans += dfs(g[1][i], 1, (m - 1) / sz(g[1]) + 1);
		else ans += dfs(g[1][i], 1, (m - 1) / sz(g[1]));
	}

	cout << ans << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}
