#include <iostream>
#include <iomanip>
#include <algorithm>
#include <string>
#include <cstring>
#include <cmath>
#include <math.h>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <assert.h>
#include <stack>
#include <bitset>
using namespace std;

typedef long long ll;

#define ff first
#define ss second
#define pr pair
#define mpr make_pair
#define pb push_back
#define sz(x) (int((x).size()))
#define clr(x) (x).clear()
#define all(x) (x).begin(), (x).end()

// -------------------------------------------------------------- //

const int N = 500005, M = 500005;
int a[M];
vector<int> g[N], g0[N];
int n, m;

ll dfs(int u, int p, int x)
{
	//cout << u << ' ' << x << ".\n";

	int i, j;
	int v;

	if (sz(g[u]) == 1 && u != 1) return x;

	for (i = 0; i < sz(g[u]); i++) if (g[u][i] == p) break;

	int ind = i;

	if (ind == sz(g[u])) {
		//cout << u << ' ' << p << "\n";
		assert(false);
	}

	ll ans = 0;

	for (i = 0; i < sz(g[u]); i++) {
		v = g[u][i];

		if (i < ind) ans += dfs(v, u, x) + x;
		else if (i == ind) ans += x;
		else {
			if (x > 1) ans += dfs(v, u, x - 1) + x - 1;
		}
	}

	return ans;
}

int ind[N];

vector<int> op;

ll solve1(int in, int m)
{
	int i, j;
	int k;

	ll ans = 0;

	int u = 1, v;

	while(1) {
		if (u == in) break;

		ans++;
		v = g[u][ind[u]];
		ind[u] = (ind[u] + 1) % sz(g[u]);

		u = v;
	}

	for (i = 1; i <= n; i++) {
		clr(op);
		for (j = ind[i]; j < sz(g[i]); j++) op.pb(g[i][j]);
		for (j = 0; j < ind[i]; j++) op.pb(g[i][j]);

		g[i] = op;
	}

	ans += m;

	int e = (m - 1) % sz(g[in]);

	for (i = 0; i < sz(g[in]); i++) {
		if (i < e) ans += dfs(g[in][i], in, (m - 1) / sz(g[in]) + 1);
		else ans += dfs(g[in][i], in, (m - 1) / sz(g[in]));
	}

	return ans;
}

int cnt[N];

void solve()
{
	int i, j;
	int k;

	cin >> n >> m;

	for (i = 1; i <= n; i++) {
		cin >> k;

		g[i].resize(k);

		for (j = 0; j < k; j++) cin >> g[i][j];

		g0[i] = g[i];
	}

	for (i = 1; i <= m; i++) {
		cin >> a[i];

		cnt[a[i]]++;
	}

	ll ans = 0;

	for (i = 1; i <= n; i++) {
		for (j = 1; j <= n; j++) {
			g[j] = g0[j];
			ind[j] = 0;
		}

		if (cnt[i] == 0) continue;

		ans = max(ans, solve1(i, cnt[i]));
	}

	cout << ans << "\n";

	return;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	solve();

	return 0;
}
