#include <iostream>
#include "game.h"
#include <algorithm>
#include <iomanip>
#include <vector>
#include <math.h>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <chrono>

using namespace std;

#define ll long long
#define fr first
#define sc second
#define pb push_back

const int N = 300005;
const ll oo = 100000000000000000, MOD = 1000000007;

bool kr[N];
ll a[N];
bool ok[N];
pair<ll,int> p[N];
int n, d;

void init(std::vector<int> A, int D) {
	 d = D;
     n = A.size();
	for (int i = 0; i < A.size(); ++i) {
		a[i] = A[i];
		p[i].fr = a[i], p[i].sc = i;
	}
	sort(p, p + n);
	for (int i = n-1; i >= 0;--i) {
		kr[p[i].sc] = 0;
		for (int j = max(p[i].sc - d, 0); j <= min(p[i].sc + d,n - 1); ++j) {
			if (ok[j] == 1 && kr[j] != 1) {
				kr[p[i].sc] = 1;
				break;
			}
		}
		ok[p[i].sc] = 1;
	}
}

void updateValue(int index, int newValue) {
	a[index] = newValue;
	for (int i = 0; i < n; ++i) {
		p[i].fr = a[i], p[i].sc = i;
	}
	for (int i = 0; i < n; ++i) {
		ok[i] = 0;
	}
	sort(p, p + n);
	for (int i = n-1; i >= 0; --i) {
		kr[p[i].sc] = 0;
		for (int j = max(p[i].sc - d, 0); j <= min(p[i].sc + d, n - 1); ++j) {
			if (ok[j] == 1 && kr[j] != 1) {
				kr[p[i].sc] = 1;
				break;
			}
		}
		ok[p[i].sc] = 1;
	}
}


bool isWinning(int startIndex) {
	return kr[startIndex];
}
