#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

//using namespace __gnu_pbds;

#define endl '\n'
#define f first
#define s second
#define l long long
#define pb push_back
#define pairs pair<l,l>
#define all(v) v.begin(),v.end()
#define dbg(x) cout<<#x<<" = "<<x<<endl;
#define ibo ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(NULL)


const l N = 2e5 + 5;
const l INF = 1e17;
const l mod = 1e9+7;
const l one = 1;

vector<int>v(N);

l n,d;

vector<l>sq( 4 * N , 0 );
unordered_map<l,l>mp;

void build(l left , l right ,l ind){
    if(left == right){
        sq[ind] = v[left];
        return;
    }

    l mid = (left + right)/2;

    build(left , mid , ind * 2);
    build(mid+1,right ,ind * 2 + 1);

    sq[ind] = max(sq[ind * 2 ] , sq[ind*2 + 1]);
}

l get(l t1, l t2 ,l left , l right , l ind){
    if(t1 > right or t2 < left){
        return -1;
    }
    
    if(t1 <= left and t2 <= right){
        return sq[ind];
    }
    
    l mid = (left + right)/2;

    return max( get(t1,t2,left, mid , ind*2) , get(t1,t2,mid+1,right,ind*2+1));
}

void updatesq(l left , l right , l k , l ind){
    if(k < left or k > right){
        return;
    }

    if(left == right){
        sq[ind] = v[k];
        return;
    }

    l mid = (left + right)/2;

    updatesq(left, mid , k , ind*2);
    updatesq(mid+1, right, k , ind*2+1);

    sq[ind] = max(sq[ind * 2] , sq[ind*2 + 1]);
}

void updateValue(int index, int newValue){
    v[index + 1] = newValue;
    updatesq(1,n,index+1,1);
    mp[v[index+1] ] = -1;
    mp[newValue] = index + 1;
}


bool isWinning(int b){

    l tm = 1;

    //cout<<"n : "<<n<<endl;
    //cout<<"d : "<<d<<endl;

    while(1){
        tm++;
        l maks = -1;
        if(b != 0){
            l left1 = max(1 , b);
            l left2 = max(one , b - d + 1);
            //cout<<"l : "<<left2 << " " << left1<<endl;
            maks = max( maks, get(left2 , left1 , 1, n , 1) );
        }
        if(b != n - 1){
            l right1 = b + 2;
            l right2 = b + d + 1;

            right1 = min(n , right1 );
            right2 = min(n , right2 );

            //cout<<"r : " <<right1<<" "<<right2<<endl;
            maks = max(maks, get(right1, right2 , 1 , n ,1));

        }

        //dbg(tm);
        //dbg(maks);
        //cout<<v[b + 1]<<endl;

        if( maks < v[b+1]){
            return bool(tm % 2);
        }

        b = mp[maks] - 1;
    }


}

void init(std::vector<int> A, int D){
    n = A.size();
    for(int i = 0;i<n;i++){
        v[i+1] = A[i];
        mp[v[i+1]] = i+1;
    }
    d = D;
    build(1,n,1);
}
