#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

//using namespace __gnu_pbds;

#define endint '\n'
#define f first
#define s second
#define pb push_back
#define pairs pair<l,l>
#define all(v) v.begin(),v.end()
#define dbg(x) cout<<#x<<" = "<<x<<endl;
#define ibo ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(NULL)


const int N = 2e5 + 5;
const int INF = 1e9;
const int mod = 1e9+7;
const int one = 1;

int n,d;
vector<int>v(N,0);
vector<int>sq( 4 * N , 0 );
unordered_map<int,int>mp;


void build(int left ,int right ,int ind){
    if(left == right){
        sq[ind] = v[left];
        return;
    }

    int mid = (left + right)/2;

    build(left , mid , ind * 2);
    build(mid+1,right ,ind * 2 + 1);

    sq[ind] = max(sq[ind * 2 ] , sq[ind*2 + 1]);
}

int get(int t1,int t2 ,int left ,int right ,int ind){
    if(t1 > right or t2 < left){
        return -1;
    }

    if(t1 <= left and right <= t2){
        return sq[ind];
    }

    int mid = (left + right)/2;

    return max( get(t1 , t2 , left  mid , ind*2) , get(t1 , t2 , mid+1 , right , ind*2+1));
}

void updatesq(int left ,int right ,int k ,int ind){
    if(k < left or k > right){
        return;
    }
    
    if(left == right){
        sq[ind] = v[k];
        return;
    }

    int mid = (left + right)/2;

    updatesq(left, mid , k , ind*2);
    updatesq(mid+1, right, k , ind*2+1);
    
    sq[ind] = max( sq[ind * 2] , sq[ind*2 + 1] );
}

void updateValue(int index, int newValue){
    index++;
    
    v[index] = newValue;
    updatesq(1,n,index,1);
    mp[newValue] = index;
}


bool isWinning(int b){
    b++;
    int tm = 1;
    
    
    while(1){
        
        tm++;
        
        int maks = -1;

        if(b != 1){
            int left1 = b - 1;
            int left2 = b - d;

            if(left1 < 1){
                left1 = 1;
            }
            if(left2 < 1){
                left2 = 1;
            }
            
            maks = max( maks, get(left2 , left1 , 1, n , 1));
        }

        if(b != n ){
            int right1 = b + 1;
            int right2 = b + d;

            if(right1 > n ){
                right1 = n;
            }
            if(right2 > n){
                right2 = n;
            }
            
            maks = max(maks, get(right1, right2 , 1 , n ,1));

        }
        
        
        if( maks < v[b]){
            if(tm%2 == 1){
                return 1;
            }
            else{
                return 0;
            }
        }
        b = mp[maks];
    }
    
}

void init(vector<int> A, int D){
    n = A.size();
    for(int i = 0;i<n;i++){
        v[i+1] = A[i];
        mp[v[i+1]] = i+1;
    }
    d = D;
    build(1,n,1);
}
