#include "game.h"
#include <bits/stdc++.h>

#define ll long long
#define endl "\n"

using namespace std;

const ll N = 2e5 + 5;
bool dp[N][2];
ll a[N], n, d;
pair<ll, ll> b[N];
void init(std::vector<int> A, int D)
{
    n = A.size();
    d = D;
    for (ll i = 1; i <= n; i++)
        a[i] = A[i - 1];
    for (ll i = 1; i <= n; i++)
        b[i] = make_pair(a[i], i);
    sort(b + 1, b + n + 1);
    for (ll ind = n; ind >= 1; ind--)
    {
        ll cnt = 0, i = b[ind].second;
        for (ll j = max(1ll, i - d); j <= min(n, i + d); j++)
            cnt += a[i] < a[j];
        if (!cnt)
            dp[i][0] = false, dp[i][1] = true;
        else
        {
            dp[i][0] = dp[i][1] = false;
            for (ll j = max(1ll, i - d); j <= min(n, i + d); j++)
                if (a[i] < a[j])
                    dp[i][0] |= !dp[j][0], dp[i][1] |= !dp[j][1];
        }
    }
}

void updateValue(int index, int newValue)
{
    a[index + 1] = newValue;
    // b[index + 1] = make_pair(a[index + 1], index + 1);
    for (ll i = 1; i <= n; i++)
        b[i] = make_pair(a[i], i);
    sort(b + 1, b + n + 1);
    // for (ll i = 1; i <= n; i++)
    //     cout << b[i].second << " \n"[i == n];
    for (ll ind = n; ind >= 1; ind--)
    {
        ll cnt = 0, i = b[ind].second;
        for (ll j = max(1ll, i - d); j <= min(n, i + d); j++)
            cnt += a[i] < a[j];
        // cout << i << " " << cnt << endl;
        if (!cnt)
            dp[i][0] = false, dp[i][1] = true;
        else
        {
            dp[i][0] = dp[i][1] = false;
            for (ll j = max(1ll, i - d); j <= min(n, i + d); j++)
                if (a[i] < a[j])
                    dp[i][0] |= !dp[j][0], dp[i][1] |= !dp[j][1];
        }
    }
    // for (ll i = 1; i <= n; i++)
    //     cout << i << " : " << dp[i][0] << " " << dp[i][1] << endl;
}

bool isWinning(int startIndex)
{
    return dp[startIndex + 1][0];
}