#include <bits/stdc++.h>
using namespace std;

#include "game.h"

const int N = 2e5 + 55;

bool is_win[N];

vector<int> a;

int d;

void init(std::vector<int> v, int D) {
    a = v;
    d = D;
    int mx = 0 , ind = 0 , n = a.size();
    bool used[n];
    set<pair<int , int>> s;
    for (int i = 0;i < n;i ++) {
        if (mx < a[i]) {
            mx = a[i];
            ind = i;
        }
        used[i] = false;
        is_win[i] = false;
        s.insert({a[i] , i});
    }

    for (int i = 0;i < n;i ++) {
        if (is_win[i] == true) {
            continue;
        }
        bool as = false;
        for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
            if (a[j] > a[i]) {
                as = true;
                break;
            }
        }
        if (as == false) {
            for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
                is_win[j] = true;
                used[j] = true;
            }
            is_win[i] = false;
        }
    }
    while ((int)s.size() > 0) {
        auto t = *s.begin();
        s.erase(s.begin());
        if (used[t.second] == true) {
            continue;
        }
        bool as = false;
        for (int j = max(0 , t.second - d);j <= min(n - 1 , t.second + d);j ++) {
            if (used[j] == true && is_win[j] == 0) {
                as = true;
                break;
            }
        }
        is_win[t.second] = as;
        used[t.second] = true;
    }
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    int mx = 0 , ind = 0 , n = a.size();
    bool used[n];
    set<pair<int , int>> s;
    for (int i = 0;i < n;i ++) {
        if (mx < a[i]) {
            mx = a[i];
            ind = i;
        }
        used[i] = false;
        is_win[i] = false;
        s.insert({a[i] , i});
    }

    for (int i = 0;i < n;i ++) {
        if (is_win[i] == true) {
            continue;
        }
        bool as = false;
        for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
            if (a[j] > a[i]) {
                as = true;
                break;
            }
        }
        if (as == false) {
            for (int j = max(0 , i - d);j <= min(n - 1 , i + d);j ++) {
                is_win[j] = true;
                used[j] = true;
            }
            is_win[i] = false;
        }
    }
    while ((int)s.size() > 0) {
        auto t = *s.begin();
        s.erase(s.begin());
        if (used[t.second] == true) {
            continue;
        }
        bool as = false;
        for (int j = max(0 , t.second - d);j <= min(n - 1 , t.second + d);j ++) {
            if (used[j] == true && is_win[j] == 0) {
                as = true;
                break;
            }
        }
        is_win[t.second] = as;
        used[t.second] = true;
    }
}

bool isWinning(int startIndex) {
    return is_win[startIndex];
}