#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define oo 1e9

const int MAX = 5e5 + 5;

int n, m;
vector<int> g[MAX];
int nxt[MAX];
int par[MAX];
int tar;
int F[MAX];
bool done[MAX];
int sub[MAX];
ll ans = 0;

int c = 1;

void dfs(int node, int p){
    ans++;
    if(node == 1) tar--;
    if(c == n && node == 1) return;
    if(!tar) return;
    int to = g[node][nxt[node]];
    if(to == par[node] && !done[node]){
        c++;
        done[node] = 1;
    }
    nxt[node] = (nxt[node] + 1) % g[node].size();
    dfs(to, node);
}

void init(int node, int p){
    par[node] = p;
    sub[node] = 1;
    for(int to : g[node]){
        if(p == to) continue;
        init(to, node);
        sub[node] += sub[to]; 
    }
}

int main(){
    cin >> n >> m;
    for(int i = 1; i <= n; i++){
        int k; cin >> k;
        for(int j = 1; j <= k; j++){
            int a; cin >> a;
            g[i].push_back(a);
        }
    }
    tar = m;
    for(int i = 1; i <= m; i++){
        cin >> F[i];
    }
    init(1, 1);
    dfs(1, 1);
    while(nxt[1] && tar){
        ans += 2 * sub[g[1][nxt[1]]];
        nxt[1]++;
        nxt[1] %= g[1].size();
        tar--;
    } 
    ans += 1ll * tar / g[1].size() * (2 * n - 2); 
    tar %= g[1].size();
    while(nxt[1] != g[1].size() && tar){
        ans += 2 * sub[g[1][nxt[1]]];
        nxt[1]++;
        tar--;
    } 
    cout << ans << '\n';
}
