#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

vector<vector<int> > graph, idxs;
vector<int> par, first_vis, dpth;
vector<bool> here; int num_here = 0;

struct seggy {
    vector<int> tree;
    int n;

    seggy() {}
    seggy(int n) : n(n) {
        tree = vector<int> (2 * n);
    }

    void add(int idx, int val) {
        for (idx += n; idx > 0; idx /= 2)
            tree[idx] += val;
    }

    int query(int l, int r) {
        int out = 0;
        for (l += n, r += n + 1; l < r; l /= 2, r /= 2) {
            if (l & 1)
                out += tree[l++];
            if (r & 1)
                out += tree[--r];
        }
        return out;
    }

    int getsuf(int a) {
        return query(0, idxs[a][0]);
    }
    int get_exact(int a) {
        return query(0, a);
    }
};

int is_par(int p, int c) {
    return idxs[p][0] > idxs[c][0] and idxs[p].back() < idxs[c].back();
}

seggy seg;
int pnt;

int tim2 = 0;
void init_order(int curr) {
    idxs[curr].push_back(tim2);
     
    int par_idx = find(all(graph[curr]), par[curr]) - graph[curr].begin();
    if (curr == 1)
        par_idx = -1;
    for (int i = par_idx + 1; i < graph[curr].size(); i++) {
        par[graph[curr][i]] = curr;
        dpth[graph[curr][i]] = dpth[curr] + 1;
        init_order(graph[curr][i]);
        idxs[curr].push_back(tim2);
    }
    for (int i = 0; i < par_idx; i++) {
        dpth[graph[curr][i]] = dpth[curr] + 1;
        par[graph[curr][i]] = curr;
        tim2++;
        init_order(graph[curr][i]);
        idxs[curr].push_back(tim2);
    }
    tim2++;
}

int tot_time;
queue<int> to_visit;
void do_first(int curr, int &tim) {
    int par_idx = find(all(graph[curr]), par[curr]) - graph[curr].begin();
    if (curr == 1)
        par_idx = -1;

    for (int idx : idxs[curr])
        seg.add(idx, 1);

    first_vis[curr] = tim + tot_time;
    here[curr] = true; num_here++;
    for (int i = par_idx + 1; i < graph[curr].size(); i++)
        to_visit.push(graph[curr][i]);
    for (int i = 0; i < par_idx; i++) {
        tim++;
        do_first(graph[curr][i], tim);
    }
    tim++;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    graph = idxs = vector<vector<int> > (n + 1);
    par = first_vis = dpth = vector<int> (n + 1);
    here = vector<bool> (n + 1);
    

    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        graph[i] = vector<int>(k);
        for (int j = 0; j < k; j++)
            cin >> graph[i][j];
    }
    init_order(1);
    seg = seggy(tim2 + 1);
    vector<int> guys(m);
    for (int i = 0; i < m; i++)
        cin >> guys[i];
    
    int pnt = 0;
    to_visit.push(1);
    int ans = 0, last = 0;
    for (; pnt < m; pnt++) {
        if (!here[guys[pnt]]) {
            while (!here[guys[pnt]]) {
                int c = to_visit.front(); to_visit.pop();
                if (idxs[c][0] < last)
                    tot_time += 2 * num_here - 2;
                int start_tim = seg.getsuf(c); // vidjet +- 1
                do_first(c, start_tim);
                last = idxs[c].back();
            }
            ans = first_vis[guys[pnt]];
        } else {
            //cout << guys[pnt] << " " << tot_time << " " << num_here << "\n"; 
            while (!to_visit.empty() and idxs[to_visit.front()].back() > idxs[guys[pnt]][0]) {
                int c = to_visit.front(); to_visit.pop();
                if (idxs[c][0] < last)
                    tot_time += 2 * num_here - 2;
                int start_tim = seg.getsuf(c);
                do_first(c, start_tim);
                last = idxs[c].back();
            }
            
            while (!to_visit.empty() and idxs[to_visit.front()].back() < idxs[guys[pnt]][0]) {
                int c = to_visit.front(); to_visit.pop();
                if (idxs[c][0] < last)
                    tot_time += 2 * num_here - 2;
                int start_tim = seg.getsuf(c);
                do_first(c, start_tim);
                last = idxs[c].back();
            }

            if (!(idxs[guys[pnt]][0] < last and idxs[guys[pnt]].back() > last)) {
                //cout << "hello" << endl;
                if (last > idxs[guys[pnt]].back())
                    tot_time += 2 * num_here - 2;
                ans = tot_time + seg.getsuf(guys[pnt]);
                last = idxs[guys[pnt]][0];
            }
            else {
                int me_og = *lower_bound(all(idxs[guys[pnt]]), last);
                ans = tot_time + seg.get_exact(me_og);
                last = me_og;
            }
            //cout << ans << "\n";
            //cout << "\n";
        }
    }

    cout << ans << "\n";
}