#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;

vector<vector<int> > graph, idxs;
vector<int> par, first_vis, dpth;
vector<bool> here; int num_here = 0;

struct seggy {
    set<int> op;
    vector<int> tree;
    int n;

    seggy() {}
    seggy(int n) : n(n) {
        tree = vector<int> (2 * n);
    }

    void add(int idx, int val) {
        op.insert(idx);
        for (idx += n; idx > 0; idx /= 2)
            tree[idx] += val;
    }

    int query(int l, int r) {
        int out = 0;
        for (l += n, r += n + 1; l < r; l /= 2, r /= 2) {
            if (l & 1)
                out += tree[l++];
            if (r & 1)
                out += tree[--r];
        }
        return out;
    }

    int getsuf(int a) {
        return query(0, idxs[a][0]);
    }
    int get_exact(int a) {
        return query(0, a);
    }

    int get_next(int val) {
        if (op.lower_bound(val + 1) == op.end())
            return 0;
        return *op.lower_bound(val + 1);
    }
};

int is_par(int p, int c) {
    return idxs[p][0] > idxs[c][0] and idxs[p].back() < idxs[c].back();
}

seggy seg;

int tim2 = 0;
void init_order(int curr) {
    idxs[curr].push_back(tim2);
     
    int par_idx = find(all(graph[curr]), par[curr]) - graph[curr].begin();
    if (curr == 1)
        par_idx = -1;
    for (int i = par_idx + 1; i < graph[curr].size(); i++) {
        par[graph[curr][i]] = curr;
        dpth[graph[curr][i]] = dpth[curr] + 1;
        tim2++;
        init_order(graph[curr][i]);
        idxs[curr].push_back(tim2);
    }
    for (int i = 0; i < par_idx; i++) {
        dpth[graph[curr][i]] = dpth[curr] + 1;
        par[graph[curr][i]] = curr;
        tim2++;
        init_order(graph[curr][i]);
        idxs[curr].push_back(tim2);
    }
    tim2++;
}

int tot_time; int pnt = 0, ans;
vector<int> guys;
queue<int> to_visit;
void do_first(int curr, int &tim) {   
    int par_idx = find(all(graph[curr]), par[curr]) - graph[curr].begin();
    if (curr == 1)
        par_idx = graph[curr].size();

    for (int i = 0; i < idxs[curr].size(); i++) {
        int idx = idxs[curr][i];
        if (!(curr == 1 and idx == idxs[curr].back()))
            seg.add(idx, 1);
    }
    
    first_vis[curr] = tim + tot_time;
    if (curr == guys[pnt])
    {
        ans = tim + tot_time, pnt++;
        //cout << "asd: " << guys[pnt - 1] << " " << ans << "\n";
    }
    here[curr] = true; num_here++;
    for (int i = par_idx + 1; i < graph[curr].size(); i++)
        to_visit.push(graph[curr][i]);
    for (int i = 0; i < par_idx; i++) {
        tim++;
        do_first(graph[curr][i], tim);
        //cout << curr << " " << guys[pnt] << "\n";
        if (curr == guys[pnt])
        {
            ans = tim + tot_time;
            pnt++;
            //cout << "asd: " << guys[pnt - 1] << " " << tot_time << " " << tim <<  " " << ans << "\n";
        }
    }
    tim++;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    graph = idxs = vector<vector<int> > (n + 1);
    par = first_vis = dpth = vector<int> (n + 1);
    here = vector<bool> (n + 1);
    

    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        graph[i] = vector<int>(k);
        for (int j = 0; j < k; j++)
            cin >> graph[i][j];
    }

    init_order(1);
    seg = seggy(tim2 + 1);
    guys = vector<int> (m);
    guys.push_back(1e9);
    for (int i = 0; i < m; i++)
        cin >> guys[i];
    
    to_visit.push(1);
    int last = 0;
    for (; pnt < m; pnt++) {
        while (pnt != m and !here[guys[pnt]]) {
            int c = to_visit.front(); to_visit.pop();
            if (idxs[c][0] < last)
                tot_time += 2 * num_here - 2;
            int start_tim = seg.getsuf(c); // vidjet +- 1
            do_first(c, start_tim);
            last = seg.get_next(idxs[c].back());
            //cout << c << " " << last << endl;
            if (last == 0)
                tot_time += 2 * num_here - 2;
            //cout << "DONE WITH FIRST " << pnt << " " << tot_time << endl;
        }
        if (pnt == m)
            break;
        //cout << guys[pnt] << " " << tot_time << " " << num_here << "\n"; 
        while (!to_visit.empty() and last > idxs[guys[pnt]][0]) {
            int c = to_visit.front(); to_visit.pop();
            if (idxs[c][0] < last)
                tot_time += 2 * num_here - 2;
            int start_tim = seg.getsuf(c);
            do_first(c, start_tim);
            last = seg.get_next(idxs[c].back());
            if (last == 0)
                tot_time += 2 * num_here - 2;
            //cout << guys[pnt] << " " << last << " " << c <<" " << *prev(seg.op.end()) << "\n";
        }
        
        while (!to_visit.empty() and idxs[to_visit.front()].back() < idxs[guys[pnt]][0]) {
            int c = to_visit.front(); to_visit.pop();
            if (idxs[c][0] < last)
                tot_time += 2 * num_here - 2;
            int start_tim = seg.getsuf(c);
            do_first(c, start_tim);
            last = seg.get_next(idxs[c].back());
            if (last == 0)
                tot_time += 2 * num_here - 2;
        }

        if (last > idxs[guys[pnt]].back())
            tot_time += 2 * num_here - 2, last = 0;
        if (!(idxs[guys[pnt]][0] < last and idxs[guys[pnt]].back() > last)) {
            //cout << "hello" << last << "\n";
            ans = tot_time + seg.getsuf(guys[pnt]);
            last = seg.get_next(idxs[guys[pnt]][0]);
            if (last == 0)
                tot_time += 2 * num_here - 2;
        }
        else {
            //cout << "hello 2" << "\n";
            int me_og = *lower_bound(all(idxs[guys[pnt]]), last);
            cout << me_og << endl;
            ans = tot_time + seg.get_exact(me_og);
            last = seg.get_next(me_og);
            if (last == 0)
                tot_time += 2 * num_here - 2;
        }
        //cout << ans << "\n";
    }

    cout << ans + 1 << "\n";
}