#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int MAX=1e9;
vector<int>primes;
bool is_prime(int x){
	if(x==2||x==3||x==5||x==7)return 1;
	if(x%2==0)return 0;
	for(int i=3;i*i<=x;i+=2){
		if(x%i==0)return 0;
	}
	return 1;
}
void pre(){
	for(int i=2;primes.size()<3402;i++){
		if(is_prime(i))primes.push_back(i);
	}
}
void rec(int i,int cur,vector<pair<int,int>>&p,vector<int>&res){
	if(i==p.size()){
		res.push_back(cur);
		return;
	}
	for(int j=0,pw=1;j<=p[i].second;j++){
		rec(i+1,cur*pw,p,res);
		pw*=p[i].first;
	}
}
map<int,vector<int>>d;
vector<int>get_divs(int x){
	if(d.count(x))return d[x];
	auto&res=d[x];
	vector<pair<int,int>>pr;
	for(auto p:primes){
		if(p*p>x)break;
		if(x%p==0){
			int cnt=0;
			while(x%p==0)x/=p,cnt++;
			pr.push_back({p,cnt});
		}
	}
	if(x>1)pr.push_back({x,1});
	rec(0,1,pr,res);
	return res;
}
mt19937_64 mt(time(NULL));
map<int,ull>mp,mp2;
int n,k,x;
map<int,int>freq;
ull Hash2(int x){
	if(mp.count(x))return mp[x];
	return mp[x]=mt();
}
ull Hash(int x){
	if(mp2.count(x))return mp2[x];
	vector<int>divs=get_divs(x);
	ull res=0;
	for(auto z:divs){
		if(freq[z]>=k)res^=Hash2(z);
	}
	return mp2[x]=res;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	pre();
	int t;
	cin>>t;
	while(t--){
		cin>>n>>k>>x;
		if(x==1){
			freq.clear();
			int a[n];
			for(int i=0;i<n;i++){
				cin>>a[i];
				auto v=get_divs(a[i]);
				for(auto x:v)freq[x]++;
			}
			for(int i=0;i<n;i++){
				for(int j=i+1;j<n;j++){
					if(a[i]>a[j]&&Hash(a[i])==Hash(a[j]))swap(a[i],a[j]);
				}
				cout<<a[i]<<" ";
			}
			cout<<"\n";
		}else exit(0);
	}
	return 0;
}