#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

const int N = 1e5+5;

mt19937_64 rng(2008);

gp_hash_table<long long, long long> ids;
vector<long long> v, ans;
gp_hash_table<long long, int> fr;
gp_hash_table<long long, vector<long long>> mp, mp2;


long long hsh(long long x)
{
    if(ids[x])    return ids[x];
    return ids[x] = (rng())%(long long)(4e18)+1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    #ifndef EVAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
    #endif
    int tc;
    cin >> tc;
    while(tc--)
    {
        fr.clear();
        mp.clear();
        mp2.clear();    
        long long n, k, x;
        cin >> n >> k >> x;
        v.resize(n);
        ids.clear();
        long long go = 0;
        for(int i = 0; i < n; i++)
        {
            cin >> v[i];
            go = __gcd(go, v[i]);
        }
        for(int i = 0; i < n; i++)
        {
            v[i] /= go;
            long long z = v[i];
            for(long long j = 2; j*j <= z; j++)
            {
                long long o = j;
                while(z%j == 0)
                {
                    fr[o]++;
                    o *= j;
                    z /= j;
                }
            }
            if(z > 1)   fr[z]++;
        }
        ans = v;
        for(int i = 0; i < n; i++)
        {
            long long z = v[i];
            vector<long long> se;
            for(long long j = 2; j*j <= z; j++)
            {
                if(z%j == 0)    se.push_back(j);
                while(z%j == 0)
                {
                    z /= j;
                }
            }
            if(z > 1) se.push_back(z);
            long long prim = 0;
            for(auto it : se)
            {
                long long h = it;
                while(v[i]%h == 0 && fr[h] >= k)
                {
                    h *= it;
                }
                h /= it;
                if(fr[h] >= k && v[i]%h == 0)  prim ^= hsh(h);
            }
            mp[prim].push_back(i);
            mp2[prim].push_back(v[i]);
        }
        for(auto &[a, it]: mp)
        {
            sort(mp2[a].begin(), mp2[a].end());
            for(int i = 0; i < it.size(); i++)  ans[it[i]] = mp2[a][i];
        }        
        for(int i = 0; i < n; i++) cout << ans[i]*go << ' ';
        cout << '\n';
    }
    
}



