#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define sz(x) (int) x.size()

const int N = 500'005;
vector<int> adj[N];
ll ans;
void returnBack(int i, int cnt, int p) {
	if (cnt == 0) return;
// 	cout << "-" << i << "- ";
	ans += cnt;
	int v = cnt;
	int pos = 0, ctr = 0;
	for (auto nxt : adj[i]) {
		ctr++;
		if (nxt == p) {
			pos = ctr;
			v--;
			continue;
		}
		returnBack(nxt, v, i);
		ans += v;
	}
	rotate(adj[i].begin(), adj[i].begin() + pos, adj[i].end());
}
int target, gud[N];
bool getPath(int i, int p) {
	if (i == target) {
		gud[i] = 1;
		return 1;
	}
	for (auto nxt : adj[i]) {
		if (nxt == p) continue;
		gud[i] |= getPath(nxt, i);
	}
	return gud[i];
}
int dfs(int i, int p) {
	if (i == target) {
		ans++;
		return 1;
	}
	int part = 0, pos = 0, found = 0;
	int cnt;
	for (auto nxt : adj[i]) {
		if (!found) pos++;
		if (nxt == p) {
			if (!found) {
				part = 1;
			}
			continue;
		}
		if (gud[nxt]) {
			found = 1;
			cnt = dfs(nxt, i);
		}
	}
	int ret;
	if (part == 0) {
		ret = cnt;
		for (auto nxt : adj[i]) {
			if (nxt == p) {
				continue;
			}
			if (gud[nxt]) {
				cnt--;
				continue;
			}
			returnBack(nxt, cnt, i);
			ans += cnt;
		}
	} else {
		ret = cnt + 1;
		cnt++;
		for (auto nxt : adj[i]) {
			if (nxt == p) {
				cnt--;
				continue;
			}
			if (gud[nxt]) {
				cnt--;
				continue;
			}
			returnBack(nxt, cnt, i);
			ans += cnt;
		}
	}
	ans += ret - (p == 0);
	rotate(adj[i].begin(), adj[i].begin() + pos, adj[i].end());
	return ret;
}
int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		int sz;
		cin >> sz;
		adj[i].resize(sz);
		for (auto &j : adj[i]) {
			cin >> j;
		}
	}
	int root = 1, p[m];
	ans++;
	for (int i = 0; i < m; i++) {
		cin >> p[i];
	}
	for (int i = 0; i < m; i++) {
		if (i == 0 && p[i] == 1) continue;
		if (p[i] == root) {
// 			cout << "(" << adj[adj[root][0]][0] << ") ";
			returnBack(adj[root][0], 1, root);
			ans++;
			rotate(adj[root].begin(), adj[root].begin() + 1, adj[root].end());
		} else {
			for (int j = 1; j <= n; j++) {
				gud[j] = 0;
			}
			target = p[i];
			getPath(root, 0);
			dfs(root, 0);
			root = p[i];
		}
// 		cout << ans << ' ';
	}
// 	cout << '\n';
	cout << ans << '\n';
	return 0;
}

