#include <bits/stdc++.h>
using namespace std;
#define ll long long

const int N = 100'005;
vector<int> divs[N];
int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int T;
	cin >> T;
	while (T--) {
		int n, k, x;
		cin >> n >> k >> x;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		map<int, int> frq;
		for (int i = 0; i < n; i++) {
			divs[i].clear();
			for (int j = 1; j * j <= a[i]; j++) {
				if (a[i] % j == 0) {
					divs[i].push_back(j);
					frq[j]++;
					if (j * j != a[i]) {
						divs[i].push_back(a[i] / j);
						frq[a[i] / j]++;
					}
				}
			}
		}
		multiset<array<int, 2>> s;
		for (int i = 0; i < n; i++) {
			s.insert({a[i], i});
		}
		vector<int> b;
		while (s.size()) {
			array<int, 2> best = {-1, -1};
			for (auto [v, idx] : s) {
				bool bad = 0;
				for (auto d : divs[idx]) {
					if (a[b.size()] % d && frq[d] >= k) {
// 						cout << v << ' ' << d << endl;
						bad = 1;
						break;
					}
				}
				if (!bad) {
					best = {v, idx};
					break;
				}
			}
			assert(best[0] != -1);
			s.erase(s.find(best));
			b.push_back(best[0]);
		}
		for (auto i : b) {
			cout << i << ' ';
		}
		cout << '\n';
	}
	return 0;
}

