#include <bits/stdc++.h>
using namespace std;
#define ll long long

const int N = 100'005;
vector<int> divs[N];
int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int T;
	cin >> T;
	while (T--) {
		int n, k, x;
		cin >> n >> k >> x;
		vector<int> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		map<int, int> frq;
		for (int i = 0; i < n; i++) {
			divs[i].clear();
			for (int j = 1; j * j <= a[i]; j++) {
				if (a[i] % j == 0) {
					divs[i].push_back(j);
					frq[j]++;
					if (j * j != a[i]) {
						divs[i].push_back(a[i] / j);
						frq[a[i] / j]++;
					}
				}
			}
		}
		vector<ll> gud(n);
		for (int i = 0; i < n; i++) {
			gud[i] = 1;
			for (auto d : divs[i]) {
				if (frq[d] >= k) {
					gud[i] = lcm(gud[i], d);
					if (gud[i] > (int) 1e9) break;
				}
			}
		}
		multiset<array<int, 2>> s;
		for (int i = 0; i < n; i++) {
			s.insert({a[i], i});
		}
		vector<int> b;
		while (s.size()) {
			array<int, 2> best = {-1, -1};
			for (auto [v, idx] : s) {
				bool bad = 0;
				if (a[idx] % gud[b.size()] || a[b.size()] % gud[idx]) {
					bad = 1;
				}
				if (!bad) {
					best = {v, idx};
					break;
				}
			}
			assert(best[0] != -1);
			s.erase(s.find(best));
			b.push_back(best[0]);
		}
		for (auto i : b) {
			cout << i << ' ';
		}
		cout << '\n';
	}
	return 0;
}
