#include <bits/stdc++.h>
using namespace std;
#define ll long long

const int N = 100'005;
vector<ll> divs[N];
vector<ll> get(int n, int k, vector<ll> a) {
	map<ll, int> frq;
	for (int i = 0; i < n; i++) {
		for (auto d : divs[i]) {
			frq[d]++;
		}
	}
	vector<ll> gud(n);
	for (int i = 0; i < n; i++) {
		gud[i] = 1;
		for (auto d : divs[i]) {
			if (frq[d] >= k) {
				gud[i] = lcm(gud[i], d);
				if (gud[i] > (int) 1e9) break;
			}
		}
	}
	multiset<array<ll, 2>> s;
	for (int i = 0; i < n; i++) {
		s.insert({a[i], i});
	}
	vector<ll> b;
	while (s.size()) {
		array<ll, 2> best = {-1, -1};
		for (auto [v, idx] : s) {
			bool bad = 0;
			if (a[idx] % gud[b.size()] || a[b.size()] % gud[idx]) {
				bad = 1;
			}
			if (!bad) {
				best = {v, idx};
				break;
			}
		}
		assert(best[0] != -1);
		s.erase(s.find(best));
		b.push_back(best[0]);
	}
	return b;
}
int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int T;
	cin >> T;
	while (T--) {
		int n, k, x;
		cin >> n >> k >> x;
		vector<ll> a(n);
		for (int i = 0; i < n; i++) {
			cin >> a[i];
		}
		for (int i = 0; i < n; i++) {
			divs[i].clear();
			for (int j = 1; j * j <= a[i]; j++) {
				if (a[i] % j == 0) {
					divs[i].push_back(j);
					if (j * j != a[i]) {
						divs[i].push_back(a[i] / j);
					}
				}
			}
		}
		vector<ll> b = get(n, k, a);
		if (x != 1) {
			for (int i = 0; i < n; i++) {
				a[i] *= x;
				int sz = divs[i].size();
				vector<ll> tmp = divs[i];
				for (auto d : tmp) {
					divs[i].push_back(d * x);
				}
				b = min(b, get(n, k, a));
				a[i] /= x;
				while (divs[i].size() > sz) divs[i].pop_back();
			}
		}
		for (auto i : b) {
			cout << i << ' ';
		}
		cout << '\n';
	}
	return 0;
}
