#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize ("Ofast")
typedef long long ll;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random (ll l, ll r) {
	return uniform_int_distribution <ll> (l, r) (rng);
}
ll g (ll x, ll c, ll n) {
	return (x * x + c) % n;
}
pair <ll, ll> f (ll n) {
	if (n == 1) return {1, 1};
	while (true) {
		ll a = random(1, n), b = random(1, n), c = random(1, n);
		ll t = 0;
		while (a != b) {
			t++; if (t >= 1e3) break;
			a = g(a, c, n);
			b = g(g(b, c, n), c, n);
			ll p = __gcd(abs(a - b), n);
			if (p > 1) {
				return {p, n / p};
			}
		}
	}
}
ll n, k, x;
vector <ll> a, b, c;
vector <vector <pair <int, int>>> cur;
map <int, vector <pair <int, int>>> dd;
map <int, vector <int>> pp;
vector <int> primes;
int sieve[1001];
vector <pair <int, int>> factorize (int x) {
	vector <pair <int, int>> ret;
	map <int, int> ehbed;
	for (ll i : primes) {
		while (x % i == 0) {
			x /= i;
			ehbed[i]++;
		}
	}
	auto g = f(x);
	if (g.first != 1) ehbed[g.first]++;
	if (g.second != 1) ehbed[g.second]++;
	for (auto i : ehbed) ret.push_back(i);
	sort(ret.begin(), ret.end());
	return ret;
}
void resolve () {
	dd.clear(); pp.clear();
	for (int i = 0; i < n; i++) {
		for (auto [x, y] : cur[i]) {
			dd[x].push_back({y, i});
		}
	}
	for (int i = 0; i < n; i++) b[i] = 1;
	for (auto i : dd) {
		auto h = i.second;
		sort(h.begin(), h.end());
		reverse(h.begin(), h.end());
		int pre[h[0].first + 1] = {};
		pre[0] = 1; for (int j = 1; j <= h[0].first; j++) pre[j] = i.first * pre[j - 1];
		int pref[(int)h.size()] = {};
		for (int l = (int)h.size() - 1; l >= 0; l--) {
			if (l >= k - 1) pref[l] = h[l].first;
			if (l < (int)h.size() - 1) pref[l] = max(pref[l], pref[l + 1]);
		}
		for (int l = 0; l < (int)h.size(); l++) {
			b[h[l].second] *= pre[pref[l]];
		}
	}
	for (int i = 0; i < n; i++) {
		pp[b[i]].push_back(a[i]);
	}
	for (auto &i : pp) {
		sort(i.second.begin(), i.second.end());
		reverse(i.second.begin(), i.second.end());
	}
	for (int i = 0; i < n; i++) {
		int z = pp[b[i]].back();
		pp[b[i]].pop_back();
		b[i] = z;
	}
}
void solve () {
	cin >> n >> k >> x;
	a.clear(); b.clear(); c.clear(); pp.clear(); dd.clear(); cur.clear();
	a.resize(n); b.resize(n); c.resize(n); cur.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < n; i++) {
		cur[i] = factorize(a[i]);
	}
	if (x == 1) {
		resolve();
		for (auto i : b) cout << i << " ";
		cout << '\n';
		return;
	}
	resolve();
	c = b;
	for (int i = 0; i < n; i++) {
		pair <int, int> ff = {x, 0};
		a[i] *= x;
		auto g = lower_bound(cur[i].begin(), cur[i].end(), ff) - cur[i].begin();
		bool f = 0;
		if (g == (int)cur[i].size() || cur[i][g].first != x) {
			cur[i].push_back({x, 1});
			f = 1;
		} else {
			cur[i][g].second++;
		}
		resolve();
		c = min(c, b);
		if (f) cur[i].pop_back();
		else cur[i][g].second--;
		a[i] /= x;
	}
	for (auto i : c) cout << i << " ";
	cout << '\n';
}
signed main () {
	sieve[0] = 1;
	for (int i = 2; i * i <= 1000; i++) {
		if (!sieve[i]) {
			for (int j = 2 * i; j <= 1000; j += i) {
				sieve[j] = 1;
			}
		}
	}
	for (int i = 2; i <= 1000; i++) {
		if (!sieve[i]) {
			primes.push_back(i);
		}
	}
	ios::sync_with_stdio(0); cin.tie(0);
	int t = 1; cin >> t;
	while (t--) solve();
}