#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;
typedef long long ll;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random (ll l, ll r) {
    return uniform_int_distribution <ll> (l, r) (rng);
}
ll g (ll x, ll c, ll n) {
    return (x * x + c) % n;
}
pair <ll, ll> f (ll n) {
    if (n == 1) return {1, 1};
    while (true) {
        ll a = random(1, n), b = random(1, n), c = random(1, n);
        ll t = 0;
        while (a != b) {
            t++; if (t >= 1e3) break;
            a = g(a, c, n);
            b = g(g(b, c, n), c, n);
            ll p = __gcd(abs(a - b), n);
            if (p > 1) {
                return {p, n / p};
            }
        }
    }
}
#define int long long
int n, k, x;
vector <int> a, b, c;
map <int, vector <pair <int, int>>> dd;
map <int, vector <int>> pp;
int sieve[1001];
vector <int> primes;
vector <pair <int, int>> factorize (int x) {
    vector <pair <int, int>> ret;
    for (auto i : primes) {
        int cnt = 0;
        while (x % i == 0) {
            x /= i;
            cnt++;
        }
        if (cnt) ret.push_back({i, cnt});
    }
    if (x > 1) {
        auto y = f(x);
        if (y.first > y.second) swap(y.first, y.second);
        if (y.first > 1) ret.push_back({y.first, 1});
        if (y.first == y.second) ret.back().second++;
        else ret.push_back({y.second, 1});
    }
    return ret;
}
int power (int a, int b) {
    if (!b) return 1;
    int u = power(a, b >> 1);
    u *= u;
    if (b & 1) u *= a;
    return u;
}
void resolve () {
    dd.clear(); pp.clear();
    for (int i = 0; i < n; i++) {
        auto g = factorize(a[i]);
        for (auto [x, y] : g) {
            dd[x].push_back({y, i});
        }
    }
    for (int i = 0; i < n; i++) b[i] = 1;
    for (auto i : dd) {
        auto h = i.second;
        sort(h.begin(), h.end());
        reverse(h.begin(), h.end());
        int pref[(int)h.size()] = {};
        for (int l = (int)h.size() - 1; l >= 0; l--) {
            if (l >= k - 1) pref[l] = h[l].first;
            if (l < (int)h.size() - 1) pref[l] = max(pref[l], pref[l + 1]);
        }
        for (int l = 0; l < (int)h.size(); l++) {
            b[h[l].second] *= power(i.first, pref[l]);
        }
    }
    for (int i = 0; i < n; i++) {
        pp[b[i]].push_back(a[i]);
    }
    for (auto &i : pp) {
        sort(i.second.begin(), i.second.end());
        reverse(i.second.begin(), i.second.end());
    }
    for (int i = 0; i < n; i++) {
        int z = pp[b[i]].back();
        pp[b[i]].pop_back();
        b[i] = z;
    }
}
void solve () {
    cin >> n >> k >> x;
    a.resize(n); b.resize(n); c.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (x == 1) {
        resolve();
        for (auto i : b) cout << i << " ";
        cout << '\n';
        return;
    }
    resolve();
    c = b;
    for (int i = 0; i < n; i++) {
        a[i] *= x;
        resolve();
        c = min(c, b);
        a[i] /= x;
    }
    for (auto i : c) cout << i << " ";
    cout << '\n';
}
signed main () {
    for (int i = 2; i * i <= 1000; i++) {
        if (!sieve[i]) {
            for (int j = 2 * i; j <= 1000; j += i) {
                sieve[j] = 1;
            }
        }
    }
    for (int i = 2; i <= 1000; i++) {
        if (!sieve[i]) {
            primes.push_back(i);
        }
    }
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
}