#include <bits/stdc++.h>
using namespace std;
#include "game.h"
#define ll long long
#define pb push_back
int a[200001], n, d;
std::vector <int> t(800004);
void build(int v, int tl, int tr){
    if (tl == tr){
        t[v] = a[tl];
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v, tl, tm);
    build(2 * v + 1, tm + 1, tr);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}
void update(int v, int tl, int tr, int pos, int val){
    if (tl == tr){
        t[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos <= tm){
        update(2 * v, tl, tm, pos, val);
    } else update(2 * v + 1, tm + 1, tr, pos, val);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}
int getmax(int v, int tl, int tr, int l, int r){
    if (l > r)return 0;
    if (tl >= l and tr <= r)
        return t[v];
    int tm = (tl + tr) / 2;
    return max(getmax(2 * v, tl, tm, l, min(r, tm)), getmax(2 * v + 1, tm + 1, tr, max(l, tm + 1), r));
}
void init(std::vector<int> A, int D){
    n = A.size(); d = D;
    for (int i = 1; i <= n; i++)
        a[i] = A[i - 1];
    build(1, 1, n);
}
void updateValue(int index, int newValue){
    a[index + 1] = newValue;
    update(1, 1, n, index + 1, newValue);
}
bool isWinning(int startIndex){
    startIndex++;
    int l = 1, r = n, newl = 0, newr = 0;
    while(l < r){
        for (int i = l; i <= r; i++){
            if (a[i] == getmax(1, 1, n, max(l, i - d), min(r, i + d))){
                if (i <= startIndex + d and i >= startIndex - d)
                    return (i != startIndex);
                if (i <= startIndex)newl = i;
                if (i >= startIndex and newr == 0)newr = i;
            }
        }
        if (newl)l = min(n, newl + d + 1);
        if (newr)r = max(1, newr - d - 1);
    } return (a[startIndex] == getmax(1, 1, n, max(1, startIndex - d), min(n, startIndex + d)));
}