#include "game.h"
#include <bits/stdc++.h>
using namespace std;
const int N = 2e5 + 5;
int n, d;
vector<int> a(N), t(N);

int get(int id){
    int mx = 0;
    for(int j = max(0, id - d); j <= min(n, id + d); j++){
        mx = max(mx, t[j]);
    }
    return mx;
}
void up(int l, int r){
    for(int i = l; i <= r; i++){
        t[i] = a[i];
    }
    for(int i = l; i <= r; i++){
        if(get(i) == a[i]){
            for(int j = max(0, i - d); j <= min(n, i + d); j++){
                if(j != i) t[j] = 0;
            }
        }
    }
    for(int i = r; i >= l; i--){
        if(get(i) == a[i]){
            for(int j = max(0, i - d); j <= min(n, i + d); j++){
                if(j != i) t[j] = 0;
            }
        }
    }
}
void init(vector<int> A, int D){
    n = A.size(); d = D;
    for(int i = 0; i < n; i++){
        a[i] = A[i];
    }
    up(0, n - 1);
}

void updateValue(int idx, int val){
    a[idx] = val;
    if(val > get(idx)) up(max(0, idx - 5 * d), min(n - 1, idx + 5 * d));
}
bool isWinning(int idx){
    if(t[idx] == 0) return true;
    else return false;
}

//int main()
//{
//    int N, D, q;
//
//    std::vector<int> nums;
//
//    scanf("%d %d", &N, &D);
//
//    for (int i = 1; i <= N; i++)
//    {
//        int x;
//        scanf("%d", &x);
//        nums.push_back(x);
//    }
//
//    init(nums, D);
//
//    scanf("%d", &q);
//
//    for (int i = 1; i <= q; i++)
//    {
//        int cm;
//
//        scanf("%d", &cm);
//
//        if (cm == 1)
//        {
//            int ind, val;
//
//            scanf("%d %d", &ind, &val);
//
//            updateValue(ind, val);
//        }
//        else
//        {
//            int ind;
//
//            scanf("%d", &ind);
//
//            printf("%d\n", (int)isWinning(ind));
//        }
//    }
//
//    return 0;
//}
