#include <bits/stdc++.h>
using namespace std;
const int N = 5e5 + 1;
int n , m , back_edges = 0;
vector<int> parent(N) , len(N) , use(N) , must_visit(N) , cycle;
vector<vector<int>> lis(N);
void dfs(int u , int p = -1){
	for(int i = 0;i < lis[u].size();i ++){
		if(lis[u][i] != p){
			parent[lis[u][i]] = u;
			dfs(lis[u][i] , u);
		}
	}
}
void DFS(int u){
	cycle.push_back(u);
	for(int i = 0;i < lis[u].size();i ++){
		DFS(lis[u][i]);
	}
	if(u != 1) cycle.push_back(parent[u]);
}
int main() {
	cin >> n >> m;
	for(int i = 1;i <= n;i ++){
		cin >> len[i];
		for(int j = 1;j <= len[i];j ++){
			int x;
			cin >> x;
			lis[i].push_back(x);
		}
	}
	for(int i = 1;i <= m;i ++){
		cin >> must_visit[i];
	}
	dfs(1);
	for(int i = 1;i <= n;i ++){
		if(lis[i][0] == parent[i] && lis[i].size() > 1) ++back_edges;
	}
	int u = 1 , id = 1 , ans = 0;
	while(id <= m){
		if(u == 1 && !back_edges) break;
		++ans;
		if(must_visit[id] == u) ++id;
		if(lis[u][use[u] % len[u]] == parent[u] && lis[u].size() > 1) --back_edges;
		++use[u];
		if(lis[u][use[u] % len[u]] == parent[u] && lis[u].size() > 1) ++back_edges;
		u = lis[u][(use[u] - 1) % len[u]];
	}
	for(int i = 1;i <= n;i ++){
		if(i != 1){
			int pos = 0;
			for(int j = 0;j < lis[i].size();j ++){
				if(lis[i][j] == parent[i]){
					pos = j;
				}
			}
			vector<int> x;
			for(int j = pos + 1;j < lis[i].size();j ++) x.push_back(lis[i][j]);
			for(int j = 0;j < pos;j ++) x.push_back(lis[i][j]);
			lis[i] = x;
		}
	}
	DFS(1);
	if(id > m){
		cout << ans << endl;
		return 0;
	}
	cycle.pop_back();
	int pos = 0;
	vector<vector<int>> occs(n + 1);
	for(int i = 1;i <= (int)cycle.size();i ++){
		occs[cycle[i - 1]].push_back(i);
	}
	for(int i = 1;i <= n;i ++){
		occs[i].push_back((int)cycle.size() + 1);
	}
	int full = 0;
	for(int i = id;i <= m;i ++){
		int need = must_visit[i] , next = *upper_bound(occs[need].begin() , occs[need].end() , pos);
		if(next <= (int)cycle.size()){
			pos = next;
		}else{
			++full;
			pos = occs[need][0];
		}
	}
	cout << ans + full * (int)cycle.size() + pos << endl;
}
