#include <bits/stdc++.h>
//#include "game.h"
using namespace std;

vector<pair<int,int>> arr;
int n,d;
vector<int> T,T1,assign;


void build(int v,int tl,int tr) {
	if(tl == tr) {
		T1[v] = arr[tl].first;
	}else {
		int tm = (tl + tr)/2;
		T1[v] = max(T1[2*v],T1[2*v+1]);
	}
}

void query1(int v,int l,int r,int tl,int tr) {
	if(l > r) return 0;
	if(tl == l and tr == r) return T[v];
	else {
		int tm = (tl + tr)/2;
		return max(query1(2*v,l,min(r,tm),tl,tm),query1(2*v+1,max(l,tm+1),r,tm+1,tr));
	}
}

void push(int v) {

	if(assign[v] != 0) {
		assign[2*v] = assign[2*v+1] = assign[v];
		T[2*v] = T[2*v+1] = assign[v];
		assign[v] = 0;
	} 

}

void update(int v,int tl,int tr,int l,int r) {
	if(l > r) return;
	if(tl == l and tr == r) {
		assign[v] = T[v] = 1;
	}else {
		push(v);
		int tm = (tl + tr)/2;
		update(2*v,tl,tm,l,min(r,tm)); update(2*v+1,tm+1,tr,max(l,tm+1),r);
		T[v] = max(T[2*v],T[2*v+1]);
	}
}

int query(int v,int l,int r,int tl,int tr) {
	if(l > r) return 0;
	else if(tl == l and tr == r) return T[v];
	else {
		push(v);
		int tm = (tl + tr)/2;
		return max(query(2*v,l,min(r,tm),tl,tm),query(2*v+1,max(l,tm+1),r,tm+1,tr));
	}
}

void init(std::vector<int> A, int D) {
	n = A.size(); arr.resize(n); 
	d = D; 
	for(int i=0;i<n;i++) {
		arr[i] = {A[i],i};
	}

	T.resize(4*n+5); T1.resize(4*n+5);
	build(1,0,n-1); 
	assign = vector<int>(4*n+5,0); 

	sort(arr.begin(),arr.end(),greater<pair<int,int>());

	for(auto [val,idx] : arr) {

		int l = idx, r = n-1,idx1,idx2;

		while(l <= r) {
			int mid = (tl + tr)/2;
			if(query(1,idx,mid,0,n-1) == 1) {
				idx1 = mid - 1;
				r = mid - 1;
			}else {
				l = mid + 1;
			}
		}

		l = 0,r = idx;

		while(l <= r) {
			int mid = (tl + tr)/2;
			if(query(1,idx,mid,0,n-1) == 1) {
				idx2 = mid + 1;
				l = mid + 1;
			}else {
				r = mid - 1;
			}
		}


		int mx = query1(1,idx1,idx2,0,n-1);

		if(mx == val) {
			update(1,0,n-1,idx1,idx-1);
			update(1,0,n-1,idx+1,idx2);
		}

	}
	
	
}

void updateValue(int index, int newValue) {}

bool isWinning(int startIndex) {

	return query(1,startIndex,startIndex,0,n-1);

}