#include <bits/stdc++.h>
#define vc vector

using ll = long long;
using namespace std;
const int M = 1e8 + 543;
const int mod = M;
const int N = 5e5;
const int lg = 20;

vc <int> g[N];
vc <int> ip[N];
int ptr[N];
int tin[N], tout[N];
int P[N], up[N][lg], timer = 0;
map <int, int> where[N];

int when (int u, int k) {
    int res = 0;
    for (; ptr[u] != k; ptr[u] = (ptr[u] + 1) % g[u].size()) {
        int v = g[u][ptr[u]];
        res += when(v, ip[u][ptr[u]]) + 2;
    }
    return res;
}

void dfs (int u) {
    tin[u] = timer++;
    for (int j = 1; j < lg; ++j)
        up[u][j] = up[up[u][j - 1]][j - 1];
    for (int v : g[u]) {
        if (v != up[u][0]) {
            up[v][0] = u;
            dfs(v);
        }
    }
    tout[u] = timer;
}

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int v;
            cin >> v;
            g[i].push_back(v - 1);
            where[i][v - 1] = j;
        }
    }

    for (int i = 0; i < m; ++i) {
        cin >> P[i];
        --P[i];
    }
    int j = 0;
    int ans = 1;
    int u = 0;
    for (; j < m; ++ans) {
        if (u == P[j])
            ++j;
        if (j == m)
            break;
        int v = g[u][ptr[u]];
        ptr[u] = (ptr[u] + 1) % g[u].size();
        u = v;
    }
    cout << ans << '\n';
    return 0;
}