#include "game.h"
#include <bits/stdc++.h>
#define vc vector
#define pii pair <int, int>

using ll = long long;
using namespace std;
const int M = 4e4;
const int mod = 1e9 + 7;
const int N = 2e3;
const int lg = 20;
const int C = 1e9;

template <class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template <class T>
bool chmin(T &a, T b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}


const int c = 25000;
ll dp[N][2][2];
int a[N], d, n;

void calc () {
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= 1; ++j)
            dp[i][j][0] = dp[i][j][1] = 0;
    }
    for (int take = 1; take <= c; ++take) {
        int cur = take & 1;
        int lst = cur ^ 1;
        for (int i = 0; i < n; ++i) {
            for (int f = 0; f < 2; ++f)
                dp[i][cur][f] = 0;
        }
        deque <int> q1, q2;
        vc <ll> cost1(n), cost2(n);
        for (int i = 0; i < n; ++i) {
            cost1[i] = dp[i][lst][0] + a[i];
            cost2[i] = dp[i][lst][1] - a[i];
        }
        for (int j = 0; j < n; ++j) {
            if (!q1.empty()) {
                chmax(dp[j][cur][1], cost1[q1.front()]);
            }
            if (!q2.empty()) {
                chmin(dp[j][cur][0], cost2[q2.front()]);
            }
            while (!q1.empty() && cost1[q1.back()] < cost1[j]) {
                q1.pop_back();
            }
            q1.push_back(j);
            if (q1.front() == j - d)
                q1.pop_front();
            while (!q2.empty() && cost2[q2.back()] > cost2[j]) {
                q2.pop_back();
            }
            q2.push_back(j);
            if (q2.front() == j - d)
                q2.pop_front();
        }
        q1.clear(); q2.clear();
        for (int j = n - 1; j >= 0; --j) {
            if (!q1.empty()) {
                chmax(dp[j][cur][1], cost1[q1.front()]);
            }
            if (!q2.empty()) {
                chmin(dp[j][cur][0], cost2[q2.front()]);
            }
            while (!q1.empty() && cost1[q1.back()] < cost1[j]) {
                q1.pop_back();
            }
            q1.push_back(j);
            if (q1.front() == j + d)
                q1.pop_front();
            while (!q2.empty() && cost2[q2.back()] > cost2[j]) {
                q2.pop_back();
            }
            q2.push_back(j);
            if (q2.front() == j + d)
                q2.pop_front();
        }
    }
}

void init (vc <int> A, int D) {
    d = D;
    n = A.size();
    for (int i = 0; i < A.size(); ++i)
        a[i] = A[i];
    calc();
}

bool isWinning(int i) {
    return dp[i][1][1] > 0;
}

void updateValue(int i, int x) {
    a[i] = x;
    calc();
}