#include <bits/stdc++.h>
#define vc vector
#define pii pair <int, int>

using ll = long long;
using namespace std;
const int M = 4e4;
const int mod = M;
const int N = 5e5;
const int lg = 20;
const int C = 1e9;

template <class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct dsu {
    vc <int> p, r;
    dsu () {}
    dsu (int n) {
        p.resize(n); iota(p.begin(), p.end(), 0);
        r.resize(n, 1);
    }
    int find (int u) {
        return u == p[u] ? u : p[u] = find(p[u]);
    }
    int unite (int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return 0;
        if (r[u] < r[v]) swap(u, v);
        p[v] = u;
        r[u] += r[v];
        return 1;
    }
};

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n, k, m;
    cin >> n >> k >> m;
    vc <int> a(n);
    vc <pii> d;
    vc <int> dd;
    vc <int> prime(M), p;
    for (int i = 2; i <= M; ++i) {
        if (!prime[i]) {
            p.push_back(i);
            for (int j = i * i; j <= M; j += i) {
                prime[j] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        int x = a[i];
        for (int j : p) {
            if (x % j == 0) {
                d.push_back({j, 0});
                while (x % j == 0)
                    d.back().second++, x /= j;
            }
        }
        if (x != 1)
            d.push_back({x, 1});
        for (auto [u, v] : d)
            dd.push_back(u);
    }
    sort(dd.begin(), dd.end()); dd.resize(unique(dd.begin(), dd.end()) - dd.begin());
    vc <dsu> dsus;
    for (int y : dd) {
        dsus.push_back(dsu(n));
        vc <vc <int>> ind(32);
        int mx = 0;
        for (int j = 0; j < n; ++j) {
            int cnt = 0, x = a[j];
            while (x % y == 0) {
                ++cnt;
                x /= y;
            }
            ind[cnt].push_back(j);
            chmax(mx, cnt);
        }
        for (int i = 0; i <= mx; ++i) {
            int s = ind[i].size();
            for (int j = 0; j < s - 1; ++j)
                dsus.back().unite(ind[i][j], ind[i][j + 1]);
        }
        if (ind[mx].size() < k) {
            for (int j = mx - 1; j >= 0; --j) {
                if (!ind[j].empty()) {
                    dsus.back().unite(ind[mx][0], ind[j][0]);
                    break;
                }
            }
        }
    }
    vc <vc <int>> g(n, vc <int> (n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            g[i][j] = 1;
            for (int v = 0; v < dd.size(); ++v) {
                g[i][j] &= dsus[v].find(i) == dsus[v].find(j);
            }
        }
    }
    vc <int> used(n);
    vc <pii> sorted;
    for (int i = 0; i < n; ++i)
        sorted.push_back({a[i], i});
    sort(sorted.begin(), sorted.end());
    vc <int> in;
    for (int i = 0; i < n; ++i) {
        for (auto [x, j] : sorted) {
            if (used[j])
                continue;
            int f = 1;
            for (int v = 0; v <= i; ++v) {
                f &= g[v][j];
            }
            if (f) {
                in.push_back(j);
                used[j] = 1;
                break;
            }
        }
    }
    for (int i : in)
        cout << a[i] << ' ';
}
// 1 2 3 2 1 2 4 2 3 2 1 2