#include <bits/stdc++.h>
#define vc vector
#define pii pair <int, int>

using ll = long long;
using namespace std;
const int M = 4e4;
const int mod = M;
const int N = 5e5;
const int lg = 20;
const int C = 1e9;

template <class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct dsu {
    vc <int> p, r;
    dsu () {}
    dsu (int n) {
        p.resize(n); iota(p.begin(), p.end(), 0);
        r.resize(n, 1);
    }
    int find (int u) {
        return u == p[u] ? u : p[u] = find(p[u]);
    }
    int unite (int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return 0;
        if (r[u] < r[v]) swap(u, v);
        p[v] = u;
        r[u] += r[v];
        return 1;
    }
};

void solve () {
    int n, k, m;
    cin >> n >> k >> m;
    vc <int> a(n);
    vc <pii> d;
    vc <int> dd;
    vc <int> prime(M), p;
    map <int, vc <pii>> who;
    for (int i = 2; i <= M; ++i) {
        if (!prime[i]) {
            p.push_back(i);
            for (int j = i * i; j <= M; j += i) {
                prime[j] = 1;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        int x = a[i];
        for (int j : p) {
            if (x % j == 0) {
                d.push_back({j, 0});
                while (x % j == 0)
                    d.back().second++, x /= j;
            }
        }
        if (x != 1)
            d.push_back({x, 1});
        for (auto [u, v] : d) {
            dd.push_back(u);
            who[u].push_back({i, v});
        }
    }
    sort(dd.begin(), dd.end()); dd.resize(unique(dd.begin(), dd.end()) - dd.begin());
    vc <dsu> dsus;
    vc <bitset <1000>> bits(n);
    for (int i = 0; i < n; ++i)
        bits[i].set(1);
    bitset <1000> cur;
    for (int y : dd) {
        vc <vc <int>> ind(32);
        int mx = 0;
        int ccc = 0;
        for (auto [j, cnt] : who[y]) {
            ind[cnt].push_back(j);
            chmax(mx, cnt);
            ccc += cnt;
        }
        if (ccc < k)
            continue;
        int sum = 0;
        vc <int> back;
        int lst = -1;
        for (int j = mx; j >= 0; --j) {
            if (sum < k && !ind[j].empty()) {
                for (int i = 0; i < ind[j].size(); ++i) {
                    back.push_back(ind[j][i]);
                }
                ind[j].clear();
            }
            if (sum >= k && !ind[j].empty()) {
                for (int i : back)
                    ind[j].push_back(i);
                mx = j;
                break;
            }
            sum += ind[j].size();
        }
        for (int i = 1; i <= mx; ++i) {
            for (int j : ind[i])
                cur[j] = 1;
            for (int j : ind[i])
                bits[j] &= cur;
            for (int j : ind[i])
                cur[j] = 0;
        }
    }
    dsu good(n);
    unordered_map <int, vc <int>> mp;
    for (int i = 0; i < n; ++i) {
        int hsh = 0;
        for (int j = 0; j < n; ++j) {
            hsh = (hsh * 1ll * 2 + bits[i][j]) % mod;
        }
        mp[hsh].push_back(i);
    }
    vc <int> in(n);
    for (auto [mysor, v] : mp) {
        vc <int> was = v;
        sort(v.begin(), v.end(), [&](int i, int j) {
            return a[i] < a[j];
        });
        for (int i = 0; i < v.size(); ++i)
            in[was[i]] = v[i];
    }
    for (int i : in)
        cout << a[i] << ' ';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int T;
    cin >> T;
    while (T--)
        solve();
}
// 1 2 3 2 1 2 4 2 3 2 1 2