#include <bits/stdc++.h>
#define int long long
#define vc vector
#define pii pair <int, int>

using ll = long long;
using namespace std;
const int M = 4e4;
const int mod = 1e9 + 7;
const int N = 5e5;
const int lg = 20;
const int C = 1e9;

template <class T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct dsu {
    vc <int> p, r;
    dsu () {}
    dsu (int n) {
        p.resize(n); iota(p.begin(), p.end(), 0);
        r.resize(n, 1);
    }
    int find (int u) {
        return u == p[u] ? u : p[u] = find(p[u]);
    }
    int unite (int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return 0;
        if (r[u] < r[v]) swap(u, v);
        p[v] = u;
        r[u] += r[v];
        return 1;
    }
};
int prime[M + 1];
vc <int> p;

void solve () {
    int n, k, x;
    cin >> n >> k >> x;
    vc <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vc <int> b = a; sort(b.begin(), b.end());
    do {
        vc <int> p(n);
        for (int i = 0; i < k; ++i)
            p[n - i - 1] = 1;
        int f = 1;
        do {
            int g1 = 0, g2 = 0;
            for (int i = 0; i < n; ++i) {
                if (p[i]) {
                    g1 = __gcd(g1, a[i]);
                    g2 = __gcd(g2, b[i]);
                }
            }
            if (g1 != g2) {
                f = 0;
                break;
            }
        } while (next_permutation(p.begin(), p.end()));
        if (f)  {
            for (int i : b)
                cout << i << ' ';
            cout << '\n';
            break;
        }
    } while (next_permutation(b.begin(), b.end()));
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    for (int i = 2; i <= M; ++i) {
        if (!prime[i]) {
            p.push_back(i);
            for (int j = i * i; j <= M; j += i) {
                prime[j] = 1;
            }
        }
    }
    int T;
    cin >> T;
    while (T--)
        solve();
}
// 2 4 8 16 32 512 128 256 1024 64 2048