#include <bits/stdc++.h>

using namespace std;

const int maxlogn = 20;
const int maxn = 500001;

int la[maxlogn][maxn];
int tin[maxn],tout[maxn];
vector<int> g[maxn];
int st[maxn];
int ntr[maxn];
int pv[maxn];
int np[maxn];
int tv[maxn];
int times = 0;
int64_t ans = 0;

void dfs(int v,int p,int tr)
{
    tin[v] = times++;
    pv[v] = p;
    ntr[v] = tr;
    int pp = -1;
    for(int i = 0;i < g[v].size();++i)
    {
        if(g[v][i] == p)
        {
            pp = i;
            tr++;
        }
        else
        {
            dfs(g[v][i],v,tr);
        }
    }
    if(pp != -1)
    {
        st[v] = g[v].size()-pp-1;
        rotate(g[v].begin(),g[v].begin() + pp + 1,g[v].end());
    }
    else
        st[v] = 0;
    tout[v] = times++;
    return ;
}
void dfs_sim(int v,int ver,int par)
{
    ans++;
    if(v == ver && tv[v] == par)
    {
        cout << ans << "\n";
        exit(0);
    }
    dfs_sim(g[v][tv[v]++],ver,par);
}
bool isP(int u,int v)
{
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}
int ne(int u,int v)
{
    for(int i = maxlogn-1;i >= 0;--i)
    {
        if(!isP(la[i][v],u))
        {
            v = la[i][v];
        }
    }
    return np[v];
}
pair<int,pair<int,int>> lca(int u,int v)
{
    for(int i = maxlogn-1;i >= 0;--i)
    {
        if(!isP(la[i][v],u))
        {
            v = la[i][v];
        }
    }
    for(int i = maxlogn-1;i >= 0;--i)
    {
        if(!isP(la[i][u],v))
        {
            u = la[i][u];
        }
    }
    return {pv[v],{u,v}};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,m;
    cin >> n >> m;
    for(int i = 0;i < n;++i)
    {
        int k;
        cin >> k;
        g[i].resize(k);
        for(int j = 0;j < k;++j)
        {
            cin >> g[i][j];
            g[i][j]--;
        }
    }
    dfs(0,-1,1);
    for(int i = 0;i < n;++i)
    {
        for(int j = 0;j < g[i].size();++j)
        {
            if(g[i][j] != pv[i])
            {
                np[g[i][j]] = j;
            }
        }
    }
    pv[0] = 0;
    for(int i = 0;i < maxlogn;++i)
    {
        for(int j = 0;j < n;++j)
        {
            if(i == 0)
                la[i][j] = pv[j];
            else
                la[i][j] = la[i-1][la[i-1][j]];
        }
    }
    int cv = 0,num = 1,nec = 0;
    for(int i = 0;i < m;++i)
    {
        int tv;
        cin >> tv;
        tv--;
        if(cv == tv && i == 0)
        {
            continue;
        }
        else if(cv == tv)
        {
            if(nec+1 != g[cv].size())
            {
                nec++;
            }
            else
            {
                num++;
                nec = 0;
            }
        }
        else if(isP(cv,tv))
        {
            int tx = ne(cv,tv);
            if(tx >= nec)
            {
                cv = tv;
                nec = (num <= ntr[tv] ? st[tv] : 0);
                num = max(num,ntr[tv]);
            }
            else
            {
                cv = tv;
                nec = (num+1 <= ntr[tv] ? st[tv] : 0);
                num = max(num+1,ntr[tv]);
            }
        }
        else if(isP(tv,cv))
        {
            int tx = ne(tv,cv);
            cv = tv;
            nec = tx + 1;
        }
        else
        {
            pair<int,pair<int,int>> ck = lca(cv,tv);
            int x = ck.first;
            int tx = ck.second.first;
            int tx2 = ck.second.second;
            if(tx2 > tx)
            {
                cv = tv;
                nec = (num <= ntr[tv] ? st[tv] : 0);
                num = max(num,ntr[tv]);
            }
            else
            {
                cv = tv;
                nec = (num+1 <= ntr[tv] ? st[tv] : 0);
                num = max(num+1,ntr[tv]);
            }
        }
    }
    for(int i = 0;i < n;++i)
    {
        if(ntr[i] > num-1)
        {
            continue;
        }
        else if(ntr[i] == num-1)
        {
            ans += g[i].size()-st[i];
        }
        else
        {
            ans += g[i].size()-st[i] + g[i].size()*(num-1-ntr[i]);
        }
    }
    for(int j = 0;j < n;++j)
    {
        tv[j] = (ntr[j] < num ? 0 : st[j]);
    }
    dfs_sim(0,cv,nec);
}
