#include "game.h"
#include <bits/stdc++.h>

using namespace std;

constexpr int N = 2e5 + 1;

int n, D;
int a[N];
bool dp[N][2];

void work() {
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return a[i] > a[j];
    });
    for (int i = 0, j = 0; i < n; i = j) {
        while (j < n && a[ord[i]] == a[ord[j]]) {
            ++j;
        }
        for (int t = i; t < j; ++t) {
            int k = ord[t];
            bool yay = false;
            bool all = true;
            bool good = 0;
            for (int p = max(0, k - D); p < min(n, k + D + 1); ++p) {
                if (p == k) {
                    continue;
                }
                if (a[p] > a[k] && !dp[p][1]) {
                    yay = true;
                }
                if (a[p] > a[k]) {
                    all = false;
                }
                good &= a[p] < a[k];
            }
            if (all) {
                dp[k][0] = false;
            } else {
                dp[k][0] = yay || good;
            }
        }
        for (int t = i; t < j; ++t) {
            int k = ord[t];
            bool yay = false;
            bool all = true;
            bool good = 0;
            for (int p = max(0, k - D); p < min(n, k + D + 1); ++p) {
                if (p == k) {
                    continue;
                }
                if (a[p] >= a[k] && !dp[p][0]) {
                    yay = true;
                }
                if (a[p] >= a[k]) {
                    all = false;
                }
                good &= a[p] <= a[k];
            }
            if (all) {
                dp[k][1] = false;
            } else {
                dp[k][1] = yay || good;
            }
        }
    }
//    for (int i = 0; i < n; ++i) {
//        cout << dp[i][0];
//    }
//    cout << '\n';
//    for (int i = 0; i < n; ++i) {
//        cout << dp[i][1];
//    }
//    cout << '\n';
}

void init(std::vector<int> A, int D) {
    n = size(A);
    ::D = D;
    copy(A.begin(), A.end(), a);
    work();
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    work();
}

bool isWinning(int i) {
    bool yay = false;
    bool any = false;
    for (int k = max(0, i - D); k < min(n, i + D + 1); ++k) {
        if (k != i && !dp[k][1]) {
            any = true;
        }
    }
    return yay || any;
}