#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, k, X;
    cin >> n >> k >> X;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    map<int, bool> checked;
    auto check = [&](int d) {
        if (d == 1) {
            return false;
        }
        if (checked.count(d)) {
            return checked[d];
        }
        int ans = 0;
        for (int x : a) {
            if (x % d == 0) {
                ans += 1;
                if (ans >= k) {
                    break;
                }
            }
        }
        return checked[d] = (ans >= k);
    };

    vector<int> grouped(n);
    vector<int> answer(n);
    for (int i = 0; i < n; ++i) {
        if (grouped[i]) {
            continue;
        }
        grouped[i] = true;
        vector<int> cur{i};
        for (int j = i + 1; j < n; ++j) {
            if (grouped[j]) {
                continue;
            }
            int x = a[i], y = a[j];
            int d = gcd(x, y);
            x /= d, y /= d;
            bool yay = true;
            for (int t : {x, y}) {
                for (int f = 1; f * f <= t && yay; ++f) {
                    if (t % f == 0) {
                        yay &= !check(f);
                        yay &= !check(t / f);
                    }
                }
            }
            if (yay) {
                grouped[j] = true;
                cur.push_back(j);
            }
        }
        vector<int> s = cur;
        sort(s.begin(), s.end(), [&](int x, int y) {
            return a[x] < a[y];
        });
        for (int t = 0; t < size(s); ++t) {
            answer[cur[t]] = a[s[t]];
        }
    }

    for (int x : answer) {
        cout << x << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}