#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    int n, k, X;
    cin >> n >> k >> X;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    map<int, int> mp;
    for (int x : a) {
        for (int d = 1; d * d <= x; ++d) {
            if (x % d == 0) {
                if (d > 1) {
                    mp[d] += 1;
                }
                if (d * d < x) {
                    mp[x / d] += 1;
                }
            }
        }
    }

    vector<int> good;
    for (auto [x, y] : mp) {
        if (y >= k) {
            good.push_back(x);
//            cout << x << " ";
        }
    }
//    cout << endl;

    vector<int> grouped(n);
    vector<int> answer(n);
    for (int i = 0; i < n; ++i) {
        if (grouped[i]) {
            continue;
        }
        grouped[i] = true;
        vector<int> cur{i};
        for (int j = i + 1; j < n; ++j) {
            if (grouped[j]) {
                continue;
            }
            int x = a[i], y = a[j];
//            int d = gcd(x, y);
//            x /= d, y /= d;
            bool yay = true;
            for (int t : good) {
                if ((x % t == 0) != (y % t == 0)) {
                    yay = false;
                    break;
                }
            }
            if (yay) {
                grouped[j] = true;
                cur.push_back(j);
            }
        }
        vector<int> s = cur;
        sort(s.begin(), s.end(), [&](int x, int y) {
            return a[x] < a[y];
        });
        for (int t = 0; t < size(s); ++t) {
            answer[cur[t]] = a[s[t]];
        }
    }

    for (int x : answer) {
        cout << x << " ";
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}