#include <bits/stdc++.h>
using namespace std;

int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b, a % b);
}

void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n), order(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        order[i] = i;
    }
    vector<int> cnt(1 << n), check;
    for (int mask = 1; mask < (1 << n); ++mask) {
        cnt[mask] = cnt[mask ^ (mask & -mask)] + 1;
        if (cnt[mask] == k) {
            check.emplace_back(mask);
        }
    }
    vector<int> ans = a, tmp(n);
    do {
        bool ok = true;
        for (const int& mask : check) {
            int resa = 0, resb = 0;
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    resa = gcd(resa, a[i]);
                    resb = gcd(resb, a[order[i]]);
                }
            }
            if (resa != resb) {
                ok = false;
                break;
            }
        }
        if (ok) {
            for (int i = 0; i < n; ++i) {
                tmp[i] = a[order[i]];
            }
            ans = min(ans, tmp);
        }
    } while (next_permutation(order.begin(), order.end()));
    for (const int& el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "-------------\n";
        cout << "-------------\n";
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif
    
    return 0;
}
