#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll binpow(ll a, ll st, ll mod) {
    if (st == 0) {
        return 1;
    }
    ll ans = binpow(a, st / 2, mod);
    ans = (ans * ans) % mod;
    if (st % 2) {
        ans = (ans * a) % mod;
    }
    return ans;
}
mt19937 rd(333);
bool check(ll x) {
    if (x % 2 == 0) {
        return false;
    }
    ll st = x - 1;
    while (st % 2 == 0) {
        st /= 2;
    }
    for (int j = 0; j < 20; j++) {
        ll a = rd() % x;
        ll d = binpow(a, st, x);
        if (d != 1) {
            ll t = st;
            while (t != (x - 1)) {
                d = (d * d) % x;
                t *= 2;
                if (d == x - 1) {
                    break;
                }
            }
            if (d != x - 1) {
                return false;
            }
        }
    }
    return true;
}

void solve() {
    ll n, k, x;
    cin >> n >> k >> x;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<ll> reserv = a;
    map<pair<ll, ll>, ll, greater<>> max_step;
    vector<vector<pair<ll, ll>>> had(n);
    for (int i = 0; i < n; i++) {
        for (ll j = 2; j * j <= a[i]; j++) {
            if (check(a[i])) {
                break;
            }
            if (a[i] % j == 0) {
                ll col = 0;
                while (a[i] % j == 0) {
                    a[i] /= j;
                    col++;
                }
                had[i].push_back({j, col});
                for (int f = 1; f <= col; f++) {
                    max_step[{j, f}]++;
                }
            }
        }
        if (a[i] != 1) {
            had[i].push_back({a[i], 1});
            max_step[{a[i], 1}]++;
        }
    }
    map<ll, ll> ogr;
    for (auto el : max_step) {
        if (el.second >= k) {
            ogr[el.first.first] = max(el.first.second, ogr[el.first.first]);
        }
    }
    for (auto& el : had) {
        for (auto& el2 : el) {
            el2.second = min(el2.second, ogr[el2.first]);
        }
        vector<pair<ll, ll>> an;
        for (auto el2 : el) {
            if (el2.second) {
                an.push_back(el2);
            }
        }
        el = an;
    }
    map<vector<pair<ll, ll>>, vector<ll>> our;
    for (int i = 0; i < n; i++) {
        our[had[i]].push_back(i);
    }
    vector<ll> ans(n);
    for (auto el : our) {
        vector<ll> z;
        for (auto el2 : el.second) {
            z.push_back(reserv[el2]);
        }
        sort(z.begin(), z.end());
        for (int j = 0; j < z.size(); j++) {
            ans[el.second[j]] = z[j];
        }
    }
    for (auto el : ans) {
        cout << el << " ";
    }
    cout << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
