﻿#include <bits/stdc++.h>
#ifdef LOCAL
#include "debug.h"
#else
#define debug(x...) 228
#endif

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define fi first
#define se second

const int inf = int(1e9) + 1;
const ll infll = ll(1e18) + 1;
const int mod = int(1e9) + 7;
mt19937_64 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) return a = b, true;
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) return a = b, true;
    return false;
}

void solve_case() {
    int n, m; cin >> n >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int x; cin >> x; x--;
            g[i].push_back(x);
        }
    }
    vector<int> a(m);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        a[i]--;
    }
    vector<int> par(n);
    vector<int> id_par(n, -1);
    vector<int> w(n);
    vector<int> cool(n);
    vector<vector<int>> start(n);
    function<void(int, int, int, int)> dfs = [&](int v, int p, int val, int biba) {
        par[v] = p;
        w[v] = val;
        if (v != 0) start[w[v]].push_back(v);
        cool[v] = biba;
        for (int id = 0; id < g[v].size(); id++) {
            if (g[v][id] == p) {
                id_par[v] = p;
                val += 1;
            } else {
                if (v == 0) biba = g[v][id];
                dfs(g[v][id], v, val, biba);
            }
        }
    };
    dfs(0, -1, 0, -1);
    vector<int> sz(n);
    ll ans = 1;
    int ptr = 0;
    if (a[ptr] == 0) {
        ptr++;
    }
    set<int> st = {0};
    vector<bool> in(n);
    for (int it = 0; ptr < m; it++) {
        if (it < n) {
            for (int x : start[it]) {
                sz[cool[x]] += 1;
                in[x] = true;
                st.insert(x);
            }
        }
        if (!st.count(a[ptr])) {
            for (int v : g[0]) {
                ans += 2 * sz[v];
            }
            continue;
        }
        int ddf = 0;
        for (int v : g[0]) {
            if (a[ptr] == 0) {
                ptr++;
                ans += 2 * sz[v];
                if (ptr == m) break;
                continue;
            }
            if (cool[a[ptr]] != v) {
                ans += 2 * sz[v];
                continue;
            }
            int curv = 0;
            vector<int> ww(n);
            ww[0] = ddf;
            for (int i = 1; i < n; i++) {
                if (w[i] < it) {
                    ww[i] = (id_par[i] + 1) % g[i].size();
                }
            }
            while (ptr != m) {
                if (a[ptr] == curv) ptr++;
                if (ptr == m) break;
                ans += 1;
                int u = g[curv][ww[v]];
                ww[curv] += 1;
                ww[curv] %= (int)g[curv].size();
                curv = u;
                if (curv == 0) break;
            }
        }
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
    clock_t tStart = clock();
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
#ifdef LOCAL
    fprintf(stderr, "\n>> Runtime: %.10fs\n", (double) (clock() - tStart) / CLOCKS_PER_SEC);
#endif
}