#include "game.h"
//#include <vector>
//#include <iostream>
#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define pb push_back
#define pii pair < int, int >
#define fob find_by_order
#define orok order_of_key

using namespace std;
using namespace __gnu_pbds;

const int N = 2e5 + 10;

int a[N], good[N];
int d, n;
int win[N];

vector < int > g[N];

typedef tree <pii, null_type, less < pii >, rb_tree_tag, tree_order_statistics_node_update > oset;

oset G;
void init(vector < int > A, int D) {
     d = D;
     n = (int)(A.size());

     for(int i = 1; i <= n; i++) {
         a[i] = A[i - 1];
     }

     for(int i = 1; i <= n; i++) {
         int l = max(1, i - d), r = min(n, i + d);
         int mx = 0;

         for(int j = l; j <= r; j++) {
             if(j != i) g[i].pb(j);
             mx = max(mx, a[j]);
         }

         good[i] = (mx == a[i]);
         if(good[i]) G.insert({i, a[i]});
     }

     set < pii > st;
     for(int i = 1; i <= n; i++) {
         st.insert({a[i], i});
     }

     for(int i = 1; i <= n; i++)
     if(good[i]) {

        st.erase({a[i], i});
        win[i] = 2;
//                cerr << "! " << i << ' ' << a[i] << ' ' << win[i] << endl;
        for(auto to : g[i]) {
//                cerr << to << endl;
                st.erase({a[to], to});
                win[to] = 1;
        }
     }
//     cout << win[5] << endl;

     while(!st.empty()) {
           pii p = (*st.rbegin());
           st.erase(p);
           win[p.S] = 2;

           for(auto to : g[p.S])
           if(!win[to]) {
//              cerr << "!!! " << to << endl;
              win[to] = 1;
              st.erase({a[to], to});

           }
     }

//     for(int i = 1; i <= n; i++) cout << win[i] << ' ';
//     cout << endl;


}

bool isWinning(int s) {
     s++;
     if(G.find({s, a[s]}) != G.end()) return 0;


     int frst = 0, scnd = n + 1;
     int lss = G.orok({s, a[s]});

     if(lss > 0) frst = (*G.fob(lss - 1)).F;
     if(lss != (int)(G.size())) scnd = (*G.fob(lss)).F;

     if(frst == 0) {
        if(scnd <= d + 1) return 1;
        return ((s % (d + 1)) != (scnd % (d + 1)));
     }
     if(scnd == n + 1) {
        if(frst + d + 1 > n) return 1;
        return ((s % (d + 1)) != (frst % (d + 1)))
     }
     set < pii > st;
     if(scnd - frst - 1 <= 2 * d) return 1;
     frst += d, scnd -= d;

     for(int i = frst + 1; i < scnd; i++) win[i] = 0, st.insert({a[i], i});

     while(!st.empty() && !win[s]) {
           pii p = (*st.rbegin());
           st.erase(p);
           win[p.S] = 2;

           for(auto to : g[p.S])
           if(!win[to]) {
//              cerr << "!!! " << to << endl;
              win[to] = 1;
              st.erase({a[to], to});

           }
     }

     return (win[s] == 1);


}

void updateValue(int i, int x) {
     a[i + 1] = x;

     int l = max(1, i + 1 - d), r = min(n, i + 1 + d);
     int mx = 0;
     for(int j = l; j <= r; j++) mx = max(mx, a[j]);

     if((win[i + 1] == 1) != (mx == a[i + 1])) return;

     for(int j = l; j <= r; j++) {
         if(win[j] == 2) {G.erase({j, a[j]}); win[j] = 1;}
         if(a[j] == mx) {G.insert({j, a[j]}); win[j] = 2;}
     }
}
