#ifndef LOCAL
#pragma GCC target("arch=skylake")
#pragma GCC optimize("O3,inline")
#endif // LOCAL

#include <bits/stdc++.h>
#include "game.h"

#define PB push_back
#define MP make_pair
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()
#define sz(x) ll(x.size())

using namespace std;
typedef int ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=2e9+2;
const ll N=2e5+2;

ve<ll> arr,dp;
unordered_set<ll> st[N];
ll d;

ll calc(ll x)
{
    if(dp[x]!=2) return dp[x];
    st[x].clear();
    
    for(ll i=max(0,x-d);i<=min(sz(arr)-1,x+d);i++)
    {
        if(i==x) continue;
        
        if(arr[i]>arr[x]&&!calc(i))
            st[x].insert(i);
    }
    
    return dp[x]=(sz(st[x])>=1);
}

void rec(ll x)
{
    for(ll i=max(0,x-d);i<=min(sz(arr)-1,x+d);i++)
    {
        if(i==x) continue;
        st[i].erase(x);
        
        if(arr[i]<arr[x]&&!dp[x])
            st[i].insert(x);
        
        if(dp[i]!=(!st[i].empty()))
        {
            dp[i]=!st[i].empty();
            rec(i);
        }
    }
}

void init(ve<ll> _arr, ll _d)
{
    arr=_arr;
    d=_d;
    dp.assign(sz(arr),2);
    
    for(ll i=0;i<sz(arr);i++)
        calc(i);
}

void updateValue(ll k, ll x)
{
    arr[k]=x;
    dp[k]=2;
    calc(k);
    rec(k);
}

bool isWinning(ll x)
{
    return calc(x);
}

#ifdef LOCAL
#include <vector>
#include <iostream>

int main()
{
    int n, D, q;

    std::vector<int> nums;

    scanf("%d %d", &n, &D);

    for (int i = 1; i <= n; i++)
    {
        int x;
        scanf("%d", &x);
        nums.push_back(x);
    }

    init(nums, D);

    scanf("%d", &q);

    for (int i = 1; i <= q; i++)
    {
        int cm;

        scanf("%d", &cm);

        if (cm == 1)
        {
            int ind, val;

            scanf("%d %d", &ind, &val);

            updateValue(ind, val);
        }
        else
        {
            int ind;

            scanf("%d", &ind);

            printf("%d\n", (int)isWinning(ind));
        }
    }

    return 0;
}
#endif // LOCAL
