#include "game.h"
#include <bits/stdc++.h>

#define ve vector
#define fi first
#define se second

using namespace std;


const int MAXN = 5e5+10;

int d;
int n;
ve<int> a;
int dp[MAXN];

void calc(){
    fill(dp, dp + n, -2);
    map<int, ve<int>, greater<int> > poses;
    for(int i = 0; i < n; i++)
        poses[a[i]].push_back(i);
    for(auto i : poses){
        for(auto j : i.se){
            for(int k = max(0, j-d); k < min(n, j + d + 1); k++)
                if(dp[k] == -1)
                    dp[j] = 1;
        }
        for(auto j : i.se){
            if(dp[j] != -2) continue;
            for(int k = max(0, j-d); k < min(n, j + d + 1); k++){
                if(k != j && a[k] == a[j] && dp[k] == -2)
                    dp[k] = 0;
                if(dp[k] == 0)
                    dp[j] = 0;
            }
        }
        for(auto j : i.se)
            if(dp[j] == -2)
                dp[j] = -1;
    }
}


void init(std::vector<int> A, int D){
    a = A;
    d = D;
    n = a.size();
    calc();
}

void updateValue(int index, int newValue){
    a[index] = newValue;
    calc();
}

bool isWinning(int startIndex){
    return dp[startIndex] >= 0;
}


