#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back

int lazy[500001], ans = 0, need, flag[500001], cur_op = 0, pred[500001], n;
deque < int > q[500001], friends;

void calc(int v, int pr)
{
    pred[v] = pr;
    for (auto to: q[v])
        if (to != pr) calc(to, v);
}

void upd_flags(int v)
{
    cur_op++;
    while (v >= 0)
    {
        flag[v] = cur_op;
        v = pred[v];
    }
}

void go_ones(int v, int pr)
{
    if (lazy[v] == 0) return;
    ans += lazy[v];
    bool fl = 0;
    while (!q[v].empty())
    {
        int nxt = q[v].front();
        q[v].pop_front();
        if (nxt == pr) lazy[v]--;
            else
            {
                lazy[nxt] += lazy[v];
                ans += lazy[nxt];
                go_ones(nxt, v);
            }
    }
}

void push(int v, int pr)
{
    if (lazy[v] == 0) return;
    ans += lazy[v];
    bool fl = 0;
    for (int i = 0; i < q[v].size(); i++)
    {
        int nxt = q[v].front();
        q[v].pop_front();
        q[v].push_back(nxt);
        if (nxt == pr)
        {
            lazy[v]--;
            if (lazy[v] == 0) return;
        }
        else
        {
            lazy[nxt] += lazy[v];
            ans += lazy[nxt];
            push(nxt, v);
        }
    }
}

void go(int v, int pr)
{
    if (flag[v] != cur_op)
    {
        lazy[v]++;
        return;
    }
    ans++;
    cerr << v << ' ' << need << ' ' << ans << endl;
    if (v == need)
    {
        friends.pop_front();
        if (friends.empty()) return;
        need = friends.front();
        upd_flags(need);
    }
    push(v, pr);
    int sz = q[v].size();
    if (v == 0) sz = 1e18;
    for (int i = 0; i < sz; i++)
    {
        int nxt = q[v].front();
        q[v].pop_front();
        q[v].push_back(nxt);
        if (nxt == pr) return;
        go(nxt, v);
        if (friends.empty()) return;
        ans++;
        if (v == need)
        {
            friends.pop_front();
            if (friends.empty()) return;
            need = friends.front();
            upd_flags(need);
        }
    }
}

void DFS(int v, int pr)
{
    push(v, pr);
    for (auto to: q[v])
        if (to != pr) DFS(to, v);
}

int32_t main()
{
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
    {
        int sz;
        cin >> sz;
        while (sz--)
        {
            int v;
            cin >> v;
            v--;
            q[i].pb(v);
        }
    }
    int cur = 0;
    bool ones = 1;
    while (m--)
    {
        int v;
        cin >> v;
        v--;
        if (v > 0) ones = 0;
        friends.pb(v);
    }
    if (ones)
    {
        int kol = friends.size() - 1, sz = q[0].size();
        int K = kol % sz;
        ans = friends.size();
        while (!q[0].empty())
        {
            int nxt = q[0].front();
            q[0].pop_front();
            int cur = kol / sz;
            if (K > 0) cur++;
            K--;
            lazy[nxt] = cur;
            go_ones(nxt, 0);
        }
        cout << ans;
        return 0;
    }
    else
    {
        calc(0, 0);
        pred[0] = -1;
        need = friends.front();
        upd_flags(need);
        while (!friends.empty())
            go(0, 0);
        DFS(0, 0);
        cout << ans;
    }
}
