#include <bits/stdc++.h>
using namespace std;

const int maxn = 100005;

int n, m, ci[maxn], pt[maxn], p[maxn][20], tmr, tin[maxn], tout[maxn], d[maxn];
long long ans;
vector<int> g[maxn];

void dfs(int v, int pa) {
    d[v] = d[pa] + 1;
    tin[v] = ++tmr;
    p[v][0] = pa;
    for (int i = 1; i <= __lg(n); i++)
        p[v][i] = p[p[v][i - 1]][i - 1];
    for (auto u : g[v])
        if (u != pa)
            dfs(u, v);
    tout[v] = ++tmr;
}

bool upper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (upper(a, b)) return a;
    if (upper(b, a)) return b;
    for (int i = __lg(n); i >= 0; i--)
        if (!upper(p[a][i], b))
            a = p[a][i];
    return p[a][0];
}

int backtome(int v, int pa) {
    if (g[v][pt[v]] == pa) {
        pt[v] = pt[v] + 1;
        if (pt[v] == g[v].size()) pt[v] -= g[v].size();
        return 1;
    }
    if (pa == 0) {
        int x = g[v][pt[v]];
        pt[v] = pt[v] + 1;
        if (pt[v] == g[v].size()) pt[v] -= g[v].size();
        return 1 + backtome(x, v);
    }
    int res = 1;
    while (g[v][pt[v]] != pa) {
        int u = g[v][pt[v]];
        pt[v] = pt[v] + 1;
        if (pt[v] == g[v].size()) pt[v] -= g[v].size();
        res += 1 + backtome(u, v);
    }
    pt[v] = pt[v] + 1;
    if (pt[v] == g[v].size()) pt[v] -= g[v].size();
    return res;
}

void solve() {
    dfs(1, 1);
    int v = 1;
    ans = 1;
    for (int k = 1; k <= m; k++) {
        int c = ci[k];
        if (k == 1 && c == 1) continue;
        if (v == c) { ans += backtome(v, 0); continue; }
        int lc = lca(v, c), vv = v, cc = c, dist = d[v] + d[c] - 2 * d[lc] + 1, w1[dist + 1];
        int l = 0, r = dist - 1;
        while (vv != lc) {
            w1[l++] = vv;
            vv = p[vv][0];
        }
        while (cc != lc) {
            w1[r--] = cc;
            cc = p[cc][0];
        }
        w1[l] = lc;

        for (int j = 1; j < dist; j++) {
            while (g[v][pt[v]] != w1[j]) {
                int res = backtome(v, 0);
                ans += res;
            }
            pt[v] = pt[v] + 1;
            if (pt[v] == g[v].size()) pt[v] -= g[v].size();
            v = w1[j];
            ans++;
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);
    cin >> n >> m;
    g[0].push_back(1);
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        g[i].resize(k);
        for (int j = 0; j < k; j++)
            cin >> g[i][j];
    }
    for (int i = 1; i <= m; i++)
        cin >> ci[i];
    solve();
    exit(0);
    if (n <= 100000 && m <= 1000) {
        solve();
        exit(0);
    }
    int v = 0;
    for (int i = 1; i <= m; i++) {
        do {
            ans++;
            int ov = v;
            v = g[v][pt[v]];
            pt[ov] = pt[ov] + 1;
            if (pt[ov] == g[ov].size())
                pt[ov] -= g[ov].size();
        } while (v != ci[i]);
    }
    cout << ans << '\n';
}
