#include <bits/stdc++.h>
#include "game.h"

#define sz(x) (int)(x).size()

using namespace std;

vector < int > a;
int d;

const int N = 1e6 + 5;
vector < int > g[N];
bool win[N], used[N];

void calc (int v) {
    if (used[v]) return;
    used[v] = true;
    for (auto& to : g[v]) {
        calc (to);
        win[v] |= !win[to];
    }

}
void rebuild () {
    for (int i = 0; i < sz(a); ++ i) used[i] = false, win[i] = false, g[i].clear();
    for (int i = 0; i < sz(a); ++ i) {
        for (int j = max (0, i - d); j < min (sz(a), i + d + 1); ++ j) {
            if (a[i] < a[j]) g[i].push_back (j);
        }
    }
    for (int i = 0; i < sz(a); ++ i) if (!used[i]) calc (i);
//    cout << " = ";
//    for (int i = 0; i < sz(a); ++ i) cout << win[i] << " ";
//    cout << "\n";
}

void init(std::vector<int> A, int D) {
    a = A, d = D;
    rebuild();
}


void updateValue(int index, int newValue) {
    a[index] = newValue;
    rebuild();
}

bool isWinning(int startIndex) {
    return win[startIndex];
}

/*
6 2
1 7 4 9 30 2
5
2 0
2 1
1 4 8
2 0
2 1
*/
