#include <bits/stdc++.h>

#define sz(x) (int)(x).size()

using namespace std;

const int N = 1e6 + 5;
using ll = long long;

int n, k, x;

bool possible (vector < int >& a, vector < int >& b, int k) {
    vector < int > p (sz(a), 0);
    fill (p.begin(), p.begin() + k, 1);
    reverse (p.begin(), p.end());

    do {
        int gcda = 0, gcdb = 0;
        for (int i = 0; i < sz(p); ++ i) {
            if(p[i]) gcda = __gcd(a[i], gcda);
            if(p[i]) gcdb = __gcd(b[i], gcdb);
        }
        if (gcda != gcdb) return false;
    } while (next_permutation(p.begin(), p.end()));
    return true;
}

void solve () {
    cin >> n >> k >> x;

    vector < int > p (n);
    for (int i = 0; i < n; ++ i) cin >> p[i];

    vector < int > p1 = p;
    sort (p1.begin(), p1.end());

    do {
        if (possible (p, p1, k)) {
            for (auto& it : p1) cout << it << " ";
            cout << "\n";
            return;
        }
    } while (next_permutation(p1.begin(), p1.end()));

}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    cin.tie(nullptr) -> sync_with_stdio(false);

    int tt;
    cin >> tt;
    while (tt --) { solve (); }

    return 0;
}
