#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

using namespace std;

void run_test(int test_case) {
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    assert(x == 1);

    vector<map<int, int>> cnts(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        int x = a[i];

        for (int j = 2; j * j <= x; j++) {
            while (x % j == 0) {
                x /= j;
                cnts[i][j]++;
            }
        }
        if (x > 1) {
            cnts[i][x]++;
        }
    }

    multiset<int> free;
    for (int i = 0; i < n; i++) {
        free.insert(a[i]);
    }
    for (int i = 0; i < n; i++) {
        vector<int> pr;
        for (auto [a, b] : cnts[i]) {
            pr.push_back(a);
        }

        int to_del = 1;
        for (int j = 0; j < sz(pr); j++) {
            int mn = cnts[i][pr[j]];

            vector<int> vals;
            for (int k = 0; k < n; k++) {
                if (k == i) continue;
                vals.push_back(cnts[k][pr[j]]);
            }
            sort(vals.rbegin(), vals.rend());
            mn = min(mn, vals[k - 2]);

            for (int k = 0; k < mn; k++) {
                to_del *= pr[j];
            }
        }
        int mn = 2e9;
        for (int i : free) {
            if (i % to_del == 0) {
                mn = min(mn, i);
            }
        }
        cout << mn << ' ';
        if (free.count(mn)) {
            free.erase(free.find(mn));
        }
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int test_cases = 1;
    cin >> test_cases;

    for (int i = 1; i <= test_cases; i++) {
        run_test(i);
    }

    return 0;
}
