#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define int long long
const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;

void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    map<int, int> mp;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        for (int j = 1; j * j <= a[i]; j++) {
            if (a[i] % j == 0) {
                mp[j]++;
                if (a[i] / j != j) {
                    mp[a[i] / j]++;
                }
            }
        }
    }
    vector<int> lcm(n + 1, 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j * j <= a[i]; j++) {
            if (a[i] % j == 0) {
                if (mp[j] >= k) {
                    lcm[i] = lcm[i] * j / __gcd(lcm[i], j);
                }
                if (a[i] / j != j) {
                    if (mp[a[i] / j] >= k) {
                        lcm[i] = lcm[i] * (a[i] / j) / __gcd(lcm[i], a[i] / j);
                    }
                }
            }
        }
    }
    vector<int> st;
    for (int i = 1; i <= n; i++) st.push_back(i);
    sort(st.begin(), st.end(), [&](int p2, int p1) {
        return a[p1] % lcm[p2] == 0 && a[p2] % lcm[p1] == 0 && a[p2] < a[p1];
    });
    for (auto i : st) cout << a[i] << ' ';
    cout << '\n';
}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
