#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

using namespace std;

using ll = long long;
const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;


vector<int> gt(vector<int> a, vector<int> lcm) {
    int n = (int)(a.size());
    map<int, vector<int>> mp2;
    for (int i = 0; i < n; i++) mp2[lcm[i]].push_back(i);
    for (auto usl : mp2) {
        vector<int> pos = usl.second;
        vector<int> st;
        for (auto i : pos) st.push_back(a[i]);
        sort(st.begin(), st.end());
        int ptr = 0;
        for (auto i : pos) {
            a[i] = st[ptr++];
        }
    }
    return a;
}

void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    gp_hash_table<int, int> mp;
    vector<int> a(n);
    vector<vector<int>> dels(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        for (int j = 1; j * j <= a[i]; j++) {
            if (a[i] % j == 0) {
                mp[j]++;
                dels[i].push_back(j);
                if (a[i] / j != j) {
                    mp[a[i] / j]++;
                }
            }
        }
    }
    vector<int> lcm(n, 1);
    for (int i = 0; i < n; i++) {
        for (auto j : dels[i]) {
            if (a[i] % j == 0) {
                if (mp[j] >= k) {
                    lcm[i] = lcm[i] * 1LL * j / __gcd(lcm[i], j);
                }
                if (a[i] / j != j) {
                    if (mp[a[i] / j] >= k) {
                        lcm[i] = lcm[i] * 1LL * (a[i] / j) / __gcd(lcm[i], a[i] / j);
                    }
                }
            }
        }
    }
    vector<int> res = a;
    res = min(res, gt(a, lcm));
    if (x > 1) {
        for (int i = 0; i < n; i++) {
            lcm[i] *= x;
            a[i] *= x;
            res = min(res, gt(a, lcm));
            lcm[i] /= x;
            a[i] /= x;
        }
    }
    for (int i = 0; i < n; i++) cout << res[i] << ' ';
    cout << '\n';
}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
