#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

using namespace std;

using ll = long long;
const int MAX = 5e5 + 7;
const int mod = 1e9 + 7;


vector<int> gt(vector<int> a, vector<int> lcm) {
    int n = (int)(a.size());
    map<int, vector<int>> mp2;
    for (int i = 0; i < n; i++) mp2[lcm[i]].push_back(i);
    for (auto usl : mp2) {
        vector<int> pos = usl.second;
        vector<int> st;
        for (auto i : pos) st.push_back(a[i]);
        sort(st.begin(), st.end());
        int ptr = 0;
        for (auto i : pos) {
            a[i] = st[ptr++];
        }
    }
    return a;
}

vector<int> Dels;

void gen(vector<pair<int, int>>& st, int pos, int res) {
    if (pos == (int)(st.size())) {
        Dels.push_back(res);
        return;
    }
    for (int i = 0; i <= st[pos].second; i++) {
        gen(st, pos + 1, res);
        res *= st[pos].first;
    }
}

void solve() {
    int n, k, X;
    cin >> n >> k >> X;
    gp_hash_table<int, int> mp;
    vector<int> a(n);
    vector<vector<int>> dels(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        int aa = a[i];
        vector<pair<int, int>> st;
        for (int j = 2; j * j <= aa; j++) {
            int x = 1, cnt = 0;
            while (aa % j == 0) {
                aa /= j;
                x *= j;
                cnt++;
            }
            if (cnt) st.push_back({j, cnt});
        }
        if (aa > 1) st.push_back({aa, 1});
        gen(st, 0, 1);
        dels[i] = Dels;
        Dels.clear();
    }
    vector<int> lcm(n, 1);
    for (int i = 0; i < n; i++) {
        for (auto j : dels[i]) {
           // cout << a[i] << ' ' << j << '\n';
            if (mp[j] >= k) {
                lcm[i] = lcm[i] * 1LL * j / __gcd(lcm[i], j);
            }
        }
    }
    vector<int> res = a;
    res = min(res, gt(a, lcm));
    if (X > 1) {
        for (int i = 0; i < n; i++) {
            lcm[i] *= X;
            a[i] *= X;
            res = min(res, gt(a, lcm));
            lcm[i] /= X;
            a[i] /= X;
        }
    }
    for (int i = 0; i < n; i++) cout << res[i] << ' ';
    cout << '\n';
}

int32_t main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}
