#include <bits/stdc++.h>

using namespace std;

constexpr int N = 5e5 + 2;

int n, m, p[N], ans, tin[N], tout[N], timer = 1;
deque<int> g[N];
bool used[N];

void dfs(int v, int pred = -1) {
    tin[v] = timer ++;
    for (int u : g[v])
        if (u != pred)
            dfs(u, v);
    tout[v] = timer;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    for (int i = 0; i < n; i ++) {
        int c;
        cin >> c;
        g[i].resize(c);
        for (int j = 0; j < c; j ++) {
            cin >> g[i][j];
            g[i][j] --;
        }
    }

    dfs(0);

    for (int i = 0; i < n; i ++) {
        cin >> p[i];
        p[i] --;
    }

    int memo = 0;
    int v = 0, ind = 0, cnt = 0;
    while (ind < m) {
//        cout << v << ' ' << ind << '\n';
        ans ++;
        if (p[ind] == v)
            ind ++;
        if (!used[v]) {
            cnt ++;
            if (cnt == n)
                memo = ans;
        }
        used[v] = true;

        int mem = v;
        v = g[v].front();
        g[mem].pop_front();
        g[mem].push_back(v);
        if (ans > 2e7)
            break;
    }


    assert(memo < 1e7);
    cout << ans;

    return 0;
}
