#include <bits/stdc++.h>
#include "game.h"

using namespace std;

constexpr int N = 2e5 + 2;

int n, a[N], d, dp[N];
priority_queue<pair<int, int> > go;

void recalc(){
    fill_n(dp, n, 0);
    for (int i = 0; i < n; i ++)
        go.emplace(a[i], i);
    while (!go.empty()){
        int pos = go.top().second;
        go.pop();
        if (dp[pos])
            continue;

        dp[pos] = 2;
        for (int i = max(0, pos - d); i <= min(n - 1, pos + d); i ++)
            if (!dp[i])
                dp[i] = 1;
    }

//    for (int i = 0; i < n; i ++)
//        cerr << dp[i] << ' ';
//    cout << '\n';
}

void init(vector<int> _a, int _d) {
    n = _a.size();
    for (int i = 0; i < n; i ++)
        a[i] = _a[i];
    d = _d;

    recalc();
}

void updateValue(int ind, int val) {
    a[ind] = val;
    recalc();
}

bool isWinning(int pos) {
    bool win = false;
    for (int i = max(0, pos - d); i <= min(n - 1, pos + d); i ++)
        if (i != pos)
            win |= dp[i] == 2;
    return win;
}

/*
6 2
1 7 4 9 30 2
5
2 0
2 1
1 4 8
2 0
2 1
*/
