#include <bits/stdc++.h>
#include "game.h"
#define ve vector
#define endl '\n'
#define pb push_back
#define all(x) x.begin(),x.end()
#define F first
#define S second
//#define int ll
#define pii pair <int , int>

using namespace std;

typedef long long ll;

const int N = int(5e5 + 10);

int nn , d;
int n;
ve <int> a;
int type[N];
int used[N];

ve <int> g[N];

void dfs(int v)
{
	///cerr << "!!!" << v << endl;
    used[v] = 1;
    for(auto to : g[v])
    {
        if(type[to] == 0)
        {
            type[v] = 1;
            continue;
        }
        if(used[to])continue;
        dfs(to);
        if(type[to] == 0)
		{
			type[v] = 1;
		}
    }
    if(type[v] == -1)
    {
        type[v] = 0;
    }
    return;
}

void solve()
{
    fill(type , type + N , -1);
    for(int i = 0;i < n;++ i)
	{
		g[i].clear();
	}
    for(int i = 0;i < nn;++ i)
    {
        for(int j = 0;j < nn;++ j)
        {
            if(abs(i - j) <= d && i != j)
            {
                if(a[i] < a[j])
                {
                	//cout << i << ' ' << j << endl;
                    g[i].pb(j);
                }
            }
        }
    }
    fill(used , used + nn , 0);
    for(int i = 0;i < nn;++ i)
    {
        bool fl = 1;
        for(int j = -d;j <= d;++ j)
        {
            if(j == 0)continue;
            if(i + j >= 0 && i + j < nn && a[i + j] > a[i])
            {
                fl = 0;
                break;
            }
        }
        if(fl)
        {
            type[i] = 0;
            used[i] = 1;
        }
    }
    for(int i = 0;i < nn;++ i)
    {
        if(!used[i])dfs(i);
    }
    /**for(int i = 0;i < n;++ i)
    {
        cout << type[i] << ' ';
    }
    cout << endl;**/
    return;
}

void init(ve <int> aa , int dd)
{
    nn = aa.size();
    n = nn;
    d = dd;
    for(int i = 0;i < nn;++ i)
    {
        a.pb(aa[i]);
    }
    solve();
    return;
}

bool isWinning(int start)
{
    for(int i = -d;i <= d;++ i)
    {
        if(i == 0)continue;
        ll x = i + start;
        if(x >= 0 && x < nn && type[x] == 0 && a[x] > a[start])return 1;
    }
    return 0;
}

void updateValue(int index, int newValue)
{
    a[index] = newValue;
    solve();
}


#ifdef LOCAL
    #include "game.h"
#include <vector>
#include <iostream>

int main()
{
	#ifdef LOCAL
        freopen("input.txt" , "r" , stdin);
        freopen("output.txt" , "w" , stdout);
    #endif // LOCAL
    int n, D, q;

    std::vector<int> nums;

    cin >> n >> D;

    for (int i = 1; i <= n; i++)
    {
        int x;
        cin >> x;
        nums.push_back(x);
    }

    init(nums, D);

    cin >> q;

    for (int i = 1; i <= q; i++)
    {
        int cm;

        cin >> cm;

        if (cm == 1)
        {
            int ind, val;

            cin >> ind >> val;

            updateValue(ind, val);
        }
        else
        {
            int ind;

            cin >> ind;

            cout << (int)isWinning(ind) << endl;
        }
    }

    return 0;
}
#endif // LOCAL
