#include <bits/stdc++.h>

using namespace std;
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define pb push_back
#define sz(x) (int)x.size()
//#define int long long
const int N = 5e5 + 1;
deque<int> g[N];
vector<int> order, zap;
const int f = 23;
int lca[f][N], h[N], n, m, p[N];

void dfs(int v, int pred) {
    lca[0][v] = pred;
    if (v != 1) {
        h[v] = h[pred] + 1;
    }
    for (int i = 1; i < f; ++i) {
        lca[i][v] = lca[i - 1][lca[i - 1][v]];
    }
    for (int i: g[v]) {
        if (i != pred) {
            dfs(i, v);
        }
    }
}

int find_lca(int v, int u) {
    if (v == u) {
        return v;
    }
    if (h[v] > h[u]) {
        swap(v, u);
    }
    for (int i = f - 1; i >= 0; i--) {
        if (h[lca[i][u]] >= h[v]) {
            u = lca[i][u];
        }
    }
    if (v == u) {
        return v;
    }
    for (int i = f - 1; i >= 0; i--) {
        if (lca[i][v] != lca[i][u]) {
            v = lca[i][v];
            u = lca[i][u];
        }
    }
    return lca[0][v];
}

int used[N], timer = 0, kol = 0;

void dfs1(int v, int pred) {
    timer++;
    if (v == zap.back()) {
        zap.pop_back();
        if (zap.empty()) {
            cout << timer;
            exit(0);
        }
    }
    for (int i = 0; i < sz(g[v]); ++i) {
        int to = g[v].front();
        g[v].pop_front();
        g[v].pb(to);
        if (to == pred) {
            if (used[v] == 0) {
                used[v] = 1;
                kol++;
            }
            return;
        } else {
            dfs1(to, v);
            timer++;
            if (v == zap.back()) {
                zap.pop_back();
                if (zap.empty()) {
                    cout << timer;
                    exit(0);
                }
            }
        }
    }
    if (used[v] == 0) {
        used[v] = 1;
        kol++;
    }
}

//
void find_order(int v) {
    order.pb(v);
    while (p[v] < sz(g[v])) {
        p[v]++;
        find_order(g[v][p[v] - 1]);
        order.pb(v);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            g[i].pb(x);
        }
    }
    zap.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> zap[m - i - 1];
    }
//    dfs(1, 1);
    //
    while (true) {
        dfs1(1, 1);
//        if (kol < n) {
            timer--;
//        }
    }
    find_order(1);
    vector<vector<int>> l(n + 1);
    for (int i = 0; i < sz(order); ++i) {
        l[order[i]].pb(i + 1);
    }
    int last = 0;
    while (!zap.empty()) {
        if (l[zap.back()].back() <= last) {
            timer += sz(order) - 1;
            last = 0;
        }
        int l1 = -1;
        int r1 = sz(l[zap.back()]) - 1;
        while (l1 + 1 < r1) {
            int mid = (l1 + r1) / 2;
            if (l[zap.back()][mid] <= last) {
                l1 = mid;
            } else {
                r1 = mid;
            }
        }
        last = l[zap.back()][r1];
        zap.pop_back();
    }
    timer += last;
    cout << timer;
    return 0;
}