#include <bits/stdc++.h>
#include "game.h"

using namespace std;
#define ll long long
#define F first
#define S second
#define pb push_back
#define all(x) x.begin(), x.end()
vector<int> a;
int d;
const int N = 2e5 + 100;
bool wins[N];
bool used[N];
map<int, int> mp;
bool updated = false;

void init(std::vector<int> A, int D) {
    a = A;
    d = D;
    updated = false;
}

void f() {
    mp.clear();
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        used[i] = false;
        mp.insert({a[i], i});
    }
    while (!mp.empty()) {
        auto it = mp.end();
        --it;
        int idx = it->S;
        mp.erase(it);
        wins[idx] = false;
        used[idx] = true;
        for (int i = idx - 1; i >= max(0, idx - d); i--) {
            if (used[i]) {
                break;
            } else {
                mp.erase(a[i]);
                used[i] = true;
                wins[i] = true;
            }
        }
        for (int i = idx + 1; i <= min(n - 1, idx + d); ++i) {
            if (used[i]) {
                break;
            } else {
                mp.erase(a[i]);
                used[i] = true;
                wins[i] = true;
            }
        }
    }
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    updated = false;
}

bool isWinning(int startIndex) {
    if (!updated) {
        f();
        updated = true;
    }
    return wins[startIndex];
}