#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 5e5 + 1, logn = 19;
deque<int> g[maxn];
vector<int> a;
int up[maxn];

void dfs(int v = 0, int p = -1) {
    up[v] = p;
    for (int u: g[v]) {
        if (p == u) continue;
        dfs(u, v);
    }
}

int bad = 0;
int sos[maxn];

int op(int v) {
    int u = g[v].front();
    g[v].pop_front();
    g[v].push_back(u);
    if (v) {
        int no = (g[v].back() == up[v]);
        if (sos[v] == no) return u;
        if (sos[v]) bad--;
        else bad++;
        sos[v] ^= 1;
    }
    return u;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        while (k--) {
            int j;
            cin >> j, j--;
            g[i].emplace_back(j);
        }
    }
    dfs();
    for (int i = 1; i < n; ++i) {
        if (g[i].back() != up[i]) bad++;
    }
    vector<int> find(m);
    for (int &v: find) cin >> v, v--;
    if (n == 1) {
        cout << m;
        return;
    }
    reverse(all(find));
    int s = 0, tot = 0;
    if (bad) {
        tot = 1;
        if (!find.empty() && find.back() == 0) find.pop_back();
        while (bad || s) {
            if (find.empty()) break;
            s = op(s);
            tot++;
            if (find.back() == s) find.pop_back();
        }
    }
    if (find.empty()) {
        cout << tot;
        return;
    }
    vector<int> base = {0};
    vector<int> used(n);
    used[0] = 1;
    int ost = n - 1;
    tot = max(1ll, tot);
    while (ost || s) {
        if (find.empty()) break;
        s = op(s);
        if (!used[s]) used[s] = 1, ost--;
        tot++;
        if (find.back() == s) find.pop_back();
        base.push_back(s);
    }
    if (find.empty()) {
        cout << tot;
        return;
    }
    int N = sz(base);
    int prev = N - 1;
    vector<vector<int>> wh(n);
    for (int i = 0; i < N; ++i) {
        wh[base[i]].emplace_back(i);
    }
    while (!find.empty()) {
        int v = find.back();
        find.pop_back();
        int next;
        if (prev >= wh[v].back()) next = wh[v][0];
        else next = *upper_bound(all(wh[v]), prev);
        if (prev < next) tot += next - prev;
        else tot += N - prev + next;
        prev = next;
    }
    cout << tot;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}