#include <bits/stdc++.h>
#include "game.h"

using namespace std;
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()

#define sz(v) (int) v.size()
vector<int> a, cool;
int n, d;

void build() {
    cool.clear(), cool.resize(n);
    for (int i = 0; i < n; ++i) {
        int ok = 1;
        for (int j = max(0, j - d); j <= min(n - 1, j + d); ++j) {
            if (j != i && a[j] > a[i]) {
                ok = 0;
                break;
            }
        }
        cool[i] = ok;
    }
}

vector<int> win, was;

int calc(int i) {
    if (was[i]) return win[i];
    if (cool[i]) {
        win[i] = 0;
        was[i] = 1;
        return 0;
    }
    for (int j = max(0, i - d); j < min(n, i + d + 1); ++j) {
        if (cool[j]) {
            win[i] = 1;
            was[i] = 1;
            return 1;
        }
    }
    for (int j = max(0, i - d); j < min(n, i + d + 1); ++j) {
        if (j == i) continue;
        int sos = calc(j);
        if (!sos) {
            win[i] = 1;
            was[i] = 1;
            return 1;
        }
    }
    win[i] = 0;
    was[i] = 1;
    return 0;
}

void init(vector<int> A, int D) {
    a = A, d = D, n = sz(a);
    build();
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    build();
}

bool isWinning(int s) {
    win.assign(n, 0);
    was.assign(n, 0);
    calc(s);
    return win[s];
}
