#include <bits/stdc++.h>
#include "game.h"

using namespace std;
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()

#define sz(v) (int) v.size()
vector<int> a, cool, close;
int n, d;


vector<int> win[2], was[2];

int calc(int i, int t) {
    if (was[t][i]) return win[t][i];
    if (cool[i]) {
        win[t][i] = 0;
        was[t][i] = 1;
        t ^= 1;
        win[t][i] = 1;
        was[t][i] = 1;
        return 0;
    }
    for (int j = max(0, i - d); j < min(n, i + d + 1); ++j) {
        if (cool[j]) {
            win[t][i] = 1;
            was[t][i] = 1;
            t ^= 1;
            win[t][i] = 0;
            was[t][i] = 1;
            return 1;
        }
    }
    int bad = 1;
    for (int j = max(0, i - d); j < min(n, i + d + 1); ++j) {
        if (j == i) continue;
        if (a[j] < a[i] || close[j]) continue;
        bad = 0;
        break;
    }
    if (bad) {
        win[t][i] = 0;
        was[t][i] = 1;
        t ^= 1;
        win[t][i] = 1;
        was[t][i] = 1;
        return 0;
    }
    for (int j = max(0, i - d); j < min(n, i + d + 1); ++j) {
        if (a[j] < a[i] || j == i) continue;
        int sos = calc(j, t ^ 1);
        if (!sos) {
            win[t][i] = 1;
            was[t][i] = 1;
            t ^= 1;
            win[t][i] = 0;
            was[t][i] = 1;
            return 1;
        }
    }
    win[t][i] = 0;
    was[t][i] = 1;
    t ^= 1;
    win[t][i] = 1;
    was[t][i] = 1;
    return 0;
}

void build() {
    cool.clear(), cool.resize(n);
    close.clear(), close.resize(n);
    for (int i = 0; i < n; ++i) {
        int ok = 1;
        for (int j = max(0, i - d); j <= min(n - 1, i + d); ++j) {
            if (j != i && a[j] > a[i]) {
                ok = 0;
                break;
            }
        }
        cool[i] = ok;
        if (!ok) continue;
        for (int j = max(0, i - d); j < min(n, i + d + 1); ++j) {
            if (j == i) continue;
            close[j] = 1;
        }
    }
    for (int i = 0; i < 2; ++i) {
        win[i].assign(n, 0);
        was[i].assign(n, 0);
    }
    for (int i = 0; i < n; ++i) {
        was[0][i] = 0;
        was[1][i] = 0;
        calc(i, 0);
    }
}

void init(vector<int> A, int D) {
    a = A, d = D, n = sz(a);
    build();
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
    build();
}

bool isWinning(int s) {
    return win[0][s];
}
/*
int main() {
    int N, D;
    cin >> N >> D;
    vector<int> A(N);
    for (int &x: A)cin >> x;
    init(A, D);
    int Q;
    cin >> Q;
    while (Q--) {
        int ty;
        cin >> ty;
        if (ty == 2) {
            int x;
            cin >> x;
            cout << isWinning(x) << '\n';
            continue;
        }
        int i, x;
        cin >> i >> x;
        updateValue(i, x);
    }
}*/