#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e5 + 1;
int a[maxn], n, k, add;

vector<int> calc() {
    unordered_map<int, vector<int>> d;
    for (int id = 0; id < n; ++id) {
        int x = a[id];
        for (int i = 2; i * i <= x; i++) {
            if (x % i != 0) continue;
            while (x % i == 0) x /= i;
            d[i].emplace_back(id);
        }
        if (x > 1) d[x].emplace_back(id);
    }
    vector<int> ans(n, 1);
    for (auto &[x, mas]: d) {
        if (sz(mas) < k) continue;
        for (int &i: mas) ans[i] = lcm(ans[i], x);
    }
    set<pii > cand;
    for (int i = 0; i < n; ++i) {
        cand.insert({a[i], i});
    }
    int p = -1;
    vector<int> res;
    while (!cand.empty()) {
        p++;
        auto it = cand.begin();
        while (it != cand.end()) {
            auto [x, i] = *it;
            if (a[p] <= x) break;
            if (a[p] % ans[i] != 0 || a[i] % ans[p] != 0) {
                it++;
                continue;
            }
            cand.erase({a[i], i});
            cand.erase({a[p], p});
            swap(a[i], a[p]);
            cand.insert({a[i], i});
            cand.insert({a[p], p});
            break;
        }
        cand.erase({a[p], p});
        res.emplace_back(a[p]);
    }
    return res;
}

int b[maxn];

void init() {
    for (int i = 0; i < n; ++i) {
        a[i] = b[i];
    }
}

void solve() {
    cin >> n >> k >> add;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
    }
    auto ans = calc();
    if (add > 1) {
        for (int i = 0; i < n; ++i) {
            init();
            a[i] *= add;
            ans = min(ans, calc());
        }
    }
    for (int an: ans) cout << an << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}