#pragma GCC Optimize("O3")
#pragma GCC Optimize("unroll-loops")
#pragma GCC Optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e5 + 1;
int a[maxn], n, k, add;

vector<int> calc() {
    unordered_map<int, vector<int>> d;
    for (int id = 0; id < n; ++id) {
        int x = a[id];
        for (int i = 2; i * i <= x; i++) {
            if (x % i != 0) continue;
            int y = 1;
            while (x % i == 0) x /= i, y *= i, d[y].emplace_back(id);
        }
        if (x > 1) d[x].emplace_back(id);
    }
    vector<int> ans(n, 1);
    for (auto &[x, mas]: d) {
        if (sz(mas) < k) continue;
        for (int &i: mas) ans[i] = lcm(ans[i], x);
    }
    vector<int> res;
    for (int p = 0; p < n; ++p) {
        for (int i = p + 1; i < n; ++i) {
            if(a[p] <= a[i]) continue;
            if(a[i] % ans[p] != 0) continue;
            if(a[p] % ans[i] != 0) continue;
            swap(a[p], a[i]);
        }
        res.emplace_back(a[p]);
    }
    return res;
}

int b[maxn];

void init() {
    for (int i = 0; i < n; ++i) {
        a[i] = b[i];
    }
}

void solve() {
    cin >> n >> k >> add;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[i] = a[i];
    }
    auto ans = calc();
    if (add > 1) {
        for (int i = 0; i < n; ++i) {
            init();
            a[i] *= add;
            ans = min(ans, calc());
        }
    }
    for (int an: ans) cout << an << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}