#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define int long long
#define F first
#define S second
#define endl '\n'
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
using namespace std;
using namespace __gnu_pbds;
const int R = 1<<20;
vector<int> t;
inline void upd(int pos){
    pos += R;
    t[pos] = 1;
    pos /= 2;
    while(pos != 0){
        t[pos] = t[pos * 2] + t[pos * 2 + 1];
        pos /= 2;
    }
}
int get(int ql, int qr, int l = 0, int r = R - 1, int v = 1){
    if(l > qr || ql > r)
        return 0;
    if(ql <= l && r <= qr)
        return t[v];
    int m = (l + r) / 2;
    return get(ql, qr, l, m, 2 * v) + get(ql, qr, m + 1, r, 2 * v + 1);
}
vector<deque<int>> edge;
vector<int> num, fin;
vector<pair<int, int>> eul;
void dfs(int v, int p, int sz = 0){
    num[v] = sz;
    fin[v] = (int)eul.size();
    eul.emplace_back(v, sz);
    int N = (int)edge[v].size();
    int x = -1;
    for(int i = 0; i < N ;i++){
        if(edge[v][i] == p)
            x = i;
    }
    for(int i = x + 1; i < N; i ++) {
        dfs(edge[v][i], v, sz + 1);
        eul.emplace_back(v, sz + 1);
    }
    for(int i = 0; i < x ;i ++) {
        dfs(edge[v][i], v, sz);
        eul.emplace_back(v, sz);
    }
}
inline void solve(){
    int n, m;
    cin>>n>>m;
    t.resize(2 * R);
    edge.resize(n);
    fin.resize(n);
    for(int i = 0; i < n ;i ++){
        int k;
        cin>>k;
        edge[i].resize(k);
        for(int j = 0; j < k ; j ++){
            cin>>edge[i][j];
            edge[i][j]--;
        }
    }
    vector<int> p(m);
    for(int i = 0; i < m ;i ++){
        cin>>p[i];
        p[i]--;
    }
    int ind = 0, root = 0, ans = 0;
    while((int)edge[root].size() > 1) {
        ans++;
        if (p[ind] == root){
            ind++;
            if(ind == m){
                cout<<ans<<endl;
                return;
            }
        }
        int to = edge[root][0];
        edge[root].pop_front();
        edge[root].push_back(to);
        root = to;
    }
    num.resize(n);
    eul = {{root, 0}};
    num[root] = 0, fin[root] = 0;
    dfs(edge[root][0], root);
    int op = 0, pos = 0;
    vector<pair<int, pair<int, int>>> b;
    for(int i = 0; i < eul.size() ;i ++) {
        b.push_back({eul[i].S, {i, eul[i].F}});
    }
    sort(b.begin(), b.end());
    vector<deque<int>> nums(n);
    int sz = (int)eul.size();
    while(ind != m){
        while(pos < sz && b[pos].F <= op){
            upd(b[pos].S.F);
            int v = b[pos].S.S;
            if(b[pos].S.F != fin[v]) {
                if (num[v] == op)
                    nums[v].push_back(b[pos].S.F);
                else
                    nums[v].push_front(b[pos].S.F);
            }
            pos++;
        }
        int x = -1;
        while(ind < m){
            int v = p[ind];
            if(num[v] > op)
                break;
            if(fin[v] > x){
                ans += get(x + 1, fin[v]);
                x = fin[v];
                ind++;
                continue;
            }
            if(nums[v].empty() || nums[v].back() <= x)
                break;
            int l = 0, r = (int)nums[v].size() - 1;
            while(r > l + 1){
                int med = (r + l) / 2;
                if(nums[v][med] > x){
                    r = med;
                }else
                    l = med;
            }
            if(nums[v][l] > x)
                r = l;
            ans += get(x + 1, nums[v][r]);
            x = nums[v][r];
            ind++;
        }
        op++;
        if(x + 1 < sz && ind < m)
            ans += get(x + 1, sz - 1);
    }
    cout<<ans<<endl;
}
signed main(){
    int T = 1;
    while(T--)
        solve();
}