#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#define F first
#define S second
#define endl '\n'
#define ios ios_base::sync_with_stdio(false); cin.tie(0);
using namespace std;
using namespace __gnu_pbds;
vector<int> t;
inline int f(int i){
    return i & (i + 1);
}
inline int rf(int i){
    return i | (i + 1);
}
inline void upd(int pos){
    for(; pos < t.size(); pos = rf(pos))
        t[pos]++;
}
inline int get(int pos){
    if(pos < 0)
        return 0;
    int res = 0;
    for(; pos >= 0; pos = f(pos) - 1)
        res += t[pos];
    return res;
}
vector<deque<int>> edge;
vector<int> num, fin;
vector<pair<int, int>> eul;
void dfs(int v, int p, int sz = 0){
    num[v] = sz;
    fin[v] = (int)eul.size();
    eul.emplace_back(v, sz);
    int N = (int)edge[v].size();
    int x = -1;
    for(int i = 0; i < N ;i++){
        if(edge[v][i] == p)
            x = i;
    }
    if(x == -1)
        exit(-1);
    for(int i = x + 1; i < N; i ++) {
        dfs(edge[v][i], v, sz + 1);
        eul.emplace_back(v, sz + 1);
    }
    for(int i = 0; i < x ;i ++) {
        dfs(edge[v][i], v, sz);
        eul.emplace_back(v, sz);
    }
}
inline void solve(){
    int n, m;
    cin>>n>>m;
    edge.resize(n);
    fin.resize(n);
    for(int i = 0; i < n ;i ++){
        int k;
        cin>>k;
        edge[i].resize(k);
        for(int j = 0; j < k ; j ++){
            cin>>edge[i][j];
            edge[i][j]--;
        }
    }
    vector<int> p(m);
    for(int i = 0; i < m ;i ++){
        cin>>p[i];
        p[i]--;
    }
    if(n == 1)
        exit(-1);
    long long ind = 0, root = 0, ans = 0, T = 0;
    while((int)edge[root].size() > 1) {
        ans++;
        if (p[ind] == root){
            ind++;
            if(ind == m){
                cout<<ans<<endl;
                return;
            }
        }
        int to = edge[root][0];
        edge[root].pop_front();
        edge[root].push_back(to);
        root = to;
        T++;
        if(T > n)
            exit(-1);
    }
    num.resize(n);
    eul = {{root, 0}};
    num[root] = 0, fin[root] = 0;
    dfs(edge[root][0], root);
    edge.clear();
    edge.shrink_to_fit();
    int op = 0, pos = 0;
    vector<pair<int, pair<int, int>>> b;
    for(int i = 0; i < eul.size() ;i ++)
        b.push_back({eul[i].S, {i, eul[i].F}});
    sort(b.begin(), b.end());
    vector<deque<int>> nums(n);
    int sz = (int)eul.size();
    t.resize(sz);
    while(ind != m){
        if(op > n + m)
            exit(-1);
        vector<pair<int, int>> rev;
        while(pos < sz && b[pos].F <= op){
            upd(b[pos].S.F);
            int v = b[pos].S.S;
            if(b[pos].S.F != fin[v]) {
                if (num[v] == op)
                    nums[v].push_back(b[pos].S.F);
                else
                    rev.emplace_back(b[pos].S.F, v);
            }
            pos++;
        }
        for(int i = (int)rev.size() - 1; i >= 0; i--)
            nums[rev[i].S].push_front(rev[i].F);
        int x = -1;
        while(ind < m){
            int v = p[ind];
            if(num[v] > op)
                break;
            if(fin[v] > x){
                ans += get(fin[v]) - get(x);
                x = fin[v];
                ind++;
                continue;
            }
            if(nums[v].empty() || nums[v].back() <= x)
                break;
            int l = 0, r = (int)nums[v].size() - 1;
            while(r > l + 1){
                int med = (r + l) / 2;
                if(nums[v][med] > x){
                    r = med;
                }else
                    l = med;
            }
            if(nums[v][l] > x)
                r = l;
            ans += get(nums[v][r]) - get(x);
            x = nums[v][r];
            ind++;
        }
        op++;
        if(x + 1 < sz && ind < m)
            ans += get(sz - 1) - get(x);
    }
    cout<<ans<<endl;
}
signed main(){
    ios
    int T = 1;
    while(T--)
        solve();
}