#include "game.h"
//#include "Lgrader.cpp"
using namespace std;
vector<int> a, pl;
int d, n;
void init(vector<int> A, int D) {
    a = A;
    n = (int)A.size();
    d = D;
}
void solve() {
    for(int i = 0; i < n; ++i) {
        int mx = a[i];
        for(int j = i - 1; j >= max(0, i - d); j--) {
            mx = max(mx, a[j]);
        }
        for(int j = i + 1; j <= min(n - 1, i + d); ++j) {
            mx = max(mx, a[j]);
        }
        if (mx == a[i]) {
            pl.push_back(i);
        }
    }
}

void updateValue(int index, int newValue) {
    a[index] = newValue;
}

bool isWinning(int startIndex) {
    pl.clear();
    solve();
    if (n == 1) {
        return true;
    }
    bool ok = 1;
    for(auto it : pl) {
        if (it == startIndex) {
            return false;
        }
        if (startIndex >= (it - d) && startIndex <= (it + d)) {
            return true;
        }
    }
    int mxl = max(0, startIndex - d), mxr = min(n - 1, startIndex + d);
    for(auto it : pl) {
        if (it < startIndex) {
            mxl = max(mxl, it + d + 1);
        }
        if (it > startIndex) {
            mxr = min(mxr, it - d - 1);
        }
    }
    int cnt = 0;
    for(int i = mxl; i <= mxr; ++i) {
        if (a[i] >= a[startIndex]) {
            cnt++;
        }
    }
    if (cnt <= 1) {
        return false;
    }
    return true;
}
