#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
unordered_map<int, int> mp;
vector<int> a;
int k;
bool cmp(int a, int b) {
    int g = __gcd(a, b);
    int a1 = a, b1 = b;
    //cout << a << ' ' << b << ' ' << a1 << ' ' << b1 << '\n';
    for(int j = 2; j <= sqrt(a1) + 1; ++j) {
        if (a1 % j == 0) {
            int y = j;
            while(a1 % j == 0) {
                if (mp[y] >= k && b % y != 0) {
                    return false;
                }
                a1 /= j;
                y *= j;
            }
        }
    }
    if (a1 != 1 && mp[a1] >= k && b % a1 != 0) {
        return false;
    }
    for(int j = 2; j <= sqrt(b1) + 1; ++j) {
        if (b1 % j == 0) {
            int y = j;
            while(b1 % j == 0) {
                if (mp[y] >= k && a % y != 0) {
                    return false;
                }
                b1 /= j;
                y *= j;
            }
        }
    }
    if (b1 != 1 && mp[b1] >= k && a % b1 != 0) {
        return false;
    }
    return a < b;
}

void solve() {
    int n, x;
    cin >> n >> k >> x;
    a.resize(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i) {
        int x = a[i];
        for(int j = 2; j <= sqrt(x) + 1; ++j) {
            if (x % j == 0) {
                int y = j;
                while(x % j == 0) {
                    mp[y]++;
                    x /= j;
                    y *= j;
                }
            }
        }
        if (x != 1) {
            mp[x]++;
        }
    }
    sort(a.begin(), a.end(), cmp);
    for(auto it : a) {
        cout << it << ' ';
    }
    a.clear();
    mp.clear();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
}
