//#pragma GCC optimize("O3")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define int long long
unordered_map<int, int> mp, mp1;

int k;
bool check(int a, int b) {
    int a1 = a, b1 = b;
    bool ok = 1;
    for(int j = 2; j <= sqrt(a1) + 1; ++j) {
        int y = j;
        while(a1 % j == 0) {
            if (mp[y] >= k && b % y != 0) {
                ok = 0;
                break;
            }
            a1 /= j;
            y *= j;
        }
        if (!ok) break;
    }
    if (a1 != 1 && mp[a1] >= k && b % a1 != 0) {
        ok = 0;
    }
    for(int j = 2; j <= sqrt(b1) + 1; ++j) {
        if (b1 % j == 0) {
            int y = j;
            while(b1 % j == 0) {
                if (mp[y] >= k && a % y != 0) {
                    ok = 0;
                    break;
                }
                b1 /= j;
                y *= j;
            }
        }
        if (!ok) break;
    }
    if (b1 != 1 && mp[b1] >= k && a % b1 != 0) {
        ok = 0;
    }
    return ok;
}

void solve() {
    int n, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    set<pair<int, int>> st;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        st.insert({a[i], i});
    }
    for(int i = 0; i < n; ++i) {
        int x = a[i];
        for(int j = 2; j <= sqrt(x) + 1; ++j) {
            if (x % j == 0) {
                int y = j;
                while(x % j == 0) {
                    mp[y]++;
                    x /= j;
                    y *= j;
                }
            }
        }
        if (x != 1) {
            mp[x]++;
        }
    }
    while(!st.empty()) {
        pair<int, int> p = *st.begin();
        st.erase(st.begin());
        for(int i = 0; i < p.second; i++) {
            if (a[i] > p.first) {
                if (check(a[i], p.first)) {
                    st.erase({a[i], i});
                    swap(a[i], a[p.second]);
                    st.insert({a[p.second], p.second});
                }
            }
        }
    }
    for(auto it : a) {
        cout << it << ' ';
    }
    mp.clear();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
}
