//#pragma GCC optimize("O3, unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define ll long long
unordered_map<int, int> mp;
map<pair<int, int>, int> can;

int k;
bool check(int a, int b) {
    int a1 = a, b1 = b;
    bool ok = 1;
    for(int j = 2; j <= sqrt(a1) + 1; ++j) {
        int y = j;
        while(a1 % j == 0) {
            if (mp[y] >= k && b % y != 0) {
                ok = 0;
                break;
            }
            a1 /= j;
            y *= j;
        }
        if (!ok) break;
    }
    if (a1 != 1 && mp[a1] >= k && b % a1 != 0) {
        ok = 0;
    }
    for(int j = 2; j <= sqrt(b1) + 1; ++j) {
        if (b1 % j == 0) {
            int y = j;
            while(b1 % j == 0) {
                if (mp[y] >= k && a % y != 0) {
                    ok = 0;
                    break;
                }
                b1 /= j;
                y *= j;
            }
        }
        if (!ok) break;
    }
    if (b1 != 1 && mp[b1] >= k && a % b1 != 0) {
        ok = 0;
    }
    return ok;
}

void solve() {
    int n, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> a1 = a;
    set<pair<int, int>> st;
    for(int i = 0; i < n; ++i) {
        st.insert({a1[i], i});
    }
    for(int i = 0; i < n; ++i) {
        int z = a1[i];
        for(int j = 2; j <= sqrt(z) + 1; ++j) {
            if (z % j == 0) {
                int y = j;
                while(z % j == 0) {
                    mp[y]++;
                    z /= j;
                    y *= j;
                }
            }
        }
        if (z != 1) {
            mp[z]++;
        }
    }
    for(int i = 0; i < n; ++i) {
        for(int j = i + 1; j < n; ++j) {
            if (can[{a[i], a[j]}] || can[{a[j], a[i]}]) continue;
            if (check(a[i], a[j])) {
                can[{a[i], a[j]}] = 1;
                can[{a[j], a[i]}] = 1;
            }
        }
    }
    while(!st.empty()) {
        pair<int, int> p = *st.begin();
        st.erase(st.begin());
        for(int i = 0; i < p.second; i++) {
            if (a1[i] > p.first) {
                if (can[{a1[i], p.first}]) {
                    st.erase({a1[i], i});
                    swap(a1[i], a1[p.second]);
                    st.insert({a1[p.second], p.second});
                    break;
                }
            }
        }
    }
    if (x != 1) {
        vector<int> b;
        for(int l = 0; l < n; ++l) {
            st.clear();
            b = a;
            b[l] *= x;
            ll y = x;
            while(b[l] % y == 0) {
                y *= x;
            }
            y /= x;
            if (y != 1 && mp[y] >= (k - 1)) {

            } else {
                continue;
            }
            mp[y]++;
            for(int i = 0; i < n; ++i) {
                if (i == l) continue;
                if (can[{b[i], b[l]}] || can[{b[l], b[i]}]) continue;
                if (check(b[i], b[l])) {
                    can[{b[i], b[l]}] = 1;
                    can[{b[l], b[i]}] = 1;
                }
            }
            for(int i = 0; i < n; ++i) {
                st.insert({b[i], i});
            }
            while(!st.empty()) {
                pair<int, int> p = *st.begin();
                st.erase(st.begin());
                for(int i = 0; i < p.second; i++) {
                    if (b[i] > p.first) {
                        if (can[{b[i], p.first}]) {
                            st.erase({b[i], i});
                            swap(b[i], b[p.second]);
                            st.insert({b[p.second], p.second});
                            break;
                        }
                    }
                }
            }
            mp[y]--;
            for(int i = 0; i < n; ++i) {
                if (b[i] == a1[i]) {

                } else {
                    if (b[i] < a1[i]) {
                        a1 = b;
                    }
                    break;
                }
            }
        }
    }

    for(auto it : a1) {
        cout << it << ' ';
    }
    mp.clear();
    can.clear();
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll T = 1;
    cin >> T;
    while(T--) {
        solve();
        cout << '\n';
    }
}
