#include <iostream>
#include <string>
#include <sstream>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <stack>
#include <deque>
#include <iomanip>
#include <stdio.h>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <ctime>
#include <cstdlib>
#include <cassert>
#include <iterator>
#include <chrono>
#include <array>
#include <bitset>
//#define int long long
#define pii pair <long long, long long>
#define debug(x) cerr << (#x) << " " << (x) << endl
#define pb push_back
#define all(vc) vc.begin(), vc.end()
#define rall(vc) vc.rbegin(), vc.rend()
#define endl "\n"
#define fir first
#define sec second
using namespace std;

const int N = 1000009, M = (int)(1e8) + 543;

mt19937 rnd(157);

vector<int> mm;
vector<deque<int>> gr;
int ans = 0;
int id = 0;

void dfs(int v) {
    ans++;
    if (mm[id] == v) {
        id++;
    }
    if (id == mm.size()) {
        cout << ans;
        exit(0);
    }

    for (int i = 0; i < gr[v].size(); i++) {
        int u = gr[v].front();
        gr[v].pop_front();
        gr[v].push_back(u);
        dfs(u);
    }
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout.precision(25);
    cout << fixed;

    int n, m;
    cin >> n >> m;

    gr.resize(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            a--;
            gr[i].pb(a);
        }
    }

    mm.resize(m);
    for (int& i : mm) {
        cin >> i;
        i--;
    }
    
    dfs(0);
    return 0;
}