#include <iostream>
#include <vector>

using namespace std;

const int maxn = 5 * 1e5 + 5;

vector<int> g[maxn];
int cnt[maxn];
vector<int> friends;
int cntFriends = 0;

int sim() {
	int cur = 1;
	for (int day = 0; ; ++day) {
		if (cur == friends[cntFriends])
			++cntFriends;
		if (cntFriends >= friends.size())
			return day;
		int nx = g[cur][cnt[cur] % g[cur].size()];
		++cnt[cur];
		cur = nx;
	}
	return 0;
}

int main() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int v;
			cin >> v;
			g[i + 1].push_back(v);
		}
	}
	for (int i = 0; i < m; ++i) {
		int fr;
		cin >> fr;
		friends.push_back(fr);
	}
	cout << sim() + 1 << '\n';
	return 0;
}