#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <cstring>

using namespace std;
vector<int> PRECALCPRIMES;

void solve() {
    int n, k, x;
    cin >> n >> k >> x;
    vector<int> a(n);
    for (auto& v : a) {
        cin >> v;
    }

    map<int, vector<int>> equv;
    map<int, int> equCnt;
    vector<int> EqHashes(n, 1);

    vector<int> b = a;

    for (auto i : PRECALCPRIMES) {
        vector<vector<int>> f(44);
        vector<int> f2(44, 0);
        int nw = 0;
        for (auto& v : b) {
            if (i > v) {
                nw++;
                continue;
            }
            int cnt2 = 0;
            while (v % i == 0) {
                if (cnt2 > 0)
                    f[cnt2 - 1].pop_back();
                //cout << "ADDING " << nw << " TO LIST OF " << i << ' ' << cnt2 << '\n';
                f[cnt2].push_back(nw);
                f2[cnt2]++;
                cnt2++;
                v /= i;
            }
            nw++;
        }
        if (f2[0] == 0) continue;
        int t = i;
        for (int j = 0; j < 44; ++j) {
            if (f2[j] < k) {
                t /= i;
            }
            //cout << t << ' ' << f2[j] << '\n';
            if (f2[j] == 0)
                break;
            for (auto ind : f[j]) {
                EqHashes[ind] *= t;
            }
            t *= i;
        }
    }

    map<int, vector<int>> cnt;
    int nwnw = 0;
    for (auto v : b) {
        if (v != 1)
            cnt[v].push_back(nwnw);
        nwnw++;
    }

    for (auto& [key, cnt2] : cnt) {
        if (cnt2.size() >= k) {
            for (auto v : cnt2) {
                EqHashes[v] *= key;
            }
        }
    }

    int nw = 0;
    for (auto v : EqHashes) {
        //cout << "EQHASH IS " << v << '\n';
        equv[v].push_back(a[nw++]);
    }

    for (auto& [key, v] : equv) {
        sort(v.begin(), v.end());
    }

    for (auto v : EqHashes) {
        cout << equv[v][equCnt[v]++] << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    bool erat[50000];
    memset(erat, 0, sizeof(erat));
    for (long long i = 2; i < 50000; ++i) {
        if (!erat[i]) {
            PRECALCPRIMES.push_back(i);
            for (long long j = i * i; j < 50000; j += i)
                erat[j] = 1;
        }
    }

    //cout << PRECALCPRIMES.size() << " Primes size\n";

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}