#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;
using pi = pair<int,int>;

const int MAX_P = 30;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--) {
        int n, k, x;
        cin >> n >> k >> x;
        vector<int> as(n);
        for(int &a : as) {
            cin >> a;
        }
        vector<int> res(n);
        vector<vector<pi>> prime_coefs(n);
        map<int,vector<int>> hist;
        int idx = -1;
        for(int a : as) {
            ++idx;
            for(int i = 2; i * i <= a; i ++) {
                if(a%i == 0) {
                    int p = 0;
                    while(a%i == 0) {
                        a /= i;
                        p++;
                    }
                    if(hist.find(i) == hist.end()) {
                        vector<int> st(MAX_P);
                        st[0] = k;
                        hist[i] = st;
                    }
                    hist[i][p]++;
                    prime_coefs[idx].push_back({i,p});
                }
            }
            if(a != 1) {
                int i = a;
                int p = 1;
                if(hist.find(i) == hist.end()) {
                    vector<int> st(MAX_P);
                    st[0] = k;
                    hist[i] = st;
                }
                hist[i][p]++;
                prime_coefs[idx].push_back({i,p});
            }
        }
        map<int,int> kth_pow;
        for(const pair<int,vector<int>> &val : hist) {
            int lft = k;
            for(int i = MAX_P-1; i >= 0; i --) {
                lft -= val.s[i];
                if(lft <= 0) {
                    kth_pow[val.f] = i;
                    break;
                }
            }
        }
        map<int,set<int>> opts;
        vector<int> new_nums(n);
        for(int i = 0; i < n; i ++) {
            int new_num = 1;
            for(pi coef : prime_coefs[i]) {
                // cout << "  " << coef.f << ' ' << coef.s << endl;
                for(int c = min(kth_pow[coef.f],coef.s); c; c--) {
                    new_num *= coef.f;
                }
            }
            // cout << as[i] << " -> " << new_num << endl;
            opts[new_num].insert(as[i]);
            new_nums[i] = new_num;
        }
        for(int i = 0; i < n; i ++) {
            int cur = new_nums[i];
            auto it = opts.find(cur);
            res[i] = *(it->s.begin());
            it->s.erase(it->s.begin());
        }
        //  = solve(n,k,x,as);
        for(int r : res) {
            cout << r << ' ';
        }
        cout << '\n';
    }
    return 0;
}