#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;
using pi = pair<int, int>;
using ll = long long;

const int MAX_P = 30;

vector<ll> solve(int n, int k, ll X, vector<ll> as) {
    vector<ll> res(n);
    vector<vector<pi>> prime_coefs(n);
    map<int, vector<int>> hist;
    int idx = -1;
    for (ll a : as) {
        ++idx;
        for (ll i = 2; i * i <= a; i++) {
            if (a % i == 0) {
                int p = 0;
                while (a % i == 0) {
                    a /= i;
                    p++;
                }
                if (hist.find(i) == hist.end()) {
                    vector<int> st(MAX_P);
                    st[0] = k;
                    hist[i] = st;
                }
                hist[i][p]++;
                prime_coefs[idx].push_back({i, p});
            }
        }
        if (a != 1) {
            int i = a;
            int p = 1;
            if (hist.find(i) == hist.end()) {
                vector<int> st(MAX_P);
                st[0] = k;
                hist[i] = st;
            }
            hist[i][p]++;
            prime_coefs[idx].push_back({i, p});
        }
    }
    map<int, int> kth_pow;
    for (const pair<int, vector<int>> &val : hist) {
        int lft = k;
        for (int i = MAX_P - 1; i >= 0; i--) {
            lft -= val.s[i];
            if (lft <= 0) {
                kth_pow[val.f] = i;
                break;
            }
        }
    }
    map<ll, multiset<pair<ll, int>>> opts;
    vector<ll> new_nums(n);
    for (int i = 0; i < n; i++) {
        ll new_num = 1;
        for (pi coef : prime_coefs[i]) {
            // cout << "  " << coef.f << ' ' << coef.s << endl;
            for (int c = min(kth_pow[coef.f], coef.s); c; c--) {
                new_num *= coef.f;
            }
        }
        // cout << as[i] << " -> " << new_num << endl;
        opts[new_num].insert({as[i], i});
        new_nums[i] = new_num;
    }
    bool usedX = false;
    for (int i = 0; i < n; i++) {
        ll cur = new_nums[i];
        auto it = opts.find(cur);
        ll opt0 = (it->s.begin())->f;
        if (usedX) {
            res[i] = opt0;
            it->s.erase(it->s.begin());
            continue;
        }
        ll mn = opt0, bestopt = 0;
        ll optY = 2e9;
        if (cur <= 2e9 / X) {
            auto itY = opts.find(cur * X);
            if (itY != opts.end() && !itY->s.empty()) {
                optY = (itY->s.begin())->f;
            }
        }
        if (optY < mn) {
            mn = optY;
            bestopt = 1;
        }
        ll optX = 2e9;
        pair<ll, int> tmp;
        if (cur % X == 0) {
            auto itX = opts.find(cur / X);
            if (itX != opts.end() && !itX->s.empty()) {
                tmp = *(itX->s.begin());
                optX = tmp.f * X;
            }
        }
        if (optX < mn) {
            mn = optX;
            bestopt = 2;
        }
        res[i] = mn;
        if (bestopt == 0) {
            it->s.erase(it->s.begin());
            continue;
        }
        usedX = true;
        if (bestopt == 1) {
            opts[cur * X].erase(opts[cur * X].begin());
            opts[cur * X].insert({as[i] * X, i});
            opts[cur].erase({as[i], i});
        } else {
            new_nums[tmp.s] = cur;
            opts[cur / X].erase(opts[cur / X].begin());
        }
    }
    //  = solve(n,k,x,as);
    return res;
}

vector<ll> solve1(int n, int k, vector<ll> as) {
    ll X = 1;
    vector<ll> res(n);
    vector<vector<pi>> prime_coefs(n);
    map<int, vector<int>> hist;
    int idx = -1;
    for (int a : as) {
        ++idx;
        for (int i = 2; i * i <= a; i++) {
            if (a % i == 0) {
                int p = 0;
                while (a % i == 0) {
                    a /= i;
                    p++;
                }
                if (hist.find(i) == hist.end()) {
                    vector<int> st(MAX_P);
                    st[0] = k;
                    hist[i] = st;
                }
                hist[i][p]++;
                prime_coefs[idx].push_back({i, p});
            }
        }
        if (a != 1) {
            int i = a;
            int p = 1;
            if (hist.find(i) == hist.end()) {
                vector<int> st(MAX_P);
                st[0] = k;
                hist[i] = st;
            }
            hist[i][p]++;
            prime_coefs[idx].push_back({i, p});
        }
    }
    map<int, int> kth_pow;
    for (const pair<int, vector<int>> &val : hist) {
        int lft = k;
        for (int i = MAX_P - 1; i >= 0; i--) {
            lft -= val.s[i];
            if (lft <= 0) {
                kth_pow[val.f] = i;
                break;
            }
        }
    }
    map<int, multiset<pair<ll, int>>> opts;
    vector<ll> new_nums(n);
    for (int i = 0; i < n; i++) {
        ll new_num = 1;
        for (pi coef : prime_coefs[i]) {
            // cout << "  " << coef.f << ' ' << coef.s << endl;
            for (int c = min(kth_pow[coef.f], coef.s); c; c--) {
                new_num *= coef.f;
            }
        }
        // cout << as[i] << " -> " << new_num << endl;
        opts[new_num].insert({as[i], i});
        new_nums[i] = new_num;
    }
    // for(ll r : new_nums) {
    //     cout << r << ' ';
    // }
    // cout << endl;
    bool usedX = false;
    for (int i = 0; i < n; i++) {
        ll cur = new_nums[i];
        auto it = opts.find(cur);
        ll opt0 = (it->s.begin())->f;
        if (usedX) {
            res[i] = opt0;
            it->s.erase(it->s.begin());
            continue;
        }
        ll mn = opt0, bestopt = 0;
        ll optY = 2e9;
        if (cur <= 2e9 / X) {
            auto itY = opts.find(cur * X);
            if (itY != opts.end() && !itY->s.empty()) {
                // cout << itY->f << ' ' << itY->s.begin()->f << ' ' <<
                // itY->s.begin()->s << endl;
                optY = (itY->s.begin())->f;
            }
        }
        if (optY < mn) {
            mn = optY;
            bestopt = 1;
        }
        ll optX = 2e9;
        pair<ll, int> tmp;
        if (cur % X == 0) {
            auto itX = opts.find(cur / X);
            if (itX != opts.end() && !itX->s.empty()) {
                tmp = *(itX->s.begin());
                optX = tmp.f * X;
            }
        }
        if (optX < mn) {
            mn = optX;
            bestopt = 2;
        }
        // cout << i << ": " << mn << ' ' << bestopt << endl;
        res[i] = mn;
        if (bestopt == 0) {
            it->s.erase(it->s.begin());
            continue;
        }
        usedX = true;
        if (bestopt == 1) {
            opts[cur * X].erase(opts[cur * X].begin());
            opts[cur * X].insert({as[i] * X, i});
            opts[cur].erase({as[i], i});
        } else {
            new_nums[tmp.s] = cur;
            opts[cur / X].erase(opts[cur / X].begin());
        }
    }
    return res;
}

vector<ll> brute(int n, int k, ll X, vector<ll> as) {
    vector<ll> opt = solve1(n, k, as);
    for (int i = 0; i < n; i++) {
        as[i] *= X;
        vector<ll> alt = solve1(n, k, as);
        as[i] /= X;
        if (alt < opt) {
            opt = alt;
        }
    }
    return opt;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n, k;
        ll X;
        cin >> n >> k >> X;
        vector<ll> as(n);
        for (ll &a : as) {
            cin >> a;
        }
        vector<ll> real = brute(n, k, X, as);
        for (ll r : real) {
            cout << r << ' ';
        }
        cout << '\n';
        
    }
    return 0;
}