#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;
using ll = long long;
using pi = pair<ll, ll>;

const ll MAX_P = 60;

vector<ll> brute(ll n, ll k, ll X, vector<ll> as) {
    vector<vector<pi>> prime_coefs(n);
    map<ll, vector<ll>> hist;
    ll idx = -1;
    for (ll a : as) {
        ++idx;
        for (ll i = 2; i * i <= a; i++) {
            if (a % i == 0) {
                ll p = 0;
                while (a % i == 0) {
                    a /= i;
                    p++;
                }
                if (hist.find(i) == hist.end()) {
                    vector<ll> st(MAX_P);
                    st[0] = k;
                    hist[i] = st;
                }
                hist[i][p]++;
                prime_coefs[idx].push_back({i, p});
            }
        }
        if (a != 1) {
            ll i = a;
            ll p = 1;
            if (hist.find(i) == hist.end()) {
                vector<ll> st(MAX_P);
                st[0] = k;
                hist[i] = st;
            }
            hist[i][p]++;
            prime_coefs[idx].push_back({i, p});
        }
    }
    map<ll, ll> kth_pow;
    for (const pair<ll, vector<ll>> &val : hist) {
        ll lft = k;
        for (ll i = MAX_P - 1; i >= 0; i--) {
            lft -= val.s[i];
            if (lft <= 0) {
                kth_pow[val.f] = i;
                break;
            }
        }
    }
    map<ll, multiset<ll>> opts;
    vector<ll> new_nums(n);
    for (ll i = 0; i < n; i++) {
        ll new_num = 1;
        for (pi coef : prime_coefs[i]) {
            for (ll c = min(kth_pow[coef.f], coef.s); c; c--) {
                new_num *= coef.f;
            }
        }
        opts[new_num].insert(as[i]);
        new_nums[i] = new_num;
    }
    vector<ll> res(n);
    for (ll i = 0; i < n; i++) {
        ll cur = new_nums[i];
        auto it = opts.find(cur);
        ll opt0 = *(it->s.begin());
        res[i] = opt0;
        it->s.erase(it->s.begin());
    }
    vector<ll> alt(n);
    for(int IT = 0; IT < n; IT ++) {
        ll cur_ = new_nums[IT];
        new_nums[IT] *= X;
        as[IT] *= X;
        // opts[cur_].erase(opts[cur_].find(as[IT]));
        // opts[cur_*X].insert(as[IT]*X);
        for(int i = 0; i < n; i ++) {
            opts[new_nums[i]].insert(as[i]);
        }
        for (ll i = 0; i < n; i++) {
            ll cur = new_nums[i];
            auto it = opts.find(cur);
            ll opt0 = *(it->s.begin());
            alt[i] = opt0;
            it->s.erase(it->s.begin());
        }
        if(alt < res) {
            res = alt;
        }
        new_nums[IT] /= X;
        as[IT] /= X;
        // opts[cur_*X].erase(opts[cur_].find(as[IT]*X));
        // opts[cur_].insert(as[IT]);
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        ll X;
        cin >> n >> k >> X;
        vector<ll> as(n);
        for (ll &a : as) {
            cin >> a;
        }
        vector<ll> real = brute(n, k, X, as);
        for (ll r : real) {
            cout << r << ' ';
        }
        cout << '\n';
        }
    return 0;
}