#include <iostream>
#include <vector>
#include <algorithm>
#include "game.h"
using namespace std;
vector <int> numbers;
vector <bool> isWin;
int d;

void setStates()
{
	vector <pair <int, int>> temp;
	for (int a = 0; a < numbers.size(); a++)
		temp.push_back({ numbers[a], a });

	sort(temp.begin(), temp.end());

	for (int a = 0; a < numbers.size(); a++)
		isWin[a] = false;

	for (int a = numbers.size() - 1; a >= 0; a--)
	{
		if (isWin[temp[a].second])
			continue;

		for (int b = max(0, temp[a].second - d); b <= min((int)numbers.size() - 1, temp[a].second + d); b++)
			if (b != temp[a].second)
				isWin[b] = true;
	}
}

void init(vector<int> A, int D)
{
	numbers = A;
	for (int a = 0; a < A.size(); a++)
		isWin.push_back(true);
	d = D;
	setStates();
}

void updateValue(int index, int newValue)
{
	numbers[index] = newValue;
	setStates();
}

bool isWinning(int startIndex)
{
	return isWin[startIndex];
}
