#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
#define howmanyPrimes 33000
#define maxNumber 1000000000
vector <int> primes;
void solve()
{
    long long N, K, X, c;
    cin >> N >> K >> X;
    vector <long long> numbers;

    for (int a = 0; a < N; a++)
    {
        cin >> c;
        numbers.push_back(c);
    }

    map <int, long long> timesDevided;

    for (int a = 0; a < N; a++)
    {
        int temp = numbers[a];

        for (int b = 0; b < primes.size() and temp >= primes[b]; b++)
        {
            int times = 0;
            int val = 1;

            while (temp % primes[b] == 0)
            {
                temp /= primes[b];
                times++;
                val *= primes[b];
                timesDevided[val]++;
            }
        }

        if (temp != 1)
            timesDevided[temp]++;
    }

    vector <pair <int, long long>> answer;
    for (int a = 0; a < N; a++)
        answer.push_back({ 1, numbers[a] });

    for (int a = 0; a < N; a++)
    {
        int temp = numbers[a];
        for (int b = 0; b < primes.size() and temp >= primes[b]; b++)
        {
            int val = primes[b];

            while (temp % primes[b] == 0 and timesDevided[val] >= K)
            {
                temp /= primes[b];
                answer[a].first *= primes[b];
                val *= primes[b];
            }
        }
    }

    vector <vector <int>> sortAll;
    vector <int> counters;
    vector <long long> mini;
    map <int, int> place;

    for (int a = 0; a < N; a++)
    {
        if (place[answer[a].first] == 0)
        {
            place[answer[a].first] = sortAll.size() + 1;
            sortAll.push_back({});
            counters.push_back(0);
            mini.push_back(maxNumber);
        }

        mini[place[answer[a].first] - 1] = min(mini[place[answer[a].first] - 1], answer[a].second);
        sortAll[place[answer[a].first] - 1].push_back(answer[a].second);
    }

    for (int a = 0; a < sortAll.size(); a++)
        sort(sortAll[a].begin(), sortAll[a].end());

    for (int a = 0; a < N; a++)
    {
        answer[a].second = sortAll[place[answer[a].first] - 1][counters[place[answer[a].first] - 1]];
        counters[place[answer[a].first] - 1]++;
    }

    bool wasMul = false;
    for (int a = 0; a < N and !wasMul and X != 1; a++)
        if (place[answer[a].first * X] != 0 and mini[place[answer[a].first * X] - 1] < answer[a].second)
        {
            answer[a].first *= X;
            answer[a].second *= X;
            sortAll[place[answer[a].first] - 1].push_back(answer[a].second);
            sort(sortAll[place[answer[a].first] - 1].begin(), sortAll[place[answer[a].first] - 1].end());
            int placeRot = place[answer[a].first] - 1;
            int counter = 0;
            for (int b = 0; b < N; b++)
                if (answer[b].first == answer[a].first)
                {
                    answer[b].second = sortAll[placeRot][counter];
                    counter++;
                }
            wasMul = true;
        }

    for (int a = 0; a < N; a++)
        cout << answer[a].second << " ";
    cout << '\n';
}

int main()
{
    vector <int> was(howmanyPrimes + 9, false);
    for (int a = 2; a < howmanyPrimes; a++)
    {
        if (!was[a])
            primes.push_back(a);
        for (int b = 0; b < primes.size() and a * primes[b] <= howmanyPrimes; b++)
            was[a * primes[b]] = true;
    }
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int T;
    cin >> T;
    for (int a = 0; a < T; a++)
        solve();
}