#include<bits/stdc++.h>
typedef long long ll;
using namespace std;

ll gcd(ll a, ll b){
    if(a % b == 0) return b;
    return gcd(b, a % b);
}

bool same_k_gcd(vector<ll> &a, vector<ll> &b, ll k, ll n){
    for(ll i = 0; i <= n-k; i++){
        ll gcd_a = gcd(a[i], a[i+1]), gcd_b = gcd(b[i], b[i+1]);
        for(ll j = i+2; j < i+k; j++) gcd_a = gcd(gcd_a, a[j]), gcd_b = gcd(gcd_b, b[j]);
        if(gcd_a != gcd_b) return false;
    }
    return true;
}

int main(){
    ll t; cin >> t;
    while(t--){
        ll n, k, x; cin >> n >> k >> x;
        vector<ll> v(n);
        for(ll i = 0; i < n; i++) cin >> v[i];
        vector<ll> a = v;
        sort(v.begin(), v.end());
        do{
            if(same_k_gcd(a, v, k, n)){
                for(ll i : v) cout << i << " ";
                cout << "\n";
                return 0;
            } 
        }
        while(next_permutation(v.begin(), v.end()));
    }
}
