#include <bits/stdc++.h>

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
int f = 0, ans = 0;
vi friends;

bool dfs(int node, vvi &adj, vi &cur) {
    //cout << node+1 << ' ';
    ++ans;
    if (node == friends[f]) ++f;
    if (f == friends.size()) return true;
    while (1) {
        int next = adj[node][cur[node]];
        cur[node] = (cur[node]+1)%adj[node].size();
        if (dfs(next, adj, cur)) return true;
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int n,m; cin >> n >> m;
    vvi adj(n);
    vi cur(n);
    for (int i = 0; i<n; ++i) {
        int a,b; cin >> a;
        adj[i].resize(a);
        for (int j = 0; j<a; ++j) {
            cin >> b;
            adj[i][j] = b-1;
        }
    }
    friends.resize(m);
    for (int i = 0; i<m; ++i) {
        cin >> friends[i]; --friends[i];
    }
    dfs(0, adj, cur);
    cout << ans;
}