#include <bits/stdc++.h>

using namespace std;

typedef vector<int> vi;
typedef vector<bool> vb;

typedef vector<vi> vvi;
typedef long long ll;
ll f = 0, ans = 0, N, M;
ll fin = 0;
vi friends;

bool first = true;
void fi(vvi &adj, vi &cur) {
    int touched = 0;
    bool forOne = false;
    vb vis(N);
    int node = 0;
    while (true) {
        if (first && node == 0 && forOne) return;
        ++ans;
        if (f < friends.size() && node == friends[f]) {
            ++f;
            if (f == friends.size()) {
                fin = ans;
                if (!first) return;
            }
        }
        if (!vis[node]) {
            vis[node] = true;
            ++touched;
            if (touched == N) forOne = true;
        }
        int next = adj[node][cur[node]];
        cur[node] = (cur[node]+1)%adj[node].size();
        node = next;
    }
}
void operation(vb &synced, ll &counter, int par, int node, vvi &adj) {
    ++counter;
    synced[node] = true;
    for (int u : adj[node]) {
        if (u == par) break;
        operation(synced, counter, node, u, adj);
        ++counter;
    }
}
ll syncronize(vi &order, vi &depth, vvi &adj, vi &par, ll &inOne) {
    int closest = 1;
    ll counter = 1;
    vb synced(N, false); synced[0] = true;
    while (closest < N) {
        int val = order[closest];
        counter += depth[val] * 2 - 1;
        operation(synced, counter, par[val], val, adj);
        while (closest < N && synced[order[closest]]) ++closest;
        ++inOne;
        if (inOne == M-1) return counter;
    }
    return counter;
}
vi euler;
void getEuler(int par, int node, vvi &adj) {
    euler.push_back(node);
    for (int u : adj[node]) {
        if (u == par) continue;
        getEuler(node, u, adj);
        euler.push_back(node);

    }
}

void preorder(int par, int node, vi &order, vvi &adj, vi &depth, vi &Par) {
    Par[node] = par;
    if (node != 0) depth[node] = depth[par]+1;
    order.push_back(node);
    for (int u : adj[node]) if (u != par) preorder(node, u, order, adj, depth, Par);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int n,m; cin >> n >> m; N = n, M = m;
    vvi adj(n);
    vi cur(n);
    for (int i = 0; i<n; ++i) {
        int a,b; cin >> a;
        adj[i].resize(a);
        for (int j = 0; j<a; ++j) {
            cin >> b;
            adj[i][j] = b-1;
        }
    }
    friends.resize(m);
    for (int i = 0; i<m; ++i) {
        cin >> friends[i]; --friends[i];
    }
    vi order, depth(n, 0), par(n);
    preorder(0,0,order, adj, depth, par);
    ll inOne = 0;
    ll toSync = syncronize(order, depth, adj, par, inOne)-1;
    if (inOne == M) {
        cout << toSync;
        return 0;
    }
    //cout << inOne;
    /*fi( adj, cur);
    if (f == M) {
        cout << fin;
        return 0;
    }
    first = false;
    fi(adj, cur);
    cout << ans;*/

    M -= inOne;
    getEuler(0,0,adj);
    euler.pop_back();
    int lastOne = 0;
    for (int i = 0; i<euler.size(); ++i) if (euler[i] == 0) lastOne = i;
    int rem = euler.size()-1-lastOne;
    ll onesInEuler = count(euler.begin(), euler.end(), 0);
    ll entire = M/onesInEuler;
    ll more = M%onesInEuler, count = 0;
    if (more == 0) {
        cout << toSync+entire*euler.size()-rem;
        return 0;
    }
    for (int i = 0; i<euler.size(); ++i) {
        if (euler[i] != 0) continue;
        ++count;
        if (count == more) {
            cout << toSync + entire*euler.size()+i+1;
            return 0;
        }
    }
}

/*
 * 4 4
2 2 3
1 1
2 4 1
1 3
2 1 1 4

 5 9
 2 5 2
 3 1 3 4
 1 2
 1 2
 1 1
 1 1 1 1 1 1 1 1 1 1 1
 */