#include <bits/stdc++.h>
#include "game.h"
using namespace std;
int n,d;
vector<bool> wins;
typedef vector<int> vi;
typedef vector<bool> vb;
typedef vector<vi> vvi;
vi topo,vals;
void dfs(int node, vvi &adj, vb &vis) {
    if (vis[node]) return;
    vis[node] = true;
    for (int u : adj[node]) dfs(u, adj, vis);
    topo.push_back(node);
}
void up() {
    topo.clear();
    fill(wins.begin(), wins.end(), false);
    vvi adj(n);
    vb vis(n, false);
    for (int i = 0; i<n; ++i) {
        for (int j = max(0,i-d); j<min(n,i+d+1); ++j) {
            if (vals[j] > vals[i])
                adj[i].push_back(j);
        }
    }
    for (int i = 0; i<n; ++i) dfs(i, adj, vis);
    for (int node : topo) {
        bool found = false;
        for (int u : adj[node]) {
            if (!wins[u]) found = true;
        }
        wins[node] = found;
    }
}
void init(std::vector<int> A, int D) {
    d = D, n = A.size();
    wins.resize(n, true);
    vals = A;
    up();

}

void updateValue(int index, int newValue) {
    vb bef = wins;
    vals[index] = newValue;
    up();
    for (int i = 0; i<n; ++i) {
        if (i >= index-d && i <= index + d) continue;
        assert(bef[i] == wins[i]);
    }
}
bool isWinning(int startIndex) {
    return wins[startIndex];
}