#include <bits/stdc++.h>
using namespace std;
typedef long long ll;


ll gcd(ll a, ll b)
{
    return b == 0 ? a : gcd(b, a % b);
}

ll gcd(vector<ll> &arr)
{
    if (arr.size() == 0) return 0;
    if (arr.size() == 1) return arr[0];
    vector<ll> gs;
    for (ll i = 0; i < (arr.size() >> 1); i++) gs.push_back(gcd(arr[i << 1], arr[(i << 1) + 1]));
    if (arr.size() % 2) gs.push_back(arr.back());
    return gcd(gs);
}


bool isEq(vector<ll> &a, vector<ll> &b, vector<ll> &t1, vector<ll> &t2, ll i, ll k)
{
    if (i == a.size()) return (t1.size() != k) || (gcd(t1) == gcd(t2));

    if (!isEq(a, b, t1, t2, i + 1, k)) return false;

    t1.push_back(a[i]);
    t2.push_back(b[i]);
    
    bool t = isEq(a, b, t1, t2, i + 1, k);

    t1.pop_back();
    t2.pop_back();

    return t;
}


void find(vector<ll> &a, vector<ll> &b, ll k)
{
    vector<ll> t1, t2;

    while (!isEq(a, b, t1, t2, 0, k))
    {
        next_permutation(b.begin(), b.end());
    }
}


int main()
{
    //freopen("C:\\Users\\Default\\Desktop\\iati day 2\\input.txt", "r", stdin);          

    ll t;
    cin >> t;

    while (t--)
    {
        ll n, k, x;
        cin >> n >> k >> x;
        vector<ll> a(n), b(n);
        for (ll i = 0; i < n; i++)
        {
            cin >> a[i];
            b[i] = a[i];
        }
        sort(b.begin(), b.end());

        find(a, b, k);

        for (ll i : b) cout << i << ' ';
        cout << '\n';
    }


    return 0;
}