#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int gcd(int a, int b) {
	return b ? gcd(b, a % b) : a;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(nullptr);

	int t; cin >> t;
	while (t--) {

		int n, k, x; cin >> n >> k >> x;
		vector<int> v(n);
		for (int& i : v) cin >> i;

		vector<int> cp = v;
		sort(cp.begin(), cp.end());
		prev_permutation(cp.begin(), cp.end());

		while (next_permutation(cp.begin(), cp.end())) {
			bool done = true;

			for (int i = 0; i < (1 << n) && done; ++i) {
				if (__builtin_popcount(i) != k) continue;

				int cur1 = 0, cur2 = 0;
				for (int j = 0; j < n; ++j) {
					if ((i >> j) % 2) {
						cur1 = gcd(cur1, cp[j]);
						cur2 = gcd(cur2, v[j]);
					}
				}

				if (cur1 != cur2) done = false;
			}

			if (done) break;
		}

		for (int i : cp) cout << i << ' '; cout << '\n';
	}
}