#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define ar array
#define pb push_back
#define ln '\n'
#define int long long

using i64 = long long;

template <class F, class _S>
bool chmin(F &u, const _S &v){
    bool flag = false;
    if ( u > v ){
        u = v; flag |= true;
    }
    return flag;
}

template <class F, class _S>
bool chmax(F &u, const _S &v){
    bool flag = false;
    if ( u < v ){
        u = v; flag |= true;
    }
    return flag;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    vector <vector<int>> adj(n);
    for ( auto &u: adj ){
        int k; cin >> k;
        u.resize(k);
        for ( auto &v: u ){
            cin >> v; --v;
        }
    }
    vector <int> q(m);
    for ( auto &u: q ){
        cin >> u; --u;
    }
    vector <int> tour, tin(n), tout(n), fa(n);
    auto pre_dfs = [&](auto pre_dfs, int u, int p) -> void{
        fa[u] = p;
        tin[u] = (int)tour.size();
        tour.pb(u);
        vector <int> nxt, tmp;
        bool vis = false;
        for ( auto &v: adj[u] ){
            if ( v == p ){
                vis = true;
                continue;
            }
            if ( vis > 0 ){
                nxt.pb(v);
            } else tmp.pb(v);
        }
        for ( auto &v: tmp ){
            nxt.pb(v);
        }
        for ( auto &v: nxt ){
            pre_dfs(pre_dfs, v, u);
            tour.pb(u);
        }
        tout[u] = (int)tour.size() - 1;
    };
    pre_dfs(pre_dfs, 0, -1);
    vector <int> dp(n);
    vector <vector<int>> upd(n);
    auto dfs = [&](auto dfs, int u, int p) -> void{
        bool vis = false;
        upd[dp[u]].pb(u);
        for ( auto &v: adj[u] ){
            if ( v == p ){
                vis = true;
                continue;
            }
            dp[v] = dp[u] + vis;
            dfs(dfs, v, u);
        }
    };
    dfs(dfs, 0, -1);
    vector <set<int>> st(n);
    int ans = 0, j = 0, lst = -1, sz = 0;
    for ( int i = 0; i < n; i++ ){
        for ( auto &v: upd[i] ){
            st[v].insert(tin[v]);
            sz++;
            if ( fa[v] != -1 && tout[v] + 1 != (int)tour.size() - 1 ){
                st[fa[v]].insert(tout[v] + 1);
                sz++;
            }
        }
        int mx = -1;
        while ( j < m ){
            auto it = st[q[j]].lower_bound(mx + 1);
            if ( it == st[q[j]].end() ){
                break;
            }
            mx = *it;
            j++;
        }
        if ( j == m ){
            lst = mx + 1;
            break;
        } ans += sz;
    }
    while ( j < m ){
        int mx = -1;
        while ( j < m ){
            auto it = st[q[j]].lower_bound(mx + 1);
            if ( it == st[q[j]].end() ){
                break;
            }
            mx = *it;
            j++;
        }
        if ( j == m ){
            lst = mx + 1;
            break;
        } ans += sz;
    }
    cout << ans + lst;

    cout << '\n';
}
