#include <bits/stdc++.h>
#include "game.h"

using namespace std;

vector<int> dp;

void init(std::vector<int> A, int D) {
    int n = A.size();
    vector<int> v = A;
    int d = D;
    dp.resize(n);
    int j_m = 0;
    for (int i = 0; i < n; i++) {
        if (v[i] > v[j_m]) {
            j_m = i;
        }
    }
    dp[j_m] = 0;
    queue<int> q;
    q.push(j_m);
    while (!q.empty()) {
        int j = q.front(); q.pop();
        for (int i = 1; i <= d; i++) {
            if (j + i < n) {
                dp[j + i] = 1;
            }
            if (j - i >= 0) {
                dp[j + i] = 1;
            }
        }
        if (j + d + 1 < n) {
            dp[j + d + 1] = 0;
            q.push(j + d + 1);
        }
        if (j - d - 1 >= 0) {
            dp[j - d - 1] = 0;
            q.push(j - d - 1);
        }
    }
}

void updateValue(int index, int newValue) {
    // A[index] = newValue
}

bool isWinning(int startIndex) {
    return dp[startIndex];
}
