#include <bits/stdc++.h>
using namespace std;

#define int long long
#define all(x) x.begin(), x.end()

struct pt {
    vector<int> v;
    bool operator<(pt b) {
        for (int i = 0; i < v.size(); i++) {
            if (v[i] > b.v[i]) {
                return false;
            } else if (v[i] < b.v[i]) {
                return true;
            }
        }
        return false;
    }
};

void solve() {
    int n, k, x; cin >> n >> k >> x;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> v = a;
    vector<pt> d;
    sort(all(v));
    do {
        bool good = true;
        int g = __gcd(v[0], a[0]);
        for (int i = 1; i < n; i++) {
            if (__gcd(v[i], a[i]) != g) {
                good = false;
                break;
            }
        }
        if (good) {
            d.push_back({v});
        }
    } while (next_permutation(all(v)));
    sort(all(d));
    if (d.size() == 0) {
        cout << -1 << "\n";
        return ;
    }
    vector<int> c = d[0].v;
    for (int i = 0; i < c.size(); i++) {
        cout << c[i] << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);// cout.tie(0);
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }
}
