#include <bits/stdc++.h>
#include "game.h"
using namespace std;
#define ff first
#define ss second
#define all(a) a.begin(), a.end()
vector<int> a, state;
int n, d;
void init(std::vector<int> A, int D){
    n = A.size();
    d = D;
    a = A;
    state.resize(n, 0);
    vector<int> p;
    for(int i = 0;i < n; i++) p.push_back(i);
    sort(all(p), [&](int i, int j){
        return a[i] > a[j];
    });
    state[p[0]] = 1;
    for(auto i : p){
        int ok = 1;
        for(int j = max(0, i - d); j <= min(n-1, i + d); j++){
            if(i != j && state[j]){
                ok = 0;
            }
        }
        state[i] = ok;
      
    }
    
}
void updateValue(int i, int x){
    a[i] = x;
    vector<int> p;
    for(int i = 0;i < n; i++){
        state[i] = 0;
        p.push_back(i);
    }
    sort(all(p), [&](int i, int j){
        return a[i] > a[j];
    });
    state[p[0]] = 1;
    for(auto i : p){
        int ok = 1;
        for(int j = max(0, i - d); j <= min(n-1, i + d); j++){
            if(i != j && state[j]){
                ok = 0;
            }
        }
        state[i] = ok;
        
    }
    
}
bool isWinning(int i){
    return !state[i];
}

/*
main(){
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int N, D; cin >> N >> D;
    vector<int> A(N);
    for(int i = 0;i < N; i++) cin >> A[i];
    init(A, D);
    int Q; cin >> Q;
    while(Q--){
        int type; cin >> type;
        if(type == 1){
            int i, x; cin >> i >> x;
            updateValue(i, x);
        }else{
            int i; cin >> i;
            cout << isWinning(i) << '\n';
        }
    }
    
    
    
    return 0;
}
*/