#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define all(x) x.begin(), x.end()
#define size(x) (int)x.size()

template<class S, class T>
bool chmin(S& a, const T& b) {
  return a > b ? (a = b) == b : false;
}
template<class S, class T>
bool chmax(S& a, const T& b) {
  return a < b ? (a = b) == b : false;
}
const int N = 5e5 + 1;

deque<int> g[N], f, path;
bool vis[N];
int cnt;

void dfs(int v) {
  if (v == 1 && !cnt) return;
  path.push_back(v);
  if (!vis[v]) cnt--;
  vis[v] = true;
  g[v].push_back(g[v].front());
  g[v].pop_front();
  dfs(g[v].back());
}

signed main() {
  cin.tie(nullptr)->sync_with_stdio(false);
  int n, m; cin >> n >> m;
  cnt = n;
  for (int i = 1; i <= n; ++i) {
    int k; cin >> k;
    while (k--) {
      int v; cin >> v;
      g[i].push_back(v);
    }
  }
  f.resize(m);
  for (auto &i : f) cin >> i;
  dfs(1);
  int res = 0;
  while (!path.empty() && !f.empty()) {
    res++;
    if (path.front() == f.front())
      f.pop_front();
    path.pop_front();
  }
  path.clear();
  memset(vis, false, sizeof(vis));
  cnt = n;
  dfs(1);
  int i = 0;
  vector<int> id[n + 1];
  for (int i = 0; i < size(path); ++i)
    id[path[i]].push_back(i);
  while (!f.empty()) {
    int j = i;
    i = upper_bound(all(id[f.front()]), i) - id[f.front()].begin();
    res += i - j;
    if (i < size(id[f.front()])) f.pop_front();
    else i = 0;
  }
  cout << res;
}