#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("avx,avx2,fma")
#include <bits/stdc++.h>
 
#define ff first
#define ss second
#define pb push_back
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define rnd(l, r) uniform_int_distribution<int>(l, r)(rng)
 
using namespace std;

void fp(string name){freopen((name+".in").c_str(),"r",stdin); freopen((name+".out").c_str(),"w",stdout);} 
int pow(int a,int b,int m){int ans=1;while(b){if(b&1){ans=(ans*a)%m;}b>>=1;a=(a*a)%m;}return ans;}
int binpow(int a,int b){int ans=1;while(b){if(b&1){ans=(ans*a);}b>>=1;a=(a*a);}return ans;}
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
 
const int N = 5e5 + 10, inf = 1e9;


void solve(){
	int n, k, x;
	cin >> n >> k >> x;
	vector <int> v(n);
	for(int i = 0; i < n; i++){
		cin >> v[i];
	}
	auto a = v, ans = v;
	sort(all(a));
	
	do{
		bool f = 1;
		for(int bit = 0; bit < (1 << n); bit++){
			if(__builtin_popcount(bit) != k)continue;
			int fgcd = 0, sgcd = 0;
			for(int i = 0; i < n; i++){
				if(!(bit & (1 << i)))continue;
				fgcd = __gcd(fgcd, v[i]);
				sgcd = __gcd(sgcd, a[i]);
			}
			f &= (fgcd == sgcd);
		}
		if(f)ans = min(ans, a);
	}while(next_permutation(all(a)));
	for(auto x : ans)
		cout << x <<" ";
	cout << endl;
}

main(){
	iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
	int t;
	cin >> t;
	while(t--)
		solve();
}	
/*
 * Before implementing the problem:
	
	Do I understand the problem correctly?
	Which places are tricky? What do I need to remember to implement them correctly?
	Which place is the heaviest by implementation? Can I do it simpler?
	Which place is the slowest? Where do I need to be careful about constant factors and where I can choose slower but simpler implementation?
	----------------------------------
	If not AC:
 
	Did you remember to do everything to handle the tricky places you thought about before?
	Is the solution correct?
	Do I understand the problem correctly?
	----------------------------------
	If you have a test on which the solution gives wrong answer:
 
	Is the solution doing what it was supposed to do?
	Is the problem in the code or in the idea?
*/
