#include <iostream>
#include <algorithm>
#include <vector>
#include <array>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <chrono>
#include <random>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <cassert>

using namespace std;

int gcd(int a, int b)
{
    if(a < b)
    {
        swap(a, b);
    }
    if(b == 0)
    {
        return a;
    }
    if(a == b)
    {
        return a;
    }
    return gcd(a%b, b);
}

int lcm(int a, int b)
{
    return a*b/gcd(a, b);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<queue<int>> adj(n+1);
    for(int i = 1; i <= n; i++)
    {
        int x;
        cin >> x;
        for(int j = 0; j < x;j++)
        {
            int k;
            cin >> k;
            adj[i].push(k);
        }
    }
    vector<int> mm(m);
    for(int i = 0; i < m; i++)
    {
        cin >> mm[i];
    }
    int idx = 1;
    int nowm = 0;
    int day = 0;
    while(true)
    {
        day++;
        if(mm[nowm] == idx)
        {
            nowm++;
        }
        if(nowm == m)
        {
            break;
        }
        int lastidx = idx;
        idx = adj[idx].front();
        adj[lastidx].pop();
        adj[lastidx].push(idx);
    }
    cout << day << endl;
}

int main()
{
    int t = 1;
    //cin >> t;
    while(t--)
    {
        solve();
    }
}

/*
4 4
2 2 3
1 1
2 1 4
1 3
2 1 1 4
 */
