#include <bits/stdc++.h>
#include "game.h"
using namespace std;

const int N = 2e5 + 10;
int n, d, a[N], seg_mx[4 * N];
bool win[N];

int mxi(int i, int j){
    if (a[i] > a[j])
        return i;
    return j;
}

void modify_max(int p, int val, int v = 1, int s = 0, int e = n){
    if (e - s == 1){
        seg_mx[v] = p;
        return;
    }

    int mid = (s + e) / 2, lc = 2 * v, rc = lc + 1;

    if (p < mid) modify_max(p, val, lc, s, mid);
    else modify_max(p, val, rc, mid, e);

    seg_mx[v] = mxi(seg_mx[lc], seg_mx[rc]);
}

int get_max(int l, int r, int v = 1, int s = 0, int e = n){
    if (r <= s || e <= l) return 0;
    if (l <= s && e <= r) return seg_mx[v];

    int mid = (s + e) / 2, lc = 2 * v, rc = lc + 1;

    return mxi(get_max(l, r, lc, s, mid), get_max(l, r, rc, mid, e));
}

void recur(int l, int r){
    if (l >= r) return;

    int mx_ind = get_max(l, r);
    win[mx_ind] = 0;
    for (int i = max(0, mx_ind - d); i <= min(n - 1, mx_ind + d); i ++){
        if (i == mx_ind) continue;
        win[i] = 1;
    }
    recur(l, max(0, mx_ind - d));
    recur(min(n - 1, mx_ind + d) + 1, r);
}

void init(vector<int> A, int D){
    n = A.size();
    d = D;
    for (int i = 0; i < n; i ++){
        a[i] = A[i];
        modify_max(i, a[i]);
    }

    recur(0, n);
}

void updateValue(int index, int newValue){
    a[index] = newValue;
    modify_max(index, newValue);
    recur(0, n);
}

bool isWinning(int startIndex){
    return win[startIndex];
}