#include<bits/stdc++.h>

using namespace std;

#define ll long long

const int N = 5e5 + 5;
deque<int> G[N];
vector<int> idx[N];
int t = 0, id = 0;
bool seen[N];
int n;

bool dfs(int v)
{
  id += !seen[v];
  seen[v] = true;
  
  ++t;
  idx[v].push_back(t);

  if(v == 1 && id == n)
    return true;

  bool flag = false;
  
  for(int i = 0; i < G[v].size() && !flag; i++)
    {
      G[v].push_back(G[v].front());
      G[v].pop_front();
      flag |= dfs(G[v].back());
      idx[v].push_back(++t);
    }

  return flag;
}

int main()
{
  int m;
  cin >> n >> m;
  for(int i = 1; i <= n; i ++)
    {
      int k;
      cin >> k;
      G[i].resize(k);
      for(int &j : G[i])
	cin >> j;
    }

  
  dfs(1);
  int cur = 1, ix = 1;
  ll ans = 0;
  for(int i = 0; i < m ; i++)
    {
      int p;
      cin >> p;

      if(i == 0 && p == 1) continue;
      
      auto it = upper_bound(idx[p].begin(), idx[p].end(), ix);
      if(it == idx[p].end())
	{
	  ans += t - *it;
	  it = idx[p].begin();
	  ans += *it;
	}
      else
	ans += *it - ix, cur = p, ix = *it;
    }
  cout << ans + 1 << endl;
  return 0;
}
