#include <bits/stdc++.h>

using namespace std;

const int nmax = 1e3;
const int lim = 32000;

int n,k,x;
int v[nmax + 5];

int sp[nmax + 5];
vector<pair<int,int>> f[nmax + 5];

vector<int> l[lim + 5];

map<int,int> fr;

void get_fact(int x, int poz)
{
    int d = 2;
    while(x != 1 && d * d <= x)
    {
        int p = 0;
        while(x % d == 0)
        {
            x /= d;
            ++p;
        }
        if(p != 0)
        {
            f[poz].push_back({d, p});
            l[d].push_back(p);
        }
        ++d;
    }
    if(x != 1)
    {
        if(x <= lim)
        {
            f[poz].push_back({x, 1});
            l[x].push_back(1);
        }
        else
        {
            sp[poz] = x;
            ++fr[x];
        }
    }
}

bool can_swap(int pozx, int pozy)
{
    int x = v[pozx];
    int y = v[pozy];
    for(auto it : f[pozx])
    {
        int d = it.first;
        int e = it.second;
        int p = 0;
        while(y % d == 0)
        {
            y /= d;
            ++p;
        }
        if(e > p)
        {
            if(l[d].size() < k)
            {
                continue;
            }
            if(l[d][k - 1] > p)
            {
                return false;
            }
        }
    }
    if(sp[pozx])
    {
        int d = sp[pozx];
        if(sp[pozy] != d)
        {
            if(fr[d] >= k)
            {
                return false;
            }
        }
    }
    return true;
}

void debug(vector<int> a)
{
    for(auto it : a)
    {
        cerr<<it<<' ';
    }
    cerr<<'\n';
}

void solve_test()
{
    cin>>n>>k>>x;
    for(int i=1; i<=n; i++)
    {
        cin>>v[i];
        get_fact(v[i], i);
    }
    for(int i=2;i<=lim;i++)
    {
        sort(l[i].begin(),l[i].end(),greater<int>());
    }
    for(int i=1; i<=n; i++)
    {
        int poz = 0;
        for(int j=i+1; j<=n; j++)
        {
            if(v[j] < v[i] && (poz == 0 || v[j] < v[poz]) && can_swap(i, j) && can_swap(j, i))
            {
                poz = j;
            }
        }
        if(poz)
        {
            swap(v[i], v[poz]);
        }
    }
    for(int i=2;i<=lim;i++)
    {
        l[i].clear();
    }
    for(int i=1;i<=n;i++)
    {
        cout<<v[i]<<' ';
        f[i].clear();
        sp[i] = 0;
    }
    fr.clear();
    cout<<'\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    #ifdef home
    freopen("nr.in","r",stdin);
    freopen("nr.out","w",stdout);
    #endif // home
    int t;
    cin>>t;
    for(int test=1; test<=t; test++)
    {
        solve_test();
    }
    return 0;
}
