#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("fast-math")
using namespace std;
const int INF=1e9;
int n,m,par[500005],qnodes[500005];
vector<int> ord[500005];
vector<int> muchii[500005];
vector<int> edges[500005];
int v[1000005],timp;
vector<int> where[500005];
set<int> setik;
struct date
{
    /// tip = 0 -> doar nod, tip = 1 -> interval
    int tip,l,r;
};
vector<date> vals;
void initdfs(int nod)
{
    for(int i:muchii[nod])
        if(i!=par[nod])
        {
            par[i]=nod;
            initdfs(i);
        }
}
void buildpre(int nod)
{
    timp++;
    v[timp]=nod;
    for(int i:muchii[nod])
        if(i!=par[nod])
        {
            buildpre(i);
            timp++;
            v[timp]=nod;
        }
}
void solve(int nod)
{
    vals.push_back({0,nod,nod});
    for(int i:where[nod])
        setik.erase(i);
    for(int i:ord[nod])
    {
        if(i==par[nod])
            break;
        solve(i);
        vals.push_back({0,nod,nod});
    }
}
int plsfind(int l,int r, int nod)
{
    int st=0;
    int dr=where[nod].size();
    dr--;
    int poz=1e9;
    while(st<=dr)
    {
        int mij=(st+dr)/2;
        if(where[nod][mij]>=l)
        {
            poz=where[nod][mij];
            dr=mij-1;
        }
        else
            st=mij+1;
    }
    if(poz<=r)
        return poz;
    return INF;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int i=1;i<=n;i++)
    {
        int cnt;
        cin>>cnt;
        for(int j=1;j<=cnt;j++)
        {
            int x;
            cin>>x;
            ord[i].push_back(x);
            muchii[i].push_back(x);
        }
    }
    for(int i=1;i<=m;i++)
    {
        int x;
        cin>>x;
        qnodes[i]=x;
    }
    if(n==1)
    {
        cout<<m;
        return 0;
    }
    initdfs(1);
    edges[1]=ord[1];
    for(int i=2;i<=n;i++)
    {
        vector<int> aux;
        int p=0;
        int lg=ord[i].size();
        for(int j=0;j<ord[i].size();j++)
            if(ord[i][j]==par[i])
            {
                p=j;
                break;
            }
        p=(p+1)%lg;
        while(aux.size()<ord[i].size())
        {
            aux.push_back(ord[i][p]);
            p=(p+1)%lg;
        }
        edges[i]=aux;
    }
    for(int i=1;i<=n;i++)
        muchii[i]=edges[i];
    buildpre(1);
    for(int i=1;i<=timp;i++)
    {
        where[v[i]].push_back(i);
        setik.insert(i);
    }
    for(int i:where[1])
        setik.erase(i);
    int poz=1;
    while(true)
    {
        if(poz==2&&setik.empty())
            break;
        int st=poz;
        int dr=timp;
        int p=timp+1;
        /*while(st<=dr)
        {
            int mij=(st+dr)/2;
            if(suma(mij)-suma(poz-1)<(mij-poz+1))
            {
                p=mij;
                dr=mij-1;
            }
            else
                st=mij+1;
        }*/
        auto it=setik.lower_bound(poz);
        if(it==setik.end())
            p=timp+1;
        else
            p=(*it);
        if(p>timp)
        {
            if(poz<=timp)
                vals.push_back({1,poz,timp});
            poz=2;
            continue;
        }
        if(p>poz)
            vals.push_back({1,poz,p-1});
        int nod=v[p];
        solve(nod);
        poz=where[nod].back();
        poz++;
    }
    long long ans=0;
    poz=1;
    for(date z:vals)
    {
        if(poz>m)
        {
            cout<<ans;
            return 0;
        }
        if(z.tip==0)
        {
            ans++;
            if(z.l==qnodes[poz])
                poz++;
            continue;
        }
        int l=z.l,r=z.r;
        while(l<=r&&poz<=m)
        {
            int x=plsfind(l,r,qnodes[poz]);
            if(x>timp)
            {
                ans+=r-l+1;
                break;
            }
            ans+=x-l+1;
            poz++;
            l=x+1;
        }
    }
    while(poz<=m)
    {
        int l=2;
        int r=timp;
        while(poz<=m&&l<=r)
        {
            int x=plsfind(l,r,qnodes[poz]);
            if(x>timp)
            {
                ans+=r-l+1;
                break;
            }
            ans+=x-l+1;
            poz++;
            l=x+1;
        }
    }
    cout<<ans;
    return 0;
}
