#include <bits/stdc++.h>
#include "game.h"

using namespace std;

constexpr int NMAX = 1e5 + 5;
typedef long long LL;
constexpr LL INF = 1LL * 1e17;

int N, d;
vector <int> arr;

LL WhatDiff[NMAX];
int caz[NMAX];

void SolveList (vector <int> L) {
    for (auto it : L) {
        bool exist_eq = false;
        bool exist_big = false;
        for (int j = max(0, it - d); j <= min(N, it + d); ++ j ) {
            if (j == it) continue;

            if (arr[j] > arr[it]) exist_big = true;
            if (arr[j] == arr[it]) exist_eq = true;
        }

        if (!exist_eq && !exist_big) {
            WhatDiff[it] = -INF;
            continue;
        }

        WhatDiff[it] = -INF;

        for (int j = max(0, it - d); j <= min(N, it + d); ++ j ) {
            if (j == it) continue;

            if (arr[j] < arr[it]) continue;

            LL ans = INF;

            if (arr[j] == arr[it]) ans = 0;

            for (int k = max(0, j - d); k <= min(N, j + d); ++ k ) {
                if (k == j) continue;

                if (arr[k] < arr[j]) continue;

                if (arr[k] == arr[it]) continue;

                ans = min(ans, arr[j] - arr[k] + WhatDiff[k]);
            }

            WhatDiff[it] = max(WhatDiff[it], ans);
        }
    }
}

void ComputeAnswerAll () {
    vector <pair <int, int> > V;
    for (int i = 0; i < arr.size(); ++ i ) {
        V.push_back({arr[i], i});
        WhatDiff[i] = 0;
    }

    sort(V.begin(), V.end());
    reverse(V.begin(), V.end());

    for (int i = 0; i < V.size(); ++ i ) {
        int j = i;
        vector <int> List;

        while (j < V.size() && V[j].first == V[i].first) {
            List.push_back(V[j].second);
            ++ j;
        }

        SolveList(List);
    }
}


void init(std::vector<int> A, int D) {
    N = A.size() - 1;
    arr = A;
    d = D;

    ComputeAnswerAll();
}

void updateValue(int index, int newValue) {
    arr[index] = newValue;
    ComputeAnswerAll();
}

bool isWinning(int startIndex){
    return (WhatDiff[startIndex] >= 0);
}
