#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 1e5 + 5;
typedef long long LL;
constexpr LL INF = 1LL * 1e18;

int N, K, X;

vector <LL> A;

vector <int> prime;
bool compus[NMAX];
map <LL, int> mp;

void Precompute () {
    for (int i = 2; i * i <= NMAX - 5; ++ i ) {
        if (!compus[i]) {
            for (int j = 2 * i; j <= NMAX - 5; j += i)
                compus[j] = true;
        }
    }

    for (int i = 2; i <= NMAX; ++ i ) {
        if (!compus[i]) prime.push_back(i);
    }
}

vector <int> Minimum (vector <int> a, vector <int> b) {
    if (a.empty()) return b;

    if (b.empty()) return a;

    for (int i = 0; i < a.size(); ++ i ) {
        if (a[i] < b[i]) return a;

        if (b[i] < a[i]) return b;
    }

    return a;
}

void Afis (vector <LL> V) {
    for (int i = 0; i < N; ++ i )
        cout << V[i] << " ";
    cout << '\n';
}

vector <LL> forcedWith;
vector <LL> forcedWithout[NMAX];

int Count (LL d) {
    int ans = 0;
    for (int i = 0; i < N; ++ i )
        if (A[i] % d == 0) ++ ans;

    return ans;
}

vector <LL> SolveNormal () {
    vector <LL> solutie;
    vector <LL> remFactor;
    remFactor = A;
    mp.clear();

    forcedWith.clear();
    forcedWith.resize(N, 1);

    for (int i = 0; i < N; ++ i ) {
        forcedWith[i] = 1;
        forcedWithout[i].clear();
    }

    for (auto it : prime) {
        LL val = it;
        int now = Count(val);

        if (now >= K) {
            for (int i = 0; i < N; ++ i ) {
                if (A[i] % val != 0)
                    forcedWithout[i].push_back(val);
            }
        }

        while (now >= K) {
            int nxt = Count(val * it);

            for (int i = 0; i < N; ++ i ) {
                if (A[i] % val == 0) {
                    if (nxt < K || (A[i] / val) % it != 0) {
                        remFactor[i] /= val;
                        while (remFactor[i] % it == 0)
                            remFactor[i] /= it;

                        forcedWith[i] *= val;
                    }
                    if (nxt >= K && (A[i] / val) % it != 0)
                        forcedWithout[i].push_back(val * it * 1LL);
                }
            }
            val *= 1LL * it;
            now = nxt;
        }
    }

    for (int i = 0; i < N; ++ i )
        mp[remFactor[i]] ++;

    for (int i = 0; i < N; ++ i ) {
        if (mp[remFactor[i]] >= K && remFactor[i] > 1) {
            forcedWith[i] *= remFactor[i];
            forcedWithout[i].push_back(remFactor[i] * remFactor[i]);
        }
    }

    vector <bool> used;
    used.resize(N, 0);
    solutie.resize(N, 0);

    for (int i = 0; i < N; ++ i ) {
        LL Min = INF;
        int pos = 0;
        for (int j = 0; j < N; ++ j ) {
            if (used[j]) continue;

            if (A[j] % forcedWith[i] != 0) continue;

            bool good = true;
            for (auto nu : forcedWithout[i]) {
                if (A[j] % nu == 0) good = false;

                if (!good) break;
            }

            if (good) {
                if (Min > A[j]) {
                    Min = A[j];
                    pos = j;
                }
            }
        }

        solutie[i] = Min;
        used[pos] = true;
    }

    return solutie;
}

void Read () {
    cin >> N >> K >> X;

    A.clear();
    A.resize(N, 0);
    for (int i = 0; i < N; ++ i )
        cin >> A[i];
}

void Do_Testcase () {
    Read();
    Afis(SolveNormal());
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int T;
    cin >> T;
    Precompute();

    for (; T; -- T ) {
        Do_Testcase();
    }
    return 0;
}