#include <iostream>
#include <queue>

using namespace std;

const int N = 5e5;
int sz[N], v[N];
queue <int> q[N + 10];

int n, m;

int solve () {
    int dist = 0, node = 1;

    int i = 1;

    while ( i <= m ) {

        if ( node == v[i] )
            i++;

        int copie = node;

        node = q[node].front();
        q[copie].push ( q[copie].front() );
        q[copie].pop();

        dist++;
    }

    return dist;
}

int main() {

    int x;

    cin >> n >> m;

    for ( int i = 1; i <= n; i++ ) {
        cin >> sz[i];

        for ( int j = 0; j < sz[i]; j++ ){
            cin >> x;
            q[i].push(x);
        }
    }

    for ( int i = 1; i <= m; i++ )
        cin >> v[i];

    cout << solve ();


    return 0;
}
