#include <bits/stdc++.h>
#include "game.h"

using namespace std;

const int NMAX = 2e5 + 5;
bool win[NMAX + 5];
int n;
int a[NMAX + 5];
int d;

void calculateWin(int index) {
    win[index] = 0;
    for (int i = index; i >= 0 && i >= index - d; i--) {
        if (a[i] > a[index])
            win[index] |= !win[i];
    }
    for (int i = index; i <= index + d && i < n; i++) {
        if (a[i] > a[index])
            win[index] |= !win[i];
    }
}

void init(std::vector<int> A, int D) {
    vector<pair<int, int>> ve;
    n = A.size();
    d = D;
    for (int i = 0; i < n; i++) {
        a[i] = A[i];
        ve.push_back(make_pair(A[i], i));
    }
    sort(ve.begin(), ve.end(), greater<pair<int, int>>());

    for (auto &it : ve) {
        //parcurg numerele descrescator
        int pos = it.second;
        calculateWin(pos);
    }
    /*cout << '\n';
    for (int i = 0; i < n; i++)
        cout << win[i] << ' ';
    cout << '\n' << '\n';*/
}



void updateValue(int index, int newValue) {
    vector<pair<int, int>> ve;
    a[index] = newValue;
    for (int i = 0; i < n; i++) {
        ve.push_back(make_pair(a[i], i));
    }
    sort(ve.begin(), ve.end(), greater<pair<int, int>>());

    for (auto &it : ve) {
        //parcurg numerele descrescator
        int pos = it.second;
        calculateWin(pos);
    }
}
bool isWinning(int startIndex) {
    return win[startIndex];
}

