#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e5 + 5;

int a[NMAX + 5];
int b[NMAX + 5];
int n, k, x;

bool ok() {
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) != k) continue;
        int g1 = 0, g2 = 0;
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                g1 = __gcd(g1, a[i + 1]);
                g2 = __gcd(g2, b[i + 1]);
            }
        }
        if (g1 != g2)
            return 0;
    }
    return 1;
}


void solve() {
    cin >> n >> k >> x;
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        b[i] = a[i];
    }
    sort(b + 1, b + n + 1);

    while (1) {
        if (ok()) {
            for (int i = 1; i <= n; i++)
                cout << b[i] << ' ';
            cout << '\n';
            return;
        }

        if (!next_permutation(b + 1, b + n + 1))
            break;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}
