#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll NMAX=5e5+5;
vector<ll> edg[NMAX];
vector<ll> pos[NMAX];
ll cnt=0;
ll ptr[NMAX],f[NMAX],dp[NMAX],p[NMAX],currf,n,m,d=0;
map<ll,ll> dp2[NMAX];
ll sdp[NMAX];
void dfs(ll u, ll root){
    dp2[root][dp[u]]++;
    sdp[dp[u]]++;
    bool fndpar=0;
    for(auto it : edg[u]){
        if(it==p[u]) fndpar=1;
        else{
            dp[it]=dp[u]+fndpar;
            p[it]=u;
            dfs(it,root);
        }
    }
}
void compute_euler_tour(ll u, ll layer){
    pos[u].push_back(cnt++);
    bool children=0;
    for(auto it : edg[u]){
        if(it!=p[u] && dp[it]<=layer){
            compute_euler_tour(it,layer);
            children=1;
        }
    }
    if(children) pos[u].push_back(cnt++);
}
void euler_tour(ll layer){
    cnt=0;
    for(ll i=1;i<=n;i++) pos[i].clear();
    compute_euler_tour(1,layer);
}
int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    cin>>n>>m;
    for(ll i=1;i<=n;i++){
        ll k; cin>>k;
        while(k--){
            ll x; cin>>x;
            edg[i].push_back(x);
        }
    }
    for(ll i=0;i<edg[1].size();i++){
        ll it=edg[1][i];
        p[it]=1;
        dfs(it,i);
    }
    sdp[0]=1;
    for(ll i=1;i<n;i++) sdp[i]+=sdp[i-1];
    euler_tour(0);
    ll ans=0,curr_layer=0,pos_in_euler=-1;
    for(ll i=0;i<m-1;i++){
        ll x=0;
        cin>>x;
        while(dp[x]>curr_layer || pos[x].back()<=pos_in_euler){
            ans+=cnt-pos_in_euler-1;
            pos_in_euler=0;
            euler_tour(++curr_layer);
        }
        if(pos[x][0]>pos_in_euler){
            ans+=pos[x][0]-pos_in_euler;
            pos_in_euler=pos[x][0];
        }
        else if(pos[x].back()>pos_in_euler){
            ans+=pos[x][1]-pos_in_euler;
            pos_in_euler=pos[x][1];
        }
    }
    cout<<ans<<'\n';
    return 0;
}
