#include "game.h"
#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll NMAX=2e5+5;
bool dp[NMAX];
ll d,n;
vector<int> a;
vector<pair<int,int>> lazy_queries;
void calcdp(ll l, ll r){
    if(l>r) return;
    ll Max=0,pmax=0;
    for(ll i=l;i<=r;i++){
        if(a[i]>Max){
            Max=a[i];
            pmax=i;
        }
    }
    for(ll i=max(l,pmax-d);i<=min(r,pmax+d);i++) dp[i]=0;
    dp[pmax]=1;
    calcdp(l,pmax-d-1);
    calcdp(pmax+d+1,r);
}
void init(vector<int> v, int _d){
    n=v.size();

    a=v;
    d=_d;
    calcdp(0,n-1);
}
void updateValue(int index, int newValue){
    lazy_queries.push_back({index,newValue});
    calcdp(0,n-1);
}
bool isWinning(int index){
    if(!lazy_queries.empty()){
        for(auto it : lazy_queries){
            a[it.first]=it.second;
        }
        lazy_queries.clear();
        calcdp(0,n-1);
    }
    return !dp[index];
}
