#include "game.h"
#include<bits/stdc++.h>

using namespace std;
typedef int ll;
const ll NMAX=2e5+5,LGMAX=18;
bool dp[NMAX];
ll sparse[LGMAX][NMAX],lg[NMAX];
ll d,n;
vector<int> a;
vector<pair<int,int>> lazy_queries;
ll query(ll l, ll r){
    ll bit=lg[r-l+1];
    if(a[sparse[bit][l]]>a[sparse[bit][r-(1<<bit)+1]]) return sparse[bit][l];
    else return sparse[bit][r-(1<<bit)+1];
}
void calcdp(ll l, ll r){
    if(l>r) return;
    ll pmax=query(l,r);
    for(ll i=max(l,pmax-d);i<=min(r,pmax+d);i++) dp[i]=0;
    dp[pmax]=1;
    calcdp(l,pmax-d-1);
    calcdp(pmax+d+1,r);
}
void updAll(){
    if(!lazy_queries.empty()){
        for(auto it : lazy_queries){
            a[it.first]=it.second;
        }
        lazy_queries.clear();
        calcdp(0,n-1);
    }
    for(ll bit=1;bit<LGMAX;bit++){
        for(ll i=0;i+(1<<bit)<=n;i++){
            if(a[sparse[bit-1][i]]<a[sparse[bit-1][i+(1<<(bit-1))]]) sparse[bit][i]=sparse[bit-1][i+(1<<(bit-1))];
            else sparse[bit][i]=sparse[bit-1][i];
        }
    }
    calcdp(0,n-1);
}
void init(vector<int> v, int _d){
    n=v.size();
    a=v;
    d=_d;

    for(ll i=2;i<=n;i++) lg[i]=lg[i>>1]+1;
    for(ll i=0;i<n;i++) sparse[0][i]=i;
    updAll();
}
void updateValue(int index, int newValue){
    lazy_queries.push_back({index,newValue});
}
bool isWinning(int index){
    updAll();
    return !dp[index];
}
