#include "game.h"
#include<bits/stdc++.h>

using namespace std;
typedef int ll;
const ll NMAX=2e5+5,STMAX=(1<<19)+5,LGMAX=18;
ll dp[NMAX];
ll st[STMAX];
ll d,n;
vector<int> a;
void st_init(ll l, ll r, ll node){
    if(l==r){
        st[node]=l;
        return;
    }
    st_init(l,(l+r)/2,node*2+1);
    st_init((l+r)/2+1,r,node*2+2);
    if(a[st[node*2+1]]>a[st[node*2+2]]) st[node]=st[node*2+1];
    else st[node]=st[node*2+2];
}
void update(ll qid, ll l, ll r, ll node){
    if(qid<l || qid>r || l==r) return;
    update(qid,l,(l+r)/2,node*2+1);
    update(qid,(l+r)/2+1,r,node*2+2);
    if(a[st[node*2+1]]>a[st[node*2+2]]) st[node]=st[node*2+1];
    else st[node]=st[node*2+2];
}
ll query(ll ql, ll qr, ll l, ll r, ll node){
    if(ql>r || l>qr) return n;
    if(ql<=l && r<=qr) return st[node];
    ll cnd1=query(ql,qr,l,(l+r)/2,node*2+1);
    ll cnd2=query(ql,qr,(l+r)/2+1,r,node*2+2);
    if(a[cnd1]>a[cnd2]) return cnd1;
    else return cnd2;
}
vector<pair<int,int>> lazy_queries;
ll curr_iter=1;
void calcdp(ll l, ll r){
    if(l>r) return;
    ll Max=0,pmax=0;
    //for(ll i=0;i<n;i++) cerr<<a[i]<<' ';
    //    cerr<<'\n';
    if(r-l<=50){
        for(ll i=l;i<=r;i++){
            if(a[i]>Max) pmax=i,Max=a[i];
        }
    }
    else pmax=query(l,r,0,n-1,0);
    dp[pmax]=curr_iter;
    calcdp(l,pmax-d-1);
    calcdp(pmax+d+1,r);
}
void updAll(){
    if(!lazy_queries.empty()){
        for(auto it : lazy_queries){
            a[it.first]=it.second;
            update(it.first,0,n-1,0);
        }
        lazy_queries.clear();
        curr_iter++;
        calcdp(0,n-1);
    }
}
void init(vector<int> v, int _d){
    n=v.size();
    a=v;
    a.push_back(-1e9);
    d=_d;
    st_init(0,n-1,0);
    calcdp(0,n-1);
}
void updateValue(int index, int newValue){
    lazy_queries.push_back({index,newValue});
}
bool isWinning(int index){
    updAll();
    return dp[index]!=curr_iter;
}
