#include<bits/stdc++.h>
//#define DEBUG
using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
ll getTime(){return chrono::steady_clock::now().time_since_epoch().count();}
mt19937_64 gen(0);
ll rndnext(ll l, ll r){
    uniform_int_distribution<ll> rnd(l,r);
    return rnd(gen);
}
const ll NMAX=1e5+5,NMAX2=3.2e4+5,TL=1.5e9-1e8;
ll sieve[NMAX2],primes[NMAX2],a[NMAX],Hash[NMAX],cntp=0;
unordered_map<ll,vector<ll>> groups;
unordered_map<ll,vector<ll>> tosort;
ll divs[NMAX],cntd=0;
void add_to_groups(ll pos, ll extra){
    ll x=a[pos];
    if(extra<NMAX2) x*=extra;
    divs[(cntd=0)++]=1;
    for(ll i=0;primes[i]*primes[i]<=x;i++){
        if(x%primes[i]) continue;
        ll e=0;
        while(x%primes[i]==0) x/=primes[i],e++;
        for(ll j=1,pw=primes[i];j<=e;j++,pw*=primes[i]){
            for(ll k=0;k<cntd;k++){
                divs[j*cntd+k]=divs[k]*pw;
            }
        }
        cntd*=e+1;
    }
    if(x>1){
        for(ll k=0;k<cntd;k++) divs[cntd+k]=divs[k]*x;
        cntd*=2;
    }
    if(extra>=NMAX2){
        for(ll k=0;k<cntd;k++) divs[cntd+k]=divs[k]*extra;
        cntd*=2;
    }
    for(ll i=0;i<cntd;i++)
        groups[divs[i]].push_back(pos);

}
vector<ll> tc(ll n, ll k, ll x, vector<ll> v, ll id){
    groups.clear();
    tosort.clear();
    for(ll i=0;i<n;i++){
        Hash[i]=0;
        a[i]=v[i];
        add_to_groups(i,(i==id?x:1));
        if(i==id) a[i]*=x;
    }
    for(auto it : groups){
        if(it.second.size()>=k){
            ll h=rndnext(0,LLONG_MAX);
            for(auto it2 : it.second)
                Hash[it2]^=h;
        }
    }
    for(ll i=0;i<n;i++){
        tosort[Hash[i]].push_back(i);
        //cerr<<Hash[i]<<' ';
    }
    for(auto it : tosort){
        vector<ll> sorted;
        for(auto it2 : it.second) sorted.push_back(a[it2]);
        sort(sorted.begin(),sorted.end());
        for(ll i=0;i<sorted.size();i++) v[it.second[i]]=sorted[i];
    }
    return v;
}
vector<ll> brute(ll n, ll k, ll x, vector<ll> v){
    vector<ll> p=v;
    sort(p.begin(),p.end());
    do{
        bool ok=1;
        for(ll msk=0;msk<(1<<n);msk++){
            if(__builtin_popcount(msk)!=k) continue;
            ll gcd1=-1,gcd2=-1;
            for(ll i=0;i<n;i++){
                if(msk>>i&1){
                    if(gcd1==-1) gcd1=p[i];
                    else gcd1=__gcd(gcd1,p[i]);

                    if(gcd2==-1) gcd2=v[i];
                    else gcd2=__gcd(gcd2,v[i]);
                }
            }
            if(gcd1!=gcd2){
                ok=0;
                break;
            }
        }
        if(ok) return p;
    }while(next_permutation(p.begin(),p.end()));
}
int main()
{
    ll startTime=getTime();
    for(ll i=2;i<NMAX2;i++){
        if(!sieve[i]) primes[cntp++]=i;
        for(ll j=i*i;j<NMAX2;j+=i){
            sieve[j]=1;
        }
    }
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    //freopen("in.txt","r",stdin);
    //freopen("out.txt","w",stdout);
    ll t; cin>>t; while(t--){
        ll n,k,x;
        vector<ll> v;
        #ifdef DEBUG
        n=5,k=rndnext(2,5),x=1;
        v.resize(n);
        for(ll i=0;i<n;i++) v[i]=rndnext(1,1e9);
        vector<ll> ans1=tc(n,k,x,v);
        vector<ll> ans2=brute(n,k,x,v);
        for(ll i=0;i<n;i++){
            cout<<ans2[i]<<" \n"[i==n-1];
        }
        for(ll i=0;i<n;i++){
            if(ans2[i]!=ans1[i]){
                cout<<flush;
                cerr<<"Found countertest:\n";
                cerr<<n<<' '<<k<<' '<<x<<'\n';
                for(auto it : v) cerr<<it<<' ';
                exit(0);
            }
        }
        #else
        cin>>n>>k>>x;
        v.resize(n);
        for(ll i=0;i<n;i++) cin>>v[i];
        vector<ll> ans1=tc(n,k,x,v,-1);
        if(x>1) for(ll i=0;i<n;i++){
            ans1=min(ans1,tc(n,k,x,v,i));
            if(getTime()-startTime>TL) break;
        }
        for(auto it : ans1) cout<<it<<' ';
        cout<<'\n';
        #endif
    }
    return 0;
}

