#pragma once
#include <bits/stdc++.h>
#include <vector>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;

const int NMAX = 200001;

int stare[NMAX];
vector <int> unde[NMAX];
int pz[NMAX];
int n;
vector <int> v;

bool cmp(int a, int b){
    return v[a] > v[b];
}

int f[NMAX];

void bagaMex(){
    for(int i = 0; i < n; i++){
        pz[i] = i;
    }
    sort(pz, pz + n, cmp);
    for(int i = 0; i < n; i++){
        int x = pz[i];
        if(!unde[x].size()) continue;
        int mx = 1;
        for(auto y : unde[x]){
            f[x] += (stare[y]);
            if(stare[y] == 1)
                mx = 0;
        }
        stare[x] = !(f[x] > 0);
    }
}
int d;
void init(std::vector<int> A, int D){
    n = A.size();
    v = A;
d = D;
    for(int i = 0; i < n; i++){
        pz[i] = i;
        unde[i].clear();
        int maxim = -1;
        for(int j = max(0, i - D); j < min(n, i + D + 1); j++){
           if(A[j] > A[i]){
              unde[i].push_back(j);
           }
        }
        if(unde[i].size() == 0){
            stare[i] = 1;
            continue;
        }
    }
    bagaMex();
}

int ignor[NMAX];

void changeBun(int i);

void changeState(int i) {
    stare[i] = 1;
    for(int j = max(0, i - d); j < min(n, i + d + 1); j++) {
        if(v[j] < v[i] && !ignor[i]) {
            f[j]++;
            if(f[j] == 1)
                changeBun(j);
        }
    }
}

void changeBun(int i) {
    stare[i] = 0;
    for(int j = max(0, i - d); j < min(n, i + d + 1); j++) {
        if(v[j] < v[i] && !ignor[i]) {
            f[j]--;
            if(f[j] == 0)
                changeState(j);
        }
    }
}

void updateValue(int index, int newValue) {
    int i = index;
    ignor[index] = 1;
    if(stare[index] == 1) {
        stare[index] = 0;
        for(int j = max(0, i - d); j < min(n, i + d + 1); j++) {
            if(v[j] < v[i]) { ///  && v[j] > newValue
                f[j]--;
                if(f[j] == 0) {
                    changeState(j);
                }
            }
        }
    }
    /// Imi recalculez stare
    v[index] = newValue;
    f[i] = 0;
    for(int j = max(0, i - d); j < min(n, i + d + 1); j++) {
        if(v[j] > v[i]) {
            if(stare[j]) {
                f[i]++;
            }
        }
    }
    /// Daca e cazul...modific
    if(f[i] > 0) {
        changeBun(i);
    }    ignor[index] = 0;

}
bool isWinning(int startIndex) {
    return (stare[startIndex] == 0);
}

