#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 5e5;
const int MAX_M = 5e5;

bool vis[MAX_N + 1];
int k[MAX_N + 1], ind[MAX_N + 1], p[MAX_M];
vector<int> adj[MAX_N + 1];
vector<int> prefix, cycle;
set<int> posCyc[MAX_N + 1], posPref[MAX_N + 1];

int main() {
    cin.tie( NULL );
    ios_base::sync_with_stdio( false );
    
    int n, m;
    
    cin >> n >> m;
    for ( int u = 1; u <= n; u++ ) {
        cin >> k[u];
        ind[u] = 0;
        for ( int i = 0; i < k[u]; i++ ) {
            int v;
            cin >> v;
            adj[u].push_back( v );
        }
    }
    for ( int i = 0; i < m; i++ )
        cin >> p[i];
    
    for ( int u = 1; u <= n; u++ )
    vis[u] = false;
    int u = 1, cnt = 0;
    while ( (cnt < n || u != 1) ) {
		prefix.push_back( u );
		if ( !vis[u] )
			cnt++;
		vis[u] = true;
		
        int v = adj[u][ind[u]];
        ind[u] = (ind[u] + 1) % k[u];
        u = v;
    }
    
    
    for ( int u = 1; u <= n; u++ )
    vis[u] = false;
    u = 1, cnt = 0;
    vector<int> cycle;
    while ( (cnt < n || u != 1) ) {
		cycle.push_back( u );
		if ( !vis[u] )
			cnt++;
		vis[u] = true;
		

        int v = adj[u][ind[u]];
        ind[u] = (ind[u] + 1) % k[u];
        u = v;
    }
    
    for ( int i = 0; i < (int)prefix.size(); i++ ) 
		posPref[prefix[i]].insert( i );
    for ( int i = 0; i < (int)cycle.size(); i++ ) 
		posCyc[cycle[i]].insert( i );
    
    long long t = 0;
    int pos = 0;
    bool inPref = true;
    for ( int i = 0; i < m; i++ ) {
		if ( inPref ) {
			auto ptr = posPref[p[i]].upper_bound( pos );
			if ( ptr != posPref[p[i]].end() ) {
				t += *ptr - pos;
				pos = *ptr;
			} else {
				inPref = false;
				t += (int)prefix.size() - pos + *posCyc[p[i]].begin();
				pos = *posCyc[p[i]].begin();
			}
		} else {
			
			auto ptr = posCyc[p[i]].upper_bound( pos );
			if ( ptr != posCyc[p[i]].end() ) {
				t += *ptr - pos;
				pos = *ptr;
			} else {
				t += cycle.size() - pos + *posCyc[p[i]].begin();
				pos = *posCyc[p[i]].begin();
			}
		}
	}
    
    cout << t + 1 << "\n";
    
    return 0;
}
