#include "game.h"
#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2e5;
int n, d, maxReach[MAX_N];
vector<int> a;
void init( vector<int> A, int D ) {
	n = A.size();
	a = A;
	d = D;
}

void updateValue( int index, int newValue ) {
	a[index] = newValue;
}

bool solve( int l, int r, int p ) {
	if ( l == r )
		return false;
		
	int maxx = 0, pos = -1;
	for ( int i = l; i <= r; i++ ) {
		if ( a[i] > maxx ) {
			maxx = a[i];
			pos = i;
		}
	}
	
	if ( p == pos )
		return false;
	if ( pos - d <= p && p <= pos + d ) 
		return true;
	if ( p < pos )
		return solve( l, pos - d - 1, p );
	return solve( pos + d + 1, r, p );
} 

bool isWinning( int startIndex ) {
	for ( int i = 0; i < n; i++ )
		maxReach[i] = 0;
	for ( int i = n - 1; i >= 0; i-- ) {
		for ( int j = i; j < n && j <= i + d; j++ ) {
			if ( maxReach[j] <= a[j] )
				maxReach[i] = max( maxReach[i], a[j] );
		}
	}
	for ( int i = 0; i < n; i++ ) {
		for ( int j = i; j >= 0 && j >= i - d; j-- ) {
			if ( maxReach[j] <= a[j] )
				maxReach[i] = max( maxReach[i], a[j] );
		}
	}
	if ( maxReach[startIndex] == a[startIndex] )
		return false;
	return true;
}
