#include <fstream>
#include <vector>
#include <algorithm>
#include <queue>
#include <cstring>
using namespace std;

#define cin fin
#define cout fout

ifstream fin("test.in");
ofstream fout("test.out");

const int nmax = 500000;
int n,k;

vector<int> v[nmax + 5];
vector<int> friends;


int qsz;
int viz[nmax + 5];
int stk[nmax * 3 + 5];
int sol;
int stsz;


void dfs_brute(int nod)
{
    cout<<nod<<' ';
    sol++;
    if(nod==friends.back())
        friends.pop_back();
    if(friends.empty())
        return;
    viz[nod]++;
    dfs_brute(v[nod][(viz[nod]-1)%(v[nod].size())]);
}

/**
7 7
3 4 2 5
2 3 1
1 2
1 1
3 1 6 7
1 5
1 5
1 2 3 4 5 6 7


**/


int main()
{
    cin>>n>>k;
    for(int i=1; i<=n; i++)
    {
        int sz;
        cin>>sz;
        for(int j=1; j<=sz; j++)
        {
            int x;
            cin>>x;
            v[i].push_back(x);
        }
    }
    for(int i=1; i<=k; i++)
    {
        int x;
        cin>>x;
        friends.push_back(x);
    }
    reverse(friends.begin(),friends.end());
    if(!k)
    {
        cout<<0;
        return 0;
    }
    int nod=1;
    while(!friends.empty())
    {
        sol++;
        if(nod==friends.back()) friends.pop_back();
        viz[nod]++;
        nod = v[nod][(viz[nod]-1)%(v[nod].size())];
    }
    cout<<sol;




}
