#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int nmax = 1000;
int n,k,x;
int a[nmax + 5];
int b[nmax + 5];

bool good()
{
    int cmmdc = __gcd(a[1],b[1]);
    for(int i=2;i<=n;i++)
        if(__gcd(a[i],b[i])!=cmmdc)
            return false;
    return true;
}

void solve()
{
    cin>>n>>k>>x;
    for(int i=1;i<=n;i++)
        cin>>a[i],b[i] = a[i];
    sort(b+1,b+n+1);
    bool ok = true;
    for(int i=1;i<=n && ok;i++) if(a[i]!=b[i]) ok = false;
    if(ok)
        next_permutation(b+1,b+n+1),ok = false;
    while(!ok)
    {
        if(good()) ok = true;
        else next_permutation(b+1,b+n+1);
    }
    for(int i=1;i<=n;i++)
        cout<<b[i]<<' ';
    cout<<'\n';

}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    for(int i=1;i<=t;i++)
        solve();
}
