#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int nmax = 1000;
int n,k,x;
int a[nmax + 5];
int b[nmax + 5];
int v[nmax + 5];

void backt(int pas,int cmm1,int cmm2,bool& ok)
{
    if(pas==k + 1){
        if(cmm1 != cmm2)
            ok=false;
        return;
    }
    if(!ok)
        return;
    for(int i = v[pas-1]+1;i<=n;i++){
        if(cmm1 == 0) cmm1 = a[i],cmm2=b[i];
        v[pas]=i,backt(pas+1,__gcd(cmm1,a[i]),__gcd(cmm2,b[i]),ok);
    }
}

bool good()
{
    bool ok = true;
    backt(1,0,0,ok);
}

void solve()
{
    cin>>n>>k>>x;
    for(int i=1;i<=n;i++)
        cin>>a[i],b[i] = a[i];
    sort(b+1,b+n+1);
    bool ok = false;
    int k = 1;
    for(int i=2;i<=n;i++)
        k*=i;
    for(int i=1;i<=k && !ok;i++)
        if(good()) ok = true;
        else next_permutation(b+1,b+n+1);

    for(int i=1;i<=n;i++)
        cout<<b[i]<<' ';
    cout<<'\n';

}



int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    for(int i=1;i<=t;i++)
        solve();
}
