#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int nmax = 1000;
int n,k,x;
int a[nmax + 5];
int b[nmax + 5];
int v[nmax + 5];
bool ok;

int cmmdc(int a,int b)
{
    if(a==0) return b;
    if(b==0) return a;
    while(b!=0)
    {
        int r = a%b;
        a=b;
        b=r;
    }
    return a;
}

void backt(int pas,int cmm1,int cmm2)
{
    if(pas==k + 1){
        if(cmm1 != cmm2)
            ok=false;
        return;
    }
    for(int i = v[pas-1]+1;i<=n && ok ;i++){
        v[pas]=i,backt(pas+1,cmmdc(cmm1,a[i]),cmmdc(cmm2,b[i]));
    }
}

bool good()
{
    ok = true;
    backt(1,0,0);
    return ok;
}

void solve()
{
    cin>>n>>k>>x;
    for(int i=1;i<=n;i++)
        cin>>a[i],b[i] = a[i];
    sort(b+1,b+n+1);
    while(!good())
        next_permutation(b+1,b+n+1);


    for(int i=1;i<=n;i++)
        cout<<b[i]<<' ';
    cout<<'\n';

}



int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin>>t;
    for(int i=1;i<=t;i++)
        solve();
}
