#include <iostream>
#include <iomanip>
#include <algorithm>

using namespace std;

int t, n, k, x, i, a[100010], apoz[100010], b[100010], d, ans;
bool viz[100010];

bool aPozCmp(int x, int y)
{
    return a[x] < a[y];
}

int getAns(int i)
{
    int d;
    for (d = 1; d*d <= a[i]; d++) {
        if (a[i] % d == 0) {
            int nr = a[i] / d;
            int cnt = 0;
            for (int j = 1; j <= n; j++) {
                cnt += (a[j] % nr == 0);
            }
            if (cnt >= k) return nr;
        }
    }
    for (d--; d > 1; d--) {
        if (a[i] % d == 0) {
            int cnt = 0;
            for (int j = 1; j <= n; j++) {
                cnt += (a[j] % d == 0);
            }
            if (cnt >= k) return d;
        }
    }
    return 1;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> t;
    while (t--) {
        cin >> n >> k >> x;
        for (int i = 1; i <= n; i++) {
            cin >> a[i];
            viz[i] = false;
            apoz[i] = i;
        }
        sort(apoz+1, apoz+n+1, aPozCmp);
        for (int i = 1; i <= n; i++) {
            for (int j = n; j >= 1; j--) {
                int poz = apoz[j];
                if (viz[poz]) continue;
                ans = poz;
                int cnt = 0;
                for (int k = 1; k <= n; k++) {
                    cnt += (a[k] % a[poz] == 0);
                }
                if (cnt >= k) {
                    break;
                }
            }
            viz[ans] = true;
            cout << a[ans] << ' ';
        }
        cout << '\n';
    }
    return 0;
}
