#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
const int M=5e4,NMAX=1e5;
int n,k,x;
int p[NMAX+5],ptso[NMAX+5],ap[NMAX+5],cal[NMAX+5],ptr[NMAX+5],clas[NMAX+5],a[NMAX+5],ss[NMAX+5];
vector <int> v,vvs[NMAX+5];
map <int,int> ma,ma2;
void ciur()
{
    p[0]=p[1]=1;
    int n=M;
    for (int i=2;i<=n;++i)
    {
        if (p[i]==0) {v.push_back(i);
        for (int j=2*i;j<=n;j+=i)
            p[j]=1;
        }
    }
}
void add(int a)
{
    if (a<=M)
    {
        ap[a]++;
    }
    else
    {
        ma[a]++;
    }
}
void decomp(int a)
{
    for (int i=0;i<v.size()&&a!=1;++i)
    {
        if (a%v[i]==0) {
            int pp=1;
            while (a%v[i]==0) {pp*=v[i]; add(pp); a/=v[i];}
        }
    }
    if (a!=1) {add(a);}
}
int check(int p)
{
    if (p<=M)
    {
        return ap[p]>=k;
    }
    return ma[p]>=k;
}
int calclass(int a)
{
    int cl=1;
    for (int i=0;i<v.size()&&a!=1;++i)
    {
        if (a%v[i]==0) {
            int pp=1;
            while (a%v[i]==0) {pp*=v[i]; if (check(pp)) cl*=v[i]; a/=v[i];}
        }
    }
    if (a!=1) {if (check(a)) cl*=a;}
    return cl;
}
bool cmt(int a1,int b1)
{
    return (a[a1]<a[b1]);
}
void solve()
{
    cin>>n>>k>>x;
    for (int i=1;i<=n;++i)
    {
        cin>>a[i];
        decomp(a[i]);
    }
    for (int i=1;i<=n;++i)
    {
        clas[i]=calclass(a[i]);
        ss[i]=clas[i];
    }
    sort(ss+1,ss+n+1);
    int cnt=0;
    ss[0]=-1;
    for (int i=1;i<=n;++i)
    {
        if (ss[i]!=ss[i-1]) cnt++;
        ma2[ss[i]]=cnt;
    }
    for (int i=1;i<=n;++i)
    {
        cal[i]=ma2[clas[i]];
    }
    for (int i=1;i<=n;++i)
    {
        vvs[cal[i]].push_back(i);
    }
    int ceva=0;
    for (int i=1;i<=cnt;++i)
    {
        for (int j=0;j<vvs[i].size();++j)
        {
            ptso[ceva]=vvs[i][j];
            ceva++;
        }
        sort(ptso,ptso+ceva,cmt);
        for (int j=0;j<vvs[i].size();++j)
        {
            vvs[i][j]=ptso[j];
        }
    }
    if (x==1)
    {
        for (int i=1;i<=n;++i)
        {
            cout<<a[vvs[cal[i]][ptr[cal[i]]]]<<" ";
            ptr[cal[i]]++;
        }
    }
    for (int i=1;i<=n;++i)
    {cal[i]=ptr[i]=clas[i]=a[i]=ss[i]=0;
    }
    for (int i=1;i<=cnt;++i)
    {
        vvs[i].clear();
    }
    ma.clear();
    ma2.clear();
    for (int i=0;i<v.size();++i)
    {
        if (ap[v[i]])
        {
            long long pp=1LL*v[i]*v[i];
            ap[v[i]]=0;
            while (pp<=M&&pp>0) {if (ap[pp]==0) break; ap[pp]=0; pp=pp*v[i];}
        }
    }


}
int main()
{
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
    ciur();
    int t;
    cin>>t;
    while (t)
    {
        t--;
        solve();
    }
    return 0;
}
