#include <bits/stdc++.h>
#include "game.h"

using namespace std;

#define MAX_N 2000000

const int INF = 2e9;

int n, dist;
//bitset <MAX_N + 5> ;
vector <int> lg, isInInterval, elem;
vector <pair <int, int> > intervals;
vector <vector <int> > sp;

void precalculate()
{
    lg.resize(n + 1);
    for(int i = 2; i <= n; i ++)
        lg[i] = lg[i / 2] + 1;
}

void rmq(vector <int> &v)
{
    int L = log2(n);
    sp.clear();
    sp.resize(L + 1, vector <int> (n + 1));

    for(int i = 0; i < n; i ++)
    {
        sp[0][i] = v[i];
    }

    for(int i = 1; i <= L; i ++)
    {
//        cout << i << "\n";
        for(int j = 0; j <= n - (1 << i); j ++) // j <= ? +-1
        {
            sp[i][j] = max(sp[i - 1][j], sp[i - 1][j + (1 << (i - 1))]);
//            cout << j << " " << sp[i][j] << "\n";
        }
//        cout << "\n";
    }
}

int query(int l, int r)
{
    int len = r - l + 1;
    int idk = lg[len];
    return max(sp[idk][l], sp[idk][r - (1 << idk) + 1]);
}


void init(std::vector<int> A, int D)
{
    dist = D;
//    for(auto x : A)
//        cout << x << " ";
    n = A.size();
    precalculate();
    rmq(A);
//    cerr << query(0, 5) << "\n";
//    cerr << query(1, 3) << "\n";
    isInInterval.resize(n + 1);
    int last = 0;
    bool changes = 1;
    while(changes)
    {
        int i = 0;
//        cout <<  << " a\n";
        changes = 0;
        while(i < n)
        {
            if(!isInInterval[i])
            {
                int st = i, dr = i;
                while(i - st + 1 <= D &&  st - 1>= 0  &&  !isInInterval[st - 1])
                    st --;
                while(dr + 1 - i <= D  &&  dr + 1 <= n - 1  &&  !isInInterval[dr + 1])
                    dr ++;
//                cout << st << " " << dr << " if\n";

                if(st != dr  &&  query(st, dr) == A[i])
                {
//                    cout << i << " i\n";
                    intervals.push_back({st, dr});
                    changes = 1;
                    i = dr;
                }
            }
            i ++;
        }

//        for(int k = last; k < intervals.size(); k ++)
//        {
//            for(int i = intervals[k].first; i <= intervals[k].second; i ++)
//                isInInterval[i] = k;
//        }
    }
    elem = A;
    A.clear();

//    for(auto x : intervals)
//        cout << x.first << " " << x.second << "\n";

}

void updateValue(int index, int newValue)
{
    elem[index] = newValue;
    rmq(elem);
//    cerr << query(0, 5) << "\n";
//    cerr << query(1, 3) << "\n";
    isInInterval.clear();
    intervals.clear();
    isInInterval.resize(n + 1);
    int last = 0;
    bool changes = 1;
    while(changes)
    {
        int i = 0;
//        cout <<  << " a\n";
        changes = 0;
        while(i < n)
        {
            if(!isInInterval[i])
            {
                int st = i, dr = i;
                while(i - st + 1 <= dist &&  st - 1>= 0  &&  !isInInterval[st - 1])
                    st --;
                while(dr + 1 - i <= dist  &&  dr + 1 <= n - 1  &&  !isInInterval[dr + 1])
                    dr ++;
//                cout << st << " " << dr << " if\n";

                if(st != dr  &&  query(st, dr) == elem[i])
                {
//                    cout << i << " i\n";
                    intervals.push_back({st, dr});
                    changes = 1;
                    i = dr;
                }
            }
            i ++;
        }

//        for(int k = last; k < intervals.size(); k ++)
//        {
//            for(int i = intervals[k].first; i <= intervals[k].second; i ++)
//                isInInterval[i] = k;
//        }
    }
}

bool isWinning(int startIndex)
{
    if(!isInInterval[startIndex])
        return 0;
    int k = isInInterval[startIndex];
    return (k  &&  (query(intervals[k].first, intervals[k].second) != elem[startIndex]));
}
/*
6 2
1 7 4 9 8 2
2
2 0
2 1
*/
