#include <bits/stdc++.h>
#include "game.h"

using namespace std;

const int N_MAX = 200000;
const int Q_MAX = 200000;

int N, D;
int A[N_MAX];

int order[N_MAX];
bool wins[N_MAX];

void solve () {
    iota(order, order + N, 0);
    sort(order, order + N, [&] (const int &i, const int &j) {
        return A[i] > A[j];
    });
    wins[order[0]] = false;
    for (int k = 1; k < N; k++) {
        int i = order[k];
        wins[i] = false;
        for (int j = max(0, i - D); j <= min(N - 1, i + D); j++) {
            if (A[j] > A[i]) {
                wins[i] |= !wins[j];
            }
        }
    }
}

void init(vector <int> _A, int _D) {
    N = (int) _A.size(); D = _D;
    for (int i = 0; i < N; i++) {
        A[i] = _A[i];
    }
    solve();
}

void updateValue(int pos, int val) {
    A[pos] = val;
    solve();
}
bool isWinning (int pos) {
    return wins[pos];
}

