#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100000;

int N, K, X;
int A[N_MAX + 2];

vector <int> primes;

map <int, vector <int>> with_prime;

int ex[N_MAX + 2];
vector <pair <int, int>> code[N_MAX + 2];

int order[N_MAX + 2];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        cin >> N >> K >> X;
        for (int i = 1; i <= N; i++) {
            cin >> A[i];
            int x = A[i];
            int p = 2;
            while (x > 1) {
                if ((long long) p * p > x) {
                    p = x;
                }
                if (x % p == 0) {
                    primes.push_back(p);
                    with_prime[p].push_back(i);
                    do {
                        x /= p;
                    } while (x % p == 0);
                }
                p++;
            }
        }
        sort(primes.begin(), primes.end());
        primes.resize(unique(primes.begin(), primes.end()) - primes.begin());
        for (int p : primes) {
            vector <int> v = with_prime[p];
            int cnt[30];
            fill(cnt, cnt + 30, 0);
            for (int i : v) {
                int x = A[i];
                ex[i] = 0;
                do {
                    x /= p;
                    ex[i]++;
                } while (x % p == 0);
                cnt[ex[i]]++;
            }
            for (int e = 28; e >= 0; e--) {
                cnt[e] += cnt[e + 1];
            }
            int max_e = 28;
            while (max_e > 0 && cnt[max_e] < K) {
                max_e--;
            }
            if (max_e > 0) {
                for (int i : v) {
                    code[i].push_back({p, min(ex[i], max_e)});
                }
            }
        }
        iota(order + 1, order + N + 1, 1);
        sort(order + 1, order + N + 1, [&] (const int &i, const int &j) {
            return make_pair(code[i], i) < make_pair(code[j], j);
        });
        for (int l = 1; l <= N; l++) {
            int r = l;
            while (r < N && code[order[r + 1]] == code[order[l]]) {
                r++;
            }
            vector <int> a;
            for (int i = l; i <= r; i++) {
                a.push_back(A[order[i]]);
            }
            sort(a.begin(), a.end());
            for (int i = l; i <= r; i++) {
                A[order[i]] = a[i - l];
            }
            l = r;
        }
        for (int i = 1; i <= N; i++) {
            cout << A[i] << " ";
        }
        cout << "\n";
        for (int p : primes) {
            with_prime[p].clear();
        }
        primes.clear();
        for (int i = 1; i <= N; i++) {
            code[i].clear();
        }
    }

    return 0;
}
