#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int N_MAX = 100000;
const int P_MAX = 31700;

int N, K, X;
ll A[N_MAX + 2];

vector <int> primes;

map <int, vector <int>> with_prime;

int ex[N_MAX + 2];
vector <pair <int, int>> code[N_MAX + 2];

int order[N_MAX + 2];

bool is_prime[P_MAX + 2];
vector <int> small_primes;

vector <int> cand;

int perm[N_MAX + 2];
bool aux[N_MAX + 2];

vector <ll> solve (int k) {
    for (int i = 1; i <= N; i++) {
        int x = A[i];
        int p = 2;
        while (x > 1) {
            if ((ll) p * p > x) {
                p = x;
            }
            if (x % p == 0) {
                primes.push_back(p);
                with_prime[p].push_back(i);
                do {
                    x /= p;
                } while (x % p == 0);
            }
            p++;
        }
    }
    int x = X;
    int p = 2;
    while (x > 1) {
        if ((ll) p * p > x) {
            p = x;
        }
        if (x % p == 0) {
            primes.push_back(p);
            if (A[k] % p != 0) {
                with_prime[p].push_back(k);
            }
            do {
                x /= p;
            } while (x % p == 0);
        }
        p++;
    }
    A[k] *= X;
    sort(primes.begin(), primes.end());
    primes.resize(unique(primes.begin(), primes.end()) - primes.begin());
    for (int p : primes) {
        vector <int> v = with_prime[p];
        int max_e = 0;
        for (int i : v) {
            ll x = A[i];
            ex[i] = 0;
            do {
                x /= p;
                ex[i]++;
            } while (x % p == 0);
            max_e = max(max_e, ex[i]);
        }
        int cnt[max_e + 1];
        fill(cnt, cnt + max_e + 1, 0);
        for (int i : v) {
            cnt[ex[i]]++;
        }
        for (int e = max_e - 1; e >= 0; e--) {
            cnt[e] += cnt[e + 1];
        }
        while (max_e > 0 && cnt[max_e] < K) {
            max_e--;
        }
        if (max_e > 0 && cnt[max_e] < N) {
            for (int i : v) {
                ex[i] = min(ex[i], max_e);
                code[i].push_back({p, ex[i]});
            }
            if (k > 0) {
                continue;
            }
            int max_with[max_e + 1];
            fill(max_with, max_with + max_e + 1, 0);
            for (int i : v) {
                aux[i] = true;
                if (A[i] > A[max_with[ex[i]]]) {
                    max_with[ex[i]] = i;
                }
            }
            for (int e = 1; e < max_e; e++) {
                if (max_with[e] != 0) {
                    cand.push_back(max_with[e]);
                }
            }
            if (cnt[1] < N) {
                int u = 1;
                while (u <= N && aux[perm[u]] == true) {
                    u++;
                }
                if (u <= N) {
                    cand.push_back(perm[u]);
                }
            }
            for (int i : v) {
                aux[i] = false;
            }
        }
    }
    iota(order + 1, order + N + 1, 1);
    sort(order + 1, order + N + 1, [&] (const int &i, const int &j) {
        return make_pair(code[i], i) < make_pair(code[j], j);
    });
    vector <ll> answer(N);
    for (int l = 1; l <= N; l++) {
        int r = l;
        while (r < N && code[order[r + 1]] == code[order[l]]) {
            r++;
        }
        vector <ll> a;
        for (int i = l; i <= r; i++) {
            a.push_back(A[order[i]]);
        }
        sort(a.begin(), a.end());
        for (int i = l; i <= r; i++) {
            answer[order[i] - 1] = a[i - l];
        }
        l = r;
    }
    for (int p : primes) {
        with_prime[p].clear();
    }
    primes.clear();
    for (int i = 1; i <= N; i++) {
        code[i].clear();
    }
    A[k] /= X;
    return answer;
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
//    mt19937 rnd(0);

//    fill(is_prime + 2, is_prime + P_MAX + 1, true);
//    for (int p = 2; p * p <= P_MAX; p++) {
//        if (is_prime[p] == true) {
//            for (int q = p * p; q <= P_MAX; q += p) {
//                is_prime[q] = false;
//            }
//        }
//    }
//    for (int p = 2; p <= P_MAX; p++) {
//        if (is_prime[p] == true) {
//            small_primes.push_back(p);
//        }
//    }

    int t;
    cin >> t;
//    t = 100;
    while (t--) {
        cin >> N >> K >> X;
//        N = 1000; K = 10; X = 1;
        for (int i = 1; i <= N; i++) {
            cin >> A[i];
//            A[i] = rnd() % (int) 1e9 + 1;
        }
        iota(perm + 1, perm + N + 1, 1);
        sort(perm + 1, perm + N + 1, [&] (const int &i, const int &j) {
            return A[i] > A[j];
        });
        vector <ll> answer = solve(0);
        sort(cand.begin(), cand.end());
        cand.resize(unique(cand.begin(), cand.end()) - cand.begin());
        if (X > 1) {
            for (int i : cand) {
                answer = min(answer, solve(i));
            }
        }
        for (ll a : answer) {
            cout << a << " ";
        }
        cout << "\n";
        cand.clear();
    }

    return 0;
}
