#include <bits/stdc++.h>
#define all(x) (x).begin(),(x).end()

using namespace std;
using ll = long long;

// #define int ll 

#define sz(x) ((int)(x).size())
using pii = pair<int,int>;
using tii = tuple<int,int,int>;

const int vmax = 32e3 + 5;
const int nmax = 1e5 + 5;

bitset<vmax> ciur;
vector<int> prime;

vector<pii> desc[nmax];

void testcase() {
	int n, k, X;
	cin >> n >> k >> X;
	unordered_map<int,vector<int>> exps;
	unordered_map<int, int> market_cap;
	vector<int> v(n);
	for(int i = 0; i < n; i++) {
		desc[i].clear();
		int a;
		cin >> a;
		v[i] = a;
		for(auto d : prime) {
			if(d * d > a) break;
			if(a % d == 0) {
				int cnt = 0;
				while(a % d == 0) cnt++, a /= d;
				exps[d].emplace_back(cnt);
				desc[i].emplace_back(d, cnt);
			}
		}
		if(a > 1) {
			exps[a].emplace_back(1);
			desc[i].emplace_back(a, 1);
		}
	}
	
	for(auto [a, v] : exps) {
		if(sz(v) < k) market_cap[a] = 0;
		else {
			sort(all(v));
			market_cap[a] = rbegin(v)[k - 1];
		}
	}
	
	vector<int> atribute(n);
	unordered_map<int, vector<int>> tval;
	for(int i = 0; i < n; i++) {
		int act = 1;
		for(auto [d, cnt] : desc[i]) {
			cnt = min(cnt, market_cap[d]);
			while(cnt) act *= d, cnt--;
		
		}
		
		atribute[i] = act;
		tval[act].emplace_back(v[i]);
	}
	for(auto &[a, b] : tval) sort(all(b), greater<int>());
	for(auto x : atribute) {
		cout << tval[x].back() << ' ';
		tval[x].pop_back();
	}
	cout << '\n';
}

signed main() {
	for(int i = 2; i < vmax; i++) {
		if(ciur[i] == 0) {
			prime.emplace_back(i);
			for(int j = i * i; j < vmax; j += i) ciur[j] = 0;
		}
	}
	int T;
	cin >> T;
	while(T--) testcase();
}
