#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;

//#define int __int128
//#define int long long
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector

#define sz(x) (int)(x).size()

using namespace std;

const int NMAX = 1e3;

vt <int> adj[NMAX + 1];
int wher[NMAX + 1];

vt <int> pos[NMAX + 1];

int dist(int i, int j, int LIM){
    if(i < j){
        return j - i;
    }
    return LIM - i + j;
}

int main(){

    int n, q;
    cin >> n >> q;

    for(int i = 1; i <= n; i++){
        int k;
        cin >> k;

        for(int j = 1; j <= k; j++){
            int x;
            cin >> x;
            adj[i].pb(x);
        }
    }

    vt <int> cyc;
    int node = 1;
    int LIM = n * n; // ?
    for(int tc = 1; tc <= LIM; tc++){
        cyc.pb(node);
        pos[node].pb(tc);

        //cout << ">> " << node << endl;

        int old_node = node;
        node = adj[node][wher[node]];
        wher[old_node] = (wher[old_node] + 1) % sz(adj[old_node]);
    }

    int ind = 1;

    ll ans = 0; // ?
    while(q--){
        int x;
        cin >> x;

        int st = 0, dr = sz(pos[x]) - 1;
        int new_pos = -1;
        while(st <= dr){
            int mid = (st + dr) / 2;
            if(pos[x][mid] > ind){
                new_pos = pos[x][mid];
                dr = mid - 1;
            }else{
                st = mid + 1;
            }
        }

        if(new_pos == -1){
            new_pos = pos[x][0];
        }

        ans += dist(ind, new_pos, LIM);
        ind = new_pos;

        //cout << "-- " << ans << ' ' << ind << endl;
    }

    cout << ans + 1 << '\n';

    return 0;
}
