#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using ll = long long;

//#define int __int128
//#define int long long
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector

#define sz(x) (int)(x).size()

using namespace std;

const int NMAX = 1e6 + 1; /// ????

const int B = 31;
const int MOD = 1e9 + 9;

int pw[NMAX + 1];

vt <int> adj[NMAX + 1];
int wher[NMAX + 1];

unordered_map <int, int> fap;

int cyc[NMAX + 1]; /// ????

bool viz[NMAX + 1];

vt <int> pos[NMAX + 1];

int frap[NMAX + 1];

int dist(int i, int j, int LIM, int start_cyc){
    if(j > i){
        return j - i;
    }

    if(j < start_cyc){
        exit(68);
    }

    return LIM - i + j - start_cyc + 1;
}

int main(){

    int n, q;
    cin >> n >> q;

    pw[0] = 1;
    for(int i = 1; i <= n + 1; i++){
        pw[i] = (1ll * pw[i - 1] * B) % MOD;
    }

    int h = 0;
    for(int i = 1; i <= n; i++){
        int k;
        cin >> k;

        for(int j = 1; j <= k; j++){
            int x;
            cin >> x;
            adj[i].pb(x);
        }

        wher[i] = 0;
        h = (1ll * h + (1ll * wher[i] * pw[i]) % MOD) % MOD;
    }

    int node = 1, tc = 1, start_cyc = 1, cnt = 0;
    while(1){
        if(viz[node] == 0){
            cnt++;
        }
        viz[node] = 1;

        cyc[tc] = node;

        h = (h + MOD - ((1ll * wher[node] * pw[node]) % MOD)) % MOD;
        int new_wher = (wher[node] + 1) % sz(adj[node]);
        h = (1ll * h + ((1ll * new_wher * pw[node]) % MOD)) % MOD;

        int H = (1ll * h + ((1ll * pw[n + 1] * node) % MOD)) % MOD;

        if(cnt == n && fap.find(H) != fap.end()){
            start_cyc = fap[H];
            tc--;
            break;
        }else{
            fap[H] = tc;
        }

        int old_node = node;
        node = adj[node][wher[node]];
        wher[old_node] = new_wher;

        tc++;
    }

    for(int i = 1; i <= tc; i++){
        pos[cyc[i]].pb(i);

        if(i >= start_cyc){
            if(frap[cyc[i]] == 0){
                frap[cyc[i]] = i;
            }
        }
    }

    /// do all nodes have frap ???

    int ind = 1;
    ll ans = 1;

    bool first_time = 0;
    while(q--){
        int x;
        cin >> x;

        if(x == 1 && first_time == 0){
            first_time = 1;
            continue;
        }
        first_time = 1;

        int st = 0, dr = sz(pos[x]) - 1, new_pos = -1;
        while(st <= dr){
            int mid = (st + dr) / 2;
            if(pos[x][mid] > ind){
                dr = mid - 1;
                new_pos = pos[x][mid];
            }else{
                st = mid + 1;
            }
        }

        if(new_pos == -1){
            new_pos = frap[x];
        }

        ans += dist(ind, new_pos, tc, start_cyc);
        ind = new_pos;

        //cout << ">> " << node << ' ' << ind << endl;
    }

    cout << ans << '\n';

    return 0;
}

/*
4 4
2 2 3
1 1
2 1 4
1 3


4 4
2 2 3
1 1
2 1 4
1 3
2 1 1 4


4 8
2 2 3
1 1
2 1 4
1 3
1 1 1 1 1 1 1 1
*/
