#include "game.h"
#include <algorithm>
#include <iostream>

//#define int __int128
//#define int long long
#define pii pair <int, int>
#define all(a) (a).begin(), (a).end()
#define fr first
#define sc second
#define pb push_back
#define lb lower_bound
#define ub upper_bound
#define vt vector
#define sz(x) (x).size()

using namespace std;

const int NMAX = 2e5;

vt <int> adj[NMAX + 1];
bool dp[NMAX + 1];

bool viz[NMAX + 1];
vt <int> topo;
void dfs(int node){
    viz[node] = 1;
    for(int vec : adj[node]){
        if(!viz[node]){
            dfs(vec);
        }
    }
    topo.pb(node);
}

void init(vector<int> A, int D){
    int n = sz(A);
    for(int i = 0; i < n; i++){
        for(int j = max(0, i - D); j <= min(n - 1, i + D); j++){
            if(A[i] < A[j]){
                adj[i].pb(j);
            }
        }
    }
    for(int i = 0; i < n; i++){
        if(!viz[i]){
            dfs(i);
        }
    }

    reverse(all(topo));

    for(int i = n - 1; i >= 0; i--){
        if(sz(adj[i]) == 0){
            dp[i] = 0;
        }else{
            bool andd = 1;
            for(int vec : adj[i]){
                andd &= dp[vec];
            }
            if(andd){
                dp[i] = 0;
            }else{
                dp[i] = 1;
            }
        }
    }
}

void updateValue(int index, int newValue){
    // cine?
}

bool isWinning(int startIndex){
    return dp[startIndex];
}

/*
6 2
1 7 4 9 8 2
2
2 0
2 1

*/
