#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()

using ll = long long;
#define int ll

#define pii pair<int, int>
#define fr first
#define sc second

const int NMAX = 1e5, VALMAX = 1e9, SQMAX = (int)sqrt(1e9);

pii a[NMAX + 5];
int sieve[NMAX + 5];
int ans[NMAX + 5];
vector<pii> divz[NMAX + 5];
vector<int> prime;

map<int, vector<pii>> umap;
map<int, vector<pii>> mp2;

void ciur()
{
    for(int i = 2; i <= SQMAX; i ++)
    {
        if(sieve[i] == 0)
        {
            prime.push_back(i);
            for(int j = i * i; j <= SQMAX; j += i)
                sieve[j] = 1;
        }
    }
}


int n, k, x;

vector<int> solve()
{

    for(int i = 0; i < n; i ++)
        for(auto j : divz[i])
            umap[j.fr].push_back({j.sc, i});

    for(auto vec : umap)
    {
        sort(all(vec.sc), greater<pii>());
        int exp = 0, nr = 0;
        for(auto i : vec.sc)
        {
            nr ++;
            exp = i.fr;
            if(nr >= k) //la valoarea asta ii aducem
                break;
        }
        if(nr < k)
            exp = 0;
        //cout << vec.fr << " " << nr << " " << exp << '\n';
        for(auto i : vec.sc)
        {
            while(i.fr > exp)
            {
                i.fr --;
                a[i.sc].sc /= vec.fr;
            }
        }
    }

    for(int i = 0; i < n; i ++)
    {
        mp2[a[i].sc].push_back({i, a[i].fr});
//        for(auto j : divz[i])
//            cout << j.fr << " " << j.sc << '\n';
//        cout << a[i].sc << '\n';
    }
    //cout << '\n';

    for(auto vec : mp2)
    {
        auto v = vec.sc;
        vector<int> v1, v2;

        for(auto i : v)
            v1.push_back(i.fr);
        for(auto i : v)
            v2.push_back(i.sc);

        sort(all(v1));
        sort(all(v2));

        for(int i = 0; i < v1.size(); i ++)
            ans[v1[i]] = v2[i];
    }

    vector<int> ret;

    for(int i = 0; i < n; i ++)
        ret.push_back(ans[i]);

    umap.clear();
    mp2.clear();
    //de facut RESETARE

    for(int i = 0; i < n; i ++)
        a[i].sc = a[i].fr;

    return ret;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ciur();
    int t;
    cin >> t;
    while(t --)
    {
        cin >> n >> k >> x;

        for(int i = 0; i < n; i ++)
        {
            divz[i].clear();
            cin >> a[i].fr;
            a[i].sc = a[i].fr;
            int ca = a[i].fr;
            for(auto j : prime)
                while(ca % j == 0)
                {
                    if(divz[i].empty() || divz[i].back().fr != j)
                        divz[i].push_back({j, 0});
                    divz[i].back().sc ++;
                    ca /= j;
                }
            if(ca > 1)
                divz[i].push_back({ca, 1});

        }


        vector<int> best;
        best.resize(n, 1e18 + 5);
        if(x != 1)
        {
            int ok = 0;
            for(int i = 0; i < n; i ++)
            {
                vector<int> incerc;
                if(a[i].fr % x != 0)
                {
                    a[i].fr *= x;
                    a[i].sc *= x;
                    divz[i].push_back({x, 1});

                    incerc = solve();

                    a[i].fr /= x;
                    a[i].sc /= x;
                    divz[i].pop_back();
                }
                else
                {
                    a[i].fr *= x;
                    a[i].sc *= x;
                    //divz[i].push_back({x, 1});
                    for(int j = 0; j < divz[i].size(); j ++)
                        if(divz[i][j].fr == x)
                            divz[i][j].sc ++;


                    incerc = solve();

                    a[i].fr /= x;
                    a[i].sc /= x;

                    for(int j = 0; j < divz[i].size(); j ++)
                        if(divz[i][j].fr == x)
                            divz[i][j].sc --;
                    //divz[i].pop_back();
                }

                int ok = 0;
                for(int i = 0; i < n; i ++)
                {
                    if(incerc[i] == best[i])
                        continue;
                    if(incerc[i] < best[i])
                        ok = 1;
                    break;
                }

                if(ok)
                    swap(best, incerc);

            }
        }
        else
            best = solve();

        for(auto i : best)
            cout << i << " ";
        cout << '\n';

    }
}
