#include <bits/stdc++.h>

using namespace std;

using vi = vector<int>;
using ll = long long;

#define int ll

struct tree {
    int n;

    vi euler;
    vi blc;

    vector<deque<int> > L;
    vector<vi> ord;

    tree(int N, vector<vi> ord0) : n(N), L(N), ord(ord0) {}

    void init() {
        for(int i = 0; i < n; ++i) {
            for(auto it : ord[i])
                L[i].push_back(it);
        }
    }

    int u = 0;
    int re = 0;

    void get_urm(int val) {
        while(u != val) {
            int v = L[u].front();
            L[u].pop_front();
            L[u].push_back(v);
            u = v;
            ++re;
        }
        int v = L[u].front();
        L[u].pop_front();
        L[u].push_back(v);
        u = v;
        ++re;
    }

    int get_re() {
        return re;
        ///sper ca e suficient
    }
};

signed main() {
    int n, m;
    cin >> n >> m;
    vector<vi> ord(n);
    for(int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        for(int j = 0; j < k; ++j) {
            int v;
            cin >> v;
            --v;
            ord[i].push_back(v);
        }
    }
    tree T(n, ord);
    T.init();
    vi P(m);
    for(int i = 0; i < m; ++i) {
        cin >> P[i];
        --P[i];
    }

    int v = 0;
    for(auto it : P) {
        T.get_urm(it);
    }
    cout << T.get_re() << "\n";
    return 0;
}
