#include <bits/stdc++.h>
#include "game.h"

using namespace std;

using vi = vector<int>;
using ii = pair<int, int>;

vi A;
int n, D;

struct Skip {
    int n;

    vi V, S;

    Skip() {}
    Skip(int N, vi V0) : n(N), V(V0), S(N, N) {}

    void update(int p, int v) {
        V[p] = v;
    }

    void recalc(int p) {
        S[p] = p + D + 1;
        for(int i = p + 1; i <= min(n - 1, p + D); ++i) {
            if(V[i] > V[p]) {
                S[p] = i;
                break;
            }
        }
    }

    bool win(int p) {
        int u = 0;
        while(u < p) {
            u = S[u];
        }
        if(u == p) return 0;
        return 1;
    }
} L, R;

void init(vi A0, int D0) {
    A = A0;
    D = D0;
    n = A.size();

    L = Skip(n, A);
    reverse(A0.begin(), A0.end());
    R = Skip(n, A0);

    for(int i = 0; i < n; ++i) {
        L.recalc(i);
        R.recalc(i);
    }
}

void updateValue(int p, int v) {
    L.update(p, v);
    R.update(n - p - 1, v);
    for(int i = max(0, p - 2 * D); i < min(n, p + 2 * D + 1); ++i) {
        L.recalc(i);
        R.recalc(n - i - 1);
    }
}

bool isWinning(int p) {
    int v1 = L.win(p), v2 = R.win(n - p - 1);
    return L.win(p) || R.win(n - p - 1);
}
