#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 1e5;

vector<int> g[NMAX + 1];
int k[NMAX + 1];
int rem[NMAX + 1];

int wanted;
int T = 1;

int solve(int node) {
  if (node == wanted)
    return node;
  T++;
  int i = g[node][rem[node]];
  rem[node] = (rem[node] + 1) % k[node];
  return solve(i);
}

int main() {
  int n, m;
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    cin >> k[i];
    rem[i] = 0;
    for (int j = 0, x; j < k[i]; j++) {
      cin >> x;
      g[i].push_back(x);
    }
  }

  int NODE = 1;
  for (int i = 0; i < m; i++) {
    cin >> wanted;
    NODE = solve(NODE);
  }

  cout << T;

  return 0;
}
