#include <iostream>
#include <vector>

#pragma GCC target("avx2")
#pragma GCC optimize("Ofast", "unroll-loops")

using namespace std;

const int NMAX = 1e5;

vector<int> g[NMAX + 1];
int k[NMAX + 1];
int rem[NMAX + 1];


int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0); cout.tie(0);

  int n, m;
  cin >> n >> m;
  for (int i = 1; i <= n; i++) {
    cin >> k[i];
    rem[i] = 0;
    for (int j = 0, x; j < k[i]; j++) {
      cin >> x;
      g[i].push_back(x);
    }
  }

  int node = 1, nxt, see = 0;
  vector<int> first, cyc;
  do {
    nxt = g[node][rem[node]];
    rem[node]++;
    if (rem[node] == k[node])
      rem[node] = 0;
    first.push_back(node);
    if (node == 1)
      see++;
    node = nxt;
  } while(see <= k[1]);

  see = 0;
  do {
    nxt = g[node][rem[node]];
    rem[node]++;
    if (rem[node] == k[node])
      rem[node] = 0;
    cyc.push_back(node);
    if (node == 1)
      see++;
    node = nxt;
  } while(see != k[1]);
/*
  for (int &x : first)
    cout << x << ' ';
  cout << '\n';

  for (int &x : cyc)
    cout << x << ' ';
  cout << '\n';
*/
/*
  int old = 1, wanted;
  int T = 1;
  cout << 1 << ' ';

  for (int i = 0; i < n; i++)
    rem[i] = 0;

  for (int i = 0; i < m; i++) {
    cin >> wanted;
    int node = old, nxt;
    if (wanted == 1 && i == 0)
      continue;
  }
  cout << '\n';
*/
  long long T;
  if (m <= k[1] + 1) {
    int i = 0;
    while (i < first.size() && m > 0)
      m -= (first[i++] == 1);
    T = i;
  } else {
    T = first.size();
    m -= k[1] + 1;
    T += (m / k[1]) * cyc.size();
    m %= k[1];
    int i = 0;
    while (i < cyc.size() && m > 0)
      m -= (cyc[i++] == 1);
    T += i;
  }
  cout << T;

  return 0;
}
/**
10 20
2 2 3
4 4 5 1 6
3 9 1 10
1 2
3 7 2 8
1 2
1 5
1 5
1 3
1 3
1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
*/
