#pragma once

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 2e5;

int dp[NMAX];
int n;

void init(vector<int> a, int D) {
  n = a.size();

  vector<pair<int, int>> p(n);

  for (int i = 0; i < n; i++) {
    p[i] = {-a[i], i};
    dp[i] = -1;
  }


  sort(p.begin(), p.end());

  for (int e = 0; e < n; e++) {
    int i = p[e].second;
    for (int d = 1; d <= D; d++)
      if (i - d >= 0 && dp[i - d] == 0) {
          dp[i] = 1;
          break;
      } else if (i + d < n && dp[i + d] == 0) {
        dp[i] = 1;
        break;
      }
    dp[i] = max(dp[i], 0);
  }
}

void updateValue(int index, int newValue) {
}

bool isWinning(int startIndex) {
  return dp[startIndex];
}
