#pragma once

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int NMAX = 2e5;

vector<int> A;
int D;

int dp[NMAX];
int n;

int upd[NMAX];
vector<int> big[NMAX];

void init(vector<int> a, int d) {
  n = a.size();

  A = a;
  D = d;

  vector<pair<int, int>> p(n);

  for (int i = 0; i < n; i++) {
    p[i] = {-a[i], i};
    dp[i] = -1;
  }

  sort(p.begin(), p.end());

  for (int e = 0; e < n; e++) {
    int i = p[e].second;

    for (int d = 1; d <= D; d++)
      if (i - d >= 0 && dp[i - d] == 0)
        dp[i] = 1;
      else if (i + d < n && dp[i + d] == 0)
        dp[i] = 1;

    upd[i] = 0;
    dp[i] = max(dp[i], 0);


    for (int d = 1; d <= D; d++) {
      if (i - d >= 0 && A[i - d] > A[i])
        big[i].push_back(i - d);
      if (i + d < n && A[i + d] > A[i])
        big[i].push_back(i + d);
    }
  }

  for (int i = 0; i < n; i++)
    cout << dp[i] << " \n"[i + 1 == n];
}

void updateValue(int index, int newValue) {
  if (newValue < A[index]) {
    int l = max(0, index - D);
    int r = min(n - 1, index + D);
    big[index].clear();
    upd[index] = 1;
    for (int i = l; i <= r; i++)
      if (i != index) {
        int poz = 0;
        while (poz < big[i].size() && big[i][poz] != index)
          poz++;
        upd[i] = 1;
        if (newValue < A[i]) {
          big[i].erase(big[i].begin() + poz);
          big[index].push_back(i);
        }
      }
  } else {
    int l = max(0, index - D);
    int r = min(n - 1, index + D);
    big[index].clear();
    upd[index] = 1;
    for (int i = l; i <= r; i++)
      if (i != index) {
        int poz = 0;
        while (poz < big[i].size() && big[i][poz] != index)
          poz++;
        upd[i] = 1;
        if (newValue > A[i]) {
          big[i].erase(big[i].begin() + poz);
          big[i].push_back(index);
        }
      }
  }

  A[index] = newValue;
  //init(A, D);
}

bool isWinning(int startIndex) {
 // if (upd[startIndex] == 0)
   // return dp[startIndex];

  sort(big[startIndex].begin(), big[startIndex].end(), [](int &a, int &b) {
    return A[a] > A[b];
  });

  int ans = 0;
  for (int &x : big[startIndex]) {
    dp[x] = isWinning(x);
    ans |= (dp[x] == 0);
  }

  upd[startIndex] = 0;

  return (dp[startIndex] = ans);

}
