#pragma once

#include <bits/stdc++.h>

using namespace std;

vector <bool> setState;
vector <bool> winning;
int n;

void setS( int i, bool win ) {
    if ( !setState[i] ) {
        setState[i] = true;
        winning[i] = win;
    }
}

vector <int> v;
int d;

void init(std::vector<int> a, int dist) {
    v = a;
    d = dist;
    n = v.size();
    setState.resize( n, 0 );
    winning.resize( n, 0 );

    vector <pair<int, int>> values;
    for ( int i = 0; i < n; i ++ ) {
        values.push_back( { -v[i], i } );
    }
    sort( values.begin(), values.end() );

    for ( auto p : values ) {
        int i = p.second;
        if ( winning[i] ) continue;
        setS( i, 0 );
        for ( int j = max( 0, i - d ); j <= min( n - 1, i + d ); j ++ ) {
            setS( j, 1 );
        }
    }
}
void updateValue(int index, int newValue) {
    v[index] = newValue;
    setState.clear();
    winning.clear();

    setState.resize( n, 0 );
    winning.resize( n, 0 );

    vector <pair<int, int>> values;
    for ( int i = 0; i < n; i ++ ) {
        values.push_back( { -v[i], i } );
    }
    sort( values.begin(), values.end() );

    for ( auto p : values ) {
        int i = p.second;
        if ( winning[i] ) continue;
        setS( i, 0 );
        for ( int j = max( 0, i - d ); j <= min( n - 1, i + d ); j ++ ) {
            setS( j, 1 );
        }
    }
}
bool isWinning(int startIndex) {
    return winning[startIndex];
}
