#include "game.h"
#include "bits/stdc++.h"
using namespace std;
using ll = long long;

vector<int> v;
vector<vector<int>> ans;
int D;
vector<bool> vis;

void dfs(int i) {
	if (ans[i][0] != -1) {
		return;
	}
	vis[i] = 1;
	int d = D;
	int mx = 0, mn = 1e9;
	int n = v.size();
	for (int j = max(0, i - d); j < min(n, i + d + 1); j++) {
		if (i != j) {
			mx = max(mx, v[j]);
			mn = min(mn, v[j]);
		}
	}
	if (mx < v[i]) {
		ans[i][0] = 2;
		ans[i][1] = 2;
		return;
	}
	if (mx == v[i]) {
		ans[i][0] = 3;
		ans[i][1] = 3;
		return;
	}
	ans[i][0] = 2;
	ans[i][1] = 2;
	for (int j = max(0, i - d); j < min(n, i + d + 1); j++) {
		if (i != j && v[j] > v[i]) {
			if (ans[j][0] == 3) {
				ans[i][0] = 1;
			}
			if (ans[j][1] == 2) {
				ans[i][0] = 1;
			}
			if (ans[j][0] == 2) {
				ans[i][1] = 1;
			}
		}
	}
}

// void dfs1(int i) {
// 	int d =
// 	for (int j = max(0, i - d); j < min(n, i + d + 1); j++) {
// 		if (i != j && ans[j][0] == -1) {
// 			if (ans[i][0] == 1) {
				
// 			}
// 		}
// 	}
// }

void init(std::vector<int> a, int d) {
    D = d;
    v = a;
    ans.resize(a.size(), vector<int> (2, -1));
    vis.resize(a.size(), 0);
    vector<int> rec;
    int n = a.size();
    vector<pair<int, int>> sa;
    for (int i = 0; i < n; i++) {
    	sa.push_back({a[i], i});
    }
    sort(sa.rbegin(), sa.rend());
    for (int j = 0; j < n; j++) {
    	int i = sa[j].second;
    	if (ans[i][0] != -1) {
    		continue;
    	}
    	dfs(i);
    }
}

void updateValue(int index, int newValue) {
    int n = v.size();
    for (int i = 0; i < n; i++) {
    	ans[i][0] = -1;
    	ans[i][1] = -1;
    }
    v[index] = newValue;
    vector<pair<int, int>> sa;
    for (int i = 0; i < n; i++) {
    	sa.push_back({v[i], i});
    }
    sort(sa.rbegin(), sa.rend());
    for (int j = 0; j < n; j++) {
    	int i = sa[j].second;
    	if (ans[i][0] != -1) {
    		continue;
    	}
    	dfs(i);
    }
}

bool isWinning(int startIndex) {
	return (ans[startIndex][0] == 1 || ans[startIndex][0] == 3);
}

// int main()
// {
//     int n, D, q;

//     std::vector<int> nums;

//     scanf("%d %d", &n, &D);

//     for (int i = 1; i <= n; i++)
//     {
//         int x;
//         scanf("%d", &x);
//         nums.push_back(x);
//     }

//     init(nums, D);

//     scanf("%d", &q);

//     for (int i = 1; i <= q; i++)
//     {
//         int cm;

//         scanf("%d", &cm);

//         if (cm == 1)
//         {
//             int ind, val;

//             scanf("%d %d", &ind, &val);

//             updateValue(ind, val);
//         }
//         else
//         {
//             int ind;

//             scanf("%d", &ind);

//             printf("%d\n", (int)isWinning(ind));
//         }
//     }

//     return 0;
// }
