#include <bits/stdc++.h>
using namespace std;

#define int long long
int n;
const int N = 5e5 + 36;
queue<int> M;
int days = 0;

deque<int> tree[N];
int parent[N];
bool vis[N] = {};

int ok = 0;

void pd(int v, int p=-1) {
    parent[v] = p;
    for (int u : tree[v]) if (u != p) {
        pd(u, v);
    }
}

bool first = false;
queue<int> q;
int start = 0;
void dfs(int s, vector<int>& path, bool ret = false) {
    memset(vis, 0, sizeof(vis));
    int cnt = 0;
    while (!q.empty()) {
        if (!M.size()) return;  
        int v = q.front();
        path.push_back(v);
        q.pop();
        ++days;
        if (v == M.front()) {
            M.pop();
            if (!M.size()) {
                cout << days;
                exit(0);
            }
        }
        if (!vis[v]) vis[v] = true, ++cnt;      
        int nowback = tree[v].back() == parent[v];
        int nxt = tree[v].front();
        q.push(nxt);
        tree[v].pop_front();
        tree[v].push_back(nxt);
        if (nxt == parent[v]) ++ok;
        ok -= nowback;
        if (v == 1 && ok == n - 1) {
            if (first && cnt == n) {
                return;
            }
            else if (!first) {
                start = (int)path.size() - 1;
                first = true;
                cnt = 0;
                memset(vis, 0, sizeof(vis));
            }
        }
    }    
}

int32_t main() {
    cin.tie(0)->sync_with_stdio(false);
    
    int m;
    cin >> n >> m;

    for (int i = 1; i <= n; ++i) {
        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int h;
            cin >> h;
            tree[i].push_back(h);
        }
    }
    pd(1);
    for (int i = 0; i < m; ++i) {
        int j;
        cin >> j;
        M.push(j);
    }
    for (int i = 1; i <= n; ++i) {
        if (tree[i].back() == parent[i]) ++ok;
    }
    vector<int> init_path;
    q.push(1);
    if (ok == n - 1) first = true;
    // for (int i : init_path) cout << i << " ";
    // cout << "\n";
    // init_path.clear();
    // init_path.push_back(1);
    dfs(1, init_path, true);
    init_path.pop_back();
    // for (int i : init_path) cout << i << " ";
    // cout << "\n";

    vector<vector<int>> pos(n + 1);
    int curpos = start;
    for (int j = start; j < init_path.size(); ++j) {
        pos[init_path[j]].push_back(j);
    }
    while (!M.empty()) {
        int v = M.front();
        M.pop();
        auto it = upper_bound(pos[v].begin(), pos[v].end(), curpos);
        if (it == pos[v].end()) {
            days += init_path.size() - curpos;
            days += pos[v].front() - start;
            curpos = pos[v].front();
        }
        else {
            days += *it - curpos;
            curpos = *it;
        }
    }
    cout << days;
}   