#pragma once
#include <bits/stdc++.h>
using namespace std;
const int N = 2e5 + 69;
int ar[N];
int globMax[N] = {};
int losing[N] = {};
int n;
int d;

int findMaxInd(int l, int r, int ind) {
    int res = -2e9;
    int ret = -1;
    for (int i = max(l, 0); i <= min(r, n - 1); ++i) {
        if (i == ind) continue;
        res = max(res, ar[i]);
        if (res == ar[i]) ret = i;
    }
    return ret;
}

void calculate() {
    priority_queue<pair<int, int>> q;
    bool vis[n] = {};
    fill(losing, losing + n, -1);
    for (int i = 0; i < n; ++i) {
        int mx = findMaxInd(i - d, i + d, i);
        if (ar[mx] < ar[i]) {
            globMax[i] = true;
            vis[i] = true;
            losing[i] = true;
        }
        q.push({ar[i], i});
    }
    while (!q.empty()) {
        auto [v, ind] = q.top();
        q.pop();
        for (int i = max(0, ind - d); i <= min(ind + d, n - 1); ++i) {
            if (losing[i] == 1 && ar[i] > ar[ind]) {
                losing[ind] = false;
                break;
            }
            if (!vis[i]) {
                vis[i] = true;
                q.push({ar[i], i});
            }
        }
        if (losing[ind] == -1) losing[ind] = true;
    }
}

bool isWinning(int startIndex) {
    bool first_turn = true;
    return !losing[startIndex];
}
void init(std::vector<int> A, int D) {
    n = A.size();
    for (int i = 0; i < n; ++i) ar[i] = A[i];
    d = D;
    calculate();
}
void updateValue(int index, int newValue) {
    ar[index] = newValue;
    for (int i = 0; i < n; ++i) {
        int mx = findMaxInd(i - d, i + d, i);
        if (ar[mx] < ar[i]) {
            globMax[i] = true;
        }
    }
    calculate();
}
