#include <iostream>
#include<vector>
#include<algorithm>

using namespace std;
int main()
{
    int N, M;
    cin >> N >> M;
    vector<vector<int>> G(N);
    vector<int> P(M);
    for (int i = 0; i < N; i++) {
        int k;
        cin >> k;
        G[i] = vector<int>(k);
        for (int j = 0; j < k; j++) {
            cin >> G[i][j];
            G[i][j]--;
        }
    }
    for (int i = 0; i < M; i++) {
        cin >> P[i];
        P[i]--;
    }
    vector<int> cur(N, 0);
    int city = 0;
    long long count = 1;
    for (int index = 0; index < M; index++) {
        while (P[index] != city) {
            int newcity = G[city][cur[city]];
            cur[city] = (1 + cur[city]) % G[city].size();
            city = newcity;
            count++;
        }
        if (index!=M-1&&P[index+1] == P[index]) {
            int newcity = G[city][cur[city]];
            cur[city] = (1 + cur[city]) % G[city].size();
            city = newcity;
            count++;
        }
    }
    cout << count << endl;
}
