#include <iostream>
#include<vector>
#include<map>
#include<algorithm>
#include<math.h>

int fpow(int a, int b) {
    if (b == 0)return 1;
    int ans = fpow(a, b / 2);
    return ans * ans * (b % 2 == 0 ? 1 : a);
}

using namespace std;
int main()
{
    int T;
    cin >> T;
    for (int q = 0; q < T; q++) {
        int N, K, X;
        cin >> N >> K >> X;
        vector<int>a(N);
        
        vector<map<int, int>> pr(N);
        map<int, vector<int>> pow;
        map<int, int> maxpow;
        for (int i = 0; i < N; i++) {
            cin >> a[i];
            int x = a[i];
            for (int p = 2; p <= sqrt(x); p++) {
                if (x % p==0) {
                    x /= p;
                    if (pr[i].find(p)==pr[i].end())
                        pr[i][p]=1;
                    else pr[i][p]++;
                    p--;
                }
            }
            if (x != 1) {
                if (pr[i].find(x) == pr[i].end())
                    pr[i][x] = 1;
                else pr[i][x]++;
            }
        }
        for (int i = 0; i < N; i++) {
            for (auto j = pr[i].begin(); j != pr[i].end(); ++j) {
                if (pow.find(j->first) == pow.end()) {
                    pow[j->first] = vector<int>(j->second,0);
                    pow[j->first][j->second - 1] = 1;
                }
                else {
                    if (pow[j->first].size() < j->second)
                        pow[j->first].resize(j->second);
                    pow[j->first][j->second - 1]++;
                }
            }
        }
        for (auto it = pow.begin(); it != pow.end(); ++it) {
            maxpow[it->first] = 0;
            int count = 0;
            for (int i = (it->second).size() - 1; i >= 0; i--) {
                count += (it->second)[i];
                if (count >= K) {
                    maxpow[it->first] = i + 1;
                }
            }
        }
        map<int, vector<int>> val;
        vector<int> fr(N);
        for (int i = 0; i < N; i++) {
            int real = a[i];
            for (auto it = maxpow.begin(); it != maxpow.end(); ++it) {
                auto p = pr[i].find(it->first);
                if (p == pr[i].end()) continue;
                if (it->second >= p->second) continue;
                real /= fpow(it->first, p->second - it->second);
            }
            fr[i] = real;
            auto pos = val.find(real);
            if (pos == val.end()) val[real] = vector<int>(1, a[i]);
            else val[real].push_back(a[i]);
        }
        map<int, int> ffr;
        for (auto it = val.begin(); it != val.end(); ++it) {
            ffr[it->first] = 0;
            sort((it->second).begin(), (it->second).end());
        }
        for (int i = 0; i < N; i++) {
            cout << val[fr[i]][ffr[fr[i]]] << " ";
            ffr[fr[i]]++;
        }
    }
}
