#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 5e5 + 10;

int n, m;
deque<int> adj[N];
vector<int> need;

int cur = 0;

int dfs(int node) {
    if (node == need[cur]) {
        cur++;
        if (cur == m) return 1;
    }
    int nxt = adj[node].front();
    adj[node].pop_front();
    adj[node].push_back(nxt);
    return dfs(nxt) + 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int node;
            cin >> node;
            adj[i].push_back(node);
        }
    }

    need.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> need[i];
    }


    printf("%i\n", dfs(1));

}