#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 5e5 + 10;

int n, m;
vector<int> adj[N];
int ind[N] = {};
vector<int> need;

int cur = 0;

int dfs() {
    int node = 1;
    int ans = 0;
    while (true) {
        ans++;
        if (node == need[cur]) {
            cur++;
            if (cur == m) break;
        }
        int nxt = adj[node][ind[node]];
        ind[node] = (ind[node] + 1) % (adj[node].size());
        node = nxt;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int node;
            cin >> node;
            adj[i].push_back(node);
        }
    }

    need.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> need[i];
    }


    printf("%i\n", dfs());

}