#include <bits/stdc++.h>

#pragma GCC optimize("O3")

using namespace std;
using ll = long long;

constexpr int N = 1e5 + 1;

int n, m;
vector<int> adj[N];
int ind[N] = {};
int need[N] = {};

int cur = 0;

int dfs() {
    int node = 1;
    int ans = 0;
    int nxt;
    while (cur < m) {
        ans++;
        cur += (node == need[cur]);
        nxt = adj[node][ind[node]];
        ind[node] -= -1 + adj[node].size() * (ind[node] == adj[node].size() - 1);
        node = nxt;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        adj[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> adj[i][j];    
        }
    }

    for (int i = 0; i < m; i++) {
        cin >> need[i];
    }


    printf("%i\n", dfs());

}