#include <bits/stdc++.h>
#include "game.h"

using namespace std;

constexpr int N = 2e5 + 10;

int n, d;
int a[N] = {};
bool win[N] = {};

void comp() {
    pair<int, int> b[n];
    bool did[n] = {};
    for (int i = 0; i < n; i++) {
        b[i] = {a[i], i};
    }
    sort(b, b + n, greater<pair<int, int>>());
    for (int op = 0; op < n; op++) {
        int i = b[op].second;
        if (!did[i]) {
            for (int j = max(i - d, 0); j <= min(i + d, n - 1); j++) {
                win[j] = true;
                did[j] = true;
            }
            win[i] = false;
        }
    }
}

void init(vector<int> A, int D) {
    n = A.size();
    d = D;
    for (int i = 0; i < n; i++) {
        a[i] = A[i];
    }
    comp();
}
void updateValue(int index, int newValue) {
    a[index] = newValue;
    comp();
}
bool isWinning(int startIndex) {
    return win[startIndex];
}