#include <bits/stdc++.h>

using namespace std;

constexpr int N = 1e5 + 10;

int ld[N] = {};
int n, k, x;
map<int, int> cnt;

int divs(int num, bool comp) {
    if (num == 1) {
        return 1;
    }
    int l = ld[num];
    int p = 0;
    while (num % l == 0) {
        num /= l;
        p++;
    }
    int ans = divs(num, comp);
    int cur = 1;
    for (int i = 0; i < p; i++) {
        cur *= l;
        if (comp) {
            if (cnt[cur] >= k) {
                ans *= l;
            }
        }
        else {
            cnt[cur]++;
        }
    }
    return ans;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    
    for (int i = 2; i < N; i++) {
        if (ld[i] == 0) {
            for (int j = i; j < N; j += i) {
                ld[j] = i;
            }
        }
    }

    int T;
    cin >> T;
    while (T--) {
        cnt.clear();
        
        cin >> n >> k >> x;
        int a[n];
        int b[n];
        for (int i = 0; i < n; i++) {
            cin >> a[i];
            b[i] = 1;
        }
        
        for (int i = 0; i < n; i++) {
            divs(a[i], false);
        }
        map<int, multiset<int>> mp;
        for (int i = 0; i < n; i++) {
            b[i] = divs(a[i], true);
            mp[b[i]].insert(a[i]);
        }

        for (int i = 0; i < n; i++) {
            printf("%i ", *mp[b[i]].begin());
            mp[b[i]].erase(mp[b[i]].begin());
        }
        printf("\n");
    }
}