#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

#define int ll

const int N = 5e5 + 128;
vector <int> g[N];
int tin[N], tout[N];
int timer = 0;
int k[N], idx[N];
int n, m;
int parent[N];
int dp[2][N];

void dfs(int v, int p = -1) {
    tin[v] = timer++;
    parent[v] = p;
    for (auto& to : g[v])
        if (to != p)
            dfs(to, v);
    tout[v] = timer++;
}

bool inside(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

void go(int v) {
    dp[0][v]++; dp[1][v]++;
    if (v != 1 && (int)g[v].size() == 1)
        return;

    bool wasParent = false;
    for (auto& to : g[v]) {
        if (to == parent[v]) {
            wasParent = true;
        } else {
            go(to);
            dp[1][v] += dp[1][to] + 1;
            if (!wasParent)
                dp[0][v] += dp[0][to] + 1;
        }
    }
}

bool firstTime[N];
int f[N];

void upd(int idx, int val) {
    for (; idx < N; idx = idx | (idx + 1))
        f[idx] += val;
}

int get(int r) {
    int ans = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1)
        ans += f[r];
    return ans;
}

void update(int v) {
    upd(tin[v], +1);
    upd(tin[v] + 1, -1);
}

void solve() {
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        cin >> k[i];
        g[i].resize(k[i]);
        for (auto& x : g[i])
            cin >> x;
    }

    vector <int> order(m);
    for (auto& x : order)
        cin >> x;
    assert(all_of(all(order), [&](const int& x) -> bool {return x == 1;}));

    dfs(1);
    go(1);

    int cur_v = 1;
    ll days = 1;
    m--;

    int sz = (int)g[1].size();
    for (int i = 0; i < min(sz, m); i++)
        days += dp[0][g[1][i]] + 1;
    for (int i = sz; i < m; i++)
        days += dp[1][g[1][i % sz]] + 1;

    cout << days << '\n';
}

main() {
    boost;
    solve();
    return 0;
}
