#include <bits/stdc++.h>

#define ll long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define watch(x) cout << (#x) << " : " << x << '\n'
#define boost ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;

const int N = 5e5 + 128;
vector <int> g[N];
int k[N];
int n, m;

int full[N];
int parent[N], cnt[N], cnt_before[N];

void dfs(int v, int p = -1) {
    parent[v] = p;
    cnt[v] = (int)g[v].size() - 1;
    for (auto& to : g[v])
        if (to != p)
            dfs(to, v);
    for (auto& to : g[v]) {
        if (to == p)
            break;
        cnt_before[v]++;
    }
}

int idx;
vector <int> nxt_cands[N], cands[N];

void expand(int v, bool before) {
    if (!before) {
        full[idx] -= cnt_before[v] * 2;
        full[idx] += cnt[v] * 2;
    } else {
        full[idx] += cnt_before[v] * 2;
    }

    int x = 0;

    bool wasParent = false;
    for (auto& to : g[v]) {
        if (to == parent[v]) {
            wasParent = true;
            continue;
        }
        if (before && wasParent)
            ++x;
        if (wasParent == !before)
            expand(to, true);
    }

    if (x)
        nxt_cands[idx].push_back(v);
}

void solve() {
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        cin >> k[i];
        g[i].resize(k[i]);
        for (auto& x : g[i])
            cin >> x;
    }

    dfs(1);

    vector <int> order(m);
    for (auto& x : order)
        cin >> x;
    assert(all_of(all(order), [&](const int& x) -> bool {return x == 1;}));

    int sz = (int)g[1].size();

    m--;
    ll days = 1ll;

    for (int i = 0; i < sz; i++)
        cands[i].push_back(g[1][i]);

    for (int c = 0; c < m; c++) {
        int v = c % sz;

        idx = v;

        for (auto& x : cands[v])
            expand(x, ((c < sz) ? true : false));

//        cout << "idx = " << idx << " vertex = " << g[1][v] << ", answer = " << full[idx] + 2 << '\n';

        days += full[idx] + 2;

        cands[idx] = nxt_cands[idx];
        nxt_cands[idx].clear();

    }

    cout << days << '\n';
}

main() {
    boost;
    solve();
    return 0;
}
